/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.app.ActivityManager$MemoryInfo
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.app.ActivityManager');

/**
 * @class android.app.ActivityManager$MemoryInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html}
 **/
var MemoryInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.app.ActivityManager$MemoryInfo')) {
		result = arguments[0];
	}
	else {
		result = MemoryInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MemoryInfo.prototype = Object.create(SuperClass.prototype);
MemoryInfo.prototype.constructor = MemoryInfo;

Object.defineProperty(MemoryInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MemoryInfo(this.$native.super);
	},
	enumerable: true
});

MemoryInfo.className = 'android.app.ActivityManager$MemoryInfo';
MemoryInfo.prototype.className = 'android.app.ActivityManager$MemoryInfo';

// class property
Object.defineProperty(MemoryInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.app.ActivityManager$MemoryInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MemoryInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.app.ActivityManager$MemoryInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MemoryInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MemoryInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MemoryInfo(Hyperloop.cast('android.app.ActivityManager$MemoryInfo', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#CREATOR
Object.defineProperty(MemoryInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
				return new MemoryInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#totalMem
Object.defineProperty(MemoryInfo.prototype, 'totalMem', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('totalMem');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
				return new MemoryInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('totalMem', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#availMem
Object.defineProperty(MemoryInfo.prototype, 'availMem', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('availMem');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
				return new MemoryInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('availMem', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#threshold
Object.defineProperty(MemoryInfo.prototype, 'threshold', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('threshold');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
				return new MemoryInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('threshold', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#lowMemory
Object.defineProperty(MemoryInfo.prototype, 'lowMemory', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('lowMemory');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
				return new MemoryInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('lowMemory', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function readFromParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#readFromParcel(android.os.Parcel)}
 **/
MemoryInfo.prototype.readFromParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readFromParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
			return new MemoryInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#describeContents()}
 **/
MemoryInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
			return new MemoryInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.MemoryInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
MemoryInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$MemoryInfo') {
			return new MemoryInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MemoryInfo;
