/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ActivityLifecycleCallbacks
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.app.Application');

/**
 * constructor
 * http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html
 **/
var ActivityLifecycleCallbacks = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.app.Application$ActivityLifecycleCallbacks');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ActivityLifecycleCallbacks.prototype = Object.create(SuperClass.prototype);
ActivityLifecycleCallbacks.prototype.constructor = ActivityLifecycleCallbacks;

Object.defineProperty(ActivityLifecycleCallbacks.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActivityLifecycleCallbacks(this.$native.super);
	},
	enumerable: true
});

ActivityLifecycleCallbacks.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ActivityLifecycleCallbacks.className = "android.app.Application$ActivityLifecycleCallbacks";
ActivityLifecycleCallbacks.prototype.className = "android.app.Application$ActivityLifecycleCallbacks";

// class property
Object.defineProperty(ActivityLifecycleCallbacks, 'class', {
	get: function() {
		return Hyperloop.getClass('android.app.Application$ActivityLifecycleCallbacks');
	},
	enumerable: true,
	configurable: false
});

// Cast
ActivityLifecycleCallbacks.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActivityLifecycleCallbacks(Hyperloop.cast('android.app.Application$ActivityLifecycleCallbacks', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function onActivityResumed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityResumed(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityResumed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityResumed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostDestroyed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostDestroyed(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostDestroyed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostDestroyed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPrePaused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPrePaused(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPrePaused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPrePaused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPreStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPreStarted(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPreStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPreStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostResumed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostResumed(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostResumed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostResumed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPreStopped
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPreStopped(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPreStopped = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPreStopped',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPreResumed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPreResumed(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPreResumed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPreResumed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostSaveInstanceState(android.app.Activity, android.os.Bundle)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPreSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPreSaveInstanceState(android.app.Activity, android.os.Bundle)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPreSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPreSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostStarted(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityStopped
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityStopped(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityStopped = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityStopped',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostPaused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostPaused(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostPaused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostPaused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityCreated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityCreated(android.app.Activity, android.os.Bundle)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityCreated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityCreated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPreDestroyed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPreDestroyed(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPreDestroyed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPreDestroyed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityStarted(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPaused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPaused(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPaused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPaused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostStopped
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostStopped(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostStopped = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostStopped',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivitySaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivitySaveInstanceState(android.app.Activity, android.os.Bundle)}
 **/
ActivityLifecycleCallbacks.prototype.onActivitySaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivitySaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPreCreated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPreCreated(android.app.Activity, android.os.Bundle)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPreCreated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPreCreated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityPostCreated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityPostCreated(android.app.Activity, android.os.Bundle)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityPostCreated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityPostCreated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onActivityDestroyed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/Application.ActivityLifecycleCallbacks.html#onActivityDestroyed(android.app.Activity)}
 **/
ActivityLifecycleCallbacks.prototype.onActivityDestroyed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityDestroyed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.Application$ActivityLifecycleCallbacks') {
			return new ActivityLifecycleCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ActivityLifecycleCallbacks.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ActivityLifecycleCallbacks.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ActivityLifecycleCallbacks;
