/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.app.TaskInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.app');

/**
 * @class android.app.TaskInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/app/TaskInfo.html}
 **/
var TaskInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.app.TaskInfo')) {
		result = arguments[0];
	}
	else {
		result = TaskInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TaskInfo.prototype = Object.create(SuperClass.prototype);
TaskInfo.prototype.constructor = TaskInfo;

Object.defineProperty(TaskInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TaskInfo(this.$native.super);
	},
	enumerable: true
});

TaskInfo.className = 'android.app.TaskInfo';
TaskInfo.prototype.className = 'android.app.TaskInfo';

// class property
Object.defineProperty(TaskInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.app.TaskInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TaskInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.app.TaskInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TaskInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TaskInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TaskInfo(Hyperloop.cast('android.app.TaskInfo', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/android/app/TaskInfo.html#baseIntent
Object.defineProperty(TaskInfo.prototype, 'baseIntent', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('baseIntent');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('baseIntent', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#isRunning
Object.defineProperty(TaskInfo.prototype, 'isRunning', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('isRunning');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('isRunning', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#taskDescription
Object.defineProperty(TaskInfo.prototype, 'taskDescription', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('taskDescription');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('taskDescription', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#numActivities
Object.defineProperty(TaskInfo.prototype, 'numActivities', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('numActivities');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('numActivities', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#topActivity
Object.defineProperty(TaskInfo.prototype, 'topActivity', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('topActivity');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('topActivity', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#baseActivity
Object.defineProperty(TaskInfo.prototype, 'baseActivity', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('baseActivity');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('baseActivity', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#origActivity
Object.defineProperty(TaskInfo.prototype, 'origActivity', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('origActivity');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('origActivity', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/TaskInfo.html#taskId
Object.defineProperty(TaskInfo.prototype, 'taskId', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('taskId');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.TaskInfo') {
				return new TaskInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('taskId', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/TaskInfo.html#toString()}
 **/
TaskInfo.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.TaskInfo') {
			return new TaskInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TaskInfo;
