/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.content.pm.ConfigurationInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.content.pm');

/**
 * @class android.content.pm.ConfigurationInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html}
 **/
var ConfigurationInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.content.pm.ConfigurationInfo')) {
		result = arguments[0];
	}
	else {
		result = ConfigurationInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ConfigurationInfo.prototype = Object.create(SuperClass.prototype);
ConfigurationInfo.prototype.constructor = ConfigurationInfo;

Object.defineProperty(ConfigurationInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ConfigurationInfo(this.$native.super);
	},
	enumerable: true
});

ConfigurationInfo.className = 'android.content.pm.ConfigurationInfo';
ConfigurationInfo.prototype.className = 'android.content.pm.ConfigurationInfo';

// class property
Object.defineProperty(ConfigurationInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.content.pm.ConfigurationInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ConfigurationInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.content.pm.ConfigurationInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ConfigurationInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ConfigurationInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ConfigurationInfo(Hyperloop.cast('android.content.pm.ConfigurationInfo', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#INPUT_FEATURE_FIVE_WAY_NAV}
 */
ConfigurationInfo.INPUT_FEATURE_FIVE_WAY_NAV = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#INPUT_FEATURE_HARD_KEYBOARD}
 */
ConfigurationInfo.INPUT_FEATURE_HARD_KEYBOARD = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#GL_ES_VERSION_UNDEFINED}
 */
ConfigurationInfo.GL_ES_VERSION_UNDEFINED = 0;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#CREATOR
Object.defineProperty(ConfigurationInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.ConfigurationInfo') {
				return new ConfigurationInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#reqTouchScreen
Object.defineProperty(ConfigurationInfo.prototype, 'reqTouchScreen', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('reqTouchScreen');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.ConfigurationInfo') {
				return new ConfigurationInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('reqTouchScreen', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#reqKeyboardType
Object.defineProperty(ConfigurationInfo.prototype, 'reqKeyboardType', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('reqKeyboardType');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.ConfigurationInfo') {
				return new ConfigurationInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('reqKeyboardType', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#reqGlEsVersion
Object.defineProperty(ConfigurationInfo.prototype, 'reqGlEsVersion', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('reqGlEsVersion');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.ConfigurationInfo') {
				return new ConfigurationInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('reqGlEsVersion', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#reqNavigation
Object.defineProperty(ConfigurationInfo.prototype, 'reqNavigation', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('reqNavigation');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.ConfigurationInfo') {
				return new ConfigurationInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('reqNavigation', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#reqInputFeatures
Object.defineProperty(ConfigurationInfo.prototype, 'reqInputFeatures', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('reqInputFeatures');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.ConfigurationInfo') {
				return new ConfigurationInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('reqInputFeatures', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getGlEsVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#getGlEsVersion()}
 **/
ConfigurationInfo.prototype.getGlEsVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGlEsVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.ConfigurationInfo') {
			return new ConfigurationInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#toString()}
 **/
ConfigurationInfo.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.ConfigurationInfo') {
			return new ConfigurationInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#describeContents()}
 **/
ConfigurationInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.ConfigurationInfo') {
			return new ConfigurationInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/ConfigurationInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
ConfigurationInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.ConfigurationInfo') {
			return new ConfigurationInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ConfigurationInfo;
