/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.content.pm.InstallSourceInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.content.pm');

/**
 * @class android.content.pm.InstallSourceInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html}
 **/
var InstallSourceInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.content.pm.InstallSourceInfo')) {
		result = arguments[0];
	}
	else {
		result = InstallSourceInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
InstallSourceInfo.prototype = Object.create(SuperClass.prototype);
InstallSourceInfo.prototype.constructor = InstallSourceInfo;

Object.defineProperty(InstallSourceInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new InstallSourceInfo(this.$native.super);
	},
	enumerable: true
});

InstallSourceInfo.className = 'android.content.pm.InstallSourceInfo';
InstallSourceInfo.prototype.className = 'android.content.pm.InstallSourceInfo';

// class property
Object.defineProperty(InstallSourceInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.content.pm.InstallSourceInfo');
	},
	enumerable: true,
	configurable: false
});


// Cast
InstallSourceInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new InstallSourceInfo(Hyperloop.cast('android.content.pm.InstallSourceInfo', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#CREATOR
Object.defineProperty(InstallSourceInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.InstallSourceInfo') {
				return new InstallSourceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getOriginatingPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#getOriginatingPackageName()}
 **/
InstallSourceInfo.prototype.getOriginatingPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOriginatingPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.InstallSourceInfo') {
			return new InstallSourceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInstallingPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#getInstallingPackageName()}
 **/
InstallSourceInfo.prototype.getInstallingPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInstallingPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.InstallSourceInfo') {
			return new InstallSourceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInitiatingPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#getInitiatingPackageName()}
 **/
InstallSourceInfo.prototype.getInitiatingPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInitiatingPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.InstallSourceInfo') {
			return new InstallSourceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#describeContents()}
 **/
InstallSourceInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.InstallSourceInfo') {
			return new InstallSourceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
InstallSourceInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.InstallSourceInfo') {
			return new InstallSourceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInitiatingPackageSigningInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/InstallSourceInfo.html#getInitiatingPackageSigningInfo()}
 **/
InstallSourceInfo.prototype.getInitiatingPackageSigningInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInitiatingPackageSigningInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.InstallSourceInfo') {
			return new InstallSourceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = InstallSourceInfo;
