/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.content.pm.SigningInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.content.pm');

/**
 * @class android.content.pm.SigningInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html}
 **/
var SigningInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.content.pm.SigningInfo')) {
		result = arguments[0];
	}
	else {
		result = SigningInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
SigningInfo.prototype = Object.create(SuperClass.prototype);
SigningInfo.prototype.constructor = SigningInfo;

Object.defineProperty(SigningInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SigningInfo(this.$native.super);
	},
	enumerable: true
});

SigningInfo.className = 'android.content.pm.SigningInfo';
SigningInfo.prototype.className = 'android.content.pm.SigningInfo';

// class property
Object.defineProperty(SigningInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.content.pm.SigningInfo');
	},
	enumerable: true,
	configurable: false
});


// Cast
SigningInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SigningInfo(Hyperloop.cast('android.content.pm.SigningInfo', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/content/pm/SigningInfo.html#CREATOR
Object.defineProperty(SigningInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.content.pm.SigningInfo') {
				return new SigningInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function hasMultipleSigners
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html#hasMultipleSigners()}
 **/
SigningInfo.prototype.hasMultipleSigners = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasMultipleSigners',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.SigningInfo') {
			return new SigningInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSigningCertificateHistory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html#getSigningCertificateHistory()}
 **/
SigningInfo.prototype.getSigningCertificateHistory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSigningCertificateHistory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.SigningInfo') {
			return new SigningInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasPastSigningCertificates
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html#hasPastSigningCertificates()}
 **/
SigningInfo.prototype.hasPastSigningCertificates = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasPastSigningCertificates',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.SigningInfo') {
			return new SigningInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApkContentsSigners
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html#getApkContentsSigners()}
 **/
SigningInfo.prototype.getApkContentsSigners = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApkContentsSigners',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.SigningInfo') {
			return new SigningInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html#describeContents()}
 **/
SigningInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.SigningInfo') {
			return new SigningInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/content/pm/SigningInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
SigningInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.content.pm.SigningInfo') {
			return new SigningInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SigningInfo;
