/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.BlendMode
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics');

/**
 * @class android.graphics.BlendMode
 * @extends java.lang.Enum 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/BlendMode.html}
 **/
var BlendMode = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.BlendMode')) {
		result = arguments[0];
	}
	else {
		result = BlendMode.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Enum');
BlendMode.prototype = Object.create(SuperClass.prototype);
BlendMode.prototype.constructor = BlendMode;

Object.defineProperty(BlendMode.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new BlendMode(this.$native.super);
	},
	enumerable: true
});

BlendMode.className = 'android.graphics.BlendMode';
BlendMode.prototype.className = 'android.graphics.BlendMode';

// class property
Object.defineProperty(BlendMode, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.BlendMode');
	},
	enumerable: true,
	configurable: false
});


// Cast
BlendMode.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new BlendMode(Hyperloop.cast('android.graphics.BlendMode', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/graphics/BlendMode.html#LUMINOSITY
Object.defineProperty(BlendMode, 'LUMINOSITY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('LUMINOSITY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SRC_ATOP
Object.defineProperty(BlendMode, 'SRC_ATOP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SRC_ATOP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DST_OVER
Object.defineProperty(BlendMode, 'DST_OVER', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DST_OVER');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DST_OUT
Object.defineProperty(BlendMode, 'DST_OUT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DST_OUT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SRC
Object.defineProperty(BlendMode, 'SRC', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SRC');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SRC_IN
Object.defineProperty(BlendMode, 'SRC_IN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SRC_IN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#COLOR_BURN
Object.defineProperty(BlendMode, 'COLOR_BURN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('COLOR_BURN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DST_ATOP
Object.defineProperty(BlendMode, 'DST_ATOP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DST_ATOP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#OVERLAY
Object.defineProperty(BlendMode, 'OVERLAY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('OVERLAY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DIFFERENCE
Object.defineProperty(BlendMode, 'DIFFERENCE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DIFFERENCE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SCREEN
Object.defineProperty(BlendMode, 'SCREEN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SCREEN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#COLOR
Object.defineProperty(BlendMode, 'COLOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('COLOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SOFT_LIGHT
Object.defineProperty(BlendMode, 'SOFT_LIGHT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SOFT_LIGHT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#HUE
Object.defineProperty(BlendMode, 'HUE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('HUE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SRC_OVER
Object.defineProperty(BlendMode, 'SRC_OVER', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SRC_OVER');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SRC_OUT
Object.defineProperty(BlendMode, 'SRC_OUT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SRC_OUT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DARKEN
Object.defineProperty(BlendMode, 'DARKEN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DARKEN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#HARD_LIGHT
Object.defineProperty(BlendMode, 'HARD_LIGHT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('HARD_LIGHT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DST
Object.defineProperty(BlendMode, 'DST', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DST');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#LIGHTEN
Object.defineProperty(BlendMode, 'LIGHTEN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('LIGHTEN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#COLOR_DODGE
Object.defineProperty(BlendMode, 'COLOR_DODGE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('COLOR_DODGE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#EXCLUSION
Object.defineProperty(BlendMode, 'EXCLUSION', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('EXCLUSION');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#MODULATE
Object.defineProperty(BlendMode, 'MODULATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MODULATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#XOR
Object.defineProperty(BlendMode, 'XOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('XOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#MULTIPLY
Object.defineProperty(BlendMode, 'MULTIPLY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MULTIPLY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#DST_IN
Object.defineProperty(BlendMode, 'DST_IN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DST_IN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#CLEAR
Object.defineProperty(BlendMode, 'CLEAR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CLEAR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#SATURATION
Object.defineProperty(BlendMode, 'SATURATION', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SATURATION');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/graphics/BlendMode.html#PLUS
Object.defineProperty(BlendMode, 'PLUS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('PLUS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.BlendMode') {
				return new BlendMode(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/BlendMode.html#valueOf(java.lang.String)}
 **/
BlendMode.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.BlendMode') {
			return new BlendMode(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/BlendMode.html#values()}
 **/
BlendMode.values = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'values',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.BlendMode') {
			return new BlendMode(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = BlendMode;
