/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.drawable.DrawableContainer
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics.drawable');

/**
 * @class android.graphics.drawable.DrawableContainer
 * @extends android.graphics.drawable.Drawable 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html}
 **/
var DrawableContainer = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.drawable.DrawableContainer')) {
		result = arguments[0];
	}
	else {
		result = DrawableContainer.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.graphics.drawable.Drawable');
DrawableContainer.prototype = Object.create(SuperClass.prototype);
DrawableContainer.prototype.constructor = DrawableContainer;

Object.defineProperty(DrawableContainer.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DrawableContainer(this.$native.super);
	},
	enumerable: true
});

DrawableContainer.className = 'android.graphics.drawable.DrawableContainer';
DrawableContainer.prototype.className = 'android.graphics.drawable.DrawableContainer';

// class property
Object.defineProperty(DrawableContainer, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.drawable.DrawableContainer');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
DrawableContainer.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.graphics.drawable.DrawableContainer');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(DrawableContainer.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
DrawableContainer.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DrawableContainer(Hyperloop.cast('android.graphics.drawable.DrawableContainer', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(DrawableContainer, 'DrawableContainerState', {
	get: function() {
		return require('./android.graphics.drawable.DrawableContainer$DrawableContainerState');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setColorFilter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setColorFilter(android.graphics.ColorFilter)}
 **/
DrawableContainer.prototype.setColorFilter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setColorFilter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinimumHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getMinimumHeight()}
 **/
DrawableContainer.prototype.getMinimumHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinimumHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHotspot
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setHotspot(float, float)}
 **/
DrawableContainer.prototype.setHotspot = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHotspot',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function selectDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#selectDrawable(int)}
 **/
DrawableContainer.prototype.selectDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'selectDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChangingConfigurations
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getChangingConfigurations()}
 **/
DrawableContainer.prototype.getChangingConfigurations = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChangingConfigurations',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDither
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setDither(boolean)}
 **/
DrawableContainer.prototype.setDither = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDither',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTintBlendMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setTintBlendMode(android.graphics.BlendMode)}
 **/
DrawableContainer.prototype.setTintBlendMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTintBlendMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onBoundsChange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#onBoundsChange(android.graphics.Rect)}
 **/
DrawableContainer.prototype.onBoundsChange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onBoundsChange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getConstantState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getConstantState()}
 **/
DrawableContainer.prototype.getConstantState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getConstantState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyTheme
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#applyTheme(android.content.res.Resources$Theme)}
 **/
DrawableContainer.prototype.applyTheme = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyTheme',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHotspotBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setHotspotBounds(int, int, int, int)}
 **/
DrawableContainer.prototype.setHotspotBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHotspotBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntrinsicWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getIntrinsicWidth()}
 **/
DrawableContainer.prototype.getIntrinsicWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntrinsicWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getAlpha()}
 **/
DrawableContainer.prototype.getAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOpacity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getOpacity()}
 **/
DrawableContainer.prototype.getOpacity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOpacity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOutline
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getOutline(android.graphics.Outline)}
 **/
DrawableContainer.prototype.getOutline = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOutline',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invalidateDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#invalidateDrawable(android.graphics.drawable.Drawable)}
 **/
DrawableContainer.prototype.invalidateDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invalidateDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntrinsicHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getIntrinsicHeight()}
 **/
DrawableContainer.prototype.getIntrinsicHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntrinsicHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinimumWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getMinimumWidth()}
 **/
DrawableContainer.prototype.getMinimumWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinimumWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStateChange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#onStateChange(int[])}
 **/
DrawableContainer.prototype.onStateChange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStateChange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isStateful
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#isStateful()}
 **/
DrawableContainer.prototype.isStateful = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isStateful',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAutoMirrored
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setAutoMirrored(boolean)}
 **/
DrawableContainer.prototype.setAutoMirrored = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAutoMirrored',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setVisible(boolean, boolean)}
 **/
DrawableContainer.prototype.setVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function mutate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#mutate()}
 **/
DrawableContainer.prototype.mutate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'mutate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAutoMirrored
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#isAutoMirrored()}
 **/
DrawableContainer.prototype.isAutoMirrored = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAutoMirrored',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPadding
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getPadding(android.graphics.Rect)}
 **/
DrawableContainer.prototype.getPadding = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPadding',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function jumpToCurrentState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#jumpToCurrentState()}
 **/
DrawableContainer.prototype.jumpToCurrentState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'jumpToCurrentState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setAlpha(int)}
 **/
DrawableContainer.prototype.setAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function draw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#draw(android.graphics.Canvas)}
 **/
DrawableContainer.prototype.draw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'draw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setExitFadeDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setExitFadeDuration(int)}
 **/
DrawableContainer.prototype.setExitFadeDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setExitFadeDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEnterFadeDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setEnterFadeDuration(int)}
 **/
DrawableContainer.prototype.setEnterFadeDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEnterFadeDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setConstantState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setConstantState(android.graphics.drawable.DrawableContainer$DrawableContainerState)}
 **/
DrawableContainer.prototype.setConstantState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setConstantState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function canApplyTheme
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#canApplyTheme()}
 **/
DrawableContainer.prototype.canApplyTheme = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canApplyTheme',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHotspotBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getHotspotBounds(android.graphics.Rect)}
 **/
DrawableContainer.prototype.getHotspotBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHotspotBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLevelChange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#onLevelChange(int)}
 **/
DrawableContainer.prototype.onLevelChange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLevelChange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getCurrent()}
 **/
DrawableContainer.prototype.getCurrent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unscheduleDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#unscheduleDrawable(android.graphics.drawable.Drawable, java.lang.Runnable)}
 **/
DrawableContainer.prototype.unscheduleDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unscheduleDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scheduleDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#scheduleDrawable(android.graphics.drawable.Drawable, java.lang.Runnable, long)}
 **/
DrawableContainer.prototype.scheduleDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scheduleDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#setTintList(android.content.res.ColorStateList)}
 **/
DrawableContainer.prototype.setTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayoutDirectionChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#onLayoutDirectionChanged(int)}
 **/
DrawableContainer.prototype.onLayoutDirectionChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayoutDirectionChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOpticalInsets
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/DrawableContainer.html#getOpticalInsets()}
 **/
DrawableContainer.prototype.getOpticalInsets = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOpticalInsets',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.DrawableContainer') {
			return new DrawableContainer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DrawableContainer;
