/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.drawable.Icon
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics.drawable');

/**
 * @class android.graphics.drawable.Icon
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html}
 **/
var Icon = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.drawable.Icon')) {
		result = arguments[0];
	}
	else {
		result = Icon.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Icon.prototype = Object.create(SuperClass.prototype);
Icon.prototype.constructor = Icon;

Object.defineProperty(Icon.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Icon(this.$native.super);
	},
	enumerable: true
});

Icon.className = 'android.graphics.drawable.Icon';
Icon.prototype.className = 'android.graphics.drawable.Icon';

// class property
Object.defineProperty(Icon, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.drawable.Icon');
	},
	enumerable: true,
	configurable: false
});


// Cast
Icon.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Icon(Hyperloop.cast('android.graphics.drawable.Icon', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#TYPE_URI_ADAPTIVE_BITMAP}
 */
Icon.TYPE_URI_ADAPTIVE_BITMAP = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#TYPE_ADAPTIVE_BITMAP}
 */
Icon.TYPE_ADAPTIVE_BITMAP = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#TYPE_BITMAP}
 */
Icon.TYPE_BITMAP = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#TYPE_DATA}
 */
Icon.TYPE_DATA = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#TYPE_RESOURCE}
 */
Icon.TYPE_RESOURCE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#TYPE_URI}
 */
Icon.TYPE_URI = 4;

// Inner classes
Object.defineProperty(Icon, 'OnDrawableLoadedListener', {
	get: function() {
		return require('./android.graphics.drawable.Icon$OnDrawableLoadedListener');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/graphics/drawable/Icon.html#CREATOR
Object.defineProperty(Icon, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.graphics.drawable.Icon') {
				return new Icon(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function createWithBitmap
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithBitmap(android.graphics.Bitmap)}
 **/
Icon.createWithBitmap = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithBitmap',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWithAdaptiveBitmap
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithAdaptiveBitmap(android.graphics.Bitmap)}
 **/
Icon.createWithAdaptiveBitmap = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithAdaptiveBitmap',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWithResource
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithResource(android.content.Context, int)}
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithResource(java.lang.String, int)}
 **/
Icon.createWithResource = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithResource',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWithData
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithData(byte[], int, int)}
 **/
Icon.createWithData = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithData',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWithContentUri
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithContentUri(java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithContentUri(android.net.Uri)}
 **/
Icon.createWithContentUri = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithContentUri',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWithAdaptiveBitmapContentUri
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithAdaptiveBitmapContentUri(java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithAdaptiveBitmapContentUri(android.net.Uri)}
 **/
Icon.createWithAdaptiveBitmapContentUri = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithAdaptiveBitmapContentUri',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createWithFilePath
 * @static
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#createWithFilePath(java.lang.String)}
 **/
Icon.createWithFilePath = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createWithFilePath',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getResPackage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#getResPackage()}
 **/
Icon.prototype.getResPackage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResPackage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function loadDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#loadDrawable(android.content.Context)}
 **/
Icon.prototype.loadDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'loadDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#setTintMode(android.graphics.PorterDuff$Mode)}
 **/
Icon.prototype.setTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTintBlendMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#setTintBlendMode(android.graphics.BlendMode)}
 **/
Icon.prototype.setTintBlendMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTintBlendMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#setTint(int)}
 **/
Icon.prototype.setTint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#describeContents()}
 **/
Icon.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function loadDrawableAsync
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#loadDrawableAsync(android.content.Context, android.os.Message)}
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#loadDrawableAsync(android.content.Context, android.graphics.drawable.Icon$OnDrawableLoadedListener, android.os.Handler)}
 **/
Icon.prototype.loadDrawableAsync = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'loadDrawableAsync',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#getType()}
 **/
Icon.prototype.getType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#getResId()}
 **/
Icon.prototype.getResId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#toString()}
 **/
Icon.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#writeToParcel(android.os.Parcel, int)}
 **/
Icon.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#getUri()}
 **/
Icon.prototype.getUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/drawable/Icon.html#setTintList(android.content.res.ColorStateList)}
 **/
Icon.prototype.setTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.drawable.Icon') {
			return new Icon(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Icon;
