/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.fonts.FontFamily
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics.fonts');

/**
 * @class android.graphics.fonts.FontFamily
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontFamily.html}
 **/
var FontFamily = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.fonts.FontFamily')) {
		result = arguments[0];
	}
	else {
		result = FontFamily.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FontFamily.prototype = Object.create(SuperClass.prototype);
FontFamily.prototype.constructor = FontFamily;

Object.defineProperty(FontFamily.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FontFamily(this.$native.super);
	},
	enumerable: true
});

FontFamily.className = 'android.graphics.fonts.FontFamily';
FontFamily.prototype.className = 'android.graphics.fonts.FontFamily';

// class property
Object.defineProperty(FontFamily, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.fonts.FontFamily');
	},
	enumerable: true,
	configurable: false
});


// Cast
FontFamily.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FontFamily(Hyperloop.cast('android.graphics.fonts.FontFamily', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(FontFamily, 'Builder', {
	get: function() {
		return require('./android.graphics.fonts.FontFamily$Builder');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontFamily.html#getSize()}
 **/
FontFamily.prototype.getSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontFamily') {
			return new FontFamily(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFont
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontFamily.html#getFont(int)}
 **/
FontFamily.prototype.getFont = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFont',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontFamily') {
			return new FontFamily(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FontFamily;
