/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.fonts.FontStyle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics.fonts');

/**
 * @class android.graphics.fonts.FontStyle
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html}
 **/
var FontStyle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.fonts.FontStyle')) {
		result = arguments[0];
	}
	else {
		result = FontStyle.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FontStyle.prototype = Object.create(SuperClass.prototype);
FontStyle.prototype.constructor = FontStyle;

Object.defineProperty(FontStyle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FontStyle(this.$native.super);
	},
	enumerable: true
});

FontStyle.className = 'android.graphics.fonts.FontStyle';
FontStyle.prototype.className = 'android.graphics.fonts.FontStyle';

// class property
Object.defineProperty(FontStyle, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.fonts.FontStyle');
	},
	enumerable: true,
	configurable: false
});


// Cast
FontStyle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FontStyle(Hyperloop.cast('android.graphics.fonts.FontStyle', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_MEDIUM}
 */
FontStyle.FONT_WEIGHT_MEDIUM = 500;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_SLANT_ITALIC}
 */
FontStyle.FONT_SLANT_ITALIC = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_MAX}
 */
FontStyle.FONT_WEIGHT_MAX = 1000;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_EXTRA_LIGHT}
 */
FontStyle.FONT_WEIGHT_EXTRA_LIGHT = 200;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_NORMAL}
 */
FontStyle.FONT_WEIGHT_NORMAL = 400;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_LIGHT}
 */
FontStyle.FONT_WEIGHT_LIGHT = 300;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_BLACK}
 */
FontStyle.FONT_WEIGHT_BLACK = 900;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_SEMI_BOLD}
 */
FontStyle.FONT_WEIGHT_SEMI_BOLD = 600;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_EXTRA_BOLD}
 */
FontStyle.FONT_WEIGHT_EXTRA_BOLD = 800;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_SLANT_UPRIGHT}
 */
FontStyle.FONT_SLANT_UPRIGHT = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_THIN}
 */
FontStyle.FONT_WEIGHT_THIN = 100;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_MIN}
 */
FontStyle.FONT_WEIGHT_MIN = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#FONT_WEIGHT_BOLD}
 */
FontStyle.FONT_WEIGHT_BOLD = 700;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getWeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#getWeight()}
 **/
FontStyle.prototype.getWeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontStyle') {
			return new FontStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#hashCode()}
 **/
FontStyle.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontStyle') {
			return new FontStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#equals(java.lang.Object)}
 **/
FontStyle.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontStyle') {
			return new FontStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#toString()}
 **/
FontStyle.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontStyle') {
			return new FontStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSlant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/fonts/FontStyle.html#getSlant()}
 **/
FontStyle.prototype.getSlant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSlant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.fonts.FontStyle') {
			return new FontStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FontStyle;
