/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.icu.util.ULocale
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.icu.util');

/**
 * @class android.icu.util.ULocale
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html}
 **/
var ULocale = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.icu.util.ULocale')) {
		result = arguments[0];
	}
	else {
		result = ULocale.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ULocale.prototype = Object.create(SuperClass.prototype);
ULocale.prototype.constructor = ULocale;

Object.defineProperty(ULocale.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ULocale(this.$native.super);
	},
	enumerable: true
});

ULocale.className = 'android.icu.util.ULocale';
ULocale.prototype.className = 'android.icu.util.ULocale';

// class property
Object.defineProperty(ULocale, 'class', {
	get: function() {
		return Hyperloop.getClass('android.icu.util.ULocale');
	},
	enumerable: true,
	configurable: false
});


// Cast
ULocale.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ULocale(Hyperloop.cast('android.icu.util.ULocale', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#PRIVATE_USE_EXTENSION}
 */
ULocale.PRIVATE_USE_EXTENSION = 120;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#UNICODE_LOCALE_EXTENSION}
 */
ULocale.UNICODE_LOCALE_EXTENSION = 117;

// Inner classes
Object.defineProperty(ULocale, 'Builder', {
	get: function() {
		return require('./android.icu.util.ULocale$Builder');
	},
	enumerable: true
});
Object.defineProperty(ULocale, 'Category', {
	get: function() {
		return require('./android.icu.util.ULocale$Category');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/icu/util/ULocale.html#PRC
Object.defineProperty(ULocale, 'PRC', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('PRC');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#CANADA
Object.defineProperty(ULocale, 'CANADA', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CANADA');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#ENGLISH
Object.defineProperty(ULocale, 'ENGLISH', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ENGLISH');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#ROOT
Object.defineProperty(ULocale, 'ROOT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ROOT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#TAIWAN
Object.defineProperty(ULocale, 'TAIWAN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('TAIWAN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#CHINA
Object.defineProperty(ULocale, 'CHINA', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CHINA');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#ITALY
Object.defineProperty(ULocale, 'ITALY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ITALY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#CHINESE
Object.defineProperty(ULocale, 'CHINESE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CHINESE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#KOREA
Object.defineProperty(ULocale, 'KOREA', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('KOREA');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#FRENCH
Object.defineProperty(ULocale, 'FRENCH', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('FRENCH');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#FRANCE
Object.defineProperty(ULocale, 'FRANCE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('FRANCE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#CANADA_FRENCH
Object.defineProperty(ULocale, 'CANADA_FRENCH', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CANADA_FRENCH');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#TRADITIONAL_CHINESE
Object.defineProperty(ULocale, 'TRADITIONAL_CHINESE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('TRADITIONAL_CHINESE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#GERMANY
Object.defineProperty(ULocale, 'GERMANY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('GERMANY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#ITALIAN
Object.defineProperty(ULocale, 'ITALIAN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ITALIAN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#UK
Object.defineProperty(ULocale, 'UK', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('UK');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#JAPAN
Object.defineProperty(ULocale, 'JAPAN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('JAPAN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#JAPANESE
Object.defineProperty(ULocale, 'JAPANESE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('JAPANESE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#SIMPLIFIED_CHINESE
Object.defineProperty(ULocale, 'SIMPLIFIED_CHINESE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SIMPLIFIED_CHINESE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#GERMAN
Object.defineProperty(ULocale, 'GERMAN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('GERMAN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#US
Object.defineProperty(ULocale, 'US', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('US');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/icu/util/ULocale.html#KOREAN
Object.defineProperty(ULocale, 'KOREAN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('KOREAN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.icu.util.ULocale') {
				return new ULocale(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getName
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getName(java.lang.String)}
 **/
ULocale.getName = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getName',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCountry
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getCountry(java.lang.String)}
 **/
ULocale.getCountry = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCountry',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forLanguageTag
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#forLanguageTag(java.lang.String)}
 **/
ULocale.forLanguageTag = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forLanguageTag',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayKeywordValue
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeywordValue(java.lang.String, java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeywordValue(java.lang.String, java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayKeywordValue = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayKeywordValue',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getISO3Country
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getISO3Country(java.lang.String)}
 **/
ULocale.getISO3Country = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getISO3Country',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addLikelySubtags
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#addLikelySubtags(android.icu.util.ULocale)}
 **/
ULocale.addLikelySubtags = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'addLikelySubtags',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayCountry
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayCountry(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayCountry(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayCountry = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayCountry',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getISOCountries
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getISOCountries()}
 **/
ULocale.getISOCountries = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getISOCountries',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getISOLanguages
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getISOLanguages()}
 **/
ULocale.getISOLanguages = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getISOLanguages',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAvailableLocales
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getAvailableLocales()}
 **/
ULocale.getAvailableLocales = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAvailableLocales',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayNameWithDialect
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayNameWithDialect(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayNameWithDialect(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayNameWithDialect = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayNameWithDialect',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVariant
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getVariant(java.lang.String)}
 **/
ULocale.getVariant = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getVariant',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKeywords
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getKeywords(java.lang.String)}
 **/
ULocale.getKeywords = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getKeywords',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minimizeSubtags
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#minimizeSubtags(android.icu.util.ULocale)}
 **/
ULocale.minimizeSubtags = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'minimizeSubtags',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayName
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayName(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayName(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayName = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getScript
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getScript(java.lang.String)}
 **/
ULocale.getScript = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getScript',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toUnicodeLocaleType
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toUnicodeLocaleType(java.lang.String, java.lang.String)}
 **/
ULocale.toUnicodeLocaleType = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'toUnicodeLocaleType',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBaseName
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getBaseName(java.lang.String)}
 **/
ULocale.getBaseName = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getBaseName',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getISO3Language
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getISO3Language(java.lang.String)}
 **/
ULocale.getISO3Language = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getISO3Language',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createCanonical
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#createCanonical(java.lang.String)}
 **/
ULocale.createCanonical = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createCanonical',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKeywordValue
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getKeywordValue(java.lang.String, java.lang.String)}
 **/
ULocale.getKeywordValue = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getKeywordValue',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayVariant
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayVariant(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayVariant(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayVariant = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayVariant',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayLanguageWithDialect
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguageWithDialect(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguageWithDialect(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayLanguageWithDialect = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayLanguageWithDialect',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function canonicalize
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#canonicalize(java.lang.String)}
 **/
ULocale.canonicalize = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'canonicalize',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFallback
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getFallback(java.lang.String)}
 **/
ULocale.getFallback = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getFallback',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayScript
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayScript(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayScript(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayScript = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayScript',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLanguage
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getLanguage(java.lang.String)}
 **/
ULocale.getLanguage = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getLanguage',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayKeyword
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeyword(java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeyword(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeyword(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayKeyword = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayKeyword',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLegacyKey
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toLegacyKey(java.lang.String)}
 **/
ULocale.toLegacyKey = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'toLegacyKey',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDefault
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDefault()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDefault(android.icu.util.ULocale$Category)}
 **/
ULocale.getDefault = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDefault',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forLocale
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#forLocale(java.util.Locale)}
 **/
ULocale.forLocale = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forLocale',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLegacyType
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toLegacyType(java.lang.String, java.lang.String)}
 **/
ULocale.toLegacyType = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'toLegacyType',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function acceptLanguage
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#acceptLanguage(java.lang.String, android.icu.util.ULocale[], boolean[])}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#acceptLanguage(android.icu.util.ULocale[], android.icu.util.ULocale[], boolean[])}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#acceptLanguage(java.lang.String, boolean[])}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#acceptLanguage(android.icu.util.ULocale[], boolean[])}
 **/
ULocale.acceptLanguage = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'acceptLanguage',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toUnicodeLocaleKey
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toUnicodeLocaleKey(java.lang.String)}
 **/
ULocale.toUnicodeLocaleKey = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'toUnicodeLocaleKey',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setKeywordValue
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#setKeywordValue(java.lang.String, java.lang.String, java.lang.String)}
 **/
ULocale.setKeywordValue = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'setKeywordValue',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayLanguage
 * @static
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguage(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguage(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.getDisplayLanguage = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayLanguage',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getName()}
 **/
ULocale.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCountry
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getCountry()}
 **/
ULocale.prototype.getCountry = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCountry',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUnicodeLocaleKeys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getUnicodeLocaleKeys()}
 **/
ULocale.prototype.getUnicodeLocaleKeys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnicodeLocaleKeys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#compareTo(android.icu.util.ULocale)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#compareTo(java.lang.Object)}
 **/
ULocale.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayKeywordValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeywordValue(java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayKeywordValue(java.lang.String, android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayKeywordValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayKeywordValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isRightToLeft
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#isRightToLeft()}
 **/
ULocale.prototype.isRightToLeft = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isRightToLeft',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getISO3Country
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getISO3Country()}
 **/
ULocale.prototype.getISO3Country = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getISO3Country',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayCountry
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayCountry()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayCountry(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayCountry = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayCountry',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtensionKeys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getExtensionKeys()}
 **/
ULocale.prototype.getExtensionKeys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtensionKeys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayNameWithDialect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayNameWithDialect()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayNameWithDialect(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayNameWithDialect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayNameWithDialect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLanguageTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toLanguageTag()}
 **/
ULocale.prototype.toLanguageTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLanguageTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVariant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getVariant()}
 **/
ULocale.prototype.getVariant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVariant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKeywords
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getKeywords()}
 **/
ULocale.prototype.getKeywords = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getKeywords',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayName()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayName(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getScript
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getScript()}
 **/
ULocale.prototype.getScript = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getScript',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUnicodeLocaleType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getUnicodeLocaleType(java.lang.String)}
 **/
ULocale.prototype.getUnicodeLocaleType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnicodeLocaleType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUnicodeLocaleAttributes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getUnicodeLocaleAttributes()}
 **/
ULocale.prototype.getUnicodeLocaleAttributes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnicodeLocaleAttributes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBaseName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getBaseName()}
 **/
ULocale.prototype.getBaseName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBaseName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCharacterOrientation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getCharacterOrientation()}
 **/
ULocale.prototype.getCharacterOrientation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCharacterOrientation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getISO3Language
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getISO3Language()}
 **/
ULocale.prototype.getISO3Language = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getISO3Language',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKeywordValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getKeywordValue(java.lang.String)}
 **/
ULocale.prototype.getKeywordValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getKeywordValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#hashCode()}
 **/
ULocale.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayVariant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayVariant()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayVariant(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayVariant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayVariant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayLanguageWithDialect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguageWithDialect()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguageWithDialect(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayLanguageWithDialect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayLanguageWithDialect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getFallback()}
 **/
ULocale.prototype.getFallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayScript
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayScript()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayScript(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayScript = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayScript',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocale
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toLocale()}
 **/
ULocale.prototype.toLocale = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocale',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLanguage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getLanguage()}
 **/
ULocale.prototype.getLanguage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLanguage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtension
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getExtension(char)}
 **/
ULocale.prototype.getExtension = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtension',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLineOrientation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getLineOrientation()}
 **/
ULocale.prototype.getLineOrientation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLineOrientation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#equals(java.lang.Object)}
 **/
ULocale.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#clone()}
 **/
ULocale.prototype.clone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setKeywordValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#setKeywordValue(java.lang.String, java.lang.String)}
 **/
ULocale.prototype.setKeywordValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setKeywordValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#toString()}
 **/
ULocale.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayLanguage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguage()}
 * @see {@link http://developer.android.com/reference/android/icu/util/ULocale.html#getDisplayLanguage(android.icu.util.ULocale)}
 **/
ULocale.prototype.getDisplayLanguage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayLanguage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.icu.util.ULocale') {
			return new ULocale(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ULocale;
