/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.session.MediaSession$Callback
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.session.MediaSession');

/**
 * @class android.media.session.MediaSession$Callback
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html}
 **/
var Callback = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.session.MediaSession$Callback')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.media.session.MediaSession$Callback. Create a subclass using android.media.session.MediaSession$Callback.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Callback.prototype = Object.create(SuperClass.prototype);
Callback.prototype.constructor = Callback;

Object.defineProperty(Callback.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Callback(this.$native.super);
	},
	enumerable: true
});

Callback.className = 'android.media.session.MediaSession$Callback';
Callback.prototype.className = 'android.media.session.MediaSession$Callback';

// class property
Object.defineProperty(Callback, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.session.MediaSession$Callback');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Callback.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.media.session.MediaSession$Callback');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Callback.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Callback.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Callback(Hyperloop.cast('android.media.session.MediaSession$Callback', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onSkipToPrevious
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onSkipToPrevious()}
 **/
Callback.prototype.onSkipToPrevious = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSkipToPrevious',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSeekTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onSeekTo(long)}
 **/
Callback.prototype.onSeekTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSeekTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepare
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPrepare()}
 **/
Callback.prototype.onPrepare = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepare',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCommand
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onCommand(java.lang.String, android.os.Bundle, android.os.ResultReceiver)}
 **/
Callback.prototype.onCommand = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCommand',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSkipToQueueItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onSkipToQueueItem(long)}
 **/
Callback.prototype.onSkipToQueueItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSkipToQueueItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onFastForward
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onFastForward()}
 **/
Callback.prototype.onFastForward = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onFastForward',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPlayFromMediaId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPlayFromMediaId(java.lang.String, android.os.Bundle)}
 **/
Callback.prototype.onPlayFromMediaId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPlayFromMediaId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPause()}
 **/
Callback.prototype.onPause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSetRating
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onSetRating(android.media.Rating)}
 **/
Callback.prototype.onSetRating = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSetRating',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSetPlaybackSpeed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onSetPlaybackSpeed(float)}
 **/
Callback.prototype.onSetPlaybackSpeed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSetPlaybackSpeed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPlay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPlay()}
 **/
Callback.prototype.onPlay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPlay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPlayFromUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPlayFromUri(android.net.Uri, android.os.Bundle)}
 **/
Callback.prototype.onPlayFromUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPlayFromUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSkipToNext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onSkipToNext()}
 **/
Callback.prototype.onSkipToNext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSkipToNext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepareFromUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPrepareFromUri(android.net.Uri, android.os.Bundle)}
 **/
Callback.prototype.onPrepareFromUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareFromUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPlayFromSearch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPlayFromSearch(java.lang.String, android.os.Bundle)}
 **/
Callback.prototype.onPlayFromSearch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPlayFromSearch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepareFromMediaId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPrepareFromMediaId(java.lang.String, android.os.Bundle)}
 **/
Callback.prototype.onPrepareFromMediaId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareFromMediaId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRewind
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onRewind()}
 **/
Callback.prototype.onRewind = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRewind',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onStop()}
 **/
Callback.prototype.onStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMediaButtonEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onMediaButtonEvent(android.content.Intent)}
 **/
Callback.prototype.onMediaButtonEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMediaButtonEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepareFromSearch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onPrepareFromSearch(java.lang.String, android.os.Bundle)}
 **/
Callback.prototype.onPrepareFromSearch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareFromSearch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCustomAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.Callback.html#onCustomAction(java.lang.String, android.os.Bundle)}
 **/
Callback.prototype.onCustomAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCustomAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Callback;
