/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.os.VibrationEffect$Composition
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.os.VibrationEffect');

/**
 * @class android.os.VibrationEffect$Composition
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html}
 **/
var Composition = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.os.VibrationEffect$Composition')) {
		result = arguments[0];
	}
	else {
		result = Composition.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Composition.prototype = Object.create(SuperClass.prototype);
Composition.prototype.constructor = Composition;

Object.defineProperty(Composition.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Composition(this.$native.super);
	},
	enumerable: true
});

Composition.className = 'android.os.VibrationEffect$Composition';
Composition.prototype.className = 'android.os.VibrationEffect$Composition';

// class property
Object.defineProperty(Composition, 'class', {
	get: function() {
		return Hyperloop.getClass('android.os.VibrationEffect$Composition');
	},
	enumerable: true,
	configurable: false
});


// Cast
Composition.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Composition(Hyperloop.cast('android.os.VibrationEffect$Composition', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#PRIMITIVE_QUICK_FALL}
 */
Composition.PRIMITIVE_QUICK_FALL = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#PRIMITIVE_SLOW_RISE}
 */
Composition.PRIMITIVE_SLOW_RISE = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#PRIMITIVE_QUICK_RISE}
 */
Composition.PRIMITIVE_QUICK_RISE = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#PRIMITIVE_TICK}
 */
Composition.PRIMITIVE_TICK = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#PRIMITIVE_CLICK}
 */
Composition.PRIMITIVE_CLICK = 1;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function compose
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#compose()}
 **/
Composition.prototype.compose = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compose',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.VibrationEffect$Composition') {
			return new Composition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addPrimitive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#addPrimitive(int)}
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#addPrimitive(int, float)}
 * @see {@link http://developer.android.com/reference/android/os/VibrationEffect.Composition.html#addPrimitive(int, float, int)}
 **/
Composition.prototype.addPrimitive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addPrimitive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.VibrationEffect$Composition') {
			return new Composition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Composition;
