/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.text.PrecomputedText$Params
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.text.PrecomputedText');

/**
 * @class android.text.PrecomputedText$Params
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html}
 **/
var Params = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.text.PrecomputedText$Params')) {
		result = arguments[0];
	}
	else {
		result = Params.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Params.prototype = Object.create(SuperClass.prototype);
Params.prototype.constructor = Params;

Object.defineProperty(Params.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Params(this.$native.super);
	},
	enumerable: true
});

Params.className = 'android.text.PrecomputedText$Params';
Params.prototype.className = 'android.text.PrecomputedText$Params';

// class property
Object.defineProperty(Params, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.PrecomputedText$Params');
	},
	enumerable: true,
	configurable: false
});


// Cast
Params.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Params(Hyperloop.cast('android.text.PrecomputedText$Params', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(Params, 'Builder', {
	get: function() {
		return require('./android.text.PrecomputedText$Params$Builder');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getHyphenationFrequency
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#getHyphenationFrequency()}
 **/
Params.prototype.getHyphenationFrequency = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHyphenationFrequency',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTextPaint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#getTextPaint()}
 **/
Params.prototype.getTextPaint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextPaint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#hashCode()}
 **/
Params.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#equals(java.lang.Object)}
 **/
Params.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBreakStrategy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#getBreakStrategy()}
 **/
Params.prototype.getBreakStrategy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBreakStrategy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#toString()}
 **/
Params.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTextDirection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.Params.html#getTextDirection()}
 **/
Params.prototype.getTextDirection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextDirection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText$Params') {
			return new Params(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Params;
