/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.text.PrecomputedText
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.text');

/**
 * @class android.text.PrecomputedText
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html}
 **/
var PrecomputedText = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.text.PrecomputedText')) {
		result = arguments[0];
	}
	else {
		result = PrecomputedText.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
PrecomputedText.prototype = Object.create(SuperClass.prototype);
PrecomputedText.prototype.constructor = PrecomputedText;

Object.defineProperty(PrecomputedText.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PrecomputedText(this.$native.super);
	},
	enumerable: true
});

PrecomputedText.className = 'android.text.PrecomputedText';
PrecomputedText.prototype.className = 'android.text.PrecomputedText';

// class property
Object.defineProperty(PrecomputedText, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.PrecomputedText');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
PrecomputedText.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.text.PrecomputedText');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(PrecomputedText.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
PrecomputedText.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PrecomputedText(Hyperloop.cast('android.text.PrecomputedText', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(PrecomputedText, 'Params', {
	get: function() {
		return require('./android.text.PrecomputedText$Params');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function create
 * @static
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#create(java.lang.CharSequence, android.text.PrecomputedText$Params)}
 **/
PrecomputedText.create = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'create',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getParagraphCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getParagraphCount()}
 **/
PrecomputedText.prototype.getParagraphCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParagraphCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function length
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#length()}
 **/
PrecomputedText.prototype.length = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'length',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpanStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getSpanStart(java.lang.Object)}
 **/
PrecomputedText.prototype.getSpanStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpanFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getSpanFlags(java.lang.Object)}
 **/
PrecomputedText.prototype.getSpanFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getWidth(int, int)}
 **/
PrecomputedText.prototype.getWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function subSequence
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#subSequence(int, int)}
 **/
PrecomputedText.prototype.subSequence = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'subSequence',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getBounds(int, int, android.graphics.Rect)}
 **/
PrecomputedText.prototype.getBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextSpanTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#nextSpanTransition(int, int, java.lang.Class)}
 **/
PrecomputedText.prototype.nextSpanTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextSpanTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParagraphStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getParagraphStart(int)}
 **/
PrecomputedText.prototype.getParagraphStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParagraphStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeSpan
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#removeSpan(java.lang.Object)}
 **/
PrecomputedText.prototype.removeSpan = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeSpan',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpans
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getSpans(int, int, java.lang.Class)}
 **/
PrecomputedText.prototype.getSpans = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpans',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParagraphEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getParagraphEnd(int)}
 **/
PrecomputedText.prototype.getParagraphEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParagraphEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpanEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getSpanEnd(java.lang.Object)}
 **/
PrecomputedText.prototype.getSpanEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#toString()}
 **/
PrecomputedText.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSpan
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#setSpan(java.lang.Object, int, int, int)}
 **/
PrecomputedText.prototype.setSpan = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSpan',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#getParams()}
 **/
PrecomputedText.prototype.getParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function charAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/PrecomputedText.html#charAt(int)}
 **/
PrecomputedText.prototype.charAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'charAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.PrecomputedText') {
			return new PrecomputedText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PrecomputedText;
