/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.text.TextPaint
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.text');

/**
 * @class android.text.TextPaint
 * @extends android.graphics.Paint 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/text/TextPaint.html}
 **/
var TextPaint = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.text.TextPaint')) {
		result = arguments[0];
	}
	else {
		result = TextPaint.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.graphics.Paint');
TextPaint.prototype = Object.create(SuperClass.prototype);
TextPaint.prototype.constructor = TextPaint;

Object.defineProperty(TextPaint.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextPaint(this.$native.super);
	},
	enumerable: true
});

TextPaint.className = 'android.text.TextPaint';
TextPaint.prototype.className = 'android.text.TextPaint';

// class property
Object.defineProperty(TextPaint, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.TextPaint');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TextPaint.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.text.TextPaint');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TextPaint.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TextPaint.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextPaint(Hyperloop.cast('android.text.TextPaint', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/android/text/TextPaint.html#bgColor
Object.defineProperty(TextPaint.prototype, 'bgColor', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('bgColor');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('bgColor', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/text/TextPaint.html#density
Object.defineProperty(TextPaint.prototype, 'density', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('density');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('density', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/text/TextPaint.html#underlineColor
Object.defineProperty(TextPaint.prototype, 'underlineColor', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('underlineColor');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('underlineColor', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/text/TextPaint.html#underlineThickness
Object.defineProperty(TextPaint.prototype, 'underlineThickness', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('underlineThickness');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('underlineThickness', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/text/TextPaint.html#drawableState
Object.defineProperty(TextPaint.prototype, 'drawableState', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('drawableState');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('drawableState', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/text/TextPaint.html#linkColor
Object.defineProperty(TextPaint.prototype, 'linkColor', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('linkColor');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('linkColor', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/text/TextPaint.html#baselineShift
Object.defineProperty(TextPaint.prototype, 'baselineShift', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('baselineShift');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextPaint') {
				return new TextPaint(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('baselineShift', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function set
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/TextPaint.html#set(android.text.TextPaint)}
 **/
TextPaint.prototype.set = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'set',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextPaint') {
			return new TextPaint(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUnderlineThickness
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/TextPaint.html#getUnderlineThickness()}
 **/
TextPaint.prototype.getUnderlineThickness = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnderlineThickness',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextPaint') {
			return new TextPaint(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TextPaint;
