/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.DisplayCutout
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.DisplayCutout
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html}
 **/
var DisplayCutout = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.DisplayCutout')) {
		result = arguments[0];
	}
	else {
		result = DisplayCutout.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
DisplayCutout.prototype = Object.create(SuperClass.prototype);
DisplayCutout.prototype.constructor = DisplayCutout;

Object.defineProperty(DisplayCutout.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DisplayCutout(this.$native.super);
	},
	enumerable: true
});

DisplayCutout.className = 'android.view.DisplayCutout';
DisplayCutout.prototype.className = 'android.view.DisplayCutout';

// class property
Object.defineProperty(DisplayCutout, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.DisplayCutout');
	},
	enumerable: true,
	configurable: false
});


// Cast
DisplayCutout.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DisplayCutout(Hyperloop.cast('android.view.DisplayCutout', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSafeInsetBottom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getSafeInsetBottom()}
 **/
DisplayCutout.prototype.getSafeInsetBottom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSafeInsetBottom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoundingRectRight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getBoundingRectRight()}
 **/
DisplayCutout.prototype.getBoundingRectRight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoundingRectRight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoundingRects
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getBoundingRects()}
 **/
DisplayCutout.prototype.getBoundingRects = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoundingRects',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSafeInsetTop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getSafeInsetTop()}
 **/
DisplayCutout.prototype.getSafeInsetTop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSafeInsetTop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoundingRectTop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getBoundingRectTop()}
 **/
DisplayCutout.prototype.getBoundingRectTop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoundingRectTop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoundingRectBottom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getBoundingRectBottom()}
 **/
DisplayCutout.prototype.getBoundingRectBottom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoundingRectBottom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWaterfallInsets
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getWaterfallInsets()}
 **/
DisplayCutout.prototype.getWaterfallInsets = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWaterfallInsets',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSafeInsetLeft
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getSafeInsetLeft()}
 **/
DisplayCutout.prototype.getSafeInsetLeft = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSafeInsetLeft',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoundingRectLeft
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getBoundingRectLeft()}
 **/
DisplayCutout.prototype.getBoundingRectLeft = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoundingRectLeft',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#hashCode()}
 **/
DisplayCutout.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#equals(java.lang.Object)}
 **/
DisplayCutout.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#toString()}
 **/
DisplayCutout.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSafeInsetRight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/DisplayCutout.html#getSafeInsetRight()}
 **/
DisplayCutout.prototype.getSafeInsetRight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSafeInsetRight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.DisplayCutout') {
			return new DisplayCutout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DisplayCutout;
