/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.GestureDetector
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.GestureDetector
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html}
 **/
var GestureDetector = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.GestureDetector')) {
		result = arguments[0];
	}
	else {
		result = GestureDetector.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
GestureDetector.prototype = Object.create(SuperClass.prototype);
GestureDetector.prototype.constructor = GestureDetector;

Object.defineProperty(GestureDetector.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GestureDetector(this.$native.super);
	},
	enumerable: true
});

GestureDetector.className = 'android.view.GestureDetector';
GestureDetector.prototype.className = 'android.view.GestureDetector';

// class property
Object.defineProperty(GestureDetector, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.GestureDetector');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GestureDetector.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.GestureDetector');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GestureDetector.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GestureDetector.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GestureDetector(Hyperloop.cast('android.view.GestureDetector', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(GestureDetector, 'OnGestureListener', {
	get: function() {
		return require('./android.view.GestureDetector$OnGestureListener');
	},
	enumerable: true
});
Object.defineProperty(GestureDetector, 'OnDoubleTapListener', {
	get: function() {
		return require('./android.view.GestureDetector$OnDoubleTapListener');
	},
	enumerable: true
});
Object.defineProperty(GestureDetector, 'OnContextClickListener', {
	get: function() {
		return require('./android.view.GestureDetector$OnContextClickListener');
	},
	enumerable: true
});
Object.defineProperty(GestureDetector, 'SimpleOnGestureListener', {
	get: function() {
		return require('./android.view.GestureDetector$SimpleOnGestureListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setOnDoubleTapListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html#setOnDoubleTapListener(android.view.GestureDetector$OnDoubleTapListener)}
 **/
GestureDetector.prototype.setOnDoubleTapListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnDoubleTapListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.GestureDetector') {
			return new GestureDetector(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isLongpressEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html#isLongpressEnabled()}
 **/
GestureDetector.prototype.isLongpressEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLongpressEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.GestureDetector') {
			return new GestureDetector(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html#onTouchEvent(android.view.MotionEvent)}
 **/
GestureDetector.prototype.onTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.GestureDetector') {
			return new GestureDetector(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onGenericMotionEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html#onGenericMotionEvent(android.view.MotionEvent)}
 **/
GestureDetector.prototype.onGenericMotionEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onGenericMotionEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.GestureDetector') {
			return new GestureDetector(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContextClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html#setContextClickListener(android.view.GestureDetector$OnContextClickListener)}
 **/
GestureDetector.prototype.setContextClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContextClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.GestureDetector') {
			return new GestureDetector(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIsLongpressEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/GestureDetector.html#setIsLongpressEnabled(boolean)}
 **/
GestureDetector.prototype.setIsLongpressEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIsLongpressEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.GestureDetector') {
			return new GestureDetector(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GestureDetector;
