/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.WindowInsetsAnimation
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.WindowInsetsAnimation
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html}
 **/
var WindowInsetsAnimation = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.WindowInsetsAnimation')) {
		result = arguments[0];
	}
	else {
		result = WindowInsetsAnimation.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
WindowInsetsAnimation.prototype = Object.create(SuperClass.prototype);
WindowInsetsAnimation.prototype.constructor = WindowInsetsAnimation;

Object.defineProperty(WindowInsetsAnimation.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new WindowInsetsAnimation(this.$native.super);
	},
	enumerable: true
});

WindowInsetsAnimation.className = 'android.view.WindowInsetsAnimation';
WindowInsetsAnimation.prototype.className = 'android.view.WindowInsetsAnimation';

// class property
Object.defineProperty(WindowInsetsAnimation, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.WindowInsetsAnimation');
	},
	enumerable: true,
	configurable: false
});


// Cast
WindowInsetsAnimation.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new WindowInsetsAnimation(Hyperloop.cast('android.view.WindowInsetsAnimation', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(WindowInsetsAnimation, 'Callback', {
	get: function() {
		return require('./android.view.WindowInsetsAnimation$Callback');
	},
	enumerable: true
});
Object.defineProperty(WindowInsetsAnimation, 'Bounds', {
	get: function() {
		return require('./android.view.WindowInsetsAnimation$Bounds');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setFraction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#setFraction(float)}
 **/
WindowInsetsAnimation.prototype.setFraction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFraction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInterpolatedFraction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#getInterpolatedFraction()}
 **/
WindowInsetsAnimation.prototype.getInterpolatedFraction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterpolatedFraction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDurationMillis
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#getDurationMillis()}
 **/
WindowInsetsAnimation.prototype.getDurationMillis = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDurationMillis',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInterpolator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#getInterpolator()}
 **/
WindowInsetsAnimation.prototype.getInterpolator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterpolator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#setAlpha(float)}
 **/
WindowInsetsAnimation.prototype.setAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTypeMask
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#getTypeMask()}
 **/
WindowInsetsAnimation.prototype.getTypeMask = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTypeMask',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFraction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#getFraction()}
 **/
WindowInsetsAnimation.prototype.getFraction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFraction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.html#getAlpha()}
 **/
WindowInsetsAnimation.prototype.getAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation') {
			return new WindowInsetsAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = WindowInsetsAnimation;
