/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module WindowInsetsController
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * constructor
 * http://developer.android.com/reference/android/view/WindowInsetsController.html
 **/
var WindowInsetsController = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.view.WindowInsetsController') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.view.WindowInsetsController');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
WindowInsetsController.prototype = Object.create(SuperClass.prototype);
WindowInsetsController.prototype.constructor = WindowInsetsController;

Object.defineProperty(WindowInsetsController.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new WindowInsetsController(this.$native.super);
	},
	enumerable: true
});

WindowInsetsController.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

WindowInsetsController.className = "android.view.WindowInsetsController";
WindowInsetsController.prototype.className = "android.view.WindowInsetsController";

// class property
Object.defineProperty(WindowInsetsController, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.WindowInsetsController');
	},
	enumerable: true,
	configurable: false
});

// Cast
WindowInsetsController.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new WindowInsetsController(Hyperloop.cast('android.view.WindowInsetsController', object.$native));
};

// Constants
// http://developer.android.com/reference/android/view/WindowInsetsController.html#BEHAVIOR_SHOW_TRANSIENT_BARS_BY_SWIPE
WindowInsetsController.BEHAVIOR_SHOW_TRANSIENT_BARS_BY_SWIPE = 2;
// http://developer.android.com/reference/android/view/WindowInsetsController.html#APPEARANCE_LIGHT_NAVIGATION_BARS
WindowInsetsController.APPEARANCE_LIGHT_NAVIGATION_BARS = 16;
// http://developer.android.com/reference/android/view/WindowInsetsController.html#APPEARANCE_LIGHT_STATUS_BARS
WindowInsetsController.APPEARANCE_LIGHT_STATUS_BARS = 8;
// http://developer.android.com/reference/android/view/WindowInsetsController.html#BEHAVIOR_SHOW_BARS_BY_SWIPE
WindowInsetsController.BEHAVIOR_SHOW_BARS_BY_SWIPE = 1;
// http://developer.android.com/reference/android/view/WindowInsetsController.html#BEHAVIOR_SHOW_BARS_BY_TOUCH
WindowInsetsController.BEHAVIOR_SHOW_BARS_BY_TOUCH = 0;

// Static methods

// Instance methods
/**
 * @function hide
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#hide(int)}
 **/
WindowInsetsController.prototype.hide = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hide',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function addOnControllableInsetsChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#addOnControllableInsetsChangedListener(android.view.WindowInsetsController$OnControllableInsetsChangedListener)}
 **/
WindowInsetsController.prototype.addOnControllableInsetsChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnControllableInsetsChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setSystemBarsBehavior
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#setSystemBarsBehavior(int)}
 **/
WindowInsetsController.prototype.setSystemBarsBehavior = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSystemBarsBehavior',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function show
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#show(int)}
 **/
WindowInsetsController.prototype.show = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'show',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setSystemBarsAppearance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#setSystemBarsAppearance(int, int)}
 **/
WindowInsetsController.prototype.setSystemBarsAppearance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSystemBarsAppearance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSystemBarsBehavior
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#getSystemBarsBehavior()}
 **/
WindowInsetsController.prototype.getSystemBarsBehavior = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSystemBarsBehavior',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function removeOnControllableInsetsChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#removeOnControllableInsetsChangedListener(android.view.WindowInsetsController$OnControllableInsetsChangedListener)}
 **/
WindowInsetsController.prototype.removeOnControllableInsetsChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeOnControllableInsetsChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function controlWindowInsetsAnimation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#controlWindowInsetsAnimation(int, long, android.view.animation.Interpolator, android.os.CancellationSignal, android.view.WindowInsetsAnimationControlListener)}
 **/
WindowInsetsController.prototype.controlWindowInsetsAnimation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'controlWindowInsetsAnimation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSystemBarsAppearance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsController.html#getSystemBarsAppearance()}
 **/
WindowInsetsController.prototype.getSystemBarsAppearance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSystemBarsAppearance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsController') {
			return new WindowInsetsController(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

WindowInsetsController.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

WindowInsetsController.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = WindowInsetsController;
