/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module AccessibilityStateChangeListener
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.view.accessibility.AccessibilityManager');

/**
 * constructor
 * http://developer.android.com/reference/android/view/accessibility/AccessibilityManager.AccessibilityStateChangeListener.html
 **/
var AccessibilityStateChangeListener = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
AccessibilityStateChangeListener.prototype = Object.create(SuperClass.prototype);
AccessibilityStateChangeListener.prototype.constructor = AccessibilityStateChangeListener;

Object.defineProperty(AccessibilityStateChangeListener.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityStateChangeListener(this.$native.super);
	},
	enumerable: true
});

AccessibilityStateChangeListener.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

AccessibilityStateChangeListener.className = "android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener";
AccessibilityStateChangeListener.prototype.className = "android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener";

// class property
Object.defineProperty(AccessibilityStateChangeListener, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener');
	},
	enumerable: true,
	configurable: false
});

// Cast
AccessibilityStateChangeListener.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityStateChangeListener(Hyperloop.cast('android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function onAccessibilityStateChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/accessibility/AccessibilityManager.AccessibilityStateChangeListener.html#onAccessibilityStateChanged(boolean)}
 **/
AccessibilityStateChangeListener.prototype.onAccessibilityStateChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAccessibilityStateChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.accessibility.AccessibilityManager$AccessibilityStateChangeListener') {
			return new AccessibilityStateChangeListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

AccessibilityStateChangeListener.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

AccessibilityStateChangeListener.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = AccessibilityStateChangeListener;
