/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.accessibility.AccessibilityRequestPreparer
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.accessibility');

/**
 * @class android.view.accessibility.AccessibilityRequestPreparer
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/accessibility/AccessibilityRequestPreparer.html}
 **/
var AccessibilityRequestPreparer = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.accessibility.AccessibilityRequestPreparer')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.view.accessibility.AccessibilityRequestPreparer. Create a subclass using android.view.accessibility.AccessibilityRequestPreparer.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AccessibilityRequestPreparer.prototype = Object.create(SuperClass.prototype);
AccessibilityRequestPreparer.prototype.constructor = AccessibilityRequestPreparer;

Object.defineProperty(AccessibilityRequestPreparer.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityRequestPreparer(this.$native.super);
	},
	enumerable: true
});

AccessibilityRequestPreparer.className = 'android.view.accessibility.AccessibilityRequestPreparer';
AccessibilityRequestPreparer.prototype.className = 'android.view.accessibility.AccessibilityRequestPreparer';

// class property
Object.defineProperty(AccessibilityRequestPreparer, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.accessibility.AccessibilityRequestPreparer');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AccessibilityRequestPreparer.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.accessibility.AccessibilityRequestPreparer');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AccessibilityRequestPreparer.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AccessibilityRequestPreparer.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityRequestPreparer(Hyperloop.cast('android.view.accessibility.AccessibilityRequestPreparer', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/accessibility/AccessibilityRequestPreparer.html#REQUEST_TYPE_EXTRA_DATA}
 */
AccessibilityRequestPreparer.REQUEST_TYPE_EXTRA_DATA = 1;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onPrepareExtraData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/accessibility/AccessibilityRequestPreparer.html#onPrepareExtraData(int, java.lang.String, android.os.Bundle, android.os.Message)}
 **/
AccessibilityRequestPreparer.prototype.onPrepareExtraData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareExtraData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.accessibility.AccessibilityRequestPreparer') {
			return new AccessibilityRequestPreparer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/accessibility/AccessibilityRequestPreparer.html#getView()}
 **/
AccessibilityRequestPreparer.prototype.getView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.accessibility.AccessibilityRequestPreparer') {
			return new AccessibilityRequestPreparer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityRequestPreparer;
