/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.textclassifier.ConversationActions
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.textclassifier');

/**
 * @class android.view.textclassifier.ConversationActions
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/ConversationActions.html}
 **/
var ConversationActions = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.textclassifier.ConversationActions')) {
		result = arguments[0];
	}
	else {
		result = ConversationActions.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ConversationActions.prototype = Object.create(SuperClass.prototype);
ConversationActions.prototype.constructor = ConversationActions;

Object.defineProperty(ConversationActions.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ConversationActions(this.$native.super);
	},
	enumerable: true
});

ConversationActions.className = 'android.view.textclassifier.ConversationActions';
ConversationActions.prototype.className = 'android.view.textclassifier.ConversationActions';

// class property
Object.defineProperty(ConversationActions, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.ConversationActions');
	},
	enumerable: true,
	configurable: false
});


// Cast
ConversationActions.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ConversationActions(Hyperloop.cast('android.view.textclassifier.ConversationActions', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ConversationActions, 'Message', {
	get: function() {
		return require('./android.view.textclassifier.ConversationActions$Message');
	},
	enumerable: true
});
Object.defineProperty(ConversationActions, 'Request', {
	get: function() {
		return require('./android.view.textclassifier.ConversationActions$Request');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/textclassifier/ConversationActions.html#CREATOR
Object.defineProperty(ConversationActions, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.textclassifier.ConversationActions') {
				return new ConversationActions(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getConversationActions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/ConversationActions.html#getConversationActions()}
 **/
ConversationActions.prototype.getConversationActions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getConversationActions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.ConversationActions') {
			return new ConversationActions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/ConversationActions.html#getId()}
 **/
ConversationActions.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.ConversationActions') {
			return new ConversationActions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/ConversationActions.html#describeContents()}
 **/
ConversationActions.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.ConversationActions') {
			return new ConversationActions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/ConversationActions.html#writeToParcel(android.os.Parcel, int)}
 **/
ConversationActions.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.ConversationActions') {
			return new ConversationActions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ConversationActions;
