/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.textclassifier.SelectionEvent
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.textclassifier');

/**
 * @class android.view.textclassifier.SelectionEvent
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html}
 **/
var SelectionEvent = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.textclassifier.SelectionEvent')) {
		result = arguments[0];
	}
	else {
		result = SelectionEvent.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
SelectionEvent.prototype = Object.create(SuperClass.prototype);
SelectionEvent.prototype.constructor = SelectionEvent;

Object.defineProperty(SelectionEvent.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SelectionEvent(this.$native.super);
	},
	enumerable: true
});

SelectionEvent.className = 'android.view.textclassifier.SelectionEvent';
SelectionEvent.prototype.className = 'android.view.textclassifier.SelectionEvent';

// class property
Object.defineProperty(SelectionEvent, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.SelectionEvent');
	},
	enumerable: true,
	configurable: false
});


// Cast
SelectionEvent.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SelectionEvent(Hyperloop.cast('android.view.textclassifier.SelectionEvent', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#INVOCATION_LINK}
 */
SelectionEvent.INVOCATION_LINK = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_SELECT_ALL}
 */
SelectionEvent.ACTION_SELECT_ALL = 200;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#EVENT_SMART_SELECTION_MULTI}
 */
SelectionEvent.EVENT_SMART_SELECTION_MULTI = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_CUT}
 */
SelectionEvent.ACTION_CUT = 103;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#INVOCATION_MANUAL}
 */
SelectionEvent.INVOCATION_MANUAL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_DRAG}
 */
SelectionEvent.ACTION_DRAG = 106;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_OVERTYPE}
 */
SelectionEvent.ACTION_OVERTYPE = 100;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#EVENT_SMART_SELECTION_SINGLE}
 */
SelectionEvent.EVENT_SMART_SELECTION_SINGLE = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_COPY}
 */
SelectionEvent.ACTION_COPY = 101;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#EVENT_SELECTION_STARTED}
 */
SelectionEvent.EVENT_SELECTION_STARTED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_SMART_SHARE}
 */
SelectionEvent.ACTION_SMART_SHARE = 105;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_ABANDON}
 */
SelectionEvent.ACTION_ABANDON = 107;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_RESET}
 */
SelectionEvent.ACTION_RESET = 201;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_SHARE}
 */
SelectionEvent.ACTION_SHARE = 104;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_OTHER}
 */
SelectionEvent.ACTION_OTHER = 108;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#EVENT_SELECTION_MODIFIED}
 */
SelectionEvent.EVENT_SELECTION_MODIFIED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#EVENT_AUTO_SELECTION}
 */
SelectionEvent.EVENT_AUTO_SELECTION = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#INVOCATION_UNKNOWN}
 */
SelectionEvent.INVOCATION_UNKNOWN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#ACTION_PASTE}
 */
SelectionEvent.ACTION_PASTE = 102;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#CREATOR
Object.defineProperty(SelectionEvent, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
				return new SelectionEvent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function createSelectionStartedEvent
 * @static
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#createSelectionStartedEvent(int, int)}
 **/
SelectionEvent.createSelectionStartedEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createSelectionStartedEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isTerminal
 * @static
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#isTerminal(int)}
 **/
SelectionEvent.isTerminal = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isTerminal',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createSelectionActionEvent
 * @static
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#createSelectionActionEvent(int, int, int)}
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#createSelectionActionEvent(int, int, int, android.view.textclassifier.TextClassification)}
 **/
SelectionEvent.createSelectionActionEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createSelectionActionEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createSelectionModifiedEvent
 * @static
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#createSelectionModifiedEvent(int, int)}
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#createSelectionModifiedEvent(int, int, android.view.textclassifier.TextClassification)}
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#createSelectionModifiedEvent(int, int, android.view.textclassifier.TextSelection)}
 **/
SelectionEvent.createSelectionModifiedEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createSelectionModifiedEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getWidgetVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getWidgetVersion()}
 **/
SelectionEvent.prototype.getWidgetVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidgetVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSmartEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getSmartEnd()}
 **/
SelectionEvent.prototype.getSmartEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSmartEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getStart()}
 **/
SelectionEvent.prototype.getStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#hashCode()}
 **/
SelectionEvent.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResultId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getResultId()}
 **/
SelectionEvent.prototype.getResultId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResultId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDurationSincePreviousEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getDurationSincePreviousEvent()}
 **/
SelectionEvent.prototype.getDurationSincePreviousEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDurationSincePreviousEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getEventTime()}
 **/
SelectionEvent.prototype.getEventTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWidgetType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getWidgetType()}
 **/
SelectionEvent.prototype.getWidgetType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidgetType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDurationSinceSessionStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getDurationSinceSessionStart()}
 **/
SelectionEvent.prototype.getDurationSinceSessionStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDurationSinceSessionStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEntityType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getEntityType()}
 **/
SelectionEvent.prototype.getEntityType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEntityType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInvocationMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getInvocationMethod()}
 **/
SelectionEvent.prototype.getInvocationMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInvocationMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#describeContents()}
 **/
SelectionEvent.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getEnd()}
 **/
SelectionEvent.prototype.getEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getEventType()}
 **/
SelectionEvent.prototype.getEventType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#equals(java.lang.Object)}
 **/
SelectionEvent.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getEventIndex()}
 **/
SelectionEvent.prototype.getEventIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#toString()}
 **/
SelectionEvent.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getPackageName()}
 **/
SelectionEvent.prototype.getPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSmartStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getSmartStart()}
 **/
SelectionEvent.prototype.getSmartStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSmartStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#getSessionId()}
 **/
SelectionEvent.prototype.getSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/SelectionEvent.html#writeToParcel(android.os.Parcel, int)}
 **/
SelectionEvent.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.SelectionEvent') {
			return new SelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SelectionEvent;
