/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module TextClassifier
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.textclassifier');

/**
 * constructor
 * http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html
 **/
var TextClassifier = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.view.textclassifier.TextClassifier') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.view.textclassifier.TextClassifier');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
TextClassifier.prototype = Object.create(SuperClass.prototype);
TextClassifier.prototype.constructor = TextClassifier;

Object.defineProperty(TextClassifier.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextClassifier(this.$native.super);
	},
	enumerable: true
});

TextClassifier.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

TextClassifier.className = "android.view.textclassifier.TextClassifier";
TextClassifier.prototype.className = "android.view.textclassifier.TextClassifier";

// class property
Object.defineProperty(TextClassifier, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.TextClassifier');
	},
	enumerable: true,
	configurable: false
});

// Cast
TextClassifier.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextClassifier(Hyperloop.cast('android.view.textclassifier.TextClassifier', object.$native));
};

// Constants
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_TEXTVIEW
TextClassifier.WIDGET_TYPE_TEXTVIEW = "textview";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_EDIT_WEBVIEW
TextClassifier.WIDGET_TYPE_EDIT_WEBVIEW = "edit-webview";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_UNSELECTABLE_TEXTVIEW
TextClassifier.WIDGET_TYPE_UNSELECTABLE_TEXTVIEW = "nosel-textview";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_CUSTOM_EDITTEXT
TextClassifier.WIDGET_TYPE_CUSTOM_EDITTEXT = "customedit";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_URL
TextClassifier.TYPE_URL = "url";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_FLIGHT_NUMBER
TextClassifier.TYPE_FLIGHT_NUMBER = "flight";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_CUSTOM_UNSELECTABLE_TEXTVIEW
TextClassifier.WIDGET_TYPE_CUSTOM_UNSELECTABLE_TEXTVIEW = "nosel-customview";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#HINT_TEXT_IS_EDITABLE
TextClassifier.HINT_TEXT_IS_EDITABLE = "android.text_is_editable";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_OTHER
TextClassifier.TYPE_OTHER = "other";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_WEBVIEW
TextClassifier.WIDGET_TYPE_WEBVIEW = "webview";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_ADDRESS
TextClassifier.TYPE_ADDRESS = "address";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_EMAIL
TextClassifier.TYPE_EMAIL = "email";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_EDITTEXT
TextClassifier.WIDGET_TYPE_EDITTEXT = "edittext";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#HINT_TEXT_IS_NOT_EDITABLE
TextClassifier.HINT_TEXT_IS_NOT_EDITABLE = "android.text_is_not_editable";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_UNKNOWN
TextClassifier.WIDGET_TYPE_UNKNOWN = "unknown";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#EXTRA_FROM_TEXT_CLASSIFIER
TextClassifier.EXTRA_FROM_TEXT_CLASSIFIER = "android.view.textclassifier.extra.FROM_TEXT_CLASSIFIER";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_UNKNOWN
TextClassifier.TYPE_UNKNOWN = "";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_DATE_TIME
TextClassifier.TYPE_DATE_TIME = "datetime";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_NOTIFICATION
TextClassifier.WIDGET_TYPE_NOTIFICATION = "notification";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_DATE
TextClassifier.TYPE_DATE = "date";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#TYPE_PHONE
TextClassifier.TYPE_PHONE = "phone";
// http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#WIDGET_TYPE_CUSTOM_TEXTVIEW
TextClassifier.WIDGET_TYPE_CUSTOM_TEXTVIEW = "customview";

// Static methods

// Instance methods
/**
 * @function generateLinks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#generateLinks(android.view.textclassifier.TextLinks$Request)}
 **/
TextClassifier.prototype.generateLinks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateLinks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onSelectionEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#onSelectionEvent(android.view.textclassifier.SelectionEvent)}
 **/
TextClassifier.prototype.onSelectionEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSelectionEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function classifyText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#classifyText(android.view.textclassifier.TextClassification$Request)}
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#classifyText(java.lang.CharSequence, int, int, android.os.LocaleList)}
 **/
TextClassifier.prototype.classifyText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'classifyText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onTextClassifierEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#onTextClassifierEvent(android.view.textclassifier.TextClassifierEvent)}
 **/
TextClassifier.prototype.onTextClassifierEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTextClassifierEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isDestroyed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#isDestroyed()}
 **/
TextClassifier.prototype.isDestroyed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDestroyed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getMaxGenerateLinksTextLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#getMaxGenerateLinksTextLength()}
 **/
TextClassifier.prototype.getMaxGenerateLinksTextLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaxGenerateLinksTextLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function detectLanguage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#detectLanguage(android.view.textclassifier.TextLanguage$Request)}
 **/
TextClassifier.prototype.detectLanguage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'detectLanguage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function suggestConversationActions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#suggestConversationActions(android.view.textclassifier.ConversationActions$Request)}
 **/
TextClassifier.prototype.suggestConversationActions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'suggestConversationActions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function destroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#destroy()}
 **/
TextClassifier.prototype.destroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'destroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function suggestSelection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#suggestSelection(android.view.textclassifier.TextSelection$Request)}
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifier.html#suggestSelection(java.lang.CharSequence, int, int, android.os.LocaleList)}
 **/
TextClassifier.prototype.suggestSelection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'suggestSelection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifier') {
			return new TextClassifier(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

TextClassifier.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

TextClassifier.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = TextClassifier;
