/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.textclassifier.TextClassifierEvent
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.textclassifier');

/**
 * @class android.view.textclassifier.TextClassifierEvent
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html}
 **/
var TextClassifierEvent = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.textclassifier.TextClassifierEvent')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.view.textclassifier.TextClassifierEvent. Create a subclass using android.view.textclassifier.TextClassifierEvent.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TextClassifierEvent.prototype = Object.create(SuperClass.prototype);
TextClassifierEvent.prototype.constructor = TextClassifierEvent;

Object.defineProperty(TextClassifierEvent.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextClassifierEvent(this.$native.super);
	},
	enumerable: true
});

TextClassifierEvent.className = 'android.view.textclassifier.TextClassifierEvent';
TextClassifierEvent.prototype.className = 'android.view.textclassifier.TextClassifierEvent';

// class property
Object.defineProperty(TextClassifierEvent, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.TextClassifierEvent');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TextClassifierEvent.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.textclassifier.TextClassifierEvent');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TextClassifierEvent.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TextClassifierEvent.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextClassifierEvent(Hyperloop.cast('android.view.textclassifier.TextClassifierEvent', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_PASTE_ACTION}
 */
TextClassifierEvent.TYPE_PASTE_ACTION = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SMART_ACTION}
 */
TextClassifierEvent.TYPE_SMART_ACTION = 13;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#CATEGORY_CONVERSATION_ACTIONS}
 */
TextClassifierEvent.CATEGORY_CONVERSATION_ACTIONS = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_CUT_ACTION}
 */
TextClassifierEvent.TYPE_CUT_ACTION = 11;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_LINKS_GENERATED}
 */
TextClassifierEvent.TYPE_LINKS_GENERATED = 21;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SELECTION_MODIFIED}
 */
TextClassifierEvent.TYPE_SELECTION_MODIFIED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SHARE_ACTION}
 */
TextClassifierEvent.TYPE_SHARE_ACTION = 12;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_OVERTYPE}
 */
TextClassifierEvent.TYPE_OVERTYPE = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_LINK_CLICKED}
 */
TextClassifierEvent.TYPE_LINK_CLICKED = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SELECTION_DESTROYED}
 */
TextClassifierEvent.TYPE_SELECTION_DESTROYED = 15;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#CATEGORY_SELECTION}
 */
TextClassifierEvent.CATEGORY_SELECTION = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SELECTION_STARTED}
 */
TextClassifierEvent.TYPE_SELECTION_STARTED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#CATEGORY_LANGUAGE_DETECTION}
 */
TextClassifierEvent.CATEGORY_LANGUAGE_DETECTION = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_COPY_ACTION}
 */
TextClassifierEvent.TYPE_COPY_ACTION = 9;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SMART_SELECTION_MULTI}
 */
TextClassifierEvent.TYPE_SMART_SELECTION_MULTI = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_ACTIONS_SHOWN}
 */
TextClassifierEvent.TYPE_ACTIONS_SHOWN = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#CATEGORY_LINKIFY}
 */
TextClassifierEvent.CATEGORY_LINKIFY = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_ACTIONS_GENERATED}
 */
TextClassifierEvent.TYPE_ACTIONS_GENERATED = 20;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_AUTO_SELECTION}
 */
TextClassifierEvent.TYPE_AUTO_SELECTION = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SELECTION_RESET}
 */
TextClassifierEvent.TYPE_SELECTION_RESET = 18;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SELECT_ALL}
 */
TextClassifierEvent.TYPE_SELECT_ALL = 17;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_MANUAL_REPLY}
 */
TextClassifierEvent.TYPE_MANUAL_REPLY = 19;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SELECTION_DRAG}
 */
TextClassifierEvent.TYPE_SELECTION_DRAG = 14;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_OTHER_ACTION}
 */
TextClassifierEvent.TYPE_OTHER_ACTION = 16;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#TYPE_SMART_SELECTION_SINGLE}
 */
TextClassifierEvent.TYPE_SMART_SELECTION_SINGLE = 3;

// Inner classes
Object.defineProperty(TextClassifierEvent, 'TextSelectionEvent', {
	get: function() {
		return require('./android.view.textclassifier.TextClassifierEvent$TextSelectionEvent');
	},
	enumerable: true
});
Object.defineProperty(TextClassifierEvent, 'ConversationActionsEvent', {
	get: function() {
		return require('./android.view.textclassifier.TextClassifierEvent$ConversationActionsEvent');
	},
	enumerable: true
});
Object.defineProperty(TextClassifierEvent, 'Builder', {
	get: function() {
		return require('./android.view.textclassifier.TextClassifierEvent$Builder');
	},
	enumerable: true
});
Object.defineProperty(TextClassifierEvent, 'LanguageDetectionEvent', {
	get: function() {
		return require('./android.view.textclassifier.TextClassifierEvent$LanguageDetectionEvent');
	},
	enumerable: true
});
Object.defineProperty(TextClassifierEvent, 'TextLinkifyEvent', {
	get: function() {
		return require('./android.view.textclassifier.TextClassifierEvent$TextLinkifyEvent');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#CREATOR
Object.defineProperty(TextClassifierEvent, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
				return new TextClassifierEvent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getEntityTypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getEntityTypes()}
 **/
TextClassifierEvent.prototype.getEntityTypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEntityTypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getEventContext()}
 **/
TextClassifierEvent.prototype.getEventContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getScores
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getScores()}
 **/
TextClassifierEvent.prototype.getScores = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getScores',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getModelName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getModelName()}
 **/
TextClassifierEvent.prototype.getModelName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getModelName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#describeContents()}
 **/
TextClassifierEvent.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActionIndices
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getActionIndices()}
 **/
TextClassifierEvent.prototype.getActionIndices = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActionIndices',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getEventType()}
 **/
TextClassifierEvent.prototype.getEventType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResultId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getResultId()}
 **/
TextClassifierEvent.prototype.getResultId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResultId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getEventIndex()}
 **/
TextClassifierEvent.prototype.getEventIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#toString()}
 **/
TextClassifierEvent.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getExtras()}
 **/
TextClassifierEvent.prototype.getExtras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#writeToParcel(android.os.Parcel, int)}
 **/
TextClassifierEvent.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLocale
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getLocale()}
 **/
TextClassifierEvent.prototype.getLocale = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocale',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEventCategory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.html#getEventCategory()}
 **/
TextClassifierEvent.prototype.getEventCategory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEventCategory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent') {
			return new TextClassifierEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TextClassifierEvent;
