/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.textclassifier.TextLinks$TextLinkSpan
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.view.textclassifier.TextLinks');

/**
 * @class android.view.textclassifier.TextLinks$TextLinkSpan
 * @extends android.text.style.ClickableSpan 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.TextLinkSpan.html}
 **/
var TextLinkSpan = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.textclassifier.TextLinks$TextLinkSpan')) {
		result = arguments[0];
	}
	else {
		result = TextLinkSpan.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.text.style.ClickableSpan');
TextLinkSpan.prototype = Object.create(SuperClass.prototype);
TextLinkSpan.prototype.constructor = TextLinkSpan;

Object.defineProperty(TextLinkSpan.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextLinkSpan(this.$native.super);
	},
	enumerable: true
});

TextLinkSpan.className = 'android.view.textclassifier.TextLinks$TextLinkSpan';
TextLinkSpan.prototype.className = 'android.view.textclassifier.TextLinks$TextLinkSpan';

// class property
Object.defineProperty(TextLinkSpan, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.TextLinks$TextLinkSpan');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TextLinkSpan.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.textclassifier.TextLinks$TextLinkSpan');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TextLinkSpan.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TextLinkSpan.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextLinkSpan(Hyperloop.cast('android.view.textclassifier.TextLinks$TextLinkSpan', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onClick
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.TextLinkSpan.html#onClick(android.view.View)}
 **/
TextLinkSpan.prototype.onClick = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onClick',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks$TextLinkSpan') {
			return new TextLinkSpan(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTextLink
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.TextLinkSpan.html#getTextLink()}
 **/
TextLinkSpan.prototype.getTextLink = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextLink',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks$TextLinkSpan') {
			return new TextLinkSpan(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TextLinkSpan;
