/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.textclassifier.TextLinks
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.textclassifier');

/**
 * @class android.view.textclassifier.TextLinks
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html}
 **/
var TextLinks = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.textclassifier.TextLinks')) {
		result = arguments[0];
	}
	else {
		result = TextLinks.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TextLinks.prototype = Object.create(SuperClass.prototype);
TextLinks.prototype.constructor = TextLinks;

Object.defineProperty(TextLinks.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextLinks(this.$native.super);
	},
	enumerable: true
});

TextLinks.className = 'android.view.textclassifier.TextLinks';
TextLinks.prototype.className = 'android.view.textclassifier.TextLinks';

// class property
Object.defineProperty(TextLinks, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.TextLinks');
	},
	enumerable: true,
	configurable: false
});


// Cast
TextLinks.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextLinks(Hyperloop.cast('android.view.textclassifier.TextLinks', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#STATUS_LINKS_APPLIED}
 */
TextLinks.STATUS_LINKS_APPLIED = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#STATUS_NO_LINKS_FOUND}
 */
TextLinks.STATUS_NO_LINKS_FOUND = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#APPLY_STRATEGY_IGNORE}
 */
TextLinks.APPLY_STRATEGY_IGNORE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#STATUS_UNSUPPORTED_CHARACTER}
 */
TextLinks.STATUS_UNSUPPORTED_CHARACTER = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#STATUS_DIFFERENT_TEXT}
 */
TextLinks.STATUS_DIFFERENT_TEXT = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#APPLY_STRATEGY_REPLACE}
 */
TextLinks.APPLY_STRATEGY_REPLACE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#STATUS_NO_LINKS_APPLIED}
 */
TextLinks.STATUS_NO_LINKS_APPLIED = 2;

// Inner classes
Object.defineProperty(TextLinks, 'Builder', {
	get: function() {
		return require('./android.view.textclassifier.TextLinks$Builder');
	},
	enumerable: true
});
Object.defineProperty(TextLinks, 'TextLink', {
	get: function() {
		return require('./android.view.textclassifier.TextLinks$TextLink');
	},
	enumerable: true
});
Object.defineProperty(TextLinks, 'TextLinkSpan', {
	get: function() {
		return require('./android.view.textclassifier.TextLinks$TextLinkSpan');
	},
	enumerable: true
});
Object.defineProperty(TextLinks, 'Request', {
	get: function() {
		return require('./android.view.textclassifier.TextLinks$Request');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#CREATOR
Object.defineProperty(TextLinks, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.textclassifier.TextLinks') {
				return new TextLinks(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getLinks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#getLinks()}
 **/
TextLinks.prototype.getLinks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLinks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function apply
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#apply(android.text.Spannable, int, java.util.function.Function)}
 **/
TextLinks.prototype.apply = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'apply',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#getText()}
 **/
TextLinks.prototype.getText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#toString()}
 **/
TextLinks.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#getExtras()}
 **/
TextLinks.prototype.getExtras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#describeContents()}
 **/
TextLinks.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextLinks.html#writeToParcel(android.os.Parcel, int)}
 **/
TextLinks.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextLinks') {
			return new TextLinks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TextLinks;
