/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.widget.BaseAdapter
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.widget');

/**
 * @class android.widget.BaseAdapter
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html}
 **/
var BaseAdapter = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.widget.BaseAdapter')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.widget.BaseAdapter. Create a subclass using android.widget.BaseAdapter.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
BaseAdapter.prototype = Object.create(SuperClass.prototype);
BaseAdapter.prototype.constructor = BaseAdapter;

Object.defineProperty(BaseAdapter.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new BaseAdapter(this.$native.super);
	},
	enumerable: true
});

BaseAdapter.className = 'android.widget.BaseAdapter';
BaseAdapter.prototype.className = 'android.widget.BaseAdapter';

// class property
Object.defineProperty(BaseAdapter, 'class', {
	get: function() {
		return Hyperloop.getClass('android.widget.BaseAdapter');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
BaseAdapter.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.widget.BaseAdapter');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(BaseAdapter.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
BaseAdapter.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new BaseAdapter(Hyperloop.cast('android.widget.BaseAdapter', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getViewTypeCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#getViewTypeCount()}
 **/
BaseAdapter.prototype.getViewTypeCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getViewTypeCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasStableIds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#hasStableIds()}
 **/
BaseAdapter.prototype.hasStableIds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasStableIds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getItemViewType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#getItemViewType(int)}
 **/
BaseAdapter.prototype.getItemViewType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItemViewType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEmpty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#isEmpty()}
 **/
BaseAdapter.prototype.isEmpty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEmpty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerDataSetObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#registerDataSetObserver(android.database.DataSetObserver)}
 **/
BaseAdapter.prototype.registerDataSetObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerDataSetObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyDataSetInvalidated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#notifyDataSetInvalidated()}
 **/
BaseAdapter.prototype.notifyDataSetInvalidated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyDataSetInvalidated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDropDownView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#getDropDownView(int, android.view.View, android.view.ViewGroup)}
 **/
BaseAdapter.prototype.getDropDownView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDropDownView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyDataSetChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#notifyDataSetChanged()}
 **/
BaseAdapter.prototype.notifyDataSetChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyDataSetChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAutofillOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#setAutofillOptions(java.lang.CharSequence[])}
 **/
BaseAdapter.prototype.setAutofillOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAutofillOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function areAllItemsEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#areAllItemsEnabled()}
 **/
BaseAdapter.prototype.areAllItemsEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'areAllItemsEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAutofillOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#getAutofillOptions()}
 **/
BaseAdapter.prototype.getAutofillOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAutofillOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unregisterDataSetObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#unregisterDataSetObserver(android.database.DataSetObserver)}
 **/
BaseAdapter.prototype.unregisterDataSetObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterDataSetObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/BaseAdapter.html#isEnabled(int)}
 **/
BaseAdapter.prototype.isEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.BaseAdapter') {
			return new BaseAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = BaseAdapter;
