/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.widget.Scroller
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.widget');

/**
 * @class android.widget.Scroller
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html}
 **/
var Scroller = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.widget.Scroller')) {
		result = arguments[0];
	}
	else {
		result = Scroller.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Scroller.prototype = Object.create(SuperClass.prototype);
Scroller.prototype.constructor = Scroller;

Object.defineProperty(Scroller.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Scroller(this.$native.super);
	},
	enumerable: true
});

Scroller.className = 'android.widget.Scroller';
Scroller.prototype.className = 'android.widget.Scroller';

// class property
Object.defineProperty(Scroller, 'class', {
	get: function() {
		return Hyperloop.getClass('android.widget.Scroller');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Scroller.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.widget.Scroller');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Scroller.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Scroller.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Scroller(Hyperloop.cast('android.widget.Scroller', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function abortAnimation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#abortAnimation()}
 **/
Scroller.prototype.abortAnimation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'abortAnimation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function extendDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#extendDuration(int)}
 **/
Scroller.prototype.extendDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'extendDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function timePassed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#timePassed()}
 **/
Scroller.prototype.timePassed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'timePassed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getStartX()}
 **/
Scroller.prototype.getStartX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getStartY()}
 **/
Scroller.prototype.getStartY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFinished
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#isFinished()}
 **/
Scroller.prototype.isFinished = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFinished',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrVelocity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getCurrVelocity()}
 **/
Scroller.prototype.getCurrVelocity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrVelocity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fling
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#fling(int, int, int, int, int, int, int, int)}
 **/
Scroller.prototype.fling = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fling',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFinalY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#setFinalY(int)}
 **/
Scroller.prototype.setFinalY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFinalY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forceFinished
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#forceFinished(boolean)}
 **/
Scroller.prototype.forceFinished = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forceFinished',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFinalX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#setFinalX(int)}
 **/
Scroller.prototype.setFinalX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFinalX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getDuration()}
 **/
Scroller.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getCurrY()}
 **/
Scroller.prototype.getCurrY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getCurrX()}
 **/
Scroller.prototype.getCurrX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFinalX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getFinalX()}
 **/
Scroller.prototype.getFinalX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFinalX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFinalY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#getFinalY()}
 **/
Scroller.prototype.getFinalY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFinalY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#startScroll(int, int, int, int)}
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#startScroll(int, int, int, int, int)}
 **/
Scroller.prototype.startScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFriction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#setFriction(float)}
 **/
Scroller.prototype.setFriction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFriction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeScrollOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/Scroller.html#computeScrollOffset()}
 **/
Scroller.prototype.computeScrollOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeScrollOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.Scroller') {
			return new Scroller(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Scroller;
