/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.OnBackPressedCallback
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity');

/**
 * @class androidx.activity.OnBackPressedCallback
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedCallback.html}
 **/
var OnBackPressedCallback = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.OnBackPressedCallback')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.activity.OnBackPressedCallback. Create a subclass using androidx.activity.OnBackPressedCallback.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
OnBackPressedCallback.prototype = Object.create(SuperClass.prototype);
OnBackPressedCallback.prototype.constructor = OnBackPressedCallback;

Object.defineProperty(OnBackPressedCallback.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new OnBackPressedCallback(this.$native.super);
	},
	enumerable: true
});

OnBackPressedCallback.className = 'androidx.activity.OnBackPressedCallback';
OnBackPressedCallback.prototype.className = 'androidx.activity.OnBackPressedCallback';

// class property
Object.defineProperty(OnBackPressedCallback, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.OnBackPressedCallback');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
OnBackPressedCallback.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.activity.OnBackPressedCallback');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(OnBackPressedCallback.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
OnBackPressedCallback.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new OnBackPressedCallback(Hyperloop.cast('androidx.activity.OnBackPressedCallback', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedCallback.html#setEnabled(boolean)}
 **/
OnBackPressedCallback.prototype.setEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedCallback') {
			return new OnBackPressedCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedCallback.html#isEnabled()}
 **/
OnBackPressedCallback.prototype.isEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedCallback') {
			return new OnBackPressedCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedCallback.html#remove()}
 **/
OnBackPressedCallback.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedCallback') {
			return new OnBackPressedCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function handleOnBackPressed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedCallback.html#handleOnBackPressed()}
 **/
OnBackPressedCallback.prototype.handleOnBackPressed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'handleOnBackPressed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedCallback') {
			return new OnBackPressedCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = OnBackPressedCallback;
