/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.OnBackPressedDispatcher
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity');

/**
 * @class androidx.activity.OnBackPressedDispatcher
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedDispatcher.html}
 **/
var OnBackPressedDispatcher = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.OnBackPressedDispatcher')) {
		result = arguments[0];
	}
	else {
		result = OnBackPressedDispatcher.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
OnBackPressedDispatcher.prototype = Object.create(SuperClass.prototype);
OnBackPressedDispatcher.prototype.constructor = OnBackPressedDispatcher;

Object.defineProperty(OnBackPressedDispatcher.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new OnBackPressedDispatcher(this.$native.super);
	},
	enumerable: true
});

OnBackPressedDispatcher.className = 'androidx.activity.OnBackPressedDispatcher';
OnBackPressedDispatcher.prototype.className = 'androidx.activity.OnBackPressedDispatcher';

// class property
Object.defineProperty(OnBackPressedDispatcher, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.OnBackPressedDispatcher');
	},
	enumerable: true,
	configurable: false
});


// Cast
OnBackPressedDispatcher.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new OnBackPressedDispatcher(Hyperloop.cast('androidx.activity.OnBackPressedDispatcher', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(OnBackPressedDispatcher, 'LifecycleOnBackPressedCancellable', {
	get: function() {
		return require('./androidx.activity.OnBackPressedDispatcher$LifecycleOnBackPressedCancellable');
	},
	enumerable: true
});
Object.defineProperty(OnBackPressedDispatcher, 'OnBackPressedCancellable', {
	get: function() {
		return require('./androidx.activity.OnBackPressedDispatcher$OnBackPressedCancellable');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function hasEnabledCallbacks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedDispatcher.html#hasEnabledCallbacks()}
 **/
OnBackPressedDispatcher.prototype.hasEnabledCallbacks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasEnabledCallbacks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedDispatcher') {
			return new OnBackPressedDispatcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedDispatcher.html#addCallback(androidx.activity.OnBackPressedCallback)}
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedDispatcher.html#addCallback(androidx.lifecycle.LifecycleOwner, androidx.activity.OnBackPressedCallback)}
 **/
OnBackPressedDispatcher.prototype.addCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedDispatcher') {
			return new OnBackPressedDispatcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onBackPressed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/OnBackPressedDispatcher.html#onBackPressed()}
 **/
OnBackPressedDispatcher.prototype.onBackPressed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onBackPressed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.OnBackPressedDispatcher') {
			return new OnBackPressedDispatcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = OnBackPressedDispatcher;
