/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.result.ActivityResult
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity.result');

/**
 * @class androidx.activity.result.ActivityResult
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html}
 **/
var ActivityResult = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.result.ActivityResult')) {
		result = arguments[0];
	}
	else {
		result = ActivityResult.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ActivityResult.prototype = Object.create(SuperClass.prototype);
ActivityResult.prototype.constructor = ActivityResult;

Object.defineProperty(ActivityResult.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActivityResult(this.$native.super);
	},
	enumerable: true
});

ActivityResult.className = 'androidx.activity.result.ActivityResult';
ActivityResult.prototype.className = 'androidx.activity.result.ActivityResult';

// class property
Object.defineProperty(ActivityResult, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.result.ActivityResult');
	},
	enumerable: true,
	configurable: false
});


// Cast
ActivityResult.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActivityResult(Hyperloop.cast('androidx.activity.result.ActivityResult', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#CREATOR
Object.defineProperty(ActivityResult, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.activity.result.ActivityResult') {
				return new ActivityResult(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function resultCodeToString
 * @static
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#resultCodeToString(int)}
 **/
ActivityResult.resultCodeToString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'resultCodeToString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResult') {
			return new ActivityResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getResultCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#getResultCode()}
 **/
ActivityResult.prototype.getResultCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResultCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResult') {
			return new ActivityResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#toString()}
 **/
ActivityResult.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResult') {
			return new ActivityResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#writeToParcel(android.os.Parcel, int)}
 **/
ActivityResult.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResult') {
			return new ActivityResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#describeContents()}
 **/
ActivityResult.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResult') {
			return new ActivityResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResult.html#getData()}
 **/
ActivityResult.prototype.getData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResult') {
			return new ActivityResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ActivityResult;
