/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.result.ActivityResultRegistry
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity.result');

/**
 * @class androidx.activity.result.ActivityResultRegistry
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html}
 **/
var ActivityResultRegistry = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.result.ActivityResultRegistry')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.activity.result.ActivityResultRegistry. Create a subclass using androidx.activity.result.ActivityResultRegistry.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ActivityResultRegistry.prototype = Object.create(SuperClass.prototype);
ActivityResultRegistry.prototype.constructor = ActivityResultRegistry;

Object.defineProperty(ActivityResultRegistry.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActivityResultRegistry(this.$native.super);
	},
	enumerable: true
});

ActivityResultRegistry.className = 'androidx.activity.result.ActivityResultRegistry';
ActivityResultRegistry.prototype.className = 'androidx.activity.result.ActivityResultRegistry';

// class property
Object.defineProperty(ActivityResultRegistry, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.result.ActivityResultRegistry');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ActivityResultRegistry.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.activity.result.ActivityResultRegistry');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ActivityResultRegistry.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ActivityResultRegistry.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActivityResultRegistry(Hyperloop.cast('androidx.activity.result.ActivityResultRegistry', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ActivityResultRegistry, 'CallbackAndContract', {
	get: function() {
		return require('./androidx.activity.result.ActivityResultRegistry$CallbackAndContract');
	},
	enumerable: true
});
Object.defineProperty(ActivityResultRegistry, 'LifecycleContainer', {
	get: function() {
		return require('./androidx.activity.result.ActivityResultRegistry$LifecycleContainer');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onRestoreInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#onRestoreInstanceState(android.os.Bundle)}
 **/
ActivityResultRegistry.prototype.onRestoreInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRestoreInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResultRegistry') {
			return new ActivityResultRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#dispatchResult(int, int, android.content.Intent)}
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#dispatchResult(int, java.lang.Object)}
 **/
ActivityResultRegistry.prototype.dispatchResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResultRegistry') {
			return new ActivityResultRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#onSaveInstanceState(android.os.Bundle)}
 **/
ActivityResultRegistry.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResultRegistry') {
			return new ActivityResultRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLaunch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#onLaunch(int, androidx.activity.result.contract.ActivityResultContract, java.lang.Object, androidx.core.app.ActivityOptionsCompat)}
 **/
ActivityResultRegistry.prototype.onLaunch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLaunch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResultRegistry') {
			return new ActivityResultRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function register
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#register(java.lang.String, androidx.lifecycle.LifecycleOwner, androidx.activity.result.contract.ActivityResultContract, androidx.activity.result.ActivityResultCallback)}
 * @see {@link http://developer.android.com/reference/androidx/activity/result/ActivityResultRegistry.html#register(java.lang.String, androidx.activity.result.contract.ActivityResultContract, androidx.activity.result.ActivityResultCallback)}
 **/
ActivityResultRegistry.prototype.register = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'register',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.ActivityResultRegistry') {
			return new ActivityResultRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ActivityResultRegistry;
