/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.result.contract.ActivityResultContract
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity.result.contract');

/**
 * @class androidx.activity.result.contract.ActivityResultContract
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/result/contract/ActivityResultContract.html}
 **/
var ActivityResultContract = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.result.contract.ActivityResultContract')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.activity.result.contract.ActivityResultContract. Create a subclass using androidx.activity.result.contract.ActivityResultContract.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ActivityResultContract.prototype = Object.create(SuperClass.prototype);
ActivityResultContract.prototype.constructor = ActivityResultContract;

Object.defineProperty(ActivityResultContract.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActivityResultContract(this.$native.super);
	},
	enumerable: true
});

ActivityResultContract.className = 'androidx.activity.result.contract.ActivityResultContract';
ActivityResultContract.prototype.className = 'androidx.activity.result.contract.ActivityResultContract';

// class property
Object.defineProperty(ActivityResultContract, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.result.contract.ActivityResultContract');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ActivityResultContract.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.activity.result.contract.ActivityResultContract');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ActivityResultContract.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ActivityResultContract.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActivityResultContract(Hyperloop.cast('androidx.activity.result.contract.ActivityResultContract', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ActivityResultContract, 'SynchronousResult', {
	get: function() {
		return require('./androidx.activity.result.contract.ActivityResultContract$SynchronousResult');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSynchronousResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/contract/ActivityResultContract.html#getSynchronousResult(android.content.Context, java.lang.Object)}
 **/
ActivityResultContract.prototype.getSynchronousResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSynchronousResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.contract.ActivityResultContract') {
			return new ActivityResultContract(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parseResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/contract/ActivityResultContract.html#parseResult(int, android.content.Intent)}
 **/
ActivityResultContract.prototype.parseResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parseResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.contract.ActivityResultContract') {
			return new ActivityResultContract(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/contract/ActivityResultContract.html#createIntent(android.content.Context, java.lang.Object)}
 **/
ActivityResultContract.prototype.createIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.contract.ActivityResultContract') {
			return new ActivityResultContract(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ActivityResultContract;
