/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Delegate
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.appcompat.app.ActionBarDrawerToggle');

/**
 * constructor
 * http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.Delegate.html
 **/
var Delegate = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'androidx.appcompat.app.ActionBarDrawerToggle$Delegate') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('androidx.appcompat.app.ActionBarDrawerToggle$Delegate');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Delegate.prototype = Object.create(SuperClass.prototype);
Delegate.prototype.constructor = Delegate;

Object.defineProperty(Delegate.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Delegate(this.$native.super);
	},
	enumerable: true
});

Delegate.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Delegate.className = "androidx.appcompat.app.ActionBarDrawerToggle$Delegate";
Delegate.prototype.className = "androidx.appcompat.app.ActionBarDrawerToggle$Delegate";

// class property
Object.defineProperty(Delegate, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.app.ActionBarDrawerToggle$Delegate');
	},
	enumerable: true,
	configurable: false
});

// Cast
Delegate.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Delegate(Hyperloop.cast('androidx.appcompat.app.ActionBarDrawerToggle$Delegate', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function setActionBarDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.Delegate.html#setActionBarDescription(int)}
 **/
Delegate.prototype.setActionBarDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setActionBarDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle$Delegate') {
			return new Delegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getThemeUpIndicator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.Delegate.html#getThemeUpIndicator()}
 **/
Delegate.prototype.getThemeUpIndicator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getThemeUpIndicator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle$Delegate') {
			return new Delegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getActionBarThemedContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.Delegate.html#getActionBarThemedContext()}
 **/
Delegate.prototype.getActionBarThemedContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActionBarThemedContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle$Delegate') {
			return new Delegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setActionBarUpIndicator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.Delegate.html#setActionBarUpIndicator(android.graphics.drawable.Drawable, int)}
 **/
Delegate.prototype.setActionBarUpIndicator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setActionBarUpIndicator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle$Delegate') {
			return new Delegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isNavigationVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.Delegate.html#isNavigationVisible()}
 **/
Delegate.prototype.isNavigationVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNavigationVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle$Delegate') {
			return new Delegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Delegate.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Delegate.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Delegate;
