/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.app.AppCompatDelegate
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.app');

/**
 * @class androidx.appcompat.app.AppCompatDelegate
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html}
 **/
var AppCompatDelegate = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.app.AppCompatDelegate')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.appcompat.app.AppCompatDelegate. Create a subclass using androidx.appcompat.app.AppCompatDelegate.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AppCompatDelegate.prototype = Object.create(SuperClass.prototype);
AppCompatDelegate.prototype.constructor = AppCompatDelegate;

Object.defineProperty(AppCompatDelegate.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AppCompatDelegate(this.$native.super);
	},
	enumerable: true
});

AppCompatDelegate.className = 'androidx.appcompat.app.AppCompatDelegate';
AppCompatDelegate.prototype.className = 'androidx.appcompat.app.AppCompatDelegate';

// class property
Object.defineProperty(AppCompatDelegate, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.app.AppCompatDelegate');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AppCompatDelegate.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.app.AppCompatDelegate');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AppCompatDelegate.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AppCompatDelegate.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AppCompatDelegate(Hyperloop.cast('androidx.appcompat.app.AppCompatDelegate', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_NO}
 */
AppCompatDelegate.MODE_NIGHT_NO = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_AUTO_TIME}
 */
AppCompatDelegate.MODE_NIGHT_AUTO_TIME = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_AUTO}
 */
AppCompatDelegate.MODE_NIGHT_AUTO = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#FEATURE_SUPPORT_ACTION_BAR_OVERLAY}
 */
AppCompatDelegate.FEATURE_SUPPORT_ACTION_BAR_OVERLAY = 109;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#FEATURE_SUPPORT_ACTION_BAR}
 */
AppCompatDelegate.FEATURE_SUPPORT_ACTION_BAR = 108;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_YES}
 */
AppCompatDelegate.MODE_NIGHT_YES = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_FOLLOW_SYSTEM}
 */
AppCompatDelegate.MODE_NIGHT_FOLLOW_SYSTEM = -1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_UNSPECIFIED}
 */
AppCompatDelegate.MODE_NIGHT_UNSPECIFIED = -100;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#FEATURE_ACTION_MODE_OVERLAY}
 */
AppCompatDelegate.FEATURE_ACTION_MODE_OVERLAY = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#MODE_NIGHT_AUTO_BATTERY}
 */
AppCompatDelegate.MODE_NIGHT_AUTO_BATTERY = 3;

// Inner classes
Object.defineProperty(AppCompatDelegate, 'NightMode', {
	get: function() {
		return require('./androidx.appcompat.app.AppCompatDelegate$NightMode');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function isCompatVectorFromResourcesEnabled
 * @static
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#isCompatVectorFromResourcesEnabled()}
 **/
AppCompatDelegate.isCompatVectorFromResourcesEnabled = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isCompatVectorFromResourcesEnabled',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCompatVectorFromResourcesEnabled
 * @static
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setCompatVectorFromResourcesEnabled(boolean)}
 **/
AppCompatDelegate.setCompatVectorFromResourcesEnabled = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'setCompatVectorFromResourcesEnabled',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function create
 * @static
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#create(android.app.Activity, androidx.appcompat.app.AppCompatCallback)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#create(android.app.Dialog, androidx.appcompat.app.AppCompatCallback)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#create(android.content.Context, android.view.Window, androidx.appcompat.app.AppCompatCallback)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#create(android.content.Context, android.app.Activity, androidx.appcompat.app.AppCompatCallback)}
 **/
AppCompatDelegate.create = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'create',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDefaultNightMode
 * @static
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#getDefaultNightMode()}
 **/
AppCompatDelegate.getDefaultNightMode = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDefaultNightMode',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDefaultNightMode
 * @static
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setDefaultNightMode(int)}
 **/
AppCompatDelegate.setDefaultNightMode = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'setDefaultNightMode',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function installViewFactory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#installViewFactory()}
 **/
AppCompatDelegate.prototype.installViewFactory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'installViewFactory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLocalNightMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#getLocalNightMode()}
 **/
AppCompatDelegate.prototype.getLocalNightMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocalNightMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isHandleNativeActionModesEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#isHandleNativeActionModesEnabled()}
 **/
AppCompatDelegate.prototype.isHandleNativeActionModesEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isHandleNativeActionModesEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findViewById
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#findViewById(int)}
 **/
AppCompatDelegate.prototype.findViewById = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findViewById',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#addContentView(android.view.View, android.view.ViewGroup$LayoutParams)}
 **/
AppCompatDelegate.prototype.addContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startSupportActionMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#startSupportActionMode(androidx.appcompat.view.ActionMode$Callback)}
 **/
AppCompatDelegate.prototype.startSupportActionMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startSupportActionMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function attachBaseContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#attachBaseContext(android.content.Context)}
 **/
AppCompatDelegate.prototype.attachBaseContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'attachBaseContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportActionBar
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#getSupportActionBar()}
 **/
AppCompatDelegate.prototype.getSupportActionBar = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportActionBar',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function attachBaseContext2
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#attachBaseContext2(android.content.Context)}
 **/
AppCompatDelegate.prototype.attachBaseContext2 = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'attachBaseContext2',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onStart()}
 **/
AppCompatDelegate.prototype.onStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPostCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onPostCreate(android.os.Bundle)}
 **/
AppCompatDelegate.prototype.onPostCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPostCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportActionBar
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setSupportActionBar(androidx.appcompat.widget.Toolbar)}
 **/
AppCompatDelegate.prototype.setSupportActionBar = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportActionBar',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#createView(android.view.View, java.lang.String, android.content.Context, android.util.AttributeSet)}
 **/
AppCompatDelegate.prototype.createView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onStop()}
 **/
AppCompatDelegate.prototype.onStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrawerToggleDelegate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#getDrawerToggleDelegate()}
 **/
AppCompatDelegate.prototype.getDrawerToggleDelegate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrawerToggleDelegate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHandleNativeActionModesEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setHandleNativeActionModesEnabled(boolean)}
 **/
AppCompatDelegate.prototype.setHandleNativeActionModesEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHandleNativeActionModesEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onCreate(android.os.Bundle)}
 **/
AppCompatDelegate.prototype.onCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDestroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onDestroy()}
 **/
AppCompatDelegate.prototype.onDestroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDestroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setTitle(java.lang.CharSequence)}
 **/
AppCompatDelegate.prototype.setTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyDayNight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#applyDayNight()}
 **/
AppCompatDelegate.prototype.applyDayNight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyDayNight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLocalNightMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setLocalNightMode(int)}
 **/
AppCompatDelegate.prototype.setLocalNightMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLocalNightMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestWindowFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#requestWindowFeature(int)}
 **/
AppCompatDelegate.prototype.requestWindowFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestWindowFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setContentView(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setContentView(int)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setContentView(android.view.View, android.view.ViewGroup$LayoutParams)}
 **/
AppCompatDelegate.prototype.setContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMenuInflater
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#getMenuInflater()}
 **/
AppCompatDelegate.prototype.getMenuInflater = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMenuInflater',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTheme
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#setTheme(int)}
 **/
AppCompatDelegate.prototype.setTheme = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTheme',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onSaveInstanceState(android.os.Bundle)}
 **/
AppCompatDelegate.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPostResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onPostResume()}
 **/
AppCompatDelegate.prototype.onPostResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPostResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConfigurationChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#onConfigurationChanged(android.content.res.Configuration)}
 **/
AppCompatDelegate.prototype.onConfigurationChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConfigurationChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invalidateOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#invalidateOptionsMenu()}
 **/
AppCompatDelegate.prototype.invalidateOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invalidateOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasWindowFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatDelegate.html#hasWindowFeature(int)}
 **/
AppCompatDelegate.prototype.hasWindowFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasWindowFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatDelegate') {
			return new AppCompatDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AppCompatDelegate;
