/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.graphics.drawable.DrawerArrowDrawable
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.graphics.drawable');

/**
 * @class androidx.appcompat.graphics.drawable.DrawerArrowDrawable
 * @extends android.graphics.drawable.Drawable 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html}
 **/
var DrawerArrowDrawable = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.graphics.drawable.DrawerArrowDrawable')) {
		result = arguments[0];
	}
	else {
		result = DrawerArrowDrawable.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.graphics.drawable.Drawable');
DrawerArrowDrawable.prototype = Object.create(SuperClass.prototype);
DrawerArrowDrawable.prototype.constructor = DrawerArrowDrawable;

Object.defineProperty(DrawerArrowDrawable.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DrawerArrowDrawable(this.$native.super);
	},
	enumerable: true
});

DrawerArrowDrawable.className = 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable';
DrawerArrowDrawable.prototype.className = 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable';

// class property
Object.defineProperty(DrawerArrowDrawable, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.graphics.drawable.DrawerArrowDrawable');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
DrawerArrowDrawable.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.graphics.drawable.DrawerArrowDrawable');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(DrawerArrowDrawable.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
DrawerArrowDrawable.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DrawerArrowDrawable(Hyperloop.cast('androidx.appcompat.graphics.drawable.DrawerArrowDrawable', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#ARROW_DIRECTION_END}
 */
DrawerArrowDrawable.ARROW_DIRECTION_END = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#ARROW_DIRECTION_LEFT}
 */
DrawerArrowDrawable.ARROW_DIRECTION_LEFT = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#ARROW_DIRECTION_RIGHT}
 */
DrawerArrowDrawable.ARROW_DIRECTION_RIGHT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#ARROW_DIRECTION_START}
 */
DrawerArrowDrawable.ARROW_DIRECTION_START = 2;

// Inner classes
Object.defineProperty(DrawerArrowDrawable, 'ArrowDirection', {
	get: function() {
		return require('./androidx.appcompat.graphics.drawable.DrawerArrowDrawable$ArrowDirection');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setColorFilter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setColorFilter(android.graphics.ColorFilter)}
 **/
DrawerArrowDrawable.prototype.setColorFilter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setColorFilter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDirection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getDirection()}
 **/
DrawerArrowDrawable.prototype.getDirection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDirection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGapSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getGapSize()}
 **/
DrawerArrowDrawable.prototype.getGapSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGapSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBarLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getBarLength()}
 **/
DrawerArrowDrawable.prototype.getBarLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBarLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setProgress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setProgress(float)}
 **/
DrawerArrowDrawable.prototype.setProgress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setProgress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getArrowHeadLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getArrowHeadLength()}
 **/
DrawerArrowDrawable.prototype.getArrowHeadLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getArrowHeadLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setGapSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setGapSize(float)}
 **/
DrawerArrowDrawable.prototype.setGapSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGapSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntrinsicWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getIntrinsicWidth()}
 **/
DrawerArrowDrawable.prototype.getIntrinsicWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntrinsicWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getProgress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getProgress()}
 **/
DrawerArrowDrawable.prototype.getProgress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProgress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getArrowShaftLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getArrowShaftLength()}
 **/
DrawerArrowDrawable.prototype.getArrowShaftLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getArrowShaftLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOpacity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getOpacity()}
 **/
DrawerArrowDrawable.prototype.getOpacity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOpacity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntrinsicHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getIntrinsicHeight()}
 **/
DrawerArrowDrawable.prototype.getIntrinsicHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntrinsicHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDirection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setDirection(int)}
 **/
DrawerArrowDrawable.prototype.setDirection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDirection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPaint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getPaint()}
 **/
DrawerArrowDrawable.prototype.getPaint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPaint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBarThickness
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setBarThickness(float)}
 **/
DrawerArrowDrawable.prototype.setBarThickness = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBarThickness',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBarThickness
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getBarThickness()}
 **/
DrawerArrowDrawable.prototype.getBarThickness = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBarThickness',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setArrowHeadLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setArrowHeadLength(float)}
 **/
DrawerArrowDrawable.prototype.setArrowHeadLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setArrowHeadLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setArrowShaftLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setArrowShaftLength(float)}
 **/
DrawerArrowDrawable.prototype.setArrowShaftLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setArrowShaftLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBarLength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setBarLength(float)}
 **/
DrawerArrowDrawable.prototype.setBarLength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBarLength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#getColor()}
 **/
DrawerArrowDrawable.prototype.getColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSpinEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setSpinEnabled(boolean)}
 **/
DrawerArrowDrawable.prototype.setSpinEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSpinEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setAlpha(int)}
 **/
DrawerArrowDrawable.prototype.setAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function draw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#draw(android.graphics.Canvas)}
 **/
DrawerArrowDrawable.prototype.draw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'draw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setColor(int)}
 **/
DrawerArrowDrawable.prototype.setColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setVerticalMirror
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#setVerticalMirror(boolean)}
 **/
DrawerArrowDrawable.prototype.setVerticalMirror = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVerticalMirror',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSpinEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/graphics/drawable/DrawerArrowDrawable.html#isSpinEnabled()}
 **/
DrawerArrowDrawable.prototype.isSpinEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSpinEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.graphics.drawable.DrawerArrowDrawable') {
			return new DrawerArrowDrawable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DrawerArrowDrawable;
