/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.view.menu.MenuAdapter
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.view.menu');

/**
 * @class androidx.appcompat.view.menu.MenuAdapter
 * @extends android.widget.BaseAdapter 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html}
 **/
var MenuAdapter = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.view.menu.MenuAdapter')) {
		result = arguments[0];
	}
	else {
		result = MenuAdapter.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.widget.BaseAdapter');
MenuAdapter.prototype = Object.create(SuperClass.prototype);
MenuAdapter.prototype.constructor = MenuAdapter;

Object.defineProperty(MenuAdapter.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MenuAdapter(this.$native.super);
	},
	enumerable: true
});

MenuAdapter.className = 'androidx.appcompat.view.menu.MenuAdapter';
MenuAdapter.prototype.className = 'androidx.appcompat.view.menu.MenuAdapter';

// class property
Object.defineProperty(MenuAdapter, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.view.menu.MenuAdapter');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MenuAdapter.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.view.menu.MenuAdapter');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MenuAdapter.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MenuAdapter.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MenuAdapter(Hyperloop.cast('androidx.appcompat.view.menu.MenuAdapter', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getItemId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getItemId(int)}
 **/
MenuAdapter.prototype.getItemId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItemId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyDataSetChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#notifyDataSetChanged()}
 **/
MenuAdapter.prototype.notifyDataSetChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyDataSetChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getForceShowIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getForceShowIcon()}
 **/
MenuAdapter.prototype.getForceShowIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getForceShowIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getItem(int)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getItem(int)}
 **/
MenuAdapter.prototype.getItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setForceShowIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#setForceShowIcon(boolean)}
 **/
MenuAdapter.prototype.setForceShowIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setForceShowIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getCount()}
 **/
MenuAdapter.prototype.getCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getView(int, android.view.View, android.view.ViewGroup)}
 **/
MenuAdapter.prototype.getView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAdapterMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuAdapter.html#getAdapterMenu()}
 **/
MenuAdapter.prototype.getAdapterMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAdapterMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuAdapter') {
			return new MenuAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MenuAdapter;
