/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.view.menu.MenuPopupHelper
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.view.menu');

/**
 * @class androidx.appcompat.view.menu.MenuPopupHelper
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html}
 **/
var MenuPopupHelper = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.view.menu.MenuPopupHelper')) {
		result = arguments[0];
	}
	else {
		result = MenuPopupHelper.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MenuPopupHelper.prototype = Object.create(SuperClass.prototype);
MenuPopupHelper.prototype.constructor = MenuPopupHelper;

Object.defineProperty(MenuPopupHelper.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MenuPopupHelper(this.$native.super);
	},
	enumerable: true
});

MenuPopupHelper.className = 'androidx.appcompat.view.menu.MenuPopupHelper';
MenuPopupHelper.prototype.className = 'androidx.appcompat.view.menu.MenuPopupHelper';

// class property
Object.defineProperty(MenuPopupHelper, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.view.menu.MenuPopupHelper');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MenuPopupHelper.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.view.menu.MenuPopupHelper');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MenuPopupHelper.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MenuPopupHelper.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MenuPopupHelper(Hyperloop.cast('androidx.appcompat.view.menu.MenuPopupHelper', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onDismiss
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#onDismiss()}
 **/
MenuPopupHelper.prototype.onDismiss = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDismiss',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnDismissListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#setOnDismissListener(android.widget.PopupWindow$OnDismissListener)}
 **/
MenuPopupHelper.prototype.setOnDismissListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnDismissListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function show
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#show()}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#show(int, int)}
 **/
MenuPopupHelper.prototype.show = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'show',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dismiss
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#dismiss()}
 **/
MenuPopupHelper.prototype.dismiss = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dismiss',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getListView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#getListView()}
 **/
MenuPopupHelper.prototype.getListView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getListView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAnchorView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#setAnchorView(android.view.View)}
 **/
MenuPopupHelper.prototype.setAnchorView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAnchorView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPopup
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#getPopup()}
 **/
MenuPopupHelper.prototype.getPopup = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPopup',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setForceShowIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#setForceShowIcon(boolean)}
 **/
MenuPopupHelper.prototype.setForceShowIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setForceShowIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isShowing
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#isShowing()}
 **/
MenuPopupHelper.prototype.isShowing = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isShowing',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function tryShow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#tryShow()}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#tryShow(int, int)}
 **/
MenuPopupHelper.prototype.tryShow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'tryShow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setGravity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#setGravity(int)}
 **/
MenuPopupHelper.prototype.setGravity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGravity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGravity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#getGravity()}
 **/
MenuPopupHelper.prototype.getGravity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGravity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPresenterCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPopupHelper.html#setPresenterCallback(androidx.appcompat.view.menu.MenuPresenter$Callback)}
 **/
MenuPopupHelper.prototype.setPresenterCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPresenterCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPopupHelper') {
			return new MenuPopupHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MenuPopupHelper;
