/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ItemView
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.appcompat.view.menu.MenuView');

/**
 * constructor
 * http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html
 **/
var ItemView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('androidx.appcompat.view.menu.MenuView$ItemView');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ItemView.prototype = Object.create(SuperClass.prototype);
ItemView.prototype.constructor = ItemView;

Object.defineProperty(ItemView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ItemView(this.$native.super);
	},
	enumerable: true
});

ItemView.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ItemView.className = "androidx.appcompat.view.menu.MenuView$ItemView";
ItemView.prototype.className = "androidx.appcompat.view.menu.MenuView$ItemView";

// class property
Object.defineProperty(ItemView, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.view.menu.MenuView$ItemView');
	},
	enumerable: true,
	configurable: false
});

// Cast
ItemView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ItemView(Hyperloop.cast('androidx.appcompat.view.menu.MenuView$ItemView', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function setShortcut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#setShortcut(boolean, char)}
 **/
ItemView.prototype.setShortcut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setShortcut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#setIcon(android.graphics.drawable.Drawable)}
 **/
ItemView.prototype.setIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getItemData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#getItemData()}
 **/
ItemView.prototype.getItemData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItemData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#setEnabled(boolean)}
 **/
ItemView.prototype.setEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setCheckable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#setCheckable(boolean)}
 **/
ItemView.prototype.setCheckable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCheckable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setChecked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#setChecked(boolean)}
 **/
ItemView.prototype.setChecked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setChecked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#setTitle(java.lang.CharSequence)}
 **/
ItemView.prototype.setTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function initialize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#initialize(androidx.appcompat.view.menu.MenuItemImpl, int)}
 **/
ItemView.prototype.initialize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initialize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function showsIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#showsIcon()}
 **/
ItemView.prototype.showsIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showsIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function prefersCondensedTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuView.ItemView.html#prefersCondensedTitle()}
 **/
ItemView.prototype.prefersCondensedTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prefersCondensedTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuView$ItemView') {
			return new ItemView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ItemView.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ItemView.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ItemView;
