/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.view.menu.SubMenuBuilder
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.view.menu');

/**
 * @class androidx.appcompat.view.menu.SubMenuBuilder
 * @extends androidx.appcompat.view.menu.MenuBuilder 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html}
 **/
var SubMenuBuilder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.view.menu.SubMenuBuilder')) {
		result = arguments[0];
	}
	else {
		result = SubMenuBuilder.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./androidx.appcompat.view.menu.MenuBuilder');
SubMenuBuilder.prototype = Object.create(SuperClass.prototype);
SubMenuBuilder.prototype.constructor = SubMenuBuilder;

Object.defineProperty(SubMenuBuilder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SubMenuBuilder(this.$native.super);
	},
	enumerable: true
});

SubMenuBuilder.className = 'androidx.appcompat.view.menu.SubMenuBuilder';
SubMenuBuilder.prototype.className = 'androidx.appcompat.view.menu.SubMenuBuilder';

// class property
Object.defineProperty(SubMenuBuilder, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.view.menu.SubMenuBuilder');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
SubMenuBuilder.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.view.menu.SubMenuBuilder');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(SubMenuBuilder.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
SubMenuBuilder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SubMenuBuilder(Hyperloop.cast('androidx.appcompat.view.menu.SubMenuBuilder', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setQwertyMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setQwertyMode(boolean)}
 **/
SubMenuBuilder.prototype.setQwertyMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setQwertyMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isShortcutsVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#isShortcutsVisible()}
 **/
SubMenuBuilder.prototype.isShortcutsVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isShortcutsVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isQwertyMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#isQwertyMode()}
 **/
SubMenuBuilder.prototype.isQwertyMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isQwertyMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#getItem()}
 **/
SubMenuBuilder.prototype.getItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setCallback(androidx.appcompat.view.menu.MenuBuilder$Callback)}
 **/
SubMenuBuilder.prototype.setCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setIcon(android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setIcon(int)}
 **/
SubMenuBuilder.prototype.setIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHeaderView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setHeaderView(android.view.View)}
 **/
SubMenuBuilder.prototype.setHeaderView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeaderView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setShortcutsVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setShortcutsVisible(boolean)}
 **/
SubMenuBuilder.prototype.setShortcutsVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setShortcutsVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isGroupDividerEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#isGroupDividerEnabled()}
 **/
SubMenuBuilder.prototype.isGroupDividerEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isGroupDividerEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRootMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#getRootMenu()}
 **/
SubMenuBuilder.prototype.getRootMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRootMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function collapseItemActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#collapseItemActionView(androidx.appcompat.view.menu.MenuItemImpl)}
 **/
SubMenuBuilder.prototype.collapseItemActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'collapseItemActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHeaderIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setHeaderIcon(android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setHeaderIcon(int)}
 **/
SubMenuBuilder.prototype.setHeaderIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeaderIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParentMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#getParentMenu()}
 **/
SubMenuBuilder.prototype.getParentMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParentMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setGroupDividerEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setGroupDividerEnabled(boolean)}
 **/
SubMenuBuilder.prototype.setGroupDividerEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGroupDividerEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHeaderTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setHeaderTitle(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#setHeaderTitle(int)}
 **/
SubMenuBuilder.prototype.setHeaderTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeaderTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function expandItemActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#expandItemActionView(androidx.appcompat.view.menu.MenuItemImpl)}
 **/
SubMenuBuilder.prototype.expandItemActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'expandItemActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActionViewStatesKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/SubMenuBuilder.html#getActionViewStatesKey()}
 **/
SubMenuBuilder.prototype.getActionViewStatesKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActionViewStatesKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.SubMenuBuilder') {
			return new SubMenuBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SubMenuBuilder;
