/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.widget.AppCompatImageView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.widget');

/**
 * @class androidx.appcompat.widget.AppCompatImageView
 * @extends android.widget.ImageView 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html}
 **/
var AppCompatImageView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.widget.AppCompatImageView')) {
		result = arguments[0];
	}
	else {
		result = AppCompatImageView.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.widget.ImageView');
AppCompatImageView.prototype = Object.create(SuperClass.prototype);
AppCompatImageView.prototype.constructor = AppCompatImageView;

Object.defineProperty(AppCompatImageView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AppCompatImageView(this.$native.super);
	},
	enumerable: true
});

AppCompatImageView.className = 'androidx.appcompat.widget.AppCompatImageView';
AppCompatImageView.prototype.className = 'androidx.appcompat.widget.AppCompatImageView';

// class property
Object.defineProperty(AppCompatImageView, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.widget.AppCompatImageView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AppCompatImageView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.widget.AppCompatImageView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AppCompatImageView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AppCompatImageView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AppCompatImageView(Hyperloop.cast('androidx.appcompat.widget.AppCompatImageView', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setImageBitmap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setImageBitmap(android.graphics.Bitmap)}
 **/
AppCompatImageView.prototype.setImageBitmap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setImageBitmap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportBackgroundTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setSupportBackgroundTintMode(android.graphics.PorterDuff$Mode)}
 **/
AppCompatImageView.prototype.setSupportBackgroundTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportBackgroundTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportBackgroundTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setSupportBackgroundTintList(android.content.res.ColorStateList)}
 **/
AppCompatImageView.prototype.setSupportBackgroundTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportBackgroundTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawableStateChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#drawableStateChanged()}
 **/
AppCompatImageView.prototype.drawableStateChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawableStateChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setImageURI
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setImageURI(android.net.Uri)}
 **/
AppCompatImageView.prototype.setImageURI = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setImageURI',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportImageTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setSupportImageTintMode(android.graphics.PorterDuff$Mode)}
 **/
AppCompatImageView.prototype.setSupportImageTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportImageTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasOverlappingRendering
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#hasOverlappingRendering()}
 **/
AppCompatImageView.prototype.hasOverlappingRendering = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasOverlappingRendering',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportBackgroundTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#getSupportBackgroundTintList()}
 **/
AppCompatImageView.prototype.getSupportBackgroundTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportBackgroundTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportImageTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setSupportImageTintList(android.content.res.ColorStateList)}
 **/
AppCompatImageView.prototype.setSupportImageTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportImageTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportImageTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#getSupportImageTintList()}
 **/
AppCompatImageView.prototype.getSupportImageTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportImageTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportBackgroundTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#getSupportBackgroundTintMode()}
 **/
AppCompatImageView.prototype.getSupportBackgroundTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportBackgroundTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBackgroundDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setBackgroundDrawable(android.graphics.drawable.Drawable)}
 **/
AppCompatImageView.prototype.setBackgroundDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBackgroundDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBackgroundResource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setBackgroundResource(int)}
 **/
AppCompatImageView.prototype.setBackgroundResource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBackgroundResource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setImageDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setImageDrawable(android.graphics.drawable.Drawable)}
 **/
AppCompatImageView.prototype.setImageDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setImageDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setImageResource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#setImageResource(int)}
 **/
AppCompatImageView.prototype.setImageResource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setImageResource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportImageTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatImageView.html#getSupportImageTintMode()}
 **/
AppCompatImageView.prototype.getSupportImageTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportImageTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatImageView') {
			return new AppCompatImageView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AppCompatImageView;
