/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.widget.AppCompatTextView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.widget');

/**
 * @class androidx.appcompat.widget.AppCompatTextView
 * @extends android.widget.TextView 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html}
 **/
var AppCompatTextView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.widget.AppCompatTextView')) {
		result = arguments[0];
	}
	else {
		result = AppCompatTextView.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.widget.TextView');
AppCompatTextView.prototype = Object.create(SuperClass.prototype);
AppCompatTextView.prototype.constructor = AppCompatTextView;

Object.defineProperty(AppCompatTextView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AppCompatTextView(this.$native.super);
	},
	enumerable: true
});

AppCompatTextView.className = 'androidx.appcompat.widget.AppCompatTextView';
AppCompatTextView.prototype.className = 'androidx.appcompat.widget.AppCompatTextView';

// class property
Object.defineProperty(AppCompatTextView, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.widget.AppCompatTextView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AppCompatTextView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.widget.AppCompatTextView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AppCompatTextView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AppCompatTextView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AppCompatTextView(Hyperloop.cast('androidx.appcompat.widget.AppCompatTextView', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setAutoSizeTextTypeUniformWithConfiguration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setAutoSizeTextTypeUniformWithConfiguration(int, int, int, int)}
 **/
AppCompatTextView.prototype.setAutoSizeTextTypeUniformWithConfiguration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAutoSizeTextTypeUniformWithConfiguration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTextClassifier
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setTextClassifier(android.view.textclassifier.TextClassifier)}
 **/
AppCompatTextView.prototype.setTextClassifier = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTextClassifier',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCompoundDrawables
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCompoundDrawables(android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable)}
 **/
AppCompatTextView.prototype.setCompoundDrawables = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCompoundDrawables',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAutoSizeMinTextSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getAutoSizeMinTextSize()}
 **/
AppCompatTextView.prototype.getAutoSizeMinTextSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAutoSizeMinTextSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPrecomputedText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setPrecomputedText(androidx.core.text.PrecomputedTextCompat)}
 **/
AppCompatTextView.prototype.setPrecomputedText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPrecomputedText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAutoSizeTextTypeWithDefaults
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setAutoSizeTextTypeWithDefaults(int)}
 **/
AppCompatTextView.prototype.setAutoSizeTextTypeWithDefaults = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAutoSizeTextTypeWithDefaults',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportBackgroundTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getSupportBackgroundTintList()}
 **/
AppCompatTextView.prototype.getSupportBackgroundTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportBackgroundTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportBackgroundTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getSupportBackgroundTintMode()}
 **/
AppCompatTextView.prototype.getSupportBackgroundTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportBackgroundTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAutoSizeTextType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getAutoSizeTextType()}
 **/
AppCompatTextView.prototype.getAutoSizeTextType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAutoSizeTextType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCustomSelectionActionModeCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCustomSelectionActionModeCallback(android.view.ActionMode$Callback)}
 **/
AppCompatTextView.prototype.setCustomSelectionActionModeCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCustomSelectionActionModeCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTextMetricsParamsCompat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setTextMetricsParamsCompat(androidx.core.text.PrecomputedTextCompat$Params)}
 **/
AppCompatTextView.prototype.setTextMetricsParamsCompat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTextMetricsParamsCompat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAutoSizeMaxTextSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getAutoSizeMaxTextSize()}
 **/
AppCompatTextView.prototype.getAutoSizeMaxTextSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAutoSizeMaxTextSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBackgroundResource
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setBackgroundResource(int)}
 **/
AppCompatTextView.prototype.setBackgroundResource = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBackgroundResource',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTypeface
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setTypeface(android.graphics.Typeface, int)}
 **/
AppCompatTextView.prototype.setTypeface = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTypeface',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCompoundDrawablesRelative
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCompoundDrawablesRelative(android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable)}
 **/
AppCompatTextView.prototype.setCompoundDrawablesRelative = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCompoundDrawablesRelative',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLastBaselineToBottomHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getLastBaselineToBottomHeight()}
 **/
AppCompatTextView.prototype.getLastBaselineToBottomHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLastBaselineToBottomHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAutoSizeStepGranularity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getAutoSizeStepGranularity()}
 **/
AppCompatTextView.prototype.getAutoSizeStepGranularity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAutoSizeStepGranularity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLineHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setLineHeight(int)}
 **/
AppCompatTextView.prototype.setLineHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLineHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCompoundDrawablesWithIntrinsicBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCompoundDrawablesWithIntrinsicBounds(android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCompoundDrawablesWithIntrinsicBounds(int, int, int, int)}
 **/
AppCompatTextView.prototype.setCompoundDrawablesWithIntrinsicBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCompoundDrawablesWithIntrinsicBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTextClassifier
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getTextClassifier()}
 **/
AppCompatTextView.prototype.getTextClassifier = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextClassifier',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAutoSizeTextAvailableSizes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getAutoSizeTextAvailableSizes()}
 **/
AppCompatTextView.prototype.getAutoSizeTextAvailableSizes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAutoSizeTextAvailableSizes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportBackgroundTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setSupportBackgroundTintMode(android.graphics.PorterDuff$Mode)}
 **/
AppCompatTextView.prototype.setSupportBackgroundTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportBackgroundTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTextChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#onTextChanged(java.lang.CharSequence, int, int, int)}
 **/
AppCompatTextView.prototype.onTextChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTextChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportBackgroundTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setSupportBackgroundTintList(android.content.res.ColorStateList)}
 **/
AppCompatTextView.prototype.setSupportBackgroundTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportBackgroundTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreateInputConnection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#onCreateInputConnection(android.view.inputmethod.EditorInfo)}
 **/
AppCompatTextView.prototype.onCreateInputConnection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreateInputConnection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawableStateChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#drawableStateChanged()}
 **/
AppCompatTextView.prototype.drawableStateChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawableStateChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFirstBaselineToTopHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getFirstBaselineToTopHeight()}
 **/
AppCompatTextView.prototype.getFirstBaselineToTopHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFirstBaselineToTopHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#onLayout(boolean, int, int, int, int)}
 **/
AppCompatTextView.prototype.onLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getText()}
 **/
AppCompatTextView.prototype.getText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLastBaselineToBottomHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setLastBaselineToBottomHeight(int)}
 **/
AppCompatTextView.prototype.setLastBaselineToBottomHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLastBaselineToBottomHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAutoSizeTextTypeUniformWithPresetSizes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setAutoSizeTextTypeUniformWithPresetSizes(int[], int)}
 **/
AppCompatTextView.prototype.setAutoSizeTextTypeUniformWithPresetSizes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAutoSizeTextTypeUniformWithPresetSizes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#onMeasure(int, int)}
 **/
AppCompatTextView.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCompoundDrawablesRelativeWithIntrinsicBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCompoundDrawablesRelativeWithIntrinsicBounds(android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable, android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setCompoundDrawablesRelativeWithIntrinsicBounds(int, int, int, int)}
 **/
AppCompatTextView.prototype.setCompoundDrawablesRelativeWithIntrinsicBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCompoundDrawablesRelativeWithIntrinsicBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTextSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setTextSize(int, float)}
 **/
AppCompatTextView.prototype.setTextSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTextSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBackgroundDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setBackgroundDrawable(android.graphics.drawable.Drawable)}
 **/
AppCompatTextView.prototype.setBackgroundDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBackgroundDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportCompoundDrawablesTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setSupportCompoundDrawablesTintList(android.content.res.ColorStateList)}
 **/
AppCompatTextView.prototype.setSupportCompoundDrawablesTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportCompoundDrawablesTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportCompoundDrawablesTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getSupportCompoundDrawablesTintMode()}
 **/
AppCompatTextView.prototype.getSupportCompoundDrawablesTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportCompoundDrawablesTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTextFuture
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setTextFuture(java.util.concurrent.Future)}
 **/
AppCompatTextView.prototype.setTextFuture = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTextFuture',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportCompoundDrawablesTintList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getSupportCompoundDrawablesTintList()}
 **/
AppCompatTextView.prototype.getSupportCompoundDrawablesTintList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportCompoundDrawablesTintList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTextMetricsParamsCompat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#getTextMetricsParamsCompat()}
 **/
AppCompatTextView.prototype.getTextMetricsParamsCompat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTextMetricsParamsCompat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFirstBaselineToTopHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setFirstBaselineToTopHeight(int)}
 **/
AppCompatTextView.prototype.setFirstBaselineToTopHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFirstBaselineToTopHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTextAppearance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setTextAppearance(android.content.Context, int)}
 **/
AppCompatTextView.prototype.setTextAppearance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTextAppearance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportCompoundDrawablesTintMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/AppCompatTextView.html#setSupportCompoundDrawablesTintMode(android.graphics.PorterDuff$Mode)}
 **/
AppCompatTextView.prototype.setSupportCompoundDrawablesTintMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportCompoundDrawablesTintMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.AppCompatTextView') {
			return new AppCompatTextView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AppCompatTextView;
