/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.widget.ForwardingListener
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.widget');

/**
 * @class androidx.appcompat.widget.ForwardingListener
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html}
 **/
var ForwardingListener = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.widget.ForwardingListener')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.appcompat.widget.ForwardingListener. Create a subclass using androidx.appcompat.widget.ForwardingListener.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ForwardingListener.prototype = Object.create(SuperClass.prototype);
ForwardingListener.prototype.constructor = ForwardingListener;

Object.defineProperty(ForwardingListener.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ForwardingListener(this.$native.super);
	},
	enumerable: true
});

ForwardingListener.className = 'androidx.appcompat.widget.ForwardingListener';
ForwardingListener.prototype.className = 'androidx.appcompat.widget.ForwardingListener';

// class property
Object.defineProperty(ForwardingListener, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.widget.ForwardingListener');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ForwardingListener.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.widget.ForwardingListener');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ForwardingListener.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ForwardingListener.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ForwardingListener(Hyperloop.cast('androidx.appcompat.widget.ForwardingListener', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ForwardingListener, 'DisallowIntercept', {
	get: function() {
		return require('./androidx.appcompat.widget.ForwardingListener$DisallowIntercept');
	},
	enumerable: true
});
Object.defineProperty(ForwardingListener, 'TriggerLongPress', {
	get: function() {
		return require('./androidx.appcompat.widget.ForwardingListener$TriggerLongPress');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onViewAttachedToWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html#onViewAttachedToWindow(android.view.View)}
 **/
ForwardingListener.prototype.onViewAttachedToWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onViewAttachedToWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ForwardingListener') {
			return new ForwardingListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onViewDetachedFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html#onViewDetachedFromWindow(android.view.View)}
 **/
ForwardingListener.prototype.onViewDetachedFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onViewDetachedFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ForwardingListener') {
			return new ForwardingListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPopup
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html#getPopup()}
 **/
ForwardingListener.prototype.getPopup = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPopup',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ForwardingListener') {
			return new ForwardingListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTouch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html#onTouch(android.view.View, android.view.MotionEvent)}
 **/
ForwardingListener.prototype.onTouch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTouch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ForwardingListener') {
			return new ForwardingListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onForwardingStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html#onForwardingStarted()}
 **/
ForwardingListener.prototype.onForwardingStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onForwardingStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ForwardingListener') {
			return new ForwardingListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onForwardingStopped
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ForwardingListener.html#onForwardingStopped()}
 **/
ForwardingListener.prototype.onForwardingStopped = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onForwardingStopped',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ForwardingListener') {
			return new ForwardingListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ForwardingListener;
