/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.text.PrecomputedTextCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.text');

/**
 * @class androidx.core.text.PrecomputedTextCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html}
 **/
var PrecomputedTextCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.text.PrecomputedTextCompat')) {
		result = arguments[0];
	}
	else {
		result = PrecomputedTextCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
PrecomputedTextCompat.prototype = Object.create(SuperClass.prototype);
PrecomputedTextCompat.prototype.constructor = PrecomputedTextCompat;

Object.defineProperty(PrecomputedTextCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PrecomputedTextCompat(this.$native.super);
	},
	enumerable: true
});

PrecomputedTextCompat.className = 'androidx.core.text.PrecomputedTextCompat';
PrecomputedTextCompat.prototype.className = 'androidx.core.text.PrecomputedTextCompat';

// class property
Object.defineProperty(PrecomputedTextCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.text.PrecomputedTextCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
PrecomputedTextCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.text.PrecomputedTextCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(PrecomputedTextCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
PrecomputedTextCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PrecomputedTextCompat(Hyperloop.cast('androidx.core.text.PrecomputedTextCompat', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(PrecomputedTextCompat, 'Params', {
	get: function() {
		return require('./androidx.core.text.PrecomputedTextCompat$Params');
	},
	enumerable: true
});
Object.defineProperty(PrecomputedTextCompat, 'PrecomputedTextFutureTask', {
	get: function() {
		return require('./androidx.core.text.PrecomputedTextCompat$PrecomputedTextFutureTask');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getTextFuture
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getTextFuture(java.lang.CharSequence, androidx.core.text.PrecomputedTextCompat$Params, java.util.concurrent.Executor)}
 **/
PrecomputedTextCompat.getTextFuture = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getTextFuture',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function create
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#create(java.lang.CharSequence, androidx.core.text.PrecomputedTextCompat$Params)}
 **/
PrecomputedTextCompat.create = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'create',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getParagraphCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getParagraphCount()}
 **/
PrecomputedTextCompat.prototype.getParagraphCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParagraphCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPrecomputedText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getPrecomputedText()}
 **/
PrecomputedTextCompat.prototype.getPrecomputedText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPrecomputedText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function length
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#length()}
 **/
PrecomputedTextCompat.prototype.length = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'length',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpanStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getSpanStart(java.lang.Object)}
 **/
PrecomputedTextCompat.prototype.getSpanStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpanFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getSpanFlags(java.lang.Object)}
 **/
PrecomputedTextCompat.prototype.getSpanFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function subSequence
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#subSequence(int, int)}
 **/
PrecomputedTextCompat.prototype.subSequence = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'subSequence',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextSpanTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#nextSpanTransition(int, int, java.lang.Class)}
 **/
PrecomputedTextCompat.prototype.nextSpanTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextSpanTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParagraphStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getParagraphStart(int)}
 **/
PrecomputedTextCompat.prototype.getParagraphStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParagraphStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeSpan
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#removeSpan(java.lang.Object)}
 **/
PrecomputedTextCompat.prototype.removeSpan = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeSpan',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpans
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getSpans(int, int, java.lang.Class)}
 **/
PrecomputedTextCompat.prototype.getSpans = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpans',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParagraphEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getParagraphEnd(int)}
 **/
PrecomputedTextCompat.prototype.getParagraphEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParagraphEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSpanEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getSpanEnd(java.lang.Object)}
 **/
PrecomputedTextCompat.prototype.getSpanEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#toString()}
 **/
PrecomputedTextCompat.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSpan
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#setSpan(java.lang.Object, int, int, int)}
 **/
PrecomputedTextCompat.prototype.setSpan = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSpan',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#getParams()}
 **/
PrecomputedTextCompat.prototype.getParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function charAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/text/PrecomputedTextCompat.html#charAt(int)}
 **/
PrecomputedTextCompat.prototype.charAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'charAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.text.PrecomputedTextCompat') {
			return new PrecomputedTextCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PrecomputedTextCompat;
