/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.core.view.AccessibilityDelegateCompat');

/**
 * @class androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter
 * @extends android.view.View.AccessibilityDelegate 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html}
 **/
var AccessibilityDelegateAdapter = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter')) {
		result = arguments[0];
	}
	else {
		result = AccessibilityDelegateAdapter.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.View$AccessibilityDelegate');
AccessibilityDelegateAdapter.prototype = Object.create(SuperClass.prototype);
AccessibilityDelegateAdapter.prototype.constructor = AccessibilityDelegateAdapter;

Object.defineProperty(AccessibilityDelegateAdapter.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityDelegateAdapter(this.$native.super);
	},
	enumerable: true
});

AccessibilityDelegateAdapter.className = 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter';
AccessibilityDelegateAdapter.prototype.className = 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter';

// class property
Object.defineProperty(AccessibilityDelegateAdapter, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter');
	},
	enumerable: true,
	configurable: false
});


// Cast
AccessibilityDelegateAdapter.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityDelegateAdapter(Hyperloop.cast('androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function dispatchPopulateAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#dispatchPopulateAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateAdapter.prototype.dispatchPopulateAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchPopulateAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#onInitializeAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateAdapter.prototype.onInitializeAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccessibilityNodeProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#getAccessibilityNodeProvider(android.view.View)}
 **/
AccessibilityDelegateAdapter.prototype.getAccessibilityNodeProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccessibilityNodeProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function sendAccessibilityEventUnchecked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#sendAccessibilityEventUnchecked(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateAdapter.prototype.sendAccessibilityEventUnchecked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sendAccessibilityEventUnchecked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPopulateAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#onPopulateAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateAdapter.prototype.onPopulateAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPopulateAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRequestSendAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#onRequestSendAccessibilityEvent(android.view.ViewGroup, android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateAdapter.prototype.onRequestSendAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRequestSendAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityNodeInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#onInitializeAccessibilityNodeInfo(android.view.View, android.view.accessibility.AccessibilityNodeInfo)}
 **/
AccessibilityDelegateAdapter.prototype.onInitializeAccessibilityNodeInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityNodeInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function performAccessibilityAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#performAccessibilityAction(android.view.View, int, android.os.Bundle)}
 **/
AccessibilityDelegateAdapter.prototype.performAccessibilityAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performAccessibilityAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function sendAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.AccessibilityDelegateAdapter.html#sendAccessibilityEvent(android.view.View, int)}
 **/
AccessibilityDelegateAdapter.prototype.sendAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sendAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter') {
			return new AccessibilityDelegateAdapter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityDelegateAdapter;
