/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.AccessibilityDelegateCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.view');

/**
 * @class androidx.core.view.AccessibilityDelegateCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html}
 **/
var AccessibilityDelegateCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.AccessibilityDelegateCompat')) {
		result = arguments[0];
	}
	else {
		result = AccessibilityDelegateCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AccessibilityDelegateCompat.prototype = Object.create(SuperClass.prototype);
AccessibilityDelegateCompat.prototype.constructor = AccessibilityDelegateCompat;

Object.defineProperty(AccessibilityDelegateCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityDelegateCompat(this.$native.super);
	},
	enumerable: true
});

AccessibilityDelegateCompat.className = 'androidx.core.view.AccessibilityDelegateCompat';
AccessibilityDelegateCompat.prototype.className = 'androidx.core.view.AccessibilityDelegateCompat';

// class property
Object.defineProperty(AccessibilityDelegateCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.AccessibilityDelegateCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AccessibilityDelegateCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.view.AccessibilityDelegateCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AccessibilityDelegateCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AccessibilityDelegateCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityDelegateCompat(Hyperloop.cast('androidx.core.view.AccessibilityDelegateCompat', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(AccessibilityDelegateCompat, 'AccessibilityDelegateAdapter', {
	get: function() {
		return require('./androidx.core.view.AccessibilityDelegateCompat$AccessibilityDelegateAdapter');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function dispatchPopulateAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#dispatchPopulateAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateCompat.prototype.dispatchPopulateAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchPopulateAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#onInitializeAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateCompat.prototype.onInitializeAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccessibilityNodeProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#getAccessibilityNodeProvider(android.view.View)}
 **/
AccessibilityDelegateCompat.prototype.getAccessibilityNodeProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccessibilityNodeProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function sendAccessibilityEventUnchecked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#sendAccessibilityEventUnchecked(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateCompat.prototype.sendAccessibilityEventUnchecked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sendAccessibilityEventUnchecked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPopulateAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#onPopulateAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateCompat.prototype.onPopulateAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPopulateAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRequestSendAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#onRequestSendAccessibilityEvent(android.view.ViewGroup, android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegateCompat.prototype.onRequestSendAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRequestSendAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityNodeInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#onInitializeAccessibilityNodeInfo(android.view.View, androidx.core.view.accessibility.AccessibilityNodeInfoCompat)}
 **/
AccessibilityDelegateCompat.prototype.onInitializeAccessibilityNodeInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityNodeInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function performAccessibilityAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#performAccessibilityAction(android.view.View, int, android.os.Bundle)}
 **/
AccessibilityDelegateCompat.prototype.performAccessibilityAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performAccessibilityAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function sendAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/AccessibilityDelegateCompat.html#sendAccessibilityEvent(android.view.View, int)}
 **/
AccessibilityDelegateCompat.prototype.sendAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sendAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.AccessibilityDelegateCompat') {
			return new AccessibilityDelegateCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityDelegateCompat;
