/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.ViewPropertyAnimatorCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.view');

/**
 * @class androidx.core.view.ViewPropertyAnimatorCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html}
 **/
var ViewPropertyAnimatorCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.ViewPropertyAnimatorCompat')) {
		result = arguments[0];
	}
	else {
		result = ViewPropertyAnimatorCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ViewPropertyAnimatorCompat.prototype = Object.create(SuperClass.prototype);
ViewPropertyAnimatorCompat.prototype.constructor = ViewPropertyAnimatorCompat;

Object.defineProperty(ViewPropertyAnimatorCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ViewPropertyAnimatorCompat(this.$native.super);
	},
	enumerable: true
});

ViewPropertyAnimatorCompat.className = 'androidx.core.view.ViewPropertyAnimatorCompat';
ViewPropertyAnimatorCompat.prototype.className = 'androidx.core.view.ViewPropertyAnimatorCompat';

// class property
Object.defineProperty(ViewPropertyAnimatorCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.ViewPropertyAnimatorCompat');
	},
	enumerable: true,
	configurable: false
});


// Cast
ViewPropertyAnimatorCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ViewPropertyAnimatorCompat(Hyperloop.cast('androidx.core.view.ViewPropertyAnimatorCompat', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ViewPropertyAnimatorCompat, 'ViewPropertyAnimatorListenerApi14', {
	get: function() {
		return require('./androidx.core.view.ViewPropertyAnimatorCompat$ViewPropertyAnimatorListenerApi14');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#setDuration(long)}
 **/
ViewPropertyAnimatorCompat.prototype.setDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function cancel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#cancel()}
 **/
ViewPropertyAnimatorCompat.prototype.cancel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cancel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rotationYBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#rotationYBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.rotationYBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotationYBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rotationXBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#rotationXBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.rotationXBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotationXBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartDelay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#getStartDelay()}
 **/
ViewPropertyAnimatorCompat.prototype.getStartDelay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartDelay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scaleX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#scaleX(float)}
 **/
ViewPropertyAnimatorCompat.prototype.scaleX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scaleX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scaleY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#scaleY(float)}
 **/
ViewPropertyAnimatorCompat.prototype.scaleY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scaleY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scaleYBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#scaleYBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.scaleYBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scaleYBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rotationX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#rotationX(float)}
 **/
ViewPropertyAnimatorCompat.prototype.rotationX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotationX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scaleXBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#scaleXBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.scaleXBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scaleXBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rotationY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#rotationY(float)}
 **/
ViewPropertyAnimatorCompat.prototype.rotationY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotationY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#getDuration()}
 **/
ViewPropertyAnimatorCompat.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translationXBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#translationXBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.translationXBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translationXBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translationYBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#translationYBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.translationYBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translationYBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function alpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#alpha(float)}
 **/
ViewPropertyAnimatorCompat.prototype.alpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'alpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInterpolator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#getInterpolator()}
 **/
ViewPropertyAnimatorCompat.prototype.getInterpolator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterpolator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withStartAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#withStartAction(java.lang.Runnable)}
 **/
ViewPropertyAnimatorCompat.prototype.withStartAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withStartAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setStartDelay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#setStartDelay(long)}
 **/
ViewPropertyAnimatorCompat.prototype.setStartDelay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setStartDelay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInterpolator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#setInterpolator(android.view.animation.Interpolator)}
 **/
ViewPropertyAnimatorCompat.prototype.setInterpolator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInterpolator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rotationBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#rotationBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.rotationBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotationBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rotation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#rotation(float)}
 **/
ViewPropertyAnimatorCompat.prototype.rotation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function start
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#start()}
 **/
ViewPropertyAnimatorCompat.prototype.start = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'start',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translationZBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#translationZBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.translationZBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translationZBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function xBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#xBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.xBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'xBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#zBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.zBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function yBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#yBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.yBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'yBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translationX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#translationX(float)}
 **/
ViewPropertyAnimatorCompat.prototype.translationX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translationX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function alphaBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#alphaBy(float)}
 **/
ViewPropertyAnimatorCompat.prototype.alphaBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'alphaBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setUpdateListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#setUpdateListener(androidx.core.view.ViewPropertyAnimatorUpdateListener)}
 **/
ViewPropertyAnimatorCompat.prototype.setUpdateListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setUpdateListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function x
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#x(float)}
 **/
ViewPropertyAnimatorCompat.prototype.x = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'x',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withEndAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#withEndAction(java.lang.Runnable)}
 **/
ViewPropertyAnimatorCompat.prototype.withEndAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withEndAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function y
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#y(float)}
 **/
ViewPropertyAnimatorCompat.prototype.y = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'y',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withLayer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#withLayer()}
 **/
ViewPropertyAnimatorCompat.prototype.withLayer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withLayer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#setListener(androidx.core.view.ViewPropertyAnimatorListener)}
 **/
ViewPropertyAnimatorCompat.prototype.setListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function z
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#z(float)}
 **/
ViewPropertyAnimatorCompat.prototype.z = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'z',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translationY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#translationY(float)}
 **/
ViewPropertyAnimatorCompat.prototype.translationY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translationY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translationZ
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/ViewPropertyAnimatorCompat.html#translationZ(float)}
 **/
ViewPropertyAnimatorCompat.prototype.translationZ = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translationZ',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.ViewPropertyAnimatorCompat') {
			return new ViewPropertyAnimatorCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ViewPropertyAnimatorCompat;
