/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.accessibility.AccessibilityNodeProviderCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.view.accessibility');

/**
 * @class androidx.core.view.accessibility.AccessibilityNodeProviderCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html}
 **/
var AccessibilityNodeProviderCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.accessibility.AccessibilityNodeProviderCompat')) {
		result = arguments[0];
	}
	else {
		result = AccessibilityNodeProviderCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AccessibilityNodeProviderCompat.prototype = Object.create(SuperClass.prototype);
AccessibilityNodeProviderCompat.prototype.constructor = AccessibilityNodeProviderCompat;

Object.defineProperty(AccessibilityNodeProviderCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityNodeProviderCompat(this.$native.super);
	},
	enumerable: true
});

AccessibilityNodeProviderCompat.className = 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat';
AccessibilityNodeProviderCompat.prototype.className = 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat';

// class property
Object.defineProperty(AccessibilityNodeProviderCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.accessibility.AccessibilityNodeProviderCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AccessibilityNodeProviderCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.view.accessibility.AccessibilityNodeProviderCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AccessibilityNodeProviderCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AccessibilityNodeProviderCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityNodeProviderCompat(Hyperloop.cast('androidx.core.view.accessibility.AccessibilityNodeProviderCompat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#HOST_VIEW_ID}
 */
AccessibilityNodeProviderCompat.HOST_VIEW_ID = -1;

// Inner classes
Object.defineProperty(AccessibilityNodeProviderCompat, 'AccessibilityNodeProviderApi16', {
	get: function() {
		return require('./androidx.core.view.accessibility.AccessibilityNodeProviderCompat$AccessibilityNodeProviderApi16');
	},
	enumerable: true
});
Object.defineProperty(AccessibilityNodeProviderCompat, 'AccessibilityNodeProviderApi19', {
	get: function() {
		return require('./androidx.core.view.accessibility.AccessibilityNodeProviderCompat$AccessibilityNodeProviderApi19');
	},
	enumerable: true
});
Object.defineProperty(AccessibilityNodeProviderCompat, 'AccessibilityNodeProviderApi26', {
	get: function() {
		return require('./androidx.core.view.accessibility.AccessibilityNodeProviderCompat$AccessibilityNodeProviderApi26');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function performAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#performAction(int, int, android.os.Bundle)}
 **/
AccessibilityNodeProviderCompat.prototype.performAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat') {
			return new AccessibilityNodeProviderCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addExtraDataToAccessibilityNodeInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#addExtraDataToAccessibilityNodeInfo(int, androidx.core.view.accessibility.AccessibilityNodeInfoCompat, java.lang.String, android.os.Bundle)}
 **/
AccessibilityNodeProviderCompat.prototype.addExtraDataToAccessibilityNodeInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addExtraDataToAccessibilityNodeInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat') {
			return new AccessibilityNodeProviderCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#getProvider()}
 **/
AccessibilityNodeProviderCompat.prototype.getProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat') {
			return new AccessibilityNodeProviderCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findAccessibilityNodeInfosByText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#findAccessibilityNodeInfosByText(java.lang.String, int)}
 **/
AccessibilityNodeProviderCompat.prototype.findAccessibilityNodeInfosByText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findAccessibilityNodeInfosByText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat') {
			return new AccessibilityNodeProviderCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createAccessibilityNodeInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#createAccessibilityNodeInfo(int)}
 **/
AccessibilityNodeProviderCompat.prototype.createAccessibilityNodeInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createAccessibilityNodeInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat') {
			return new AccessibilityNodeProviderCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findFocus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeProviderCompat.html#findFocus(int)}
 **/
AccessibilityNodeProviderCompat.prototype.findFocus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findFocus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeProviderCompat') {
			return new AccessibilityNodeProviderCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityNodeProviderCompat;
