/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.accessibility.AccessibilityWindowInfoCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.view.accessibility');

/**
 * @class androidx.core.view.accessibility.AccessibilityWindowInfoCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html}
 **/
var AccessibilityWindowInfoCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.accessibility.AccessibilityWindowInfoCompat')) {
		result = arguments[0];
	}
	else {
		result = AccessibilityWindowInfoCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AccessibilityWindowInfoCompat.prototype = Object.create(SuperClass.prototype);
AccessibilityWindowInfoCompat.prototype.constructor = AccessibilityWindowInfoCompat;

Object.defineProperty(AccessibilityWindowInfoCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityWindowInfoCompat(this.$native.super);
	},
	enumerable: true
});

AccessibilityWindowInfoCompat.className = 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat';
AccessibilityWindowInfoCompat.prototype.className = 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat';

// class property
Object.defineProperty(AccessibilityWindowInfoCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.accessibility.AccessibilityWindowInfoCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AccessibilityWindowInfoCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.view.accessibility.AccessibilityWindowInfoCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AccessibilityWindowInfoCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AccessibilityWindowInfoCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityWindowInfoCompat(Hyperloop.cast('androidx.core.view.accessibility.AccessibilityWindowInfoCompat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#TYPE_INPUT_METHOD}
 */
AccessibilityWindowInfoCompat.TYPE_INPUT_METHOD = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#TYPE_SYSTEM}
 */
AccessibilityWindowInfoCompat.TYPE_SYSTEM = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#TYPE_APPLICATION}
 */
AccessibilityWindowInfoCompat.TYPE_APPLICATION = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#TYPE_ACCESSIBILITY_OVERLAY}
 */
AccessibilityWindowInfoCompat.TYPE_ACCESSIBILITY_OVERLAY = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#TYPE_SPLIT_SCREEN_DIVIDER}
 */
AccessibilityWindowInfoCompat.TYPE_SPLIT_SCREEN_DIVIDER = 5;

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function obtain
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#obtain()}
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#obtain(androidx.core.view.accessibility.AccessibilityWindowInfoCompat)}
 **/
AccessibilityWindowInfoCompat.obtain = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'obtain',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getParent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getParent()}
 **/
AccessibilityWindowInfoCompat.prototype.getParent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLayer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getLayer()}
 **/
AccessibilityWindowInfoCompat.prototype.getLayer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLayer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChild
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getChild(int)}
 **/
AccessibilityWindowInfoCompat.prototype.getChild = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChild',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getId()}
 **/
AccessibilityWindowInfoCompat.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isActive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#isActive()}
 **/
AccessibilityWindowInfoCompat.prototype.isActive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isActive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFocused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#isFocused()}
 **/
AccessibilityWindowInfoCompat.prototype.isFocused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFocused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChildCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getChildCount()}
 **/
AccessibilityWindowInfoCompat.prototype.getChildCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChildCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAccessibilityFocused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#isAccessibilityFocused()}
 **/
AccessibilityWindowInfoCompat.prototype.isAccessibilityFocused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAccessibilityFocused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnchor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getAnchor()}
 **/
AccessibilityWindowInfoCompat.prototype.getAnchor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnchor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getTitle()}
 **/
AccessibilityWindowInfoCompat.prototype.getTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getType()}
 **/
AccessibilityWindowInfoCompat.prototype.getType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#hashCode()}
 **/
AccessibilityWindowInfoCompat.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#equals(java.lang.Object)}
 **/
AccessibilityWindowInfoCompat.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function recycle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#recycle()}
 **/
AccessibilityWindowInfoCompat.prototype.recycle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'recycle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#toString()}
 **/
AccessibilityWindowInfoCompat.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRoot
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getRoot()}
 **/
AccessibilityWindowInfoCompat.prototype.getRoot = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRoot',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoundsInScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityWindowInfoCompat.html#getBoundsInScreen(android.graphics.Rect)}
 **/
AccessibilityWindowInfoCompat.prototype.getBoundsInScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoundsInScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityWindowInfoCompat') {
			return new AccessibilityWindowInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityWindowInfoCompat;
