/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.customview.widget.ViewDragHelper$Callback
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.customview.widget.ViewDragHelper');

/**
 * @class androidx.customview.widget.ViewDragHelper$Callback
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html}
 **/
var Callback = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.customview.widget.ViewDragHelper$Callback')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.customview.widget.ViewDragHelper$Callback. Create a subclass using androidx.customview.widget.ViewDragHelper$Callback.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Callback.prototype = Object.create(SuperClass.prototype);
Callback.prototype.constructor = Callback;

Object.defineProperty(Callback.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Callback(this.$native.super);
	},
	enumerable: true
});

Callback.className = 'androidx.customview.widget.ViewDragHelper$Callback';
Callback.prototype.className = 'androidx.customview.widget.ViewDragHelper$Callback';

// class property
Object.defineProperty(Callback, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.customview.widget.ViewDragHelper$Callback');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Callback.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.customview.widget.ViewDragHelper$Callback');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Callback.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Callback.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Callback(Hyperloop.cast('androidx.customview.widget.ViewDragHelper$Callback', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function tryCaptureView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#tryCaptureView(android.view.View, int)}
 **/
Callback.prototype.tryCaptureView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'tryCaptureView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onViewDragStateChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onViewDragStateChanged(int)}
 **/
Callback.prototype.onViewDragStateChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onViewDragStateChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clampViewPositionVertical
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#clampViewPositionVertical(android.view.View, int, int)}
 **/
Callback.prototype.clampViewPositionVertical = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clampViewPositionVertical',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOrderedChildIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#getOrderedChildIndex(int)}
 **/
Callback.prototype.getOrderedChildIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOrderedChildIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onViewPositionChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onViewPositionChanged(android.view.View, int, int, int, int)}
 **/
Callback.prototype.onViewPositionChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onViewPositionChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onEdgeTouched
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onEdgeTouched(int, int)}
 **/
Callback.prototype.onEdgeTouched = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onEdgeTouched',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onEdgeLock
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onEdgeLock(int)}
 **/
Callback.prototype.onEdgeLock = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onEdgeLock',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clampViewPositionHorizontal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#clampViewPositionHorizontal(android.view.View, int, int)}
 **/
Callback.prototype.clampViewPositionHorizontal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clampViewPositionHorizontal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getViewHorizontalDragRange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#getViewHorizontalDragRange(android.view.View)}
 **/
Callback.prototype.getViewHorizontalDragRange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getViewHorizontalDragRange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onEdgeDragStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onEdgeDragStarted(int, int)}
 **/
Callback.prototype.onEdgeDragStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onEdgeDragStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onViewReleased
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onViewReleased(android.view.View, float, float)}
 **/
Callback.prototype.onViewReleased = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onViewReleased',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getViewVerticalDragRange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#getViewVerticalDragRange(android.view.View)}
 **/
Callback.prototype.getViewVerticalDragRange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getViewVerticalDragRange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onViewCaptured
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.Callback.html#onViewCaptured(android.view.View, int)}
 **/
Callback.prototype.onViewCaptured = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onViewCaptured',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Callback;
