/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.customview.widget.ViewDragHelper
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.customview.widget');

/**
 * @class androidx.customview.widget.ViewDragHelper
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html}
 **/
var ViewDragHelper = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.customview.widget.ViewDragHelper')) {
		result = arguments[0];
	}
	else {
		result = ViewDragHelper.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ViewDragHelper.prototype = Object.create(SuperClass.prototype);
ViewDragHelper.prototype.constructor = ViewDragHelper;

Object.defineProperty(ViewDragHelper.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ViewDragHelper(this.$native.super);
	},
	enumerable: true
});

ViewDragHelper.className = 'androidx.customview.widget.ViewDragHelper';
ViewDragHelper.prototype.className = 'androidx.customview.widget.ViewDragHelper';

// class property
Object.defineProperty(ViewDragHelper, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.customview.widget.ViewDragHelper');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ViewDragHelper.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.customview.widget.ViewDragHelper');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ViewDragHelper.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ViewDragHelper.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ViewDragHelper(Hyperloop.cast('androidx.customview.widget.ViewDragHelper', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#STATE_SETTLING}
 */
ViewDragHelper.STATE_SETTLING = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#EDGE_LEFT}
 */
ViewDragHelper.EDGE_LEFT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#STATE_IDLE}
 */
ViewDragHelper.STATE_IDLE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#EDGE_RIGHT}
 */
ViewDragHelper.EDGE_RIGHT = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#EDGE_ALL}
 */
ViewDragHelper.EDGE_ALL = 15;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#INVALID_POINTER}
 */
ViewDragHelper.INVALID_POINTER = -1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#DIRECTION_HORIZONTAL}
 */
ViewDragHelper.DIRECTION_HORIZONTAL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#EDGE_TOP}
 */
ViewDragHelper.EDGE_TOP = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#DIRECTION_ALL}
 */
ViewDragHelper.DIRECTION_ALL = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#DIRECTION_VERTICAL}
 */
ViewDragHelper.DIRECTION_VERTICAL = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#STATE_DRAGGING}
 */
ViewDragHelper.STATE_DRAGGING = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#EDGE_BOTTOM}
 */
ViewDragHelper.EDGE_BOTTOM = 8;

// Inner classes
Object.defineProperty(ViewDragHelper, 'Callback', {
	get: function() {
		return require('./androidx.customview.widget.ViewDragHelper$Callback');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function create
 * @static
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#create(android.view.ViewGroup, androidx.customview.widget.ViewDragHelper$Callback)}
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#create(android.view.ViewGroup, float, androidx.customview.widget.ViewDragHelper$Callback)}
 **/
ViewDragHelper.create = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'create',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function captureChildView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#captureChildView(android.view.View, int)}
 **/
ViewDragHelper.prototype.captureChildView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'captureChildView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function cancel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#cancel()}
 **/
ViewDragHelper.prototype.cancel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cancel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isCapturedViewUnder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#isCapturedViewUnder(int, int)}
 **/
ViewDragHelper.prototype.isCapturedViewUnder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isCapturedViewUnder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isViewUnder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#isViewUnder(android.view.View, int, int)}
 **/
ViewDragHelper.prototype.isViewUnder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isViewUnder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEdgeTouched
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#isEdgeTouched(int)}
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#isEdgeTouched(int, int)}
 **/
ViewDragHelper.prototype.isEdgeTouched = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEdgeTouched',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function continueSettling
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#continueSettling(boolean)}
 **/
ViewDragHelper.prototype.continueSettling = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'continueSettling',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEdgeSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getEdgeSize()}
 **/
ViewDragHelper.prototype.getEdgeSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEdgeSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function settleCapturedViewAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#settleCapturedViewAt(int, int)}
 **/
ViewDragHelper.prototype.settleCapturedViewAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'settleCapturedViewAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinVelocity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getMinVelocity()}
 **/
ViewDragHelper.prototype.getMinVelocity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinVelocity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getViewDragState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getViewDragState()}
 **/
ViewDragHelper.prototype.getViewDragState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getViewDragState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findTopChildUnder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#findTopChildUnder(int, int)}
 **/
ViewDragHelper.prototype.findTopChildUnder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findTopChildUnder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEdgeTrackingEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#setEdgeTrackingEnabled(int)}
 **/
ViewDragHelper.prototype.setEdgeTrackingEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEdgeTrackingEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function flingCapturedView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#flingCapturedView(int, int, int, int)}
 **/
ViewDragHelper.prototype.flingCapturedView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flingCapturedView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkTouchSlop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#checkTouchSlop(int)}
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#checkTouchSlop(int, int)}
 **/
ViewDragHelper.prototype.checkTouchSlop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkTouchSlop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDefaultEdgeSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getDefaultEdgeSize()}
 **/
ViewDragHelper.prototype.getDefaultEdgeSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDefaultEdgeSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEdgeSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#setEdgeSize(int)}
 **/
ViewDragHelper.prototype.setEdgeSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEdgeSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isPointerDown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#isPointerDown(int)}
 **/
ViewDragHelper.prototype.isPointerDown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isPointerDown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function abort
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#abort()}
 **/
ViewDragHelper.prototype.abort = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'abort',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function processTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#processTouchEvent(android.view.MotionEvent)}
 **/
ViewDragHelper.prototype.processTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'processTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActivePointerId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getActivePointerId()}
 **/
ViewDragHelper.prototype.getActivePointerId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActivePointerId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTouchSlop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getTouchSlop()}
 **/
ViewDragHelper.prototype.getTouchSlop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTouchSlop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function smoothSlideViewTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#smoothSlideViewTo(android.view.View, int, int)}
 **/
ViewDragHelper.prototype.smoothSlideViewTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'smoothSlideViewTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function canScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#canScroll(android.view.View, boolean, int, int, int, int)}
 **/
ViewDragHelper.prototype.canScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function shouldInterceptTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#shouldInterceptTouchEvent(android.view.MotionEvent)}
 **/
ViewDragHelper.prototype.shouldInterceptTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shouldInterceptTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCapturedView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#getCapturedView()}
 **/
ViewDragHelper.prototype.getCapturedView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCapturedView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setMinVelocity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/customview/widget/ViewDragHelper.html#setMinVelocity(float)}
 **/
ViewDragHelper.prototype.setMinVelocity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setMinVelocity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.customview.widget.ViewDragHelper') {
			return new ViewDragHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ViewDragHelper;
