/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module DrawerListener
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.drawerlayout.widget.DrawerLayout');

/**
 * constructor
 * http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.DrawerListener.html
 **/
var DrawerListener = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'androidx.drawerlayout.widget.DrawerLayout$DrawerListener') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('androidx.drawerlayout.widget.DrawerLayout$DrawerListener');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
DrawerListener.prototype = Object.create(SuperClass.prototype);
DrawerListener.prototype.constructor = DrawerListener;

Object.defineProperty(DrawerListener.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DrawerListener(this.$native.super);
	},
	enumerable: true
});

DrawerListener.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

DrawerListener.className = "androidx.drawerlayout.widget.DrawerLayout$DrawerListener";
DrawerListener.prototype.className = "androidx.drawerlayout.widget.DrawerLayout$DrawerListener";

// class property
Object.defineProperty(DrawerListener, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.drawerlayout.widget.DrawerLayout$DrawerListener');
	},
	enumerable: true,
	configurable: false
});

// Cast
DrawerListener.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DrawerListener(Hyperloop.cast('androidx.drawerlayout.widget.DrawerLayout$DrawerListener', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function onDrawerOpened
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.DrawerListener.html#onDrawerOpened(android.view.View)}
 **/
DrawerListener.prototype.onDrawerOpened = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerOpened',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$DrawerListener') {
			return new DrawerListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onDrawerSlide
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.DrawerListener.html#onDrawerSlide(android.view.View, float)}
 **/
DrawerListener.prototype.onDrawerSlide = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerSlide',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$DrawerListener') {
			return new DrawerListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onDrawerClosed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.DrawerListener.html#onDrawerClosed(android.view.View)}
 **/
DrawerListener.prototype.onDrawerClosed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerClosed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$DrawerListener') {
			return new DrawerListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onDrawerStateChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.DrawerListener.html#onDrawerStateChanged(int)}
 **/
DrawerListener.prototype.onDrawerStateChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerStateChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$DrawerListener') {
			return new DrawerListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

DrawerListener.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

DrawerListener.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = DrawerListener;
