/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.drawerlayout.widget.DrawerLayout
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.drawerlayout.widget');

/**
 * @class androidx.drawerlayout.widget.DrawerLayout
 * @extends android.view.ViewGroup 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html}
 **/
var DrawerLayout = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.drawerlayout.widget.DrawerLayout')) {
		result = arguments[0];
	}
	else {
		result = DrawerLayout.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.ViewGroup');
DrawerLayout.prototype = Object.create(SuperClass.prototype);
DrawerLayout.prototype.constructor = DrawerLayout;

Object.defineProperty(DrawerLayout.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DrawerLayout(this.$native.super);
	},
	enumerable: true
});

DrawerLayout.className = 'androidx.drawerlayout.widget.DrawerLayout';
DrawerLayout.prototype.className = 'androidx.drawerlayout.widget.DrawerLayout';

// class property
Object.defineProperty(DrawerLayout, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.drawerlayout.widget.DrawerLayout');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
DrawerLayout.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.drawerlayout.widget.DrawerLayout');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(DrawerLayout.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
DrawerLayout.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DrawerLayout(Hyperloop.cast('androidx.drawerlayout.widget.DrawerLayout', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#STATE_SETTLING}
 */
DrawerLayout.STATE_SETTLING = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#LOCK_MODE_UNLOCKED}
 */
DrawerLayout.LOCK_MODE_UNLOCKED = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#LOCK_MODE_UNDEFINED}
 */
DrawerLayout.LOCK_MODE_UNDEFINED = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#LOCK_MODE_LOCKED_CLOSED}
 */
DrawerLayout.LOCK_MODE_LOCKED_CLOSED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#STATE_IDLE}
 */
DrawerLayout.STATE_IDLE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#LOCK_MODE_LOCKED_OPEN}
 */
DrawerLayout.LOCK_MODE_LOCKED_OPEN = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#STATE_DRAGGING}
 */
DrawerLayout.STATE_DRAGGING = 1;

// Inner classes
Object.defineProperty(DrawerLayout, 'AccessibilityDelegate', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate');
	},
	enumerable: true
});
Object.defineProperty(DrawerLayout, 'ChildAccessibilityDelegate', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$ChildAccessibilityDelegate');
	},
	enumerable: true
});
Object.defineProperty(DrawerLayout, 'DrawerListener', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$DrawerListener');
	},
	enumerable: true
});
Object.defineProperty(DrawerLayout, 'LayoutParams', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$LayoutParams');
	},
	enumerable: true
});
Object.defineProperty(DrawerLayout, 'SavedState', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$SavedState');
	},
	enumerable: true
});
Object.defineProperty(DrawerLayout, 'SimpleDrawerListener', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$SimpleDrawerListener');
	},
	enumerable: true
});
Object.defineProperty(DrawerLayout, 'ViewDragCallback', {
	get: function() {
		return require('./androidx.drawerlayout.widget.DrawerLayout$ViewDragCallback');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setDrawerLockMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerLockMode(int)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerLockMode(int, int)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerLockMode(int, android.view.View)}
 **/
DrawerLayout.prototype.setDrawerLockMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerLockMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInterceptTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onInterceptTouchEvent(android.view.MotionEvent)}
 **/
DrawerLayout.prototype.onInterceptTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInterceptTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onKeyDown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onKeyDown(int, android.view.KeyEvent)}
 **/
DrawerLayout.prototype.onKeyDown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onKeyDown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generateLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#generateLayoutParams(android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#generateLayoutParams(android.util.AttributeSet)}
 **/
DrawerLayout.prototype.generateLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrawerElevation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#getDrawerElevation()}
 **/
DrawerLayout.prototype.getDrawerElevation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrawerElevation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRestoreInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onRestoreInstanceState(android.os.Parcelable)}
 **/
DrawerLayout.prototype.onRestoreInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRestoreInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#computeScroll()}
 **/
DrawerLayout.prototype.computeScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setScrimColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setScrimColor(int)}
 **/
DrawerLayout.prototype.setScrimColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setScrimColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRtlPropertiesChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onRtlPropertiesChanged(int)}
 **/
DrawerLayout.prototype.onRtlPropertiesChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRtlPropertiesChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generateDefaultLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#generateDefaultLayoutParams()}
 **/
DrawerLayout.prototype.generateDefaultLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateDefaultLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function openDrawer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#openDrawer(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#openDrawer(android.view.View, boolean)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#openDrawer(int)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#openDrawer(int, boolean)}
 **/
DrawerLayout.prototype.openDrawer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'openDrawer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDrawerVisible
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#isDrawerVisible(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#isDrawerVisible(int)}
 **/
DrawerLayout.prototype.isDrawerVisible = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDrawerVisible',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function closeDrawers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#closeDrawers()}
 **/
DrawerLayout.prototype.closeDrawers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'closeDrawers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDrawerOpen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#isDrawerOpen(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#isDrawerOpen(int)}
 **/
DrawerLayout.prototype.isDrawerOpen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDrawerOpen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawChild
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#drawChild(android.graphics.Canvas, android.view.View, long)}
 **/
DrawerLayout.prototype.drawChild = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawChild',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrawerTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#getDrawerTitle(int)}
 **/
DrawerLayout.prototype.getDrawerTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrawerTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#checkLayoutParams(android.view.ViewGroup$LayoutParams)}
 **/
DrawerLayout.prototype.checkLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function closeDrawer
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#closeDrawer(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#closeDrawer(android.view.View, boolean)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#closeDrawer(int)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#closeDrawer(int, boolean)}
 **/
DrawerLayout.prototype.closeDrawer = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'closeDrawer',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDraw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onDraw(android.graphics.Canvas)}
 **/
DrawerLayout.prototype.onDraw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDraw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchGenericMotionEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#dispatchGenericMotionEvent(android.view.MotionEvent)}
 **/
DrawerLayout.prototype.dispatchGenericMotionEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchGenericMotionEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setStatusBarBackground
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setStatusBarBackground(android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setStatusBarBackground(int)}
 **/
DrawerLayout.prototype.setStatusBarBackground = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setStatusBarBackground',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#close()}
 **/
DrawerLayout.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAttachedToWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onAttachedToWindow()}
 **/
DrawerLayout.prototype.onAttachedToWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAttachedToWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onKeyUp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onKeyUp(int, android.view.KeyEvent)}
 **/
DrawerLayout.prototype.onKeyUp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onKeyUp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrawerElevation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerElevation(float)}
 **/
DrawerLayout.prototype.setDrawerElevation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerElevation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onTouchEvent(android.view.MotionEvent)}
 **/
DrawerLayout.prototype.onTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStatusBarBackgroundDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#getStatusBarBackgroundDrawable()}
 **/
DrawerLayout.prototype.getStatusBarBackgroundDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStatusBarBackgroundDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onLayout(boolean, int, int, int, int)}
 **/
DrawerLayout.prototype.onLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setChildInsets
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setChildInsets(java.lang.Object, boolean)}
 **/
DrawerLayout.prototype.setChildInsets = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setChildInsets',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrawerTitle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerTitle(int, java.lang.CharSequence)}
 **/
DrawerLayout.prototype.setDrawerTitle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerTitle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onMeasure(int, int)}
 **/
DrawerLayout.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setStatusBarBackgroundColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setStatusBarBackgroundColor(int)}
 **/
DrawerLayout.prototype.setStatusBarBackgroundColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setStatusBarBackgroundColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#addView(android.view.View, int, android.view.ViewGroup$LayoutParams)}
 **/
DrawerLayout.prototype.addView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeDrawerListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#removeDrawerListener(androidx.drawerlayout.widget.DrawerLayout$DrawerListener)}
 **/
DrawerLayout.prototype.removeDrawerListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeDrawerListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrawerShadow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerShadow(android.graphics.drawable.Drawable, int)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerShadow(int, int)}
 **/
DrawerLayout.prototype.setDrawerShadow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerShadow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addFocusables
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#addFocusables(java.util.ArrayList, int, int)}
 **/
DrawerLayout.prototype.addFocusables = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addFocusables',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOpen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#isOpen()}
 **/
DrawerLayout.prototype.isOpen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOpen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrawerListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#setDrawerListener(androidx.drawerlayout.widget.DrawerLayout$DrawerListener)}
 **/
DrawerLayout.prototype.setDrawerListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#requestLayout()}
 **/
DrawerLayout.prototype.requestLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestDisallowInterceptTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#requestDisallowInterceptTouchEvent(boolean)}
 **/
DrawerLayout.prototype.requestDisallowInterceptTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestDisallowInterceptTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onSaveInstanceState()}
 **/
DrawerLayout.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDetachedFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#onDetachedFromWindow()}
 **/
DrawerLayout.prototype.onDetachedFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDetachedFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addDrawerListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#addDrawerListener(androidx.drawerlayout.widget.DrawerLayout$DrawerListener)}
 **/
DrawerLayout.prototype.addDrawerListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addDrawerListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function open
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#open()}
 **/
DrawerLayout.prototype.open = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'open',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrawerLockMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#getDrawerLockMode(int)}
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.html#getDrawerLockMode(android.view.View)}
 **/
DrawerLayout.prototype.getDrawerLockMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrawerLockMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout') {
			return new DrawerLayout(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DrawerLayout;
