/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.fragment.app.FragmentFactory
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.fragment.app');

/**
 * @class androidx.fragment.app.FragmentFactory
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentFactory.html}
 **/
var FragmentFactory = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.fragment.app.FragmentFactory')) {
		result = arguments[0];
	}
	else {
		result = FragmentFactory.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FragmentFactory.prototype = Object.create(SuperClass.prototype);
FragmentFactory.prototype.constructor = FragmentFactory;

Object.defineProperty(FragmentFactory.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FragmentFactory(this.$native.super);
	},
	enumerable: true
});

FragmentFactory.className = 'androidx.fragment.app.FragmentFactory';
FragmentFactory.prototype.className = 'androidx.fragment.app.FragmentFactory';

// class property
Object.defineProperty(FragmentFactory, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.fragment.app.FragmentFactory');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FragmentFactory.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.fragment.app.FragmentFactory');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FragmentFactory.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FragmentFactory.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FragmentFactory(Hyperloop.cast('androidx.fragment.app.FragmentFactory', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function loadFragmentClass
 * @static
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentFactory.html#loadFragmentClass(java.lang.ClassLoader, java.lang.String)}
 **/
FragmentFactory.loadFragmentClass = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'loadFragmentClass',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentFactory') {
			return new FragmentFactory(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function instantiate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentFactory.html#instantiate(java.lang.ClassLoader, java.lang.String)}
 **/
FragmentFactory.prototype.instantiate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'instantiate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentFactory') {
			return new FragmentFactory(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FragmentFactory;
