/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.lifecycle.LiveData
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.lifecycle');

/**
 * @class androidx.lifecycle.LiveData
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html}
 **/
var LiveData = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.lifecycle.LiveData')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.lifecycle.LiveData. Create a subclass using androidx.lifecycle.LiveData.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
LiveData.prototype = Object.create(SuperClass.prototype);
LiveData.prototype.constructor = LiveData;

Object.defineProperty(LiveData.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new LiveData(this.$native.super);
	},
	enumerable: true
});

LiveData.className = 'androidx.lifecycle.LiveData';
LiveData.prototype.className = 'androidx.lifecycle.LiveData';

// class property
Object.defineProperty(LiveData, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.lifecycle.LiveData');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
LiveData.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.lifecycle.LiveData');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(LiveData.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
LiveData.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new LiveData(Hyperloop.cast('androidx.lifecycle.LiveData', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(LiveData, 'AlwaysActiveObserver', {
	get: function() {
		return require('./androidx.lifecycle.LiveData$AlwaysActiveObserver');
	},
	enumerable: true
});
Object.defineProperty(LiveData, 'LifecycleBoundObserver', {
	get: function() {
		return require('./androidx.lifecycle.LiveData$LifecycleBoundObserver');
	},
	enumerable: true
});
Object.defineProperty(LiveData, 'ObserverWrapper', {
	get: function() {
		return require('./androidx.lifecycle.LiveData$ObserverWrapper');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#getValue()}
 **/
LiveData.prototype.getValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onActive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#onActive()}
 **/
LiveData.prototype.onActive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeObservers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#removeObservers(androidx.lifecycle.LifecycleOwner)}
 **/
LiveData.prototype.removeObservers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeObservers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasObservers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#hasObservers()}
 **/
LiveData.prototype.hasObservers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasObservers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeObserver
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#removeObserver(androidx.lifecycle.Observer)}
 **/
LiveData.prototype.removeObserver = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeObserver',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#setValue(java.lang.Object)}
 **/
LiveData.prototype.setValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInactive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#onInactive()}
 **/
LiveData.prototype.onInactive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInactive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function postValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#postValue(java.lang.Object)}
 **/
LiveData.prototype.postValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'postValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasActiveObservers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#hasActiveObservers()}
 **/
LiveData.prototype.hasActiveObservers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasActiveObservers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function observe
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#observe(androidx.lifecycle.LifecycleOwner, androidx.lifecycle.Observer)}
 **/
LiveData.prototype.observe = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'observe',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function observeForever
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/lifecycle/LiveData.html#observeForever(androidx.lifecycle.Observer)}
 **/
LiveData.prototype.observeForever = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'observeForever',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.lifecycle.LiveData') {
			return new LiveData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = LiveData;
