/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.savedstate.SavedStateRegistry
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.savedstate');

/**
 * @class androidx.savedstate.SavedStateRegistry
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/savedstate/SavedStateRegistry.html}
 **/
var SavedStateRegistry = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.savedstate.SavedStateRegistry')) {
		result = arguments[0];
	}
	else {
		result = SavedStateRegistry.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
SavedStateRegistry.prototype = Object.create(SuperClass.prototype);
SavedStateRegistry.prototype.constructor = SavedStateRegistry;

Object.defineProperty(SavedStateRegistry.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SavedStateRegistry(this.$native.super);
	},
	enumerable: true
});

SavedStateRegistry.className = 'androidx.savedstate.SavedStateRegistry';
SavedStateRegistry.prototype.className = 'androidx.savedstate.SavedStateRegistry';

// class property
Object.defineProperty(SavedStateRegistry, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.savedstate.SavedStateRegistry');
	},
	enumerable: true,
	configurable: false
});


// Cast
SavedStateRegistry.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SavedStateRegistry(Hyperloop.cast('androidx.savedstate.SavedStateRegistry', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(SavedStateRegistry, 'AutoRecreated', {
	get: function() {
		return require('./androidx.savedstate.SavedStateRegistry$AutoRecreated');
	},
	enumerable: true
});
Object.defineProperty(SavedStateRegistry, 'SavedStateProvider', {
	get: function() {
		return require('./androidx.savedstate.SavedStateRegistry$SavedStateProvider');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function unregisterSavedStateProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/savedstate/SavedStateRegistry.html#unregisterSavedStateProvider(java.lang.String)}
 **/
SavedStateRegistry.prototype.unregisterSavedStateProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterSavedStateProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.savedstate.SavedStateRegistry') {
			return new SavedStateRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerSavedStateProvider
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/savedstate/SavedStateRegistry.html#registerSavedStateProvider(java.lang.String, androidx.savedstate.SavedStateRegistry$SavedStateProvider)}
 **/
SavedStateRegistry.prototype.registerSavedStateProvider = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerSavedStateProvider',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.savedstate.SavedStateRegistry') {
			return new SavedStateRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isRestored
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/savedstate/SavedStateRegistry.html#isRestored()}
 **/
SavedStateRegistry.prototype.isRestored = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isRestored',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.savedstate.SavedStateRegistry') {
			return new SavedStateRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function runOnNextRecreation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/savedstate/SavedStateRegistry.html#runOnNextRecreation(java.lang.Class)}
 **/
SavedStateRegistry.prototype.runOnNextRecreation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'runOnNextRecreation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.savedstate.SavedStateRegistry') {
			return new SavedStateRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function consumeRestoredStateForKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/savedstate/SavedStateRegistry.html#consumeRestoredStateForKey(java.lang.String)}
 **/
SavedStateRegistry.prototype.consumeRestoredStateForKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'consumeRestoredStateForKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.savedstate.SavedStateRegistry') {
			return new SavedStateRegistry(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SavedStateRegistry;
