/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.GoogleApiAvailability
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common');

/**
 * @class com.google.android.gms.common.GoogleApiAvailability
 * @extends com.google.android.gms.common.GoogleApiAvailabilityLight 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html}
 **/
var GoogleApiAvailability = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.GoogleApiAvailability')) {
		result = arguments[0];
	}
	else {
		result = GoogleApiAvailability.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.GoogleApiAvailabilityLight');
GoogleApiAvailability.prototype = Object.create(SuperClass.prototype);
GoogleApiAvailability.prototype.constructor = GoogleApiAvailability;

Object.defineProperty(GoogleApiAvailability.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GoogleApiAvailability(this.$native.super);
	},
	enumerable: true
});

GoogleApiAvailability.className = 'com.google.android.gms.common.GoogleApiAvailability';
GoogleApiAvailability.prototype.className = 'com.google.android.gms.common.GoogleApiAvailability';

// class property
Object.defineProperty(GoogleApiAvailability, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.GoogleApiAvailability');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GoogleApiAvailability.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.GoogleApiAvailability');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GoogleApiAvailability.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GoogleApiAvailability.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GoogleApiAvailability(Hyperloop.cast('com.google.android.gms.common.GoogleApiAvailability', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#GOOGLE_PLAY_SERVICES_PACKAGE}
 */
GoogleApiAvailability.GOOGLE_PLAY_SERVICES_PACKAGE = "com.google.android.gms";

// Inner classes
Object.defineProperty(GoogleApiAvailability, 'zaa', {
	get: function() {
		return require('./com.google.android.gms.common.GoogleApiAvailability$zaa');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#GOOGLE_PLAY_SERVICES_VERSION_CODE
Object.defineProperty(GoogleApiAvailability, 'GOOGLE_PLAY_SERVICES_VERSION_CODE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('GOOGLE_PLAY_SERVICES_VERSION_CODE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
				return new GoogleApiAvailability(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getInstance
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getInstance()}
 **/
GoogleApiAvailability.getInstance = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getInstance',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zaa
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#zaa(android.app.Activity, android.content.DialogInterface$OnCancelListener)}
 **/
GoogleApiAvailability.zaa = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'zaa',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isUserResolvableError
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#isUserResolvableError(int)}
 **/
GoogleApiAvailability.prototype.isUserResolvableError = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUserResolvableError',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getErrorString(int)}
 **/
GoogleApiAvailability.prototype.getErrorString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorResolutionPendingIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getErrorResolutionPendingIntent(android.content.Context, int, int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getErrorResolutionPendingIntent(android.content.Context, com.google.android.gms.common.ConnectionResult)}
 **/
GoogleApiAvailability.prototype.getErrorResolutionPendingIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorResolutionPendingIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeGooglePlayServicesAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#makeGooglePlayServicesAvailable(android.app.Activity)}
 **/
GoogleApiAvailability.prototype.makeGooglePlayServicesAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'makeGooglePlayServicesAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isGooglePlayServicesAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#isGooglePlayServicesAvailable(android.content.Context)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#isGooglePlayServicesAvailable(android.content.Context, int)}
 **/
GoogleApiAvailability.prototype.isGooglePlayServicesAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isGooglePlayServicesAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showErrorNotification
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#showErrorNotification(android.content.Context, int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#showErrorNotification(android.content.Context, com.google.android.gms.common.ConnectionResult)}
 **/
GoogleApiAvailability.prototype.showErrorNotification = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showErrorNotification',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showErrorDialogFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#showErrorDialogFragment(android.app.Activity, int, int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#showErrorDialogFragment(android.app.Activity, int, int, android.content.DialogInterface$OnCancelListener)}
 **/
GoogleApiAvailability.prototype.showErrorDialogFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showErrorDialogFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkApiAvailability
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#checkApiAvailability(com.google.android.gms.common.api.GoogleApi, com.google.android.gms.common.api.GoogleApi[])}
 **/
GoogleApiAvailability.prototype.checkApiAvailability = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkApiAvailability',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getClientVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getClientVersion(android.content.Context)}
 **/
GoogleApiAvailability.prototype.getClientVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClientVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDefaultNotificationChannelId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#setDefaultNotificationChannelId(android.content.Context, java.lang.String)}
 **/
GoogleApiAvailability.prototype.setDefaultNotificationChannelId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDefaultNotificationChannelId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorResolutionIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getErrorResolutionIntent(android.content.Context, int, java.lang.String)}
 **/
GoogleApiAvailability.prototype.getErrorResolutionIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorResolutionIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zaa
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#zaa(android.app.Activity, com.google.android.gms.common.api.internal.LifecycleFragment, int, int, android.content.DialogInterface$OnCancelListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#zaa(android.content.Context, com.google.android.gms.common.ConnectionResult, int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#zaa(android.content.Context, com.google.android.gms.common.api.internal.zabr)}
 **/
GoogleApiAvailability.prototype.zaa = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zaa',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorDialog
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getErrorDialog(android.app.Activity, int, int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailability.html#getErrorDialog(android.app.Activity, int, int, android.content.DialogInterface$OnCancelListener)}
 **/
GoogleApiAvailability.prototype.getErrorDialog = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorDialog',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailability') {
			return new GoogleApiAvailability(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GoogleApiAvailability;
