/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.Api$AbstractClientBuilder
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./com.google.android.gms.common.api.Api');

/**
 * @class com.google.android.gms.common.api.Api$AbstractClientBuilder
 * @extends com.google.android.gms.common.api.Api.BaseClientBuilder 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.AbstractClientBuilder.html}
 **/
var AbstractClientBuilder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.Api$AbstractClientBuilder')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.common.api.Api$AbstractClientBuilder. Create a subclass using com.google.android.gms.common.api.Api$AbstractClientBuilder.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.api.Api$BaseClientBuilder');
AbstractClientBuilder.prototype = Object.create(SuperClass.prototype);
AbstractClientBuilder.prototype.constructor = AbstractClientBuilder;

Object.defineProperty(AbstractClientBuilder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AbstractClientBuilder(this.$native.super);
	},
	enumerable: true
});

AbstractClientBuilder.className = 'com.google.android.gms.common.api.Api$AbstractClientBuilder';
AbstractClientBuilder.prototype.className = 'com.google.android.gms.common.api.Api$AbstractClientBuilder';

// class property
Object.defineProperty(AbstractClientBuilder, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.Api$AbstractClientBuilder');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AbstractClientBuilder.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.Api$AbstractClientBuilder');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AbstractClientBuilder.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AbstractClientBuilder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AbstractClientBuilder(Hyperloop.cast('com.google.android.gms.common.api.Api$AbstractClientBuilder', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function buildClient
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.AbstractClientBuilder.html#buildClient(android.content.Context, android.os.Looper, com.google.android.gms.common.internal.ClientSettings, java.lang.Object, com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks, com.google.android.gms.common.api.GoogleApiClient$OnConnectionFailedListener)}
 **/
AbstractClientBuilder.prototype.buildClient = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'buildClient',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$AbstractClientBuilder') {
			return new AbstractClientBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AbstractClientBuilder;
