/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Client
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./com.google.android.gms.common.api.Api');

/**
 * constructor
 * http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html
 **/
var Client = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'com.google.android.gms.common.api.Api$Client') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('com.google.android.gms.common.api.Api$Client');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Client.prototype = Object.create(SuperClass.prototype);
Client.prototype.constructor = Client;

Object.defineProperty(Client.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Client(this.$native.super);
	},
	enumerable: true
});

Client.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Client.className = "com.google.android.gms.common.api.Api$Client";
Client.prototype.className = "com.google.android.gms.common.api.Api$Client";

// class property
Object.defineProperty(Client, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.Api$Client');
	},
	enumerable: true,
	configurable: false
});

// Cast
Client.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Client(Hyperloop.cast('com.google.android.gms.common.api.Api$Client', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function disconnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#disconnect()}
 **/
Client.prototype.disconnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'disconnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getRequiredFeatures
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getRequiredFeatures()}
 **/
Client.prototype.getRequiredFeatures = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRequiredFeatures',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getRemoteService
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getRemoteService(com.google.android.gms.common.internal.IAccountAccessor, java.util.Set)}
 **/
Client.prototype.getRemoteService = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRemoteService',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isConnected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#isConnected()}
 **/
Client.prototype.isConnected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function requiresSignIn
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#requiresSignIn()}
 **/
Client.prototype.requiresSignIn = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requiresSignIn',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isConnecting
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#isConnecting()}
 **/
Client.prototype.isConnecting = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnecting',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function requiresAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#requiresAccount()}
 **/
Client.prototype.requiresAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requiresAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSignInIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getSignInIntent()}
 **/
Client.prototype.getSignInIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSignInIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onUserSignOut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#onUserSignOut(com.google.android.gms.common.internal.BaseGmsClient$SignOutCallbacks)}
 **/
Client.prototype.onUserSignOut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onUserSignOut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getServiceBrokerBinder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getServiceBrokerBinder()}
 **/
Client.prototype.getServiceBrokerBinder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getServiceBrokerBinder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getMinApkVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getMinApkVersion()}
 **/
Client.prototype.getMinApkVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinApkVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function requiresGooglePlayServices
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#requiresGooglePlayServices()}
 **/
Client.prototype.requiresGooglePlayServices = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requiresGooglePlayServices',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getEndpointPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getEndpointPackageName()}
 **/
Client.prototype.getEndpointPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEndpointPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#dump(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
Client.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function connect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#connect(com.google.android.gms.common.internal.BaseGmsClient$ConnectionProgressReportCallbacks)}
 **/
Client.prototype.connect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'connect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function providesSignIn
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#providesSignIn()}
 **/
Client.prototype.providesSignIn = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'providesSignIn',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAvailableFeatures
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.Client.html#getAvailableFeatures()}
 **/
Client.prototype.getAvailableFeatures = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAvailableFeatures',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api$Client') {
			return new Client(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Client.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Client.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Client;
