/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.Api
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api');

/**
 * @class com.google.android.gms.common.api.Api
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.html}
 **/
var Api = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.Api')) {
		result = arguments[0];
	}
	else {
		result = Api.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Api.prototype = Object.create(SuperClass.prototype);
Api.prototype.constructor = Api;

Object.defineProperty(Api.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Api(this.$native.super);
	},
	enumerable: true
});

Api.className = 'com.google.android.gms.common.api.Api';
Api.prototype.className = 'com.google.android.gms.common.api.Api';

// class property
Object.defineProperty(Api, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.Api');
	},
	enumerable: true,
	configurable: false
});


// Cast
Api.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Api(Hyperloop.cast('com.google.android.gms.common.api.Api', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(Api, 'AbstractClientBuilder', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$AbstractClientBuilder');
	},
	enumerable: true
});
Object.defineProperty(Api, 'AnyClient', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$AnyClient');
	},
	enumerable: true
});
Object.defineProperty(Api, 'AnyClientKey', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$AnyClientKey');
	},
	enumerable: true
});
Object.defineProperty(Api, 'ApiOptions', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$ApiOptions');
	},
	enumerable: true
});
Object.defineProperty(Api, 'BaseClientBuilder', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$BaseClientBuilder');
	},
	enumerable: true
});
Object.defineProperty(Api, 'Client', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$Client');
	},
	enumerable: true
});
Object.defineProperty(Api, 'ClientKey', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$ClientKey');
	},
	enumerable: true
});
Object.defineProperty(Api, 'SimpleClient', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$SimpleClient');
	},
	enumerable: true
});
Object.defineProperty(Api, 'zaa', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$zaa');
	},
	enumerable: true
});
Object.defineProperty(Api, 'zab', {
	get: function() {
		return require('./com.google.android.gms.common.api.Api$zab');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function zah
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.html#zah()}
 **/
Api.prototype.zah = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zah',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api') {
			return new Api(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getClientKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.html#getClientKey()}
 **/
Api.prototype.getClientKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClientKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api') {
			return new Api(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zai
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.html#zai()}
 **/
Api.prototype.zai = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zai',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api') {
			return new Api(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Api.html#getName()}
 **/
Api.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Api') {
			return new Api(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Api;
