/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.GoogleApi$Settings
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./com.google.android.gms.common.api.GoogleApi');

/**
 * @class com.google.android.gms.common.api.GoogleApi$Settings
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.Settings.html}
 **/
var Settings = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.GoogleApi$Settings')) {
		result = arguments[0];
	}
	else {
		result = Settings.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Settings.prototype = Object.create(SuperClass.prototype);
Settings.prototype.constructor = Settings;

Object.defineProperty(Settings.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Settings(this.$native.super);
	},
	enumerable: true
});

Settings.className = 'com.google.android.gms.common.api.GoogleApi$Settings';
Settings.prototype.className = 'com.google.android.gms.common.api.GoogleApi$Settings';

// class property
Object.defineProperty(Settings, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.GoogleApi$Settings');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Settings.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.GoogleApi$Settings');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Settings.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Settings.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Settings(Hyperloop.cast('com.google.android.gms.common.api.GoogleApi$Settings', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(Settings, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.common.api.GoogleApi$Settings$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.Settings.html#DEFAULT_SETTINGS
Object.defineProperty(Settings, 'DEFAULT_SETTINGS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DEFAULT_SETTINGS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.GoogleApi$Settings') {
				return new Settings(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.Settings.html#zabn
Object.defineProperty(Settings.prototype, 'zabn', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('zabn');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.GoogleApi$Settings') {
				return new Settings(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.Settings.html#zabo
Object.defineProperty(Settings.prototype, 'zabo', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('zabo');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.GoogleApi$Settings') {
				return new Settings(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Static methods

// Instance methods

// export the class
module.exports = Settings;
