/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.GoogleApi
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api');

/**
 * @class com.google.android.gms.common.api.GoogleApi
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html}
 **/
var GoogleApi = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.GoogleApi')) {
		result = arguments[0];
	}
	else {
		result = GoogleApi.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
GoogleApi.prototype = Object.create(SuperClass.prototype);
GoogleApi.prototype.constructor = GoogleApi;

Object.defineProperty(GoogleApi.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GoogleApi(this.$native.super);
	},
	enumerable: true
});

GoogleApi.className = 'com.google.android.gms.common.api.GoogleApi';
GoogleApi.prototype.className = 'com.google.android.gms.common.api.GoogleApi';

// class property
Object.defineProperty(GoogleApi, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.GoogleApi');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GoogleApi.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.GoogleApi');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GoogleApi.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GoogleApi.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GoogleApi(Hyperloop.cast('com.google.android.gms.common.api.GoogleApi', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(GoogleApi, 'Settings', {
	get: function() {
		return require('./com.google.android.gms.common.api.GoogleApi$Settings');
	},
	enumerable: true
});

// Static fields

// Instance Fields
// http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#zabm
Object.defineProperty(GoogleApi.prototype, 'zabm', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('zabm');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
				return new GoogleApi(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getInstanceId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#getInstanceId()}
 **/
GoogleApi.prototype.getInstanceId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInstanceId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doUnregisterEventListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doUnregisterEventListener(com.google.android.gms.common.api.internal.ListenerHolder$ListenerKey)}
 **/
GoogleApi.prototype.doUnregisterEventListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doUnregisterEventListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApiOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#getApiOptions()}
 **/
GoogleApi.prototype.getApiOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApiOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zak
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#zak()}
 **/
GoogleApi.prototype.zak = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zak',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doRead
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doRead(com.google.android.gms.common.api.internal.BaseImplementation$ApiMethodImpl)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doRead(com.google.android.gms.common.api.internal.TaskApiCall)}
 **/
GoogleApi.prototype.doRead = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doRead',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doBestEffortWrite
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doBestEffortWrite(com.google.android.gms.common.api.internal.BaseImplementation$ApiMethodImpl)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doBestEffortWrite(com.google.android.gms.common.api.internal.TaskApiCall)}
 **/
GoogleApi.prototype.doBestEffortWrite = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doBestEffortWrite',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doRegisterEventListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doRegisterEventListener(com.google.android.gms.common.api.internal.RegisterListenerMethod, com.google.android.gms.common.api.internal.UnregisterListenerMethod)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doRegisterEventListener(com.google.android.gms.common.api.internal.RegistrationMethods)}
 **/
GoogleApi.prototype.doRegisterEventListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doRegisterEventListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asGoogleApiClient
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#asGoogleApiClient()}
 **/
GoogleApi.prototype.asGoogleApiClient = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asGoogleApiClient',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doWrite
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doWrite(com.google.android.gms.common.api.internal.BaseImplementation$ApiMethodImpl)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#doWrite(com.google.android.gms.common.api.internal.TaskApiCall)}
 **/
GoogleApi.prototype.doWrite = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doWrite',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApi
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#getApi()}
 **/
GoogleApi.prototype.getApi = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApi',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#registerListener(java.lang.Object, java.lang.String)}
 **/
GoogleApi.prototype.registerListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createClientSettingsBuilder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#createClientSettingsBuilder()}
 **/
GoogleApi.prototype.createClientSettingsBuilder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createClientSettingsBuilder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApplicationContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#getApplicationContext()}
 **/
GoogleApi.prototype.getApplicationContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApplicationContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLooper
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#getLooper()}
 **/
GoogleApi.prototype.getLooper = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLooper',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function disconnectService
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#disconnectService()}
 **/
GoogleApi.prototype.disconnectService = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'disconnectService',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zaa
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#zaa(android.os.Looper, com.google.android.gms.common.api.internal.GoogleApiManager$zaa)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApi.html#zaa(android.content.Context, android.os.Handler)}
 **/
GoogleApi.prototype.zaa = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zaa',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApi') {
			return new GoogleApi(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GoogleApi;
