/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ConnectionCallbacks
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./com.google.android.gms.common.api.GoogleApiClient');

/**
 * constructor
 * http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.ConnectionCallbacks.html
 **/
var ConnectionCallbacks = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ConnectionCallbacks.prototype = Object.create(SuperClass.prototype);
ConnectionCallbacks.prototype.constructor = ConnectionCallbacks;

Object.defineProperty(ConnectionCallbacks.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ConnectionCallbacks(this.$native.super);
	},
	enumerable: true
});

ConnectionCallbacks.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ConnectionCallbacks.className = "com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks";
ConnectionCallbacks.prototype.className = "com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks";

// class property
Object.defineProperty(ConnectionCallbacks, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks');
	},
	enumerable: true,
	configurable: false
});

// Cast
ConnectionCallbacks.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ConnectionCallbacks(Hyperloop.cast('com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks', object.$native));
};

// Constants
// http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.ConnectionCallbacks.html#CAUSE_NETWORK_LOST
ConnectionCallbacks.CAUSE_NETWORK_LOST = 2;
// http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.ConnectionCallbacks.html#CAUSE_SERVICE_DISCONNECTED
ConnectionCallbacks.CAUSE_SERVICE_DISCONNECTED = 1;

// Static methods

// Instance methods
/**
 * @function onConnected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.ConnectionCallbacks.html#onConnected(android.os.Bundle)}
 **/
ConnectionCallbacks.prototype.onConnected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConnected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks') {
			return new ConnectionCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onConnectionSuspended
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.ConnectionCallbacks.html#onConnectionSuspended(int)}
 **/
ConnectionCallbacks.prototype.onConnectionSuspended = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConnectionSuspended',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks') {
			return new ConnectionCallbacks(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ConnectionCallbacks.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ConnectionCallbacks.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ConnectionCallbacks;
