/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.GoogleApiClient
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api');

/**
 * @class com.google.android.gms.common.api.GoogleApiClient
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html}
 **/
var GoogleApiClient = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.GoogleApiClient')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.common.api.GoogleApiClient. Create a subclass using com.google.android.gms.common.api.GoogleApiClient.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
GoogleApiClient.prototype = Object.create(SuperClass.prototype);
GoogleApiClient.prototype.constructor = GoogleApiClient;

Object.defineProperty(GoogleApiClient.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GoogleApiClient(this.$native.super);
	},
	enumerable: true
});

GoogleApiClient.className = 'com.google.android.gms.common.api.GoogleApiClient';
GoogleApiClient.prototype.className = 'com.google.android.gms.common.api.GoogleApiClient';

// class property
Object.defineProperty(GoogleApiClient, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.GoogleApiClient');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GoogleApiClient.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.GoogleApiClient');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GoogleApiClient.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GoogleApiClient.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GoogleApiClient(Hyperloop.cast('com.google.android.gms.common.api.GoogleApiClient', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#DEFAULT_ACCOUNT}
 */
GoogleApiClient.DEFAULT_ACCOUNT = "<<default account>>";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#SIGN_IN_MODE_OPTIONAL}
 */
GoogleApiClient.SIGN_IN_MODE_OPTIONAL = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#SIGN_IN_MODE_REQUIRED}
 */
GoogleApiClient.SIGN_IN_MODE_REQUIRED = 1;

// Inner classes
Object.defineProperty(GoogleApiClient, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.common.api.GoogleApiClient$Builder');
	},
	enumerable: true
});
Object.defineProperty(GoogleApiClient, 'ConnectionCallbacks', {
	get: function() {
		return require('./com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks');
	},
	enumerable: true
});
Object.defineProperty(GoogleApiClient, 'OnConnectionFailedListener', {
	get: function() {
		return require('./com.google.android.gms.common.api.GoogleApiClient$OnConnectionFailedListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function dumpAll
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#dumpAll(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
GoogleApiClient.dumpAll = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'dumpAll',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAllClients
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#getAllClients()}
 **/
GoogleApiClient.getAllClients = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAllClients',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function disconnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#disconnect()}
 **/
GoogleApiClient.prototype.disconnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'disconnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function blockingConnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#blockingConnect()}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#blockingConnect(long, java.util.concurrent.TimeUnit)}
 **/
GoogleApiClient.prototype.blockingConnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'blockingConnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isConnected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#isConnected()}
 **/
GoogleApiClient.prototype.isConnected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clearDefaultAccountAndReconnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#clearDefaultAccountAndReconnect()}
 **/
GoogleApiClient.prototype.clearDefaultAccountAndReconnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clearDefaultAccountAndReconnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#registerListener(java.lang.Object)}
 **/
GoogleApiClient.prototype.registerListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reconnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#reconnect()}
 **/
GoogleApiClient.prototype.reconnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reconnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isConnectionFailedListenerRegistered
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#isConnectionFailedListenerRegistered(com.google.android.gms.common.api.GoogleApiClient$OnConnectionFailedListener)}
 **/
GoogleApiClient.prototype.isConnectionFailedListenerRegistered = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnectionFailedListenerRegistered',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerConnectionFailedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#registerConnectionFailedListener(com.google.android.gms.common.api.GoogleApiClient$OnConnectionFailedListener)}
 **/
GoogleApiClient.prototype.registerConnectionFailedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerConnectionFailedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerConnectionCallbacks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#registerConnectionCallbacks(com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks)}
 **/
GoogleApiClient.prototype.registerConnectionCallbacks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerConnectionCallbacks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unregisterConnectionFailedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#unregisterConnectionFailedListener(com.google.android.gms.common.api.GoogleApiClient$OnConnectionFailedListener)}
 **/
GoogleApiClient.prototype.unregisterConnectionFailedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterConnectionFailedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zab
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#zab(com.google.android.gms.common.api.internal.zacm)}
 **/
GoogleApiClient.prototype.zab = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zab',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function stopAutoManage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#stopAutoManage(androidx.fragment.app.FragmentActivity)}
 **/
GoogleApiClient.prototype.stopAutoManage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'stopAutoManage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#dump(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
GoogleApiClient.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zaa
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#zaa(com.google.android.gms.common.api.internal.zacm)}
 **/
GoogleApiClient.prototype.zaa = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zaa',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function connect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#connect()}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#connect(int)}
 **/
GoogleApiClient.prototype.connect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'connect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasApi
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#hasApi(com.google.android.gms.common.api.Api)}
 **/
GoogleApiClient.prototype.hasApi = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasApi',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unregisterConnectionCallbacks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#unregisterConnectionCallbacks(com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks)}
 **/
GoogleApiClient.prototype.unregisterConnectionCallbacks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterConnectionCallbacks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function maybeSignIn
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#maybeSignIn(com.google.android.gms.common.api.internal.SignInConnectionListener)}
 **/
GoogleApiClient.prototype.maybeSignIn = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'maybeSignIn',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getClient
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#getClient(com.google.android.gms.common.api.Api$AnyClientKey)}
 **/
GoogleApiClient.prototype.getClient = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClient',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isConnectionCallbacksRegistered
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#isConnectionCallbacksRegistered(com.google.android.gms.common.api.GoogleApiClient$ConnectionCallbacks)}
 **/
GoogleApiClient.prototype.isConnectionCallbacksRegistered = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnectionCallbacksRegistered',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function execute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#execute(com.google.android.gms.common.api.internal.BaseImplementation$ApiMethodImpl)}
 **/
GoogleApiClient.prototype.execute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'execute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isConnecting
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#isConnecting()}
 **/
GoogleApiClient.prototype.isConnecting = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnecting',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function enqueue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#enqueue(com.google.android.gms.common.api.internal.BaseImplementation$ApiMethodImpl)}
 **/
GoogleApiClient.prototype.enqueue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'enqueue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getConnectionResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#getConnectionResult(com.google.android.gms.common.api.Api)}
 **/
GoogleApiClient.prototype.getConnectionResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getConnectionResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function maybeSignOut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#maybeSignOut()}
 **/
GoogleApiClient.prototype.maybeSignOut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'maybeSignOut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLooper
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#getLooper()}
 **/
GoogleApiClient.prototype.getLooper = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLooper',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasConnectedApi
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#hasConnectedApi(com.google.android.gms.common.api.Api)}
 **/
GoogleApiClient.prototype.hasConnectedApi = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasConnectedApi',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/GoogleApiClient.html#getContext()}
 **/
GoogleApiClient.prototype.getContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.GoogleApiClient') {
			return new GoogleApiClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GoogleApiClient;
