/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.ResultTransform
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api');

/**
 * @class com.google.android.gms.common.api.ResultTransform
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/ResultTransform.html}
 **/
var ResultTransform = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.ResultTransform')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.common.api.ResultTransform. Create a subclass using com.google.android.gms.common.api.ResultTransform.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ResultTransform.prototype = Object.create(SuperClass.prototype);
ResultTransform.prototype.constructor = ResultTransform;

Object.defineProperty(ResultTransform.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ResultTransform(this.$native.super);
	},
	enumerable: true
});

ResultTransform.className = 'com.google.android.gms.common.api.ResultTransform';
ResultTransform.prototype.className = 'com.google.android.gms.common.api.ResultTransform';

// class property
Object.defineProperty(ResultTransform, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.ResultTransform');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ResultTransform.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.ResultTransform');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ResultTransform.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ResultTransform.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ResultTransform(Hyperloop.cast('com.google.android.gms.common.api.ResultTransform', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function createFailedResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/ResultTransform.html#createFailedResult(com.google.android.gms.common.api.Status)}
 **/
ResultTransform.prototype.createFailedResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createFailedResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.ResultTransform') {
			return new ResultTransform(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onFailure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/ResultTransform.html#onFailure(com.google.android.gms.common.api.Status)}
 **/
ResultTransform.prototype.onFailure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onFailure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.ResultTransform') {
			return new ResultTransform(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSuccess
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/ResultTransform.html#onSuccess(com.google.android.gms.common.api.Result)}
 **/
ResultTransform.prototype.onSuccess = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSuccess',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.ResultTransform') {
			return new ResultTransform(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ResultTransform;
