/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.Status
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api');

/**
 * @class com.google.android.gms.common.api.Status
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html}
 **/
var Status = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.Status')) {
		result = arguments[0];
	}
	else {
		result = Status.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
Status.prototype = Object.create(SuperClass.prototype);
Status.prototype.constructor = Status;

Object.defineProperty(Status.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Status(this.$native.super);
	},
	enumerable: true
});

Status.className = 'com.google.android.gms.common.api.Status';
Status.prototype.className = 'com.google.android.gms.common.api.Status';

// class property
Object.defineProperty(Status, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.Status');
	},
	enumerable: true,
	configurable: false
});


// Cast
Status.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Status(Hyperloop.cast('com.google.android.gms.common.api.Status', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#RESULT_TIMEOUT
Object.defineProperty(Status, 'RESULT_TIMEOUT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_TIMEOUT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#RESULT_CANCELED
Object.defineProperty(Status, 'RESULT_CANCELED', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_CANCELED');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#RESULT_SUCCESS
Object.defineProperty(Status, 'RESULT_SUCCESS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_SUCCESS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#CREATOR
Object.defineProperty(Status, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#RESULT_INTERRUPTED
Object.defineProperty(Status, 'RESULT_INTERRUPTED', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_INTERRUPTED');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#RESULT_INTERNAL_ERROR
Object.defineProperty(Status, 'RESULT_INTERNAL_ERROR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_INTERNAL_ERROR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#RESULT_DEAD_CLIENT
Object.defineProperty(Status, 'RESULT_DEAD_CLIENT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_DEAD_CLIENT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.Status') {
				return new Status(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getResolution
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#getResolution()}
 **/
Status.prototype.getResolution = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResolution',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isCanceled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#isCanceled()}
 **/
Status.prototype.isCanceled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isCanceled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStatusMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#getStatusMessage()}
 **/
Status.prototype.getStatusMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStatusMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isInterrupted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#isInterrupted()}
 **/
Status.prototype.isInterrupted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isInterrupted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zzg
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#zzg()}
 **/
Status.prototype.zzg = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zzg',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStatus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#getStatus()}
 **/
Status.prototype.getStatus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStatus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStatusCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#getStatusCode()}
 **/
Status.prototype.getStatusCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStatusCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startResolutionForResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#startResolutionForResult(android.app.Activity, int)}
 **/
Status.prototype.startResolutionForResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startResolutionForResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#hashCode()}
 **/
Status.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#equals(java.lang.Object)}
 **/
Status.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#toString()}
 **/
Status.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#writeToParcel(android.os.Parcel, int)}
 **/
Status.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasResolution
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#hasResolution()}
 **/
Status.prototype.hasResolution = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasResolution',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSuccess
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/Status.html#isSuccess()}
 **/
Status.prototype.isSuccess = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSuccess',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.Status') {
			return new Status(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Status;
