/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.internal.GoogleApiManager
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api.internal');

/**
 * @class com.google.android.gms.common.api.internal.GoogleApiManager
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html}
 **/
var GoogleApiManager = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.internal.GoogleApiManager')) {
		result = arguments[0];
	}
	else {
		result = GoogleApiManager.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
GoogleApiManager.prototype = Object.create(SuperClass.prototype);
GoogleApiManager.prototype.constructor = GoogleApiManager;

Object.defineProperty(GoogleApiManager.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GoogleApiManager(this.$native.super);
	},
	enumerable: true
});

GoogleApiManager.className = 'com.google.android.gms.common.api.internal.GoogleApiManager';
GoogleApiManager.prototype.className = 'com.google.android.gms.common.api.internal.GoogleApiManager';

// class property
Object.defineProperty(GoogleApiManager, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.internal.GoogleApiManager');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GoogleApiManager.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.internal.GoogleApiManager');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GoogleApiManager.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GoogleApiManager.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GoogleApiManager(Hyperloop.cast('com.google.android.gms.common.api.internal.GoogleApiManager', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(GoogleApiManager, 'zaa', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.GoogleApiManager$zaa');
	},
	enumerable: true
});
Object.defineProperty(GoogleApiManager, 'zab', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.GoogleApiManager$zab');
	},
	enumerable: true
});
Object.defineProperty(GoogleApiManager, 'zac', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.GoogleApiManager$zac');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zahx
Object.defineProperty(GoogleApiManager, 'zahx', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('zahx');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
				return new GoogleApiManager(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function zabc
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zabc()}
 **/
GoogleApiManager.zabc = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'zabc',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zab
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zab(android.content.Context)}
 **/
GoogleApiManager.zab = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'zab',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reportSignOut
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#reportSignOut()}
 **/
GoogleApiManager.reportSignOut = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'reportSignOut',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function zabd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zabd()}
 **/
GoogleApiManager.prototype.zabd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zabd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function handleMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#handleMessage(android.os.Message)}
 **/
GoogleApiManager.prototype.handleMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'handleMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zao
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zao()}
 **/
GoogleApiManager.prototype.zao = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zao',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zaa
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.api.GoogleApi)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.api.internal.zaae)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(java.lang.Iterable)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.api.GoogleApi, int, com.google.android.gms.common.api.internal.BaseImplementation$ApiMethodImpl)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.api.GoogleApi, int, com.google.android.gms.common.api.internal.TaskApiCall, com.google.android.gms.tasks.TaskCompletionSource, com.google.android.gms.common.api.internal.StatusExceptionMapper)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.api.GoogleApi, com.google.android.gms.common.api.internal.RegisterListenerMethod, com.google.android.gms.common.api.internal.UnregisterListenerMethod)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.api.GoogleApi, com.google.android.gms.common.api.internal.ListenerHolder$ListenerKey)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zaa(com.google.android.gms.common.ConnectionResult, int)}
 **/
GoogleApiManager.prototype.zaa = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zaa',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zac
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/GoogleApiManager.html#zac(com.google.android.gms.common.api.GoogleApi)}
 **/
GoogleApiManager.prototype.zac = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zac',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.GoogleApiManager') {
			return new GoogleApiManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GoogleApiManager;
