/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.internal.LifecycleCallback
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api.internal');

/**
 * @class com.google.android.gms.common.api.internal.LifecycleCallback
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html}
 **/
var LifecycleCallback = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.internal.LifecycleCallback')) {
		result = arguments[0];
	}
	else {
		result = LifecycleCallback.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
LifecycleCallback.prototype = Object.create(SuperClass.prototype);
LifecycleCallback.prototype.constructor = LifecycleCallback;

Object.defineProperty(LifecycleCallback.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new LifecycleCallback(this.$native.super);
	},
	enumerable: true
});

LifecycleCallback.className = 'com.google.android.gms.common.api.internal.LifecycleCallback';
LifecycleCallback.prototype.className = 'com.google.android.gms.common.api.internal.LifecycleCallback';

// class property
Object.defineProperty(LifecycleCallback, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.internal.LifecycleCallback');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
LifecycleCallback.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.internal.LifecycleCallback');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(LifecycleCallback.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
LifecycleCallback.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new LifecycleCallback(Hyperloop.cast('com.google.android.gms.common.api.internal.LifecycleCallback', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#mLifecycleFragment
Object.defineProperty(LifecycleCallback.prototype, 'mLifecycleFragment', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('mLifecycleFragment');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
				return new LifecycleCallback(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function getFragment
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#getFragment(com.google.android.gms.common.api.internal.LifecycleActivity)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#getFragment(android.app.Activity)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#getFragment(android.content.ContextWrapper)}
 **/
LifecycleCallback.getFragment = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getFragment',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onCreate(android.os.Bundle)}
 **/
LifecycleCallback.prototype.onCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDestroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onDestroy()}
 **/
LifecycleCallback.prototype.onDestroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDestroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#getActivity()}
 **/
LifecycleCallback.prototype.getActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onStart()}
 **/
LifecycleCallback.prototype.onStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onSaveInstanceState(android.os.Bundle)}
 **/
LifecycleCallback.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#dump(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
LifecycleCallback.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onActivityResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onActivityResult(int, int, android.content.Intent)}
 **/
LifecycleCallback.prototype.onActivityResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onResume()}
 **/
LifecycleCallback.prototype.onResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/LifecycleCallback.html#onStop()}
 **/
LifecycleCallback.prototype.onStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.LifecycleCallback') {
			return new LifecycleCallback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = LifecycleCallback;
