/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.internal.ListenerHolder
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api.internal');

/**
 * @class com.google.android.gms.common.api.internal.ListenerHolder
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/ListenerHolder.html}
 **/
var ListenerHolder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.internal.ListenerHolder')) {
		result = arguments[0];
	}
	else {
		result = ListenerHolder.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ListenerHolder.prototype = Object.create(SuperClass.prototype);
ListenerHolder.prototype.constructor = ListenerHolder;

Object.defineProperty(ListenerHolder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ListenerHolder(this.$native.super);
	},
	enumerable: true
});

ListenerHolder.className = 'com.google.android.gms.common.api.internal.ListenerHolder';
ListenerHolder.prototype.className = 'com.google.android.gms.common.api.internal.ListenerHolder';

// class property
Object.defineProperty(ListenerHolder, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.internal.ListenerHolder');
	},
	enumerable: true,
	configurable: false
});


// Cast
ListenerHolder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ListenerHolder(Hyperloop.cast('com.google.android.gms.common.api.internal.ListenerHolder', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ListenerHolder, 'ListenerKey', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.ListenerHolder$ListenerKey');
	},
	enumerable: true
});
Object.defineProperty(ListenerHolder, 'Notifier', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.ListenerHolder$Notifier');
	},
	enumerable: true
});
Object.defineProperty(ListenerHolder, 'zaa', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.ListenerHolder$zaa');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getListenerKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/ListenerHolder.html#getListenerKey()}
 **/
ListenerHolder.prototype.getListenerKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getListenerKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.ListenerHolder') {
			return new ListenerHolder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/ListenerHolder.html#notifyListener(com.google.android.gms.common.api.internal.ListenerHolder$Notifier)}
 **/
ListenerHolder.prototype.notifyListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.ListenerHolder') {
			return new ListenerHolder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/ListenerHolder.html#clear()}
 **/
ListenerHolder.prototype.clear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.ListenerHolder') {
			return new ListenerHolder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/ListenerHolder.html#hasListener()}
 **/
ListenerHolder.prototype.hasListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.ListenerHolder') {
			return new ListenerHolder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ListenerHolder;
