/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.api.internal.TaskApiCall
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.api.internal');

/**
 * @class com.google.android.gms.common.api.internal.TaskApiCall
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/TaskApiCall.html}
 **/
var TaskApiCall = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.api.internal.TaskApiCall')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.common.api.internal.TaskApiCall. Create a subclass using com.google.android.gms.common.api.internal.TaskApiCall.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TaskApiCall.prototype = Object.create(SuperClass.prototype);
TaskApiCall.prototype.constructor = TaskApiCall;

Object.defineProperty(TaskApiCall.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TaskApiCall(this.$native.super);
	},
	enumerable: true
});

TaskApiCall.className = 'com.google.android.gms.common.api.internal.TaskApiCall';
TaskApiCall.prototype.className = 'com.google.android.gms.common.api.internal.TaskApiCall';

// class property
Object.defineProperty(TaskApiCall, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.api.internal.TaskApiCall');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TaskApiCall.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.api.internal.TaskApiCall');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TaskApiCall.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TaskApiCall.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TaskApiCall(Hyperloop.cast('com.google.android.gms.common.api.internal.TaskApiCall', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(TaskApiCall, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.common.api.internal.TaskApiCall$Builder');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function builder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/TaskApiCall.html#builder()}
 **/
TaskApiCall.builder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'builder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.TaskApiCall') {
			return new TaskApiCall(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function zabt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/TaskApiCall.html#zabt()}
 **/
TaskApiCall.prototype.zabt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zabt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.TaskApiCall') {
			return new TaskApiCall(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doExecute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/TaskApiCall.html#doExecute(com.google.android.gms.common.api.Api$AnyClient, com.google.android.gms.tasks.TaskCompletionSource)}
 **/
TaskApiCall.prototype.doExecute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doExecute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.TaskApiCall') {
			return new TaskApiCall(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function shouldAutoResolveMissingFeatures
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/api/internal/TaskApiCall.html#shouldAutoResolveMissingFeatures()}
 **/
TaskApiCall.prototype.shouldAutoResolveMissingFeatures = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shouldAutoResolveMissingFeatures',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.api.internal.TaskApiCall') {
			return new TaskApiCall(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TaskApiCall;
