/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.internal.ClientSettings$Builder
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./com.google.android.gms.common.internal.ClientSettings');

/**
 * @class com.google.android.gms.common.internal.ClientSettings$Builder
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html}
 **/
var Builder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.internal.ClientSettings$Builder')) {
		result = arguments[0];
	}
	else {
		result = Builder.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Builder.prototype = Object.create(SuperClass.prototype);
Builder.prototype.constructor = Builder;

Object.defineProperty(Builder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Builder(this.$native.super);
	},
	enumerable: true
});

Builder.className = 'com.google.android.gms.common.internal.ClientSettings$Builder';
Builder.prototype.className = 'com.google.android.gms.common.internal.ClientSettings$Builder';

// class property
Object.defineProperty(Builder, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.internal.ClientSettings$Builder');
	},
	enumerable: true,
	configurable: false
});


// Cast
Builder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Builder(Hyperloop.cast('com.google.android.gms.common.internal.ClientSettings$Builder', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setViewForPopups
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setViewForPopups(android.view.View)}
 **/
Builder.prototype.setViewForPopups = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setViewForPopups',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addAllRequiredScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#addAllRequiredScopes(java.util.Collection)}
 **/
Builder.prototype.addAllRequiredScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addAllRequiredScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOptionalApiSettingsMap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setOptionalApiSettingsMap(java.util.Map)}
 **/
Builder.prototype.setOptionalApiSettingsMap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOptionalApiSettingsMap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addRequiredScope
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#addRequiredScope(com.google.android.gms.common.api.Scope)}
 **/
Builder.prototype.addRequiredScope = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addRequiredScope',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setGravityForPopups
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setGravityForPopups(int)}
 **/
Builder.prototype.setGravityForPopups = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGravityForPopups',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function build
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#build()}
 **/
Builder.prototype.build = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'build',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setAccount(android.accounts.Account)}
 **/
Builder.prototype.setAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function enableSignInClientDisconnectFix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#enableSignInClientDisconnectFix()}
 **/
Builder.prototype.enableSignInClientDisconnectFix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'enableSignInClientDisconnectFix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRealClientClassName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setRealClientClassName(java.lang.String)}
 **/
Builder.prototype.setRealClientClassName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRealClientClassName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRealClientPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setRealClientPackageName(java.lang.String)}
 **/
Builder.prototype.setRealClientPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRealClientPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSignInOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.Builder.html#setSignInOptions(com.google.android.gms.signin.SignInOptions)}
 **/
Builder.prototype.setSignInOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSignInOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings$Builder') {
			return new Builder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Builder;
