/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.internal.ClientSettings
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.internal');

/**
 * @class com.google.android.gms.common.internal.ClientSettings
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html}
 **/
var ClientSettings = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.internal.ClientSettings')) {
		result = arguments[0];
	}
	else {
		result = ClientSettings.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ClientSettings.prototype = Object.create(SuperClass.prototype);
ClientSettings.prototype.constructor = ClientSettings;

Object.defineProperty(ClientSettings.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ClientSettings(this.$native.super);
	},
	enumerable: true
});

ClientSettings.className = 'com.google.android.gms.common.internal.ClientSettings';
ClientSettings.prototype.className = 'com.google.android.gms.common.internal.ClientSettings';

// class property
Object.defineProperty(ClientSettings, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.internal.ClientSettings');
	},
	enumerable: true,
	configurable: false
});


// Cast
ClientSettings.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ClientSettings(Hyperloop.cast('com.google.android.gms.common.internal.ClientSettings', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#KEY_CLIENT_SESSION_ID}
 */
ClientSettings.KEY_CLIENT_SESSION_ID = "com.google.android.gms.common.internal.ClientSettings.sessionId";

// Inner classes
Object.defineProperty(ClientSettings, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.common.internal.ClientSettings$Builder');
	},
	enumerable: true
});
Object.defineProperty(ClientSettings, 'OptionalApiSettings', {
	get: function() {
		return require('./com.google.android.gms.common.internal.ClientSettings$OptionalApiSettings');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function createDefault
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#createDefault(android.content.Context)}
 **/
ClientSettings.createDefault = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createDefault',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getViewForPopups
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getViewForPopups()}
 **/
ClientSettings.prototype.getViewForPopups = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getViewForPopups',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRealClientPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getRealClientPackageName()}
 **/
ClientSettings.prototype.getRealClientPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRealClientPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSignInOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getSignInOptions()}
 **/
ClientSettings.prototype.getSignInOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSignInOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getClientSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getClientSessionId()}
 **/
ClientSettings.prototype.getClientSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClientSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApplicableScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getApplicableScopes(com.google.android.gms.common.api.Api)}
 **/
ClientSettings.prototype.getApplicableScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApplicableScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSignInClientDisconnectFixEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#isSignInClientDisconnectFixEnabled()}
 **/
ClientSettings.prototype.isSignInClientDisconnectFixEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSignInClientDisconnectFixEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setClientSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#setClientSessionId(java.lang.Integer)}
 **/
ClientSettings.prototype.setClientSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setClientSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGravityForPopups
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getGravityForPopups()}
 **/
ClientSettings.prototype.getGravityForPopups = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGravityForPopups',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAllRequestedScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getAllRequestedScopes()}
 **/
ClientSettings.prototype.getAllRequestedScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllRequestedScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRequiredScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getRequiredScopes()}
 **/
ClientSettings.prototype.getRequiredScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRequiredScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccountName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getAccountName()}
 **/
ClientSettings.prototype.getAccountName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccountName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getAccount()}
 **/
ClientSettings.prototype.getAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRealClientClassName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getRealClientClassName()}
 **/
ClientSettings.prototype.getRealClientClassName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRealClientClassName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccountOrDefault
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getAccountOrDefault()}
 **/
ClientSettings.prototype.getAccountOrDefault = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccountOrDefault',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOptionalApiSettings
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ClientSettings.html#getOptionalApiSettings()}
 **/
ClientSettings.prototype.getOptionalApiSettings = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOptionalApiSettings',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ClientSettings') {
			return new ClientSettings(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ClientSettings;
