/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.internal.ResolveAccountResponse
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.internal');

/**
 * @class com.google.android.gms.common.internal.ResolveAccountResponse
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html}
 **/
var ResolveAccountResponse = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.internal.ResolveAccountResponse')) {
		result = arguments[0];
	}
	else {
		result = ResolveAccountResponse.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
ResolveAccountResponse.prototype = Object.create(SuperClass.prototype);
ResolveAccountResponse.prototype.constructor = ResolveAccountResponse;

Object.defineProperty(ResolveAccountResponse.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ResolveAccountResponse(this.$native.super);
	},
	enumerable: true
});

ResolveAccountResponse.className = 'com.google.android.gms.common.internal.ResolveAccountResponse';
ResolveAccountResponse.prototype.className = 'com.google.android.gms.common.internal.ResolveAccountResponse';

// class property
Object.defineProperty(ResolveAccountResponse, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.internal.ResolveAccountResponse');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ResolveAccountResponse.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.internal.ResolveAccountResponse');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ResolveAccountResponse.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ResolveAccountResponse.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ResolveAccountResponse(Hyperloop.cast('com.google.android.gms.common.internal.ResolveAccountResponse', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#CREATOR
Object.defineProperty(ResolveAccountResponse, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
				return new ResolveAccountResponse(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setAccountAccessor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#setAccountAccessor(com.google.android.gms.common.internal.IAccountAccessor)}
 **/
ResolveAccountResponse.prototype.setAccountAccessor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAccountAccessor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getConnectionResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#getConnectionResult()}
 **/
ResolveAccountResponse.prototype.getConnectionResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getConnectionResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSaveDefaultAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#getSaveDefaultAccount()}
 **/
ResolveAccountResponse.prototype.getSaveDefaultAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSaveDefaultAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSaveDefaultAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#setSaveDefaultAccount(boolean)}
 **/
ResolveAccountResponse.prototype.setSaveDefaultAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSaveDefaultAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccountAccessor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#getAccountAccessor()}
 **/
ResolveAccountResponse.prototype.getAccountAccessor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccountAccessor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFromCrossClientAuth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#isFromCrossClientAuth()}
 **/
ResolveAccountResponse.prototype.isFromCrossClientAuth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFromCrossClientAuth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#equals(java.lang.Object)}
 **/
ResolveAccountResponse.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIsFromCrossClientAuth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#setIsFromCrossClientAuth(boolean)}
 **/
ResolveAccountResponse.prototype.setIsFromCrossClientAuth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIsFromCrossClientAuth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/ResolveAccountResponse.html#writeToParcel(android.os.Parcel, int)}
 **/
ResolveAccountResponse.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.ResolveAccountResponse') {
			return new ResolveAccountResponse(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ResolveAccountResponse;
