/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.signin.SignInOptions
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.signin');

/**
 * @class com.google.android.gms.signin.SignInOptions
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html}
 **/
var SignInOptions = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.signin.SignInOptions')) {
		result = arguments[0];
	}
	else {
		result = SignInOptions.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
SignInOptions.prototype = Object.create(SuperClass.prototype);
SignInOptions.prototype.constructor = SignInOptions;

Object.defineProperty(SignInOptions.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new SignInOptions(this.$native.super);
	},
	enumerable: true
});

SignInOptions.className = 'com.google.android.gms.signin.SignInOptions';
SignInOptions.prototype.className = 'com.google.android.gms.signin.SignInOptions';

// class property
Object.defineProperty(SignInOptions, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.signin.SignInOptions');
	},
	enumerable: true,
	configurable: false
});


// Cast
SignInOptions.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new SignInOptions(Hyperloop.cast('com.google.android.gms.signin.SignInOptions', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(SignInOptions, 'zaa', {
	get: function() {
		return require('./com.google.android.gms.signin.SignInOptions$zaa');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#DEFAULT
Object.defineProperty(SignInOptions, 'DEFAULT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DEFAULT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
				return new SignInOptions(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isOfflineAccessRequested
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#isOfflineAccessRequested()}
 **/
SignInOptions.prototype.isOfflineAccessRequested = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOfflineAccessRequested',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHostedDomain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#getHostedDomain()}
 **/
SignInOptions.prototype.getHostedDomain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHostedDomain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function waitForAccessTokenRefresh
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#waitForAccessTokenRefresh()}
 **/
SignInOptions.prototype.waitForAccessTokenRefresh = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'waitForAccessTokenRefresh',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRealClientLibraryVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#getRealClientLibraryVersion()}
 **/
SignInOptions.prototype.getRealClientLibraryVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRealClientLibraryVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isForceCodeForRefreshToken
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#isForceCodeForRefreshToken()}
 **/
SignInOptions.prototype.isForceCodeForRefreshToken = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isForceCodeForRefreshToken',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isIdTokenRequested
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#isIdTokenRequested()}
 **/
SignInOptions.prototype.isIdTokenRequested = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isIdTokenRequested',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAuthApiSignInModuleVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#getAuthApiSignInModuleVersion()}
 **/
SignInOptions.prototype.getAuthApiSignInModuleVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAuthApiSignInModuleVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getServerClientId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/signin/SignInOptions.html#getServerClientId()}
 **/
SignInOptions.prototype.getServerClientId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getServerClientId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.signin.SignInOptions') {
			return new SignInOptions(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = SignInOptions;
