/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.tasks.CancellationToken
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.tasks');

/**
 * @class com.google.android.gms.tasks.CancellationToken
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/CancellationToken.html}
 **/
var CancellationToken = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.tasks.CancellationToken')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.tasks.CancellationToken. Create a subclass using com.google.android.gms.tasks.CancellationToken.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
CancellationToken.prototype = Object.create(SuperClass.prototype);
CancellationToken.prototype.constructor = CancellationToken;

Object.defineProperty(CancellationToken.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new CancellationToken(this.$native.super);
	},
	enumerable: true
});

CancellationToken.className = 'com.google.android.gms.tasks.CancellationToken';
CancellationToken.prototype.className = 'com.google.android.gms.tasks.CancellationToken';

// class property
Object.defineProperty(CancellationToken, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.tasks.CancellationToken');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
CancellationToken.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.tasks.CancellationToken');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(CancellationToken.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
CancellationToken.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new CancellationToken(Hyperloop.cast('com.google.android.gms.tasks.CancellationToken', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isCancellationRequested
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/CancellationToken.html#isCancellationRequested()}
 **/
CancellationToken.prototype.isCancellationRequested = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isCancellationRequested',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.CancellationToken') {
			return new CancellationToken(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCanceledRequested
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/CancellationToken.html#onCanceledRequested(com.google.android.gms.tasks.OnTokenCanceledListener)}
 **/
CancellationToken.prototype.onCanceledRequested = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCanceledRequested',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.CancellationToken') {
			return new CancellationToken(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = CancellationToken;
