/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.tasks.TaskCompletionSource
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.tasks');

/**
 * @class com.google.android.gms.tasks.TaskCompletionSource
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/TaskCompletionSource.html}
 **/
var TaskCompletionSource = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.tasks.TaskCompletionSource')) {
		result = arguments[0];
	}
	else {
		result = TaskCompletionSource.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TaskCompletionSource.prototype = Object.create(SuperClass.prototype);
TaskCompletionSource.prototype.constructor = TaskCompletionSource;

Object.defineProperty(TaskCompletionSource.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TaskCompletionSource(this.$native.super);
	},
	enumerable: true
});

TaskCompletionSource.className = 'com.google.android.gms.tasks.TaskCompletionSource';
TaskCompletionSource.prototype.className = 'com.google.android.gms.tasks.TaskCompletionSource';

// class property
Object.defineProperty(TaskCompletionSource, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.tasks.TaskCompletionSource');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TaskCompletionSource.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.tasks.TaskCompletionSource');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TaskCompletionSource.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TaskCompletionSource.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TaskCompletionSource(Hyperloop.cast('com.google.android.gms.tasks.TaskCompletionSource', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function trySetException
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/TaskCompletionSource.html#trySetException(java.lang.Exception)}
 **/
TaskCompletionSource.prototype.trySetException = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'trySetException',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.TaskCompletionSource') {
			return new TaskCompletionSource(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/TaskCompletionSource.html#setResult(java.lang.Object)}
 **/
TaskCompletionSource.prototype.setResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.TaskCompletionSource') {
			return new TaskCompletionSource(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setException
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/TaskCompletionSource.html#setException(java.lang.Exception)}
 **/
TaskCompletionSource.prototype.setException = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setException',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.TaskCompletionSource') {
			return new TaskCompletionSource(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function trySetResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/TaskCompletionSource.html#trySetResult(java.lang.Object)}
 **/
TaskCompletionSource.prototype.trySetResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'trySetResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.TaskCompletionSource') {
			return new TaskCompletionSource(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTask
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/TaskCompletionSource.html#getTask()}
 **/
TaskCompletionSource.prototype.getTask = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTask',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.TaskCompletionSource') {
			return new TaskCompletionSource(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TaskCompletionSource;
