/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.CardInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.CardInfo
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html}
 **/
var CardInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.CardInfo')) {
		result = arguments[0];
	}
	else {
		result = CardInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
CardInfo.prototype = Object.create(SuperClass.prototype);
CardInfo.prototype.constructor = CardInfo;

Object.defineProperty(CardInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new CardInfo(this.$native.super);
	},
	enumerable: true
});

CardInfo.className = 'com.google.android.gms.wallet.CardInfo';
CardInfo.prototype.className = 'com.google.android.gms.wallet.CardInfo';

// class property
Object.defineProperty(CardInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.CardInfo');
	},
	enumerable: true,
	configurable: false
});


// Cast
CardInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new CardInfo(Hyperloop.cast('com.google.android.gms.wallet.CardInfo', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#CREATOR
Object.defineProperty(CardInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
				return new CardInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getBillingAddress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#getBillingAddress()}
 **/
CardInfo.prototype.getBillingAddress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBillingAddress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
			return new CardInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCardClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#getCardClass()}
 **/
CardInfo.prototype.getCardClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCardClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
			return new CardInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCardDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#getCardDescription()}
 **/
CardInfo.prototype.getCardDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCardDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
			return new CardInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCardDetails
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#getCardDetails()}
 **/
CardInfo.prototype.getCardDetails = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCardDetails',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
			return new CardInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCardNetwork
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#getCardNetwork()}
 **/
CardInfo.prototype.getCardNetwork = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCardNetwork',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
			return new CardInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
CardInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardInfo') {
			return new CardInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = CardInfo;
