/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.IsReadyToPayRequest
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.IsReadyToPayRequest
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html}
 **/
var IsReadyToPayRequest = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.IsReadyToPayRequest')) {
		result = arguments[0];
	}
	else {
		result = IsReadyToPayRequest.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
IsReadyToPayRequest.prototype = Object.create(SuperClass.prototype);
IsReadyToPayRequest.prototype.constructor = IsReadyToPayRequest;

Object.defineProperty(IsReadyToPayRequest.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new IsReadyToPayRequest(this.$native.super);
	},
	enumerable: true
});

IsReadyToPayRequest.className = 'com.google.android.gms.wallet.IsReadyToPayRequest';
IsReadyToPayRequest.prototype.className = 'com.google.android.gms.wallet.IsReadyToPayRequest';

// class property
Object.defineProperty(IsReadyToPayRequest, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.IsReadyToPayRequest');
	},
	enumerable: true,
	configurable: false
});


// Cast
IsReadyToPayRequest.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new IsReadyToPayRequest(Hyperloop.cast('com.google.android.gms.wallet.IsReadyToPayRequest', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(IsReadyToPayRequest, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.IsReadyToPayRequest$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#CREATOR
Object.defineProperty(IsReadyToPayRequest, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
				return new IsReadyToPayRequest(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function fromJson
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#fromJson(java.lang.String)}
 **/
IsReadyToPayRequest.fromJson = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fromJson',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#newBuilder()}
 **/
IsReadyToPayRequest.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function toJson
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#toJson()}
 **/
IsReadyToPayRequest.prototype.toJson = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toJson',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isExistingPaymentMethodRequired
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#isExistingPaymentMethodRequired()}
 **/
IsReadyToPayRequest.prototype.isExistingPaymentMethodRequired = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isExistingPaymentMethodRequired',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAllowedPaymentMethods
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#getAllowedPaymentMethods()}
 **/
IsReadyToPayRequest.prototype.getAllowedPaymentMethods = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllowedPaymentMethods',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#writeToParcel(android.os.Parcel, int)}
 **/
IsReadyToPayRequest.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAllowedCardNetworks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/IsReadyToPayRequest.html#getAllowedCardNetworks()}
 **/
IsReadyToPayRequest.prototype.getAllowedCardNetworks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllowedCardNetworks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.IsReadyToPayRequest') {
			return new IsReadyToPayRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = IsReadyToPayRequest;
