/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.PaymentData
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.PaymentData
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html}
 **/
var PaymentData = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.PaymentData')) {
		result = arguments[0];
	}
	else {
		result = PaymentData.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
PaymentData.prototype = Object.create(SuperClass.prototype);
PaymentData.prototype.constructor = PaymentData;

Object.defineProperty(PaymentData.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PaymentData(this.$native.super);
	},
	enumerable: true
});

PaymentData.className = 'com.google.android.gms.wallet.PaymentData';
PaymentData.prototype.className = 'com.google.android.gms.wallet.PaymentData';

// class property
Object.defineProperty(PaymentData, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.PaymentData');
	},
	enumerable: true,
	configurable: false
});


// Cast
PaymentData.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PaymentData(Hyperloop.cast('com.google.android.gms.wallet.PaymentData', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(PaymentData, 'zza', {
	get: function() {
		return require('./com.google.android.gms.wallet.PaymentData$zza');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#CREATOR
Object.defineProperty(PaymentData, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
				return new PaymentData(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getFromIntent
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getFromIntent(android.content.Intent)}
 **/
PaymentData.getFromIntent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getFromIntent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fromJson
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#fromJson(java.lang.String)}
 **/
PaymentData.fromJson = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fromJson',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getShippingAddress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getShippingAddress()}
 **/
PaymentData.prototype.getShippingAddress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getShippingAddress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toJson
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#toJson()}
 **/
PaymentData.prototype.toJson = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toJson',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCardInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getCardInfo()}
 **/
PaymentData.prototype.getCardInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCardInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putIntoIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#putIntoIntent(android.content.Intent)}
 **/
PaymentData.prototype.putIntoIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putIntoIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGoogleTransactionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getGoogleTransactionId()}
 **/
PaymentData.prototype.getGoogleTransactionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGoogleTransactionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtraData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getExtraData()}
 **/
PaymentData.prototype.getExtraData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtraData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEmail
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getEmail()}
 **/
PaymentData.prototype.getEmail = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEmail',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPaymentMethodToken
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#getPaymentMethodToken()}
 **/
PaymentData.prototype.getPaymentMethodToken = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPaymentMethodToken',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentData.html#writeToParcel(android.os.Parcel, int)}
 **/
PaymentData.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentData') {
			return new PaymentData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PaymentData;
