/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.PaymentMethodToken
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.PaymentMethodToken
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodToken.html}
 **/
var PaymentMethodToken = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.PaymentMethodToken')) {
		result = arguments[0];
	}
	else {
		result = PaymentMethodToken.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
PaymentMethodToken.prototype = Object.create(SuperClass.prototype);
PaymentMethodToken.prototype.constructor = PaymentMethodToken;

Object.defineProperty(PaymentMethodToken.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PaymentMethodToken(this.$native.super);
	},
	enumerable: true
});

PaymentMethodToken.className = 'com.google.android.gms.wallet.PaymentMethodToken';
PaymentMethodToken.prototype.className = 'com.google.android.gms.wallet.PaymentMethodToken';

// class property
Object.defineProperty(PaymentMethodToken, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.PaymentMethodToken');
	},
	enumerable: true,
	configurable: false
});


// Cast
PaymentMethodToken.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PaymentMethodToken(Hyperloop.cast('com.google.android.gms.wallet.PaymentMethodToken', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodToken.html#CREATOR
Object.defineProperty(PaymentMethodToken, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodToken') {
				return new PaymentMethodToken(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getToken
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodToken.html#getToken()}
 **/
PaymentMethodToken.prototype.getToken = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getToken',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodToken') {
			return new PaymentMethodToken(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPaymentMethodTokenizationType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodToken.html#getPaymentMethodTokenizationType()}
 **/
PaymentMethodToken.prototype.getPaymentMethodTokenizationType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPaymentMethodTokenizationType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodToken') {
			return new PaymentMethodToken(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodToken.html#writeToParcel(android.os.Parcel, int)}
 **/
PaymentMethodToken.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodToken') {
			return new PaymentMethodToken(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PaymentMethodToken;
