/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.PaymentMethodTokenizationParameters
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.PaymentMethodTokenizationParameters
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodTokenizationParameters.html}
 **/
var PaymentMethodTokenizationParameters = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.PaymentMethodTokenizationParameters')) {
		result = arguments[0];
	}
	else {
		result = PaymentMethodTokenizationParameters.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
PaymentMethodTokenizationParameters.prototype = Object.create(SuperClass.prototype);
PaymentMethodTokenizationParameters.prototype.constructor = PaymentMethodTokenizationParameters;

Object.defineProperty(PaymentMethodTokenizationParameters.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PaymentMethodTokenizationParameters(this.$native.super);
	},
	enumerable: true
});

PaymentMethodTokenizationParameters.className = 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters';
PaymentMethodTokenizationParameters.prototype.className = 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters';

// class property
Object.defineProperty(PaymentMethodTokenizationParameters, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.PaymentMethodTokenizationParameters');
	},
	enumerable: true,
	configurable: false
});


// Cast
PaymentMethodTokenizationParameters.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PaymentMethodTokenizationParameters(Hyperloop.cast('com.google.android.gms.wallet.PaymentMethodTokenizationParameters', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(PaymentMethodTokenizationParameters, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.PaymentMethodTokenizationParameters$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodTokenizationParameters.html#CREATOR
Object.defineProperty(PaymentMethodTokenizationParameters, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters') {
				return new PaymentMethodTokenizationParameters(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodTokenizationParameters.html#newBuilder()}
 **/
PaymentMethodTokenizationParameters.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters') {
			return new PaymentMethodTokenizationParameters(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getParameters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodTokenizationParameters.html#getParameters()}
 **/
PaymentMethodTokenizationParameters.prototype.getParameters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParameters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters') {
			return new PaymentMethodTokenizationParameters(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPaymentMethodTokenizationType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodTokenizationParameters.html#getPaymentMethodTokenizationType()}
 **/
PaymentMethodTokenizationParameters.prototype.getPaymentMethodTokenizationType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPaymentMethodTokenizationType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters') {
			return new PaymentMethodTokenizationParameters(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/PaymentMethodTokenizationParameters.html#writeToParcel(android.os.Parcel, int)}
 **/
PaymentMethodTokenizationParameters.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.PaymentMethodTokenizationParameters') {
			return new PaymentMethodTokenizationParameters(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PaymentMethodTokenizationParameters;
