/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.Wallet
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.Wallet
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/Wallet.html}
 **/
var Wallet = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.Wallet')) {
		result = arguments[0];
	}
	else {
		result = Wallet.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Wallet.prototype = Object.create(SuperClass.prototype);
Wallet.prototype.constructor = Wallet;

Object.defineProperty(Wallet.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Wallet(this.$native.super);
	},
	enumerable: true
});

Wallet.className = 'com.google.android.gms.wallet.Wallet';
Wallet.prototype.className = 'com.google.android.gms.wallet.Wallet';

// class property
Object.defineProperty(Wallet, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.Wallet');
	},
	enumerable: true,
	configurable: false
});


// Cast
Wallet.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Wallet(Hyperloop.cast('com.google.android.gms.wallet.Wallet', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(Wallet, 'WalletOptions', {
	get: function() {
		return require('./com.google.android.gms.wallet.Wallet$WalletOptions');
	},
	enumerable: true
});
Object.defineProperty(Wallet, 'zza', {
	get: function() {
		return require('./com.google.android.gms.wallet.Wallet$zza');
	},
	enumerable: true
});
Object.defineProperty(Wallet, 'zzb', {
	get: function() {
		return require('./com.google.android.gms.wallet.Wallet$zzb');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/Wallet.html#API
Object.defineProperty(Wallet, 'API', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('API');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.Wallet') {
				return new Wallet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getPaymentsClient
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/Wallet.html#getPaymentsClient(android.app.Activity, com.google.android.gms.wallet.Wallet$WalletOptions)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/Wallet.html#getPaymentsClient(android.content.Context, com.google.android.gms.wallet.Wallet$WalletOptions)}
 **/
Wallet.getPaymentsClient = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getPaymentsClient',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.Wallet') {
			return new Wallet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWalletObjectsClient
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/Wallet.html#getWalletObjectsClient(android.app.Activity, com.google.android.gms.wallet.Wallet$WalletOptions)}
 **/
Wallet.getWalletObjectsClient = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getWalletObjectsClient',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.Wallet') {
			return new Wallet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = Wallet;
