/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.wobs.TimeInterval
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet.wobs');

/**
 * @class com.google.android.gms.wallet.wobs.TimeInterval
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/TimeInterval.html}
 **/
var TimeInterval = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.wobs.TimeInterval')) {
		result = arguments[0];
	}
	else {
		result = TimeInterval.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
TimeInterval.prototype = Object.create(SuperClass.prototype);
TimeInterval.prototype.constructor = TimeInterval;

Object.defineProperty(TimeInterval.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TimeInterval(this.$native.super);
	},
	enumerable: true
});

TimeInterval.className = 'com.google.android.gms.wallet.wobs.TimeInterval';
TimeInterval.prototype.className = 'com.google.android.gms.wallet.wobs.TimeInterval';

// class property
Object.defineProperty(TimeInterval, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.wobs.TimeInterval');
	},
	enumerable: true,
	configurable: false
});


// Cast
TimeInterval.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TimeInterval(Hyperloop.cast('com.google.android.gms.wallet.wobs.TimeInterval', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/wobs/TimeInterval.html#CREATOR
Object.defineProperty(TimeInterval, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.wobs.TimeInterval') {
				return new TimeInterval(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getStartTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/TimeInterval.html#getStartTimestamp()}
 **/
TimeInterval.prototype.getStartTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.TimeInterval') {
			return new TimeInterval(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEndTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/TimeInterval.html#getEndTimestamp()}
 **/
TimeInterval.prototype.getEndTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEndTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.TimeInterval') {
			return new TimeInterval(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/TimeInterval.html#writeToParcel(android.os.Parcel, int)}
 **/
TimeInterval.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.TimeInterval') {
			return new TimeInterval(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TimeInterval;
