/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.wobs.UriData
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet.wobs');

/**
 * @class com.google.android.gms.wallet.wobs.UriData
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/UriData.html}
 **/
var UriData = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.wobs.UriData')) {
		result = arguments[0];
	}
	else {
		result = UriData.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
UriData.prototype = Object.create(SuperClass.prototype);
UriData.prototype.constructor = UriData;

Object.defineProperty(UriData.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new UriData(this.$native.super);
	},
	enumerable: true
});

UriData.className = 'com.google.android.gms.wallet.wobs.UriData';
UriData.prototype.className = 'com.google.android.gms.wallet.wobs.UriData';

// class property
Object.defineProperty(UriData, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.wobs.UriData');
	},
	enumerable: true,
	configurable: false
});


// Cast
UriData.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new UriData(Hyperloop.cast('com.google.android.gms.wallet.wobs.UriData', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/wobs/UriData.html#CREATOR
Object.defineProperty(UriData, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.wobs.UriData') {
				return new UriData(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/UriData.html#writeToParcel(android.os.Parcel, int)}
 **/
UriData.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.UriData') {
			return new UriData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/UriData.html#getDescription()}
 **/
UriData.prototype.getDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.UriData') {
			return new UriData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/UriData.html#getUri()}
 **/
UriData.prototype.getUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.UriData') {
			return new UriData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = UriData;
