/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.wobs.WalletObjectMessage
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet.wobs');

/**
 * @class com.google.android.gms.wallet.wobs.WalletObjectMessage
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html}
 **/
var WalletObjectMessage = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.wobs.WalletObjectMessage')) {
		result = arguments[0];
	}
	else {
		result = WalletObjectMessage.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
WalletObjectMessage.prototype = Object.create(SuperClass.prototype);
WalletObjectMessage.prototype.constructor = WalletObjectMessage;

Object.defineProperty(WalletObjectMessage.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new WalletObjectMessage(this.$native.super);
	},
	enumerable: true
});

WalletObjectMessage.className = 'com.google.android.gms.wallet.wobs.WalletObjectMessage';
WalletObjectMessage.prototype.className = 'com.google.android.gms.wallet.wobs.WalletObjectMessage';

// class property
Object.defineProperty(WalletObjectMessage, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.wobs.WalletObjectMessage');
	},
	enumerable: true,
	configurable: false
});


// Cast
WalletObjectMessage.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new WalletObjectMessage(Hyperloop.cast('com.google.android.gms.wallet.wobs.WalletObjectMessage', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(WalletObjectMessage, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.wobs.WalletObjectMessage$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#CREATOR
Object.defineProperty(WalletObjectMessage, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
				return new WalletObjectMessage(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#newBuilder()}
 **/
WalletObjectMessage.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getDisplayInterval
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#getDisplayInterval()}
 **/
WalletObjectMessage.prototype.getDisplayInterval = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayInterval',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBody
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#getBody()}
 **/
WalletObjectMessage.prototype.getBody = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBody',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getImageUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#getImageUri()}
 **/
WalletObjectMessage.prototype.getImageUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getImageUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#writeToParcel(android.os.Parcel, int)}
 **/
WalletObjectMessage.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHeader
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#getHeader()}
 **/
WalletObjectMessage.prototype.getHeader = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHeader',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActionUri
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/WalletObjectMessage.html#getActionUri()}
 **/
WalletObjectMessage.prototype.getActionUri = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActionUri',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.WalletObjectMessage') {
			return new WalletObjectMessage(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = WalletObjectMessage;
