/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.lang.invoke.MethodHandle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.lang.invoke');

/**
 * @class java.lang.invoke.MethodHandle
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html}
 **/
var MethodHandle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.lang.invoke.MethodHandle')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: java.lang.invoke.MethodHandle. Create a subclass using java.lang.invoke.MethodHandle.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MethodHandle.prototype = Object.create(SuperClass.prototype);
MethodHandle.prototype.constructor = MethodHandle;

Object.defineProperty(MethodHandle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MethodHandle(this.$native.super);
	},
	enumerable: true
});

MethodHandle.className = 'java.lang.invoke.MethodHandle';
MethodHandle.prototype.className = 'java.lang.invoke.MethodHandle';

// class property
Object.defineProperty(MethodHandle, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.invoke.MethodHandle');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MethodHandle.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.lang.invoke.MethodHandle');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MethodHandle.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MethodHandle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MethodHandle(Hyperloop.cast('java.lang.invoke.MethodHandle', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function asSpreader
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asSpreader(java.lang.Class, int)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asSpreader(int, java.lang.Class, int)}
 **/
MethodHandle.prototype.asSpreader = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asSpreader',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asCollector
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asCollector(java.lang.Class, int)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asCollector(int, java.lang.Class, int)}
 **/
MethodHandle.prototype.asCollector = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asCollector',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withVarargs
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#withVarargs(boolean)}
 **/
MethodHandle.prototype.withVarargs = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withVarargs',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invokeExact
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#invokeExact(java.lang.Object[])}
 **/
MethodHandle.prototype.invokeExact = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invokeExact',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invoke
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#invoke(java.lang.Object[])}
 **/
MethodHandle.prototype.invoke = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invoke',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function type
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#type()}
 **/
MethodHandle.prototype.type = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'type',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeConstable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#describeConstable()}
 **/
MethodHandle.prototype.describeConstable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeConstable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asType(java.lang.invoke.MethodType)}
 **/
MethodHandle.prototype.asType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asVarargsCollector
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asVarargsCollector(java.lang.Class)}
 **/
MethodHandle.prototype.asVarargsCollector = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asVarargsCollector',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function bindTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#bindTo(java.lang.Object)}
 **/
MethodHandle.prototype.bindTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'bindTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invokeWithArguments
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#invokeWithArguments(java.lang.Object[])}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#invokeWithArguments(java.util.List)}
 **/
MethodHandle.prototype.invokeWithArguments = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invokeWithArguments',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isVarargsCollector
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#isVarargsCollector()}
 **/
MethodHandle.prototype.isVarargsCollector = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isVarargsCollector',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asFixedArity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#asFixedArity()}
 **/
MethodHandle.prototype.asFixedArity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asFixedArity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandle.html#toString()}
 **/
MethodHandle.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandle') {
			return new MethodHandle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MethodHandle;
