/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module MethodHandleInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.lang.invoke');

/**
 * constructor
 * http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html
 **/
var MethodHandleInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.lang.invoke.MethodHandleInfo') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.lang.invoke.MethodHandleInfo');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
MethodHandleInfo.prototype = Object.create(SuperClass.prototype);
MethodHandleInfo.prototype.constructor = MethodHandleInfo;

Object.defineProperty(MethodHandleInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MethodHandleInfo(this.$native.super);
	},
	enumerable: true
});

MethodHandleInfo.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

MethodHandleInfo.className = "java.lang.invoke.MethodHandleInfo";
MethodHandleInfo.prototype.className = "java.lang.invoke.MethodHandleInfo";

// class property
Object.defineProperty(MethodHandleInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.invoke.MethodHandleInfo');
	},
	enumerable: true,
	configurable: false
});

// Cast
MethodHandleInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MethodHandleInfo(Hyperloop.cast('java.lang.invoke.MethodHandleInfo', object.$native));
};

// Constants
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_getStatic
MethodHandleInfo.REF_getStatic = 2;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_getField
MethodHandleInfo.REF_getField = 1;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_putStatic
MethodHandleInfo.REF_putStatic = 4;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_newInvokeSpecial
MethodHandleInfo.REF_newInvokeSpecial = 8;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_putField
MethodHandleInfo.REF_putField = 3;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_invokeVirtual
MethodHandleInfo.REF_invokeVirtual = 5;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_invokeSpecial
MethodHandleInfo.REF_invokeSpecial = 7;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_invokeStatic
MethodHandleInfo.REF_invokeStatic = 6;
// http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#REF_invokeInterface
MethodHandleInfo.REF_invokeInterface = 9;

// Static methods
/**
 * TODO Fill out docs more...
 * @function referenceKindToString
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#referenceKindToString(int)}
 **/
MethodHandleInfo.referenceKindToString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'referenceKindToString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#toString(int, java.lang.Class, java.lang.String, java.lang.invoke.MethodType)}
 **/
MethodHandleInfo.toString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'toString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function getReferenceKind
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#getReferenceKind()}
 **/
MethodHandleInfo.prototype.getReferenceKind = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getReferenceKind',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDeclaringClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#getDeclaringClass()}
 **/
MethodHandleInfo.prototype.getDeclaringClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDeclaringClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#getName()}
 **/
MethodHandleInfo.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isVarArgs
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#isVarArgs()}
 **/
MethodHandleInfo.prototype.isVarArgs = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isVarArgs',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getMethodType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#getMethodType()}
 **/
MethodHandleInfo.prototype.getMethodType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMethodType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function reflectAs
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#reflectAs(java.lang.Class, java.lang.invoke.MethodHandles$Lookup)}
 **/
MethodHandleInfo.prototype.reflectAs = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reflectAs',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getModifiers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandleInfo.html#getModifiers()}
 **/
MethodHandleInfo.prototype.getModifiers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getModifiers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandleInfo') {
			return new MethodHandleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

MethodHandleInfo.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

MethodHandleInfo.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = MethodHandleInfo;
