/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.lang.invoke.MethodHandles$Lookup
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./java.lang.invoke.MethodHandles');

/**
 * @class java.lang.invoke.MethodHandles$Lookup
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html}
 **/
var Lookup = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.lang.invoke.MethodHandles$Lookup')) {
		result = arguments[0];
	}
	else {
		result = Lookup.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Lookup.prototype = Object.create(SuperClass.prototype);
Lookup.prototype.constructor = Lookup;

Object.defineProperty(Lookup.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Lookup(this.$native.super);
	},
	enumerable: true
});

Lookup.className = 'java.lang.invoke.MethodHandles$Lookup';
Lookup.prototype.className = 'java.lang.invoke.MethodHandles$Lookup';

// class property
Object.defineProperty(Lookup, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.invoke.MethodHandles$Lookup');
	},
	enumerable: true,
	configurable: false
});


// Cast
Lookup.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Lookup(Hyperloop.cast('java.lang.invoke.MethodHandles$Lookup', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#MODULE}
 */
Lookup.MODULE = 16;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#PACKAGE}
 */
Lookup.PACKAGE = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#PUBLIC}
 */
Lookup.PUBLIC = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#UNCONDITIONAL}
 */
Lookup.UNCONDITIONAL = 32;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#PROTECTED}
 */
Lookup.PROTECTED = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#PRIVATE}
 */
Lookup.PRIVATE = 2;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function findStaticVarHandle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findStaticVarHandle(java.lang.Class, java.lang.String, java.lang.Class)}
 **/
Lookup.prototype.findStaticVarHandle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findStaticVarHandle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasFullPrivilegeAccess
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#hasFullPrivilegeAccess()}
 **/
Lookup.prototype.hasFullPrivilegeAccess = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasFullPrivilegeAccess',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findStaticGetter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findStaticGetter(java.lang.Class, java.lang.String, java.lang.Class)}
 **/
Lookup.prototype.findStaticGetter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findStaticGetter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lookupClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#lookupClass()}
 **/
Lookup.prototype.lookupClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lookupClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function defineHiddenClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#defineHiddenClass(byte[], boolean, java.lang.invoke.MethodHandles$Lookup$ClassOption[])}
 **/
Lookup.prototype.defineHiddenClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'defineHiddenClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unreflectSetter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#unreflectSetter(java.lang.reflect.Field)}
 **/
Lookup.prototype.unreflectSetter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unreflectSetter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findVirtual
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findVirtual(java.lang.Class, java.lang.String, java.lang.invoke.MethodType)}
 **/
Lookup.prototype.findVirtual = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findVirtual',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findConstructor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findConstructor(java.lang.Class, java.lang.invoke.MethodType)}
 **/
Lookup.prototype.findConstructor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findConstructor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dropLookupMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#dropLookupMode(int)}
 **/
Lookup.prototype.dropLookupMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dropLookupMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findStaticSetter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findStaticSetter(java.lang.Class, java.lang.String, java.lang.Class)}
 **/
Lookup.prototype.findStaticSetter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findStaticSetter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function bind
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#bind(java.lang.Object, java.lang.String, java.lang.invoke.MethodType)}
 **/
Lookup.prototype.bind = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'bind',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findGetter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findGetter(java.lang.Class, java.lang.String, java.lang.Class)}
 **/
Lookup.prototype.findGetter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findGetter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasPrivateAccess
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#hasPrivateAccess()}
 **/
Lookup.prototype.hasPrivateAccess = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasPrivateAccess',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function accessClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#accessClass(java.lang.Class)}
 **/
Lookup.prototype.accessClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'accessClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unreflectGetter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#unreflectGetter(java.lang.reflect.Field)}
 **/
Lookup.prototype.unreflectGetter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unreflectGetter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findSpecial
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findSpecial(java.lang.Class, java.lang.String, java.lang.invoke.MethodType, java.lang.Class)}
 **/
Lookup.prototype.findSpecial = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findSpecial',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function in
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#in(java.lang.Class)}
 **/
Lookup.prototype.in = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'in',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function defineClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#defineClass(byte[])}
 **/
Lookup.prototype.defineClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'defineClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unreflectConstructor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#unreflectConstructor(java.lang.reflect.Constructor)}
 **/
Lookup.prototype.unreflectConstructor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unreflectConstructor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findClass(java.lang.String)}
 **/
Lookup.prototype.findClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unreflectVarHandle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#unreflectVarHandle(java.lang.reflect.Field)}
 **/
Lookup.prototype.unreflectVarHandle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unreflectVarHandle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lookupModes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#lookupModes()}
 **/
Lookup.prototype.lookupModes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lookupModes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findStatic
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findStatic(java.lang.Class, java.lang.String, java.lang.invoke.MethodType)}
 **/
Lookup.prototype.findStatic = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findStatic',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ensureInitialized
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#ensureInitialized(java.lang.Class)}
 **/
Lookup.prototype.ensureInitialized = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'ensureInitialized',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unreflectSpecial
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#unreflectSpecial(java.lang.reflect.Method, java.lang.Class)}
 **/
Lookup.prototype.unreflectSpecial = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unreflectSpecial',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unreflect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#unreflect(java.lang.reflect.Method)}
 **/
Lookup.prototype.unreflect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unreflect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findSetter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findSetter(java.lang.Class, java.lang.String, java.lang.Class)}
 **/
Lookup.prototype.findSetter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findSetter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findVarHandle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#findVarHandle(java.lang.Class, java.lang.String, java.lang.Class)}
 **/
Lookup.prototype.findVarHandle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findVarHandle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#toString()}
 **/
Lookup.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function previousLookupClass
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#previousLookupClass()}
 **/
Lookup.prototype.previousLookupClass = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'previousLookupClass',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function revealDirect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.Lookup.html#revealDirect(java.lang.invoke.MethodHandle)}
 **/
Lookup.prototype.revealDirect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'revealDirect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles$Lookup') {
			return new Lookup(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Lookup;
