/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.lang.invoke.MethodType
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.lang.invoke');

/**
 * @class java.lang.invoke.MethodType
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html}
 **/
var MethodType = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.lang.invoke.MethodType')) {
		result = arguments[0];
	}
	else {
		result = MethodType.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MethodType.prototype = Object.create(SuperClass.prototype);
MethodType.prototype.constructor = MethodType;

Object.defineProperty(MethodType.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MethodType(this.$native.super);
	},
	enumerable: true
});

MethodType.className = 'java.lang.invoke.MethodType';
MethodType.prototype.className = 'java.lang.invoke.MethodType';

// class property
Object.defineProperty(MethodType, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.invoke.MethodType');
	},
	enumerable: true,
	configurable: false
});


// Cast
MethodType.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MethodType(Hyperloop.cast('java.lang.invoke.MethodType', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function fromMethodDescriptorString
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#fromMethodDescriptorString(java.lang.String, java.lang.ClassLoader)}
 **/
MethodType.fromMethodDescriptorString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fromMethodDescriptorString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function methodType
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#methodType(java.lang.Class, java.lang.Class[])}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#methodType(java.lang.Class, java.util.List)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#methodType(java.lang.Class, java.lang.Class, java.lang.Class[])}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#methodType(java.lang.Class)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#methodType(java.lang.Class, java.lang.Class)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#methodType(java.lang.Class, java.lang.invoke.MethodType)}
 **/
MethodType.methodType = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'methodType',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function genericMethodType
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#genericMethodType(int, boolean)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#genericMethodType(int)}
 **/
MethodType.genericMethodType = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'genericMethodType',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function toMethodDescriptorString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#toMethodDescriptorString()}
 **/
MethodType.prototype.toMethodDescriptorString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toMethodDescriptorString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dropParameterTypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#dropParameterTypes(int, int)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#dropParameterTypes(int, int)}
 **/
MethodType.prototype.dropParameterTypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dropParameterTypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function changeReturnType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#changeReturnType(java.lang.Class)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#changeReturnType(java.lang.invoke.TypeDescriptor$OfField)}
 **/
MethodType.prototype.changeReturnType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'changeReturnType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lastParameterType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#lastParameterType()}
 **/
MethodType.prototype.lastParameterType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lastParameterType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeConstable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#describeConstable()}
 **/
MethodType.prototype.describeConstable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeConstable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function changeParameterType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#changeParameterType(int, java.lang.Class)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#changeParameterType(int, java.lang.invoke.TypeDescriptor$OfField)}
 **/
MethodType.prototype.changeParameterType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'changeParameterType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unwrap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#unwrap()}
 **/
MethodType.prototype.unwrap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unwrap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasWrappers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#hasWrappers()}
 **/
MethodType.prototype.hasWrappers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasWrappers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parameterArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#parameterArray()}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#parameterArray()}
 **/
MethodType.prototype.parameterArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parameterArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#hashCode()}
 **/
MethodType.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function appendParameterTypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#appendParameterTypes(java.lang.Class[])}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#appendParameterTypes(java.util.List)}
 **/
MethodType.prototype.appendParameterTypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'appendParameterTypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parameterType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#parameterType(int)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#parameterType(int)}
 **/
MethodType.prototype.parameterType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parameterType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function erase
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#erase()}
 **/
MethodType.prototype.erase = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'erase',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parameterCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#parameterCount()}
 **/
MethodType.prototype.parameterCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parameterCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function descriptorString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#descriptorString()}
 **/
MethodType.prototype.descriptorString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'descriptorString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function insertParameterTypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#insertParameterTypes(int, java.lang.Class[])}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#insertParameterTypes(int, java.util.List)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#insertParameterTypes(int, java.lang.invoke.TypeDescriptor$OfField[])}
 **/
MethodType.prototype.insertParameterTypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'insertParameterTypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generic
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#generic()}
 **/
MethodType.prototype.generic = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generic',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasPrimitives
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#hasPrimitives()}
 **/
MethodType.prototype.hasPrimitives = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasPrimitives',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#equals(java.lang.Object)}
 **/
MethodType.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parameterList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#parameterList()}
 **/
MethodType.prototype.parameterList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parameterList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#toString()}
 **/
MethodType.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function wrap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#wrap()}
 **/
MethodType.prototype.wrap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'wrap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function returnType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#returnType()}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodType.html#returnType()}
 **/
MethodType.prototype.returnType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'returnType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodType') {
			return new MethodType(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MethodType;
