/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.lang.ref.WeakReference
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.lang.ref');

/**
 * @class java.lang.ref.WeakReference
 * @extends java.lang.ref.Reference 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/lang/ref/WeakReference.html}
 **/
var WeakReference = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.lang.ref.WeakReference')) {
		result = arguments[0];
	}
	else {
		result = WeakReference.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.ref.Reference');
WeakReference.prototype = Object.create(SuperClass.prototype);
WeakReference.prototype.constructor = WeakReference;

Object.defineProperty(WeakReference.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new WeakReference(this.$native.super);
	},
	enumerable: true
});

WeakReference.className = 'java.lang.ref.WeakReference';
WeakReference.prototype.className = 'java.lang.ref.WeakReference';

// class property
Object.defineProperty(WeakReference, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.ref.WeakReference');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
WeakReference.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.lang.ref.WeakReference');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(WeakReference.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
WeakReference.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new WeakReference(Hyperloop.cast('java.lang.ref.WeakReference', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods

// export the class
module.exports = WeakReference;
