/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.text.AttributedCharacterIterator$Attribute
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./java.text.AttributedCharacterIterator');

/**
 * @class java.text.AttributedCharacterIterator$Attribute
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html}
 **/
var Attribute = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.text.AttributedCharacterIterator$Attribute')) {
		result = arguments[0];
	}
	else {
		result = Attribute.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Attribute.prototype = Object.create(SuperClass.prototype);
Attribute.prototype.constructor = Attribute;

Object.defineProperty(Attribute.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Attribute(this.$native.super);
	},
	enumerable: true
});

Attribute.className = 'java.text.AttributedCharacterIterator$Attribute';
Attribute.prototype.className = 'java.text.AttributedCharacterIterator$Attribute';

// class property
Object.defineProperty(Attribute, 'class', {
	get: function() {
		return Hyperloop.getClass('java.text.AttributedCharacterIterator$Attribute');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Attribute.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.text.AttributedCharacterIterator$Attribute');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Attribute.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Attribute.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Attribute(Hyperloop.cast('java.text.AttributedCharacterIterator$Attribute', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#LANGUAGE
Object.defineProperty(Attribute, 'LANGUAGE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('LANGUAGE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
				return new Attribute(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#INPUT_METHOD_SEGMENT
Object.defineProperty(Attribute, 'INPUT_METHOD_SEGMENT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('INPUT_METHOD_SEGMENT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
				return new Attribute(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#READING
Object.defineProperty(Attribute, 'READING', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('READING');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
				return new Attribute(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#getName()}
 **/
Attribute.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
			return new Attribute(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function readResolve
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#readResolve()}
 **/
Attribute.prototype.readResolve = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readResolve',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
			return new Attribute(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#hashCode()}
 **/
Attribute.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
			return new Attribute(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#equals(java.lang.Object)}
 **/
Attribute.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
			return new Attribute(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.Attribute.html#toString()}
 **/
Attribute.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator$Attribute') {
			return new Attribute(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Attribute;
