/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.text.FieldPosition
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.text');

/**
 * @class java.text.FieldPosition
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html}
 **/
var FieldPosition = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.text.FieldPosition')) {
		result = arguments[0];
	}
	else {
		result = FieldPosition.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FieldPosition.prototype = Object.create(SuperClass.prototype);
FieldPosition.prototype.constructor = FieldPosition;

Object.defineProperty(FieldPosition.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FieldPosition(this.$native.super);
	},
	enumerable: true
});

FieldPosition.className = 'java.text.FieldPosition';
FieldPosition.prototype.className = 'java.text.FieldPosition';

// class property
Object.defineProperty(FieldPosition, 'class', {
	get: function() {
		return Hyperloop.getClass('java.text.FieldPosition');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FieldPosition.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.text.FieldPosition');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FieldPosition.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FieldPosition.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FieldPosition(Hyperloop.cast('java.text.FieldPosition', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getEndIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#getEndIndex()}
 **/
FieldPosition.prototype.getEndIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEndIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#hashCode()}
 **/
FieldPosition.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFieldAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#getFieldAttribute()}
 **/
FieldPosition.prototype.getFieldAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFieldAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#equals(java.lang.Object)}
 **/
FieldPosition.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getField
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#getField()}
 **/
FieldPosition.prototype.getField = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getField',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEndIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#setEndIndex(int)}
 **/
FieldPosition.prototype.setEndIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEndIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#toString()}
 **/
FieldPosition.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBeginIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#getBeginIndex()}
 **/
FieldPosition.prototype.getBeginIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBeginIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBeginIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/FieldPosition.html#setBeginIndex(int)}
 **/
FieldPosition.prototype.setBeginIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBeginIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.FieldPosition') {
			return new FieldPosition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FieldPosition;
