/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.text.Format
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.text');

/**
 * @class java.text.Format
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/text/Format.html}
 **/
var Format = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.text.Format')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: java.text.Format. Create a subclass using java.text.Format.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Format.prototype = Object.create(SuperClass.prototype);
Format.prototype.constructor = Format;

Object.defineProperty(Format.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Format(this.$native.super);
	},
	enumerable: true
});

Format.className = 'java.text.Format';
Format.prototype.className = 'java.text.Format';

// class property
Object.defineProperty(Format, 'class', {
	get: function() {
		return Hyperloop.getClass('java.text.Format');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Format.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.text.Format');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Format.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Format.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Format(Hyperloop.cast('java.text.Format', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(Format, 'Field', {
	get: function() {
		return require('./java.text.Format$Field');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function formatToCharacterIterator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/Format.html#formatToCharacterIterator(java.lang.Object)}
 **/
Format.prototype.formatToCharacterIterator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'formatToCharacterIterator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.Format') {
			return new Format(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/Format.html#format(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/text/Format.html#format(java.lang.Object, java.lang.StringBuffer, java.text.FieldPosition)}
 **/
Format.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.Format') {
			return new Format(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/Format.html#clone()}
 **/
Format.prototype.clone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.Format') {
			return new Format(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parseObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/Format.html#parseObject(java.lang.String, java.text.ParsePosition)}
 * @see {@link http://developer.android.com/reference/java/text/Format.html#parseObject(java.lang.String)}
 **/
Format.prototype.parseObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parseObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.Format') {
			return new Format(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Format;
