/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.Instant
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.Instant
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/Instant.html}
 **/
var Instant = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.Instant')) {
		result = arguments[0];
	}
	else {
		result = Instant.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Instant.prototype = Object.create(SuperClass.prototype);
Instant.prototype.constructor = Instant;

Object.defineProperty(Instant.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Instant(this.$native.super);
	},
	enumerable: true
});

Instant.className = 'java.time.Instant';
Instant.prototype.className = 'java.time.Instant';

// class property
Object.defineProperty(Instant, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.Instant');
	},
	enumerable: true,
	configurable: false
});


// Cast
Instant.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Instant(Hyperloop.cast('java.time.Instant', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/Instant.html#MIN
Object.defineProperty(Instant, 'MIN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MIN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.Instant') {
				return new Instant(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/Instant.html#MAX
Object.defineProperty(Instant, 'MAX', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MAX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.Instant') {
				return new Instant(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/Instant.html#EPOCH
Object.defineProperty(Instant, 'EPOCH', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('EPOCH');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.Instant') {
				return new Instant(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofEpochSecond
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#ofEpochSecond(long)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#ofEpochSecond(long, long)}
 **/
Instant.ofEpochSecond = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofEpochSecond',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofEpochMilli
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#ofEpochMilli(long)}
 **/
Instant.ofEpochMilli = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofEpochMilli',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function now
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#now()}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#now(java.time.Clock)}
 **/
Instant.now = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'now',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#from(java.time.temporal.TemporalAccessor)}
 **/
Instant.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parse
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#parse(java.lang.CharSequence)}
 **/
Instant.parse = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parse',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minus(java.time.temporal.TemporalAmount)}
 **/
Instant.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#adjustInto(java.time.temporal.Temporal)}
 **/
Instant.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#range(java.time.temporal.TemporalField)}
 **/
Instant.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMillis
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minusMillis(long)}
 **/
Instant.prototype.minusMillis = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMillis',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#compareTo(java.time.Instant)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#compareTo(java.lang.Object)}
 **/
Instant.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#hashCode()}
 **/
Instant.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#get(java.time.temporal.TemporalField)}
 **/
Instant.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plusSeconds(long)}
 **/
Instant.prototype.plusSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusNanos
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plusNanos(long)}
 **/
Instant.prototype.plusNanos = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusNanos',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function truncatedTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#truncatedTo(java.time.temporal.TemporalUnit)}
 **/
Instant.prototype.truncatedTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'truncatedTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#query(java.time.temporal.TemporalQuery)}
 **/
Instant.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function atOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#atOffset(java.time.ZoneOffset)}
 **/
Instant.prototype.atOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNano
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#getNano()}
 **/
Instant.prototype.getNano = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNano',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusNanos
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minusNanos(long)}
 **/
Instant.prototype.minusNanos = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusNanos',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toEpochMilli
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#toEpochMilli()}
 **/
Instant.prototype.toEpochMilli = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochMilli',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
Instant.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function atZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#atZone(java.time.ZoneId)}
 **/
Instant.prototype.atZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plus(java.time.temporal.TemporalAmount)}
 **/
Instant.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#isBefore(java.time.Instant)}
 **/
Instant.prototype.isBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#getLong(java.time.temporal.TemporalField)}
 **/
Instant.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#with(java.time.temporal.TemporalAdjuster)}
 **/
Instant.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMillis
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#plusMillis(long)}
 **/
Instant.prototype.plusMillis = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMillis',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#equals(java.lang.Object)}
 **/
Instant.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 **/
Instant.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#toString()}
 **/
Instant.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEpochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#getEpochSecond()}
 **/
Instant.prototype.getEpochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEpochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#minusSeconds(long)}
 **/
Instant.prototype.minusSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Instant.html#isAfter(java.time.Instant)}
 **/
Instant.prototype.isAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Instant') {
			return new Instant(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Instant;
