/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.OffsetDateTime
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.OffsetDateTime
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html}
 **/
var OffsetDateTime = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.OffsetDateTime')) {
		result = arguments[0];
	}
	else {
		result = OffsetDateTime.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
OffsetDateTime.prototype = Object.create(SuperClass.prototype);
OffsetDateTime.prototype.constructor = OffsetDateTime;

Object.defineProperty(OffsetDateTime.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new OffsetDateTime(this.$native.super);
	},
	enumerable: true
});

OffsetDateTime.className = 'java.time.OffsetDateTime';
OffsetDateTime.prototype.className = 'java.time.OffsetDateTime';

// class property
Object.defineProperty(OffsetDateTime, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.OffsetDateTime');
	},
	enumerable: true,
	configurable: false
});


// Cast
OffsetDateTime.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new OffsetDateTime(Hyperloop.cast('java.time.OffsetDateTime', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/OffsetDateTime.html#MIN
Object.defineProperty(OffsetDateTime, 'MIN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MIN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.OffsetDateTime') {
				return new OffsetDateTime(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/OffsetDateTime.html#MAX
Object.defineProperty(OffsetDateTime, 'MAX', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MAX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.OffsetDateTime') {
				return new OffsetDateTime(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#from(java.time.temporal.TemporalAccessor)}
 **/
OffsetDateTime.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofInstant
 * @static
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#ofInstant(java.time.Instant, java.time.ZoneId)}
 **/
OffsetDateTime.ofInstant = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofInstant',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function now
 * @static
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#now()}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#now(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#now(java.time.Clock)}
 **/
OffsetDateTime.now = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'now',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#of(java.time.LocalDate, java.time.LocalTime, java.time.ZoneOffset)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#of(java.time.LocalDateTime, java.time.ZoneOffset)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#of(int, int, int, int, int, int, int, java.time.ZoneOffset)}
 **/
OffsetDateTime.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parse
 * @static
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#parse(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#parse(java.lang.CharSequence, java.time.format.DateTimeFormatter)}
 **/
OffsetDateTime.parse = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parse',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function timeLineOrder
 * @static
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#timeLineOrder()}
 **/
OffsetDateTime.timeLineOrder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'timeLineOrder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function plusHours
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusHours(long)}
 **/
OffsetDateTime.prototype.plusHours = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusHours',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEqual
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#isEqual(java.time.OffsetDateTime)}
 **/
OffsetDateTime.prototype.isEqual = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEqual',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocalTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toLocalTime()}
 **/
OffsetDateTime.prototype.toLocalTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#compareTo(java.time.OffsetDateTime)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#compareTo(java.lang.Object)}
 **/
OffsetDateTime.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withOffsetSameLocal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withOffsetSameLocal(java.time.ZoneOffset)}
 **/
OffsetDateTime.prototype.withOffsetSameLocal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withOffsetSameLocal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfWeek
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getDayOfWeek()}
 **/
OffsetDateTime.prototype.getDayOfWeek = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfWeek',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getMinute()}
 **/
OffsetDateTime.prototype.getMinute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusSeconds(long)}
 **/
OffsetDateTime.prototype.plusSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getMonth()}
 **/
OffsetDateTime.prototype.getMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusNanos
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusNanos(long)}
 **/
OffsetDateTime.prototype.plusNanos = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusNanos',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function atZoneSameInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#atZoneSameInstant(java.time.ZoneId)}
 **/
OffsetDateTime.prototype.atZoneSameInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atZoneSameInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withHour
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withHour(int)}
 **/
OffsetDateTime.prototype.withHour = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withHour',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusMonths(long)}
 **/
OffsetDateTime.prototype.plusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function truncatedTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#truncatedTo(java.time.temporal.TemporalUnit)}
 **/
OffsetDateTime.prototype.truncatedTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'truncatedTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusYears(long)}
 **/
OffsetDateTime.prototype.plusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#query(java.time.temporal.TemporalQuery)}
 **/
OffsetDateTime.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNano
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getNano()}
 **/
OffsetDateTime.prototype.getNano = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNano',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusNanos
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusNanos(long)}
 **/
OffsetDateTime.prototype.minusNanos = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusNanos',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#format(java.time.format.DateTimeFormatter)}
 **/
OffsetDateTime.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
OffsetDateTime.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plus(java.time.temporal.TemporalAmount)}
 **/
OffsetDateTime.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getYear()}
 **/
OffsetDateTime.prototype.getYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toEpochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toEpochSecond()}
 **/
OffsetDateTime.prototype.toEpochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocalDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toLocalDateTime()}
 **/
OffsetDateTime.prototype.toLocalDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDayOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withDayOfMonth(int)}
 **/
OffsetDateTime.prototype.withDayOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDayOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withMonth(int)}
 **/
OffsetDateTime.prototype.withMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#isAfter(java.time.OffsetDateTime)}
 **/
OffsetDateTime.prototype.isAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minus(java.time.temporal.TemporalAmount)}
 **/
OffsetDateTime.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toOffsetTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toOffsetTime()}
 **/
OffsetDateTime.prototype.toOffsetTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toOffsetTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusHours
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusHours(long)}
 **/
OffsetDateTime.prototype.minusHours = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusHours',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getOffset()}
 **/
OffsetDateTime.prototype.getOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#adjustInto(java.time.temporal.Temporal)}
 **/
OffsetDateTime.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#range(java.time.temporal.TemporalField)}
 **/
OffsetDateTime.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withYear(int)}
 **/
OffsetDateTime.prototype.withYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMinutes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusMinutes(long)}
 **/
OffsetDateTime.prototype.plusMinutes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMinutes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusDays(long)}
 **/
OffsetDateTime.prototype.plusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMinutes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusMinutes(long)}
 **/
OffsetDateTime.prototype.minusMinutes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMinutes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function atZoneSimilarLocal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#atZoneSimilarLocal(java.time.ZoneId)}
 **/
OffsetDateTime.prototype.atZoneSimilarLocal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atZoneSimilarLocal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#hashCode()}
 **/
OffsetDateTime.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#get(java.time.temporal.TemporalField)}
 **/
OffsetDateTime.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getDayOfYear()}
 **/
OffsetDateTime.prototype.getDayOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHour
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getHour()}
 **/
OffsetDateTime.prototype.getHour = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHour',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusWeeks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#plusWeeks(long)}
 **/
OffsetDateTime.prototype.plusWeeks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusWeeks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withMinute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withMinute(int)}
 **/
OffsetDateTime.prototype.withMinute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withMinute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonthValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getMonthValue()}
 **/
OffsetDateTime.prototype.getMonthValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonthValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toZonedDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toZonedDateTime()}
 **/
OffsetDateTime.prototype.toZonedDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toZonedDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusYears(long)}
 **/
OffsetDateTime.prototype.minusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusWeeks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusWeeks(long)}
 **/
OffsetDateTime.prototype.minusWeeks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusWeeks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDayOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withDayOfYear(int)}
 **/
OffsetDateTime.prototype.withDayOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDayOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toInstant()}
 **/
OffsetDateTime.prototype.toInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#isBefore(java.time.OffsetDateTime)}
 **/
OffsetDateTime.prototype.isBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusDays(long)}
 **/
OffsetDateTime.prototype.minusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getLong(java.time.temporal.TemporalField)}
 **/
OffsetDateTime.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withNano
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withNano(int)}
 **/
OffsetDateTime.prototype.withNano = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withNano',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 **/
OffsetDateTime.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusMonths(long)}
 **/
OffsetDateTime.prototype.minusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocalDate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toLocalDate()}
 **/
OffsetDateTime.prototype.toLocalDate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalDate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withOffsetSameInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withOffsetSameInstant(java.time.ZoneOffset)}
 **/
OffsetDateTime.prototype.withOffsetSameInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withOffsetSameInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#equals(java.lang.Object)}
 **/
OffsetDateTime.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getSecond()}
 **/
OffsetDateTime.prototype.getSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 **/
OffsetDateTime.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#toString()}
 **/
OffsetDateTime.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#getDayOfMonth()}
 **/
OffsetDateTime.prototype.getDayOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#minusSeconds(long)}
 **/
OffsetDateTime.prototype.minusSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/OffsetDateTime.html#withSecond(int)}
 **/
OffsetDateTime.prototype.withSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.OffsetDateTime') {
			return new OffsetDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = OffsetDateTime;
