/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.Period
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.Period
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/Period.html}
 **/
var Period = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.Period')) {
		result = arguments[0];
	}
	else {
		result = Period.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Period.prototype = Object.create(SuperClass.prototype);
Period.prototype.constructor = Period;

Object.defineProperty(Period.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Period(this.$native.super);
	},
	enumerable: true
});

Period.className = 'java.time.Period';
Period.prototype.className = 'java.time.Period';

// class property
Object.defineProperty(Period, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.Period');
	},
	enumerable: true,
	configurable: false
});


// Cast
Period.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Period(Hyperloop.cast('java.time.Period', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/Period.html#ZERO
Object.defineProperty(Period, 'ZERO', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ZERO');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.Period') {
				return new Period(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofYears
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#ofYears(int)}
 **/
Period.ofYears = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofYears',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#of(int, int, int)}
 **/
Period.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#from(java.time.temporal.TemporalAmount)}
 **/
Period.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function between
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#between(java.time.LocalDate, java.time.LocalDate)}
 **/
Period.between = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'between',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofDays
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#ofDays(int)}
 **/
Period.ofDays = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofDays',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parse
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#parse(java.lang.CharSequence)}
 **/
Period.parse = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parse',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofWeeks
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#ofWeeks(int)}
 **/
Period.ofWeeks = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofWeeks',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofMonths
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Period.html#ofMonths(int)}
 **/
Period.ofMonths = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofMonths',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/Period.html#minus(java.time.temporal.TemporalAmount)}
 **/
Period.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function negated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#negated()}
 * @see {@link http://developer.android.com/reference/java/time/Period.html#negated()}
 **/
Period.prototype.negated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'negated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function normalized
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#normalized()}
 * @see {@link http://developer.android.com/reference/java/time/Period.html#normalized()}
 **/
Period.prototype.normalized = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'normalized',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#getMonths()}
 **/
Period.prototype.getMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#plusDays(long)}
 **/
Period.prototype.plusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function multipliedBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#multipliedBy(int)}
 * @see {@link http://developer.android.com/reference/java/time/Period.html#multipliedBy(int)}
 **/
Period.prototype.multipliedBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'multipliedBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#getYears()}
 **/
Period.prototype.getYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#hashCode()}
 **/
Period.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#get(java.time.temporal.TemporalUnit)}
 **/
Period.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isZero
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#isZero()}
 **/
Period.prototype.isZero = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isZero',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#withDays(int)}
 **/
Period.prototype.withDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#getChronology()}
 * @see {@link http://developer.android.com/reference/java/time/Period.html#getChronology()}
 **/
Period.prototype.getChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isNegative
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#isNegative()}
 **/
Period.prototype.isNegative = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNegative',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#withMonths(int)}
 **/
Period.prototype.withMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#minusYears(long)}
 **/
Period.prototype.minusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#plusMonths(long)}
 **/
Period.prototype.plusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#plusYears(long)}
 **/
Period.prototype.plusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/Period.html#plus(java.time.temporal.TemporalAmount)}
 **/
Period.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toTotalMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#toTotalMonths()}
 **/
Period.prototype.toTotalMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toTotalMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#minusDays(long)}
 **/
Period.prototype.minusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#minusMonths(long)}
 **/
Period.prototype.minusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#getDays()}
 **/
Period.prototype.getDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function subtractFrom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#subtractFrom(java.time.temporal.Temporal)}
 **/
Period.prototype.subtractFrom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'subtractFrom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#equals(java.lang.Object)}
 **/
Period.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUnits
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#getUnits()}
 **/
Period.prototype.getUnits = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnits',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#addTo(java.time.temporal.Temporal)}
 **/
Period.prototype.addTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#toString()}
 **/
Period.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Period.html#withYears(int)}
 **/
Period.prototype.withYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Period') {
			return new Period(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Period;
