/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.ZoneId
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.ZoneId
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html}
 **/
var ZoneId = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.ZoneId')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: java.time.ZoneId. Create a subclass using java.time.ZoneId.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ZoneId.prototype = Object.create(SuperClass.prototype);
ZoneId.prototype.constructor = ZoneId;

Object.defineProperty(ZoneId.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ZoneId(this.$native.super);
	},
	enumerable: true
});

ZoneId.className = 'java.time.ZoneId';
ZoneId.prototype.className = 'java.time.ZoneId';

// class property
Object.defineProperty(ZoneId, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.ZoneId');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ZoneId.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.time.ZoneId');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ZoneId.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ZoneId.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ZoneId(Hyperloop.cast('java.time.ZoneId', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/ZoneId.html#SHORT_IDS
Object.defineProperty(ZoneId, 'SHORT_IDS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SHORT_IDS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.ZoneId') {
				return new ZoneId(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function systemDefault
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#systemDefault()}
 **/
ZoneId.systemDefault = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'systemDefault',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofOffset
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#ofOffset(java.lang.String, java.time.ZoneOffset)}
 **/
ZoneId.ofOffset = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofOffset',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAvailableZoneIds
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#getAvailableZoneIds()}
 **/
ZoneId.getAvailableZoneIds = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAvailableZoneIds',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#of(java.lang.String, java.util.Map)}
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#of(java.lang.String)}
 **/
ZoneId.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#from(java.time.temporal.TemporalAccessor)}
 **/
ZoneId.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#getDisplayName(java.time.format.TextStyle, java.util.Locale)}
 **/
ZoneId.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function normalized
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#normalized()}
 **/
ZoneId.prototype.normalized = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'normalized',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#hashCode()}
 **/
ZoneId.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#equals(java.lang.Object)}
 **/
ZoneId.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#getId()}
 **/
ZoneId.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#toString()}
 **/
ZoneId.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRules
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneId.html#getRules()}
 **/
ZoneId.prototype.getRules = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRules',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneId') {
			return new ZoneId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ZoneId;
