/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.ZonedDateTime
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.ZonedDateTime
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html}
 **/
var ZonedDateTime = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.ZonedDateTime')) {
		result = arguments[0];
	}
	else {
		result = ZonedDateTime.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ZonedDateTime.prototype = Object.create(SuperClass.prototype);
ZonedDateTime.prototype.constructor = ZonedDateTime;

Object.defineProperty(ZonedDateTime.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ZonedDateTime(this.$native.super);
	},
	enumerable: true
});

ZonedDateTime.className = 'java.time.ZonedDateTime';
ZonedDateTime.prototype.className = 'java.time.ZonedDateTime';

// class property
Object.defineProperty(ZonedDateTime, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.ZonedDateTime');
	},
	enumerable: true,
	configurable: false
});


// Cast
ZonedDateTime.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ZonedDateTime(Hyperloop.cast('java.time.ZonedDateTime', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofLocal
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#ofLocal(java.time.LocalDateTime, java.time.ZoneId, java.time.ZoneOffset)}
 **/
ZonedDateTime.ofLocal = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofLocal',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofStrict
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#ofStrict(java.time.LocalDateTime, java.time.ZoneOffset, java.time.ZoneId)}
 **/
ZonedDateTime.ofStrict = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofStrict',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#from(java.time.temporal.TemporalAccessor)}
 **/
ZonedDateTime.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofInstant
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#ofInstant(java.time.Instant, java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#ofInstant(java.time.LocalDateTime, java.time.ZoneOffset, java.time.ZoneId)}
 **/
ZonedDateTime.ofInstant = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofInstant',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function now
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#now()}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#now(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#now(java.time.Clock)}
 **/
ZonedDateTime.now = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'now',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#of(java.time.LocalDate, java.time.LocalTime, java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#of(java.time.LocalDateTime, java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#of(int, int, int, int, int, int, int, java.time.ZoneId)}
 **/
ZonedDateTime.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parse
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#parse(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#parse(java.lang.CharSequence, java.time.format.DateTimeFormatter)}
 **/
ZonedDateTime.parse = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parse',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function plusHours
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusHours(long)}
 **/
ZonedDateTime.prototype.plusHours = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusHours',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocalTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toLocalTime()}
 **/
ZonedDateTime.prototype.toLocalTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfWeek
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getDayOfWeek()}
 **/
ZonedDateTime.prototype.getDayOfWeek = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfWeek',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getMinute()}
 **/
ZonedDateTime.prototype.getMinute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusSeconds(long)}
 **/
ZonedDateTime.prototype.plusSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getMonth()}
 **/
ZonedDateTime.prototype.getMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusNanos
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusNanos(long)}
 **/
ZonedDateTime.prototype.plusNanos = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusNanos',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withHour
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withHour(int)}
 **/
ZonedDateTime.prototype.withHour = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withHour',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusMonths(long)}
 **/
ZonedDateTime.prototype.plusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function truncatedTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#truncatedTo(java.time.temporal.TemporalUnit)}
 **/
ZonedDateTime.prototype.truncatedTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'truncatedTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusYears(long)}
 **/
ZonedDateTime.prototype.plusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#query(java.time.temporal.TemporalQuery)}
 **/
ZonedDateTime.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNano
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getNano()}
 **/
ZonedDateTime.prototype.getNano = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNano',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusNanos
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusNanos(long)}
 **/
ZonedDateTime.prototype.minusNanos = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusNanos',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#format(java.time.format.DateTimeFormatter)}
 **/
ZonedDateTime.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getZone()}
 **/
ZonedDateTime.prototype.getZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
ZonedDateTime.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plus(java.time.temporal.TemporalAmount)}
 **/
ZonedDateTime.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getYear()}
 **/
ZonedDateTime.prototype.getYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocalDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toLocalDateTime()}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toLocalDateTime()}
 **/
ZonedDateTime.prototype.toLocalDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDayOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withDayOfMonth(int)}
 **/
ZonedDateTime.prototype.withDayOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDayOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withMonth(int)}
 **/
ZonedDateTime.prototype.withMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toOffsetDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toOffsetDateTime()}
 **/
ZonedDateTime.prototype.toOffsetDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toOffsetDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minus(java.time.temporal.TemporalAmount)}
 **/
ZonedDateTime.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withFixedOffsetZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withFixedOffsetZone()}
 **/
ZonedDateTime.prototype.withFixedOffsetZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withFixedOffsetZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusHours
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusHours(long)}
 **/
ZonedDateTime.prototype.minusHours = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusHours',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getOffset()}
 **/
ZonedDateTime.prototype.getOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#range(java.time.temporal.TemporalField)}
 **/
ZonedDateTime.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withYear(int)}
 **/
ZonedDateTime.prototype.withYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMinutes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusMinutes(long)}
 **/
ZonedDateTime.prototype.plusMinutes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMinutes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusDays(long)}
 **/
ZonedDateTime.prototype.plusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMinutes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusMinutes(long)}
 **/
ZonedDateTime.prototype.minusMinutes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMinutes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withLaterOffsetAtOverlap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withLaterOffsetAtOverlap()}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withLaterOffsetAtOverlap()}
 **/
ZonedDateTime.prototype.withLaterOffsetAtOverlap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withLaterOffsetAtOverlap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#hashCode()}
 **/
ZonedDateTime.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#get(java.time.temporal.TemporalField)}
 **/
ZonedDateTime.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withEarlierOffsetAtOverlap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withEarlierOffsetAtOverlap()}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withEarlierOffsetAtOverlap()}
 **/
ZonedDateTime.prototype.withEarlierOffsetAtOverlap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withEarlierOffsetAtOverlap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withZoneSameLocal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withZoneSameLocal(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withZoneSameLocal(java.time.ZoneId)}
 **/
ZonedDateTime.prototype.withZoneSameLocal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZoneSameLocal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getDayOfYear()}
 **/
ZonedDateTime.prototype.getDayOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHour
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getHour()}
 **/
ZonedDateTime.prototype.getHour = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHour',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusWeeks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#plusWeeks(long)}
 **/
ZonedDateTime.prototype.plusWeeks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusWeeks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withMinute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withMinute(int)}
 **/
ZonedDateTime.prototype.withMinute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withMinute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonthValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getMonthValue()}
 **/
ZonedDateTime.prototype.getMonthValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonthValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusYears(long)}
 **/
ZonedDateTime.prototype.minusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withZoneSameInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withZoneSameInstant(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withZoneSameInstant(java.time.ZoneId)}
 **/
ZonedDateTime.prototype.withZoneSameInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZoneSameInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusWeeks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusWeeks(long)}
 **/
ZonedDateTime.prototype.minusWeeks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusWeeks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDayOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withDayOfYear(int)}
 **/
ZonedDateTime.prototype.withDayOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDayOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusDays(long)}
 **/
ZonedDateTime.prototype.minusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getLong(java.time.temporal.TemporalField)}
 **/
ZonedDateTime.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withNano
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withNano(int)}
 **/
ZonedDateTime.prototype.withNano = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withNano',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 **/
ZonedDateTime.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusMonths(long)}
 **/
ZonedDateTime.prototype.minusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toLocalDate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toLocalDate()}
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toLocalDate()}
 **/
ZonedDateTime.prototype.toLocalDate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalDate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#equals(java.lang.Object)}
 **/
ZonedDateTime.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getSecond()}
 **/
ZonedDateTime.prototype.getSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 **/
ZonedDateTime.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#toString()}
 **/
ZonedDateTime.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#getDayOfMonth()}
 **/
ZonedDateTime.prototype.getDayOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#minusSeconds(long)}
 **/
ZonedDateTime.prototype.minusSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZonedDateTime.html#withSecond(int)}
 **/
ZonedDateTime.prototype.withSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZonedDateTime') {
			return new ZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ZonedDateTime;
