/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ChronoPeriod
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.chrono');

/**
 * constructor
 * http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html
 **/
var ChronoPeriod = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.chrono.ChronoPeriod') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.chrono.ChronoPeriod');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ChronoPeriod.prototype = Object.create(SuperClass.prototype);
ChronoPeriod.prototype.constructor = ChronoPeriod;

Object.defineProperty(ChronoPeriod.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ChronoPeriod(this.$native.super);
	},
	enumerable: true
});

ChronoPeriod.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ChronoPeriod.className = "java.time.chrono.ChronoPeriod";
ChronoPeriod.prototype.className = "java.time.chrono.ChronoPeriod";

// class property
Object.defineProperty(ChronoPeriod, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.chrono.ChronoPeriod');
	},
	enumerable: true,
	configurable: false
});

// Cast
ChronoPeriod.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ChronoPeriod(Hyperloop.cast('java.time.chrono.ChronoPeriod', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function between
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#between(java.time.chrono.ChronoLocalDate, java.time.chrono.ChronoLocalDate)}
 **/
ChronoPeriod.between = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'between',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function isNegative
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#isNegative()}
 **/
ChronoPeriod.prototype.isNegative = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNegative',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#minus(java.time.temporal.TemporalAmount)}
 **/
ChronoPeriod.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function negated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#negated()}
 **/
ChronoPeriod.prototype.negated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'negated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function normalized
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#normalized()}
 **/
ChronoPeriod.prototype.normalized = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'normalized',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#plus(java.time.temporal.TemporalAmount)}
 **/
ChronoPeriod.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function multipliedBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#multipliedBy(int)}
 **/
ChronoPeriod.prototype.multipliedBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'multipliedBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function subtractFrom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#subtractFrom(java.time.temporal.Temporal)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#subtractFrom(java.time.temporal.Temporal)}
 **/
ChronoPeriod.prototype.subtractFrom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'subtractFrom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#hashCode()}
 **/
ChronoPeriod.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#get(java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#get(java.time.temporal.TemporalUnit)}
 **/
ChronoPeriod.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#equals(java.lang.Object)}
 **/
ChronoPeriod.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getUnits
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#getUnits()}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#getUnits()}
 **/
ChronoPeriod.prototype.getUnits = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnits',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isZero
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#isZero()}
 **/
ChronoPeriod.prototype.isZero = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isZero',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function addTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#addTo(java.time.temporal.Temporal)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#addTo(java.time.temporal.Temporal)}
 **/
ChronoPeriod.prototype.addTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#toString()}
 **/
ChronoPeriod.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoPeriod.html#getChronology()}
 **/
ChronoPeriod.prototype.getChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoPeriod') {
			return new ChronoPeriod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ChronoPeriod.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ChronoPeriod.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ChronoPeriod;
