/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ChronoZonedDateTime
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.chrono');

/**
 * constructor
 * http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html
 **/
var ChronoZonedDateTime = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.chrono.ChronoZonedDateTime') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.chrono.ChronoZonedDateTime');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ChronoZonedDateTime.prototype = Object.create(SuperClass.prototype);
ChronoZonedDateTime.prototype.constructor = ChronoZonedDateTime;

Object.defineProperty(ChronoZonedDateTime.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ChronoZonedDateTime(this.$native.super);
	},
	enumerable: true
});

ChronoZonedDateTime.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ChronoZonedDateTime.className = "java.time.chrono.ChronoZonedDateTime";
ChronoZonedDateTime.prototype.className = "java.time.chrono.ChronoZonedDateTime";

// class property
Object.defineProperty(ChronoZonedDateTime, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.chrono.ChronoZonedDateTime');
	},
	enumerable: true,
	configurable: false
});

// Cast
ChronoZonedDateTime.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ChronoZonedDateTime(Hyperloop.cast('java.time.chrono.ChronoZonedDateTime', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#from(java.time.temporal.TemporalAccessor)}
 **/
ChronoZonedDateTime.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function timeLineOrder
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#timeLineOrder()}
 **/
ChronoZonedDateTime.timeLineOrder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'timeLineOrder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#minus(long, java.time.temporal.TemporalUnit)}
 **/
ChronoZonedDateTime.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#getOffset()}
 **/
ChronoZonedDateTime.prototype.getOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isEqual
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isEqual(java.time.chrono.ChronoZonedDateTime)}
 **/
ChronoZonedDateTime.prototype.isEqual = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEqual',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toLocalTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#toLocalTime()}
 **/
ChronoZonedDateTime.prototype.toLocalTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#range(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#range(java.time.temporal.TemporalField)}
 **/
ChronoZonedDateTime.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#compareTo(java.time.chrono.ChronoZonedDateTime)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#compareTo(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#compareTo(java.lang.Object)}
 **/
ChronoZonedDateTime.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function withLaterOffsetAtOverlap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#withLaterOffsetAtOverlap()}
 **/
ChronoZonedDateTime.prototype.withLaterOffsetAtOverlap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withLaterOffsetAtOverlap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#hashCode()}
 **/
ChronoZonedDateTime.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#get(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#get(java.time.temporal.TemporalField)}
 **/
ChronoZonedDateTime.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function withEarlierOffsetAtOverlap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#withEarlierOffsetAtOverlap()}
 **/
ChronoZonedDateTime.prototype.withEarlierOffsetAtOverlap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withEarlierOffsetAtOverlap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function withZoneSameLocal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#withZoneSameLocal(java.time.ZoneId)}
 **/
ChronoZonedDateTime.prototype.withZoneSameLocal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZoneSameLocal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#getChronology()}
 **/
ChronoZonedDateTime.prototype.getChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function withZoneSameInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#withZoneSameInstant(java.time.ZoneId)}
 **/
ChronoZonedDateTime.prototype.withZoneSameInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZoneSameInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#query(java.time.temporal.TemporalQuery)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#query(java.time.temporal.TemporalQuery)}
 **/
ChronoZonedDateTime.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#format(java.time.format.DateTimeFormatter)}
 **/
ChronoZonedDateTime.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#getZone()}
 **/
ChronoZonedDateTime.prototype.getZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isSupported(java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
ChronoZonedDateTime.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#toInstant()}
 **/
ChronoZonedDateTime.prototype.toInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#plus(long, java.time.temporal.TemporalUnit)}
 **/
ChronoZonedDateTime.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isBefore(java.time.chrono.ChronoZonedDateTime)}
 **/
ChronoZonedDateTime.prototype.isBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#getLong(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#getLong(java.time.temporal.TemporalField)}
 **/
ChronoZonedDateTime.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#with(java.time.temporal.TemporalField, long)}
 **/
ChronoZonedDateTime.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toLocalDate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#toLocalDate()}
 **/
ChronoZonedDateTime.prototype.toLocalDate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalDate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toEpochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#toEpochSecond()}
 **/
ChronoZonedDateTime.prototype.toEpochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toLocalDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#toLocalDateTime()}
 **/
ChronoZonedDateTime.prototype.toLocalDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toLocalDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#equals(java.lang.Object)}
 **/
ChronoZonedDateTime.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#toString()}
 **/
ChronoZonedDateTime.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 **/
ChronoZonedDateTime.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoZonedDateTime.html#isAfter(java.time.chrono.ChronoZonedDateTime)}
 **/
ChronoZonedDateTime.prototype.isAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoZonedDateTime') {
			return new ChronoZonedDateTime(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ChronoZonedDateTime.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ChronoZonedDateTime.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ChronoZonedDateTime;
