/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Chronology
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.chrono');

/**
 * constructor
 * http://developer.android.com/reference/java/time/chrono/Chronology.html
 **/
var Chronology = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.chrono.Chronology') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.chrono.Chronology');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Chronology.prototype = Object.create(SuperClass.prototype);
Chronology.prototype.constructor = Chronology;

Object.defineProperty(Chronology.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Chronology(this.$native.super);
	},
	enumerable: true
});

Chronology.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Chronology.className = "java.time.chrono.Chronology";
Chronology.prototype.className = "java.time.chrono.Chronology";

// class property
Object.defineProperty(Chronology, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.chrono.Chronology');
	},
	enumerable: true,
	configurable: false
});

// Cast
Chronology.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Chronology(Hyperloop.cast('java.time.chrono.Chronology', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofLocale
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#ofLocale(java.util.Locale)}
 **/
Chronology.ofLocale = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofLocale',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#of(java.lang.String)}
 **/
Chronology.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#from(java.time.temporal.TemporalAccessor)}
 **/
Chronology.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAvailableChronologies
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#getAvailableChronologies()}
 **/
Chronology.getAvailableChronologies = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAvailableChronologies',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function date
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#date(java.time.chrono.Era, int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#date(int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#date(java.time.temporal.TemporalAccessor)}
 **/
Chronology.prototype.date = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'date',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function localDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#localDateTime(java.time.temporal.TemporalAccessor)}
 **/
Chronology.prototype.localDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'localDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#range(java.time.temporal.ChronoField)}
 **/
Chronology.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#getId()}
 **/
Chronology.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#compareTo(java.time.chrono.Chronology)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#compareTo(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#compareTo(java.lang.Object)}
 **/
Chronology.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function dateNow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#dateNow()}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#dateNow(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#dateNow(java.time.Clock)}
 **/
Chronology.prototype.dateNow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dateNow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function eraOf
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#eraOf(int)}
 **/
Chronology.prototype.eraOf = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'eraOf',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function prolepticYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#prolepticYear(java.time.chrono.Era, int)}
 **/
Chronology.prototype.prolepticYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prolepticYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function zonedDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#zonedDateTime(java.time.temporal.TemporalAccessor)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#zonedDateTime(java.time.Instant, java.time.ZoneId)}
 **/
Chronology.prototype.zonedDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zonedDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#hashCode()}
 **/
Chronology.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function epochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#epochSecond(int, int, int, int, int, int, java.time.ZoneOffset)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#epochSecond(java.time.chrono.Era, int, int, int, int, int, int, java.time.ZoneOffset)}
 **/
Chronology.prototype.epochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'epochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function period
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#period(int, int, int)}
 **/
Chronology.prototype.period = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'period',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getCalendarType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#getCalendarType()}
 **/
Chronology.prototype.getCalendarType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCalendarType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function dateYearDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#dateYearDay(java.time.chrono.Era, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#dateYearDay(int, int)}
 **/
Chronology.prototype.dateYearDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dateYearDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function resolveDate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#resolveDate(java.util.Map, java.time.format.ResolverStyle)}
 **/
Chronology.prototype.resolveDate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resolveDate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isLeapYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#isLeapYear(long)}
 **/
Chronology.prototype.isLeapYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLeapYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function dateEpochDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#dateEpochDay(long)}
 **/
Chronology.prototype.dateEpochDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dateEpochDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function eras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#eras()}
 **/
Chronology.prototype.eras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'eras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#getDisplayName(java.time.format.TextStyle, java.util.Locale)}
 **/
Chronology.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#equals(java.lang.Object)}
 **/
Chronology.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Chronology.html#toString()}
 **/
Chronology.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Chronology') {
			return new Chronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Chronology.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Chronology.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Chronology;
