/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.chrono.IsoChronology
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.chrono');

/**
 * @class java.time.chrono.IsoChronology
 * @extends java.time.chrono.AbstractChronology 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html}
 **/
var IsoChronology = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.chrono.IsoChronology')) {
		result = arguments[0];
	}
	else {
		result = IsoChronology.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.time.chrono.AbstractChronology');
IsoChronology.prototype = Object.create(SuperClass.prototype);
IsoChronology.prototype.constructor = IsoChronology;

Object.defineProperty(IsoChronology.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new IsoChronology(this.$native.super);
	},
	enumerable: true
});

IsoChronology.className = 'java.time.chrono.IsoChronology';
IsoChronology.prototype.className = 'java.time.chrono.IsoChronology';

// class property
Object.defineProperty(IsoChronology, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.chrono.IsoChronology');
	},
	enumerable: true,
	configurable: false
});


// Cast
IsoChronology.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new IsoChronology(Hyperloop.cast('java.time.chrono.IsoChronology', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/chrono/IsoChronology.html#INSTANCE
Object.defineProperty(IsoChronology, 'INSTANCE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('INSTANCE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.chrono.IsoChronology') {
				return new IsoChronology(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function date
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#date(java.time.chrono.Era, int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#date(int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#date(java.time.temporal.TemporalAccessor)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#date(java.time.temporal.TemporalAccessor)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#date(int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#date(java.time.chrono.Era, int, int, int)}
 **/
IsoChronology.prototype.date = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'date',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function localDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#localDateTime(java.time.temporal.TemporalAccessor)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#localDateTime(java.time.temporal.TemporalAccessor)}
 **/
IsoChronology.prototype.localDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'localDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function period
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#period(int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#period(int, int, int)}
 **/
IsoChronology.prototype.period = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'period',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCalendarType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#getCalendarType()}
 **/
IsoChronology.prototype.getCalendarType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCalendarType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dateYearDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateYearDay(java.time.chrono.Era, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateYearDay(int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateYearDay(int, int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateYearDay(java.time.chrono.Era, int, int)}
 **/
IsoChronology.prototype.dateYearDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dateYearDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function resolveDate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#resolveDate(java.util.Map, java.time.format.ResolverStyle)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#resolveDate(java.util.Map, java.time.format.ResolverStyle)}
 **/
IsoChronology.prototype.resolveDate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resolveDate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isLeapYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#isLeapYear(long)}
 **/
IsoChronology.prototype.isLeapYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLeapYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#range(java.time.temporal.ChronoField)}
 **/
IsoChronology.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#getId()}
 **/
IsoChronology.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dateEpochDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateEpochDay(long)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateEpochDay(long)}
 **/
IsoChronology.prototype.dateEpochDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dateEpochDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dateNow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateNow()}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateNow(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateNow(java.time.Clock)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateNow(java.time.Clock)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateNow(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#dateNow()}
 **/
IsoChronology.prototype.dateNow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dateNow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function eraOf
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#eraOf(int)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#eraOf(int)}
 **/
IsoChronology.prototype.eraOf = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'eraOf',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function eras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#eras()}
 **/
IsoChronology.prototype.eras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'eras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function prolepticYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#prolepticYear(java.time.chrono.Era, int)}
 **/
IsoChronology.prototype.prolepticYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'prolepticYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zonedDateTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#zonedDateTime(java.time.temporal.TemporalAccessor)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#zonedDateTime(java.time.Instant, java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#zonedDateTime(java.time.Instant, java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#zonedDateTime(java.time.temporal.TemporalAccessor)}
 **/
IsoChronology.prototype.zonedDateTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zonedDateTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function epochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/IsoChronology.html#epochSecond(int, int, int, int, int, int, java.time.ZoneOffset)}
 **/
IsoChronology.prototype.epochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'epochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.IsoChronology') {
			return new IsoChronology(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = IsoChronology;
