/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.format.ResolverStyle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.format');

/**
 * @class java.time.format.ResolverStyle
 * @extends java.lang.Enum 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/format/ResolverStyle.html}
 **/
var ResolverStyle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.format.ResolverStyle')) {
		result = arguments[0];
	}
	else {
		result = ResolverStyle.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Enum');
ResolverStyle.prototype = Object.create(SuperClass.prototype);
ResolverStyle.prototype.constructor = ResolverStyle;

Object.defineProperty(ResolverStyle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ResolverStyle(this.$native.super);
	},
	enumerable: true
});

ResolverStyle.className = 'java.time.format.ResolverStyle';
ResolverStyle.prototype.className = 'java.time.format.ResolverStyle';

// class property
Object.defineProperty(ResolverStyle, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.format.ResolverStyle');
	},
	enumerable: true,
	configurable: false
});


// Cast
ResolverStyle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ResolverStyle(Hyperloop.cast('java.time.format.ResolverStyle', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/format/ResolverStyle.html#STRICT
Object.defineProperty(ResolverStyle, 'STRICT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('STRICT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.ResolverStyle') {
				return new ResolverStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/ResolverStyle.html#LENIENT
Object.defineProperty(ResolverStyle, 'LENIENT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('LENIENT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.ResolverStyle') {
				return new ResolverStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/ResolverStyle.html#SMART
Object.defineProperty(ResolverStyle, 'SMART', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SMART');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.ResolverStyle') {
				return new ResolverStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/ResolverStyle.html#valueOf(java.lang.String)}
 **/
ResolverStyle.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.ResolverStyle') {
			return new ResolverStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/ResolverStyle.html#values()}
 **/
ResolverStyle.values = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'values',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.ResolverStyle') {
			return new ResolverStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = ResolverStyle;
