/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Temporal
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.temporal');

/**
 * constructor
 * http://developer.android.com/reference/java/time/temporal/Temporal.html
 **/
var Temporal = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.temporal.Temporal') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.temporal.Temporal');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Temporal.prototype = Object.create(SuperClass.prototype);
Temporal.prototype.constructor = Temporal;

Object.defineProperty(Temporal.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Temporal(this.$native.super);
	},
	enumerable: true
});

Temporal.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Temporal.className = "java.time.temporal.Temporal";
Temporal.prototype.className = "java.time.temporal.Temporal";

// class property
Object.defineProperty(Temporal, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.temporal.Temporal');
	},
	enumerable: true,
	configurable: false
});

// Cast
Temporal.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Temporal(Hyperloop.cast('java.time.temporal.Temporal', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#with(java.time.temporal.TemporalField, long)}
 **/
Temporal.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.Temporal') {
			return new Temporal(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#minus(long, java.time.temporal.TemporalUnit)}
 **/
Temporal.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.Temporal') {
			return new Temporal(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 **/
Temporal.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.Temporal') {
			return new Temporal(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
Temporal.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.Temporal') {
			return new Temporal(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/temporal/Temporal.html#plus(long, java.time.temporal.TemporalUnit)}
 **/
Temporal.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.Temporal') {
			return new Temporal(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Temporal.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Temporal.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Temporal;
