/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.temporal.ValueRange
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.temporal');

/**
 * @class java.time.temporal.ValueRange
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html}
 **/
var ValueRange = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.temporal.ValueRange')) {
		result = arguments[0];
	}
	else {
		result = ValueRange.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ValueRange.prototype = Object.create(SuperClass.prototype);
ValueRange.prototype.constructor = ValueRange;

Object.defineProperty(ValueRange.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ValueRange(this.$native.super);
	},
	enumerable: true
});

ValueRange.className = 'java.time.temporal.ValueRange';
ValueRange.prototype.className = 'java.time.temporal.ValueRange';

// class property
Object.defineProperty(ValueRange, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.temporal.ValueRange');
	},
	enumerable: true,
	configurable: false
});


// Cast
ValueRange.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ValueRange(Hyperloop.cast('java.time.temporal.ValueRange', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#of(long, long)}
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#of(long, long, long)}
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#of(long, long, long, long)}
 **/
ValueRange.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getMaximum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#getMaximum()}
 **/
ValueRange.prototype.getMaximum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaximum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSmallestMaximum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#getSmallestMaximum()}
 **/
ValueRange.prototype.getSmallestMaximum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSmallestMaximum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#isIntValue()}
 **/
ValueRange.prototype.isIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLargestMinimum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#getLargestMinimum()}
 **/
ValueRange.prototype.getLargestMinimum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLargestMinimum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isValidValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#isValidValue(long)}
 **/
ValueRange.prototype.isValidValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isValidValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#hashCode()}
 **/
ValueRange.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#equals(java.lang.Object)}
 **/
ValueRange.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinimum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#getMinimum()}
 **/
ValueRange.prototype.getMinimum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinimum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkValidValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#checkValidValue(long, java.time.temporal.TemporalField)}
 **/
ValueRange.prototype.checkValidValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkValidValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkValidIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#checkValidIntValue(long, java.time.temporal.TemporalField)}
 **/
ValueRange.prototype.checkValidIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkValidIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#toString()}
 **/
ValueRange.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFixed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#isFixed()}
 **/
ValueRange.prototype.isFixed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFixed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isValidIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ValueRange.html#isValidIntValue(long)}
 **/
ValueRange.prototype.isValidIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isValidIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ValueRange') {
			return new ValueRange(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ValueRange;
