/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.zone.ZoneOffsetTransition
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.zone');

/**
 * @class java.time.zone.ZoneOffsetTransition
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html}
 **/
var ZoneOffsetTransition = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.zone.ZoneOffsetTransition')) {
		result = arguments[0];
	}
	else {
		result = ZoneOffsetTransition.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ZoneOffsetTransition.prototype = Object.create(SuperClass.prototype);
ZoneOffsetTransition.prototype.constructor = ZoneOffsetTransition;

Object.defineProperty(ZoneOffsetTransition.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ZoneOffsetTransition(this.$native.super);
	},
	enumerable: true
});

ZoneOffsetTransition.className = 'java.time.zone.ZoneOffsetTransition';
ZoneOffsetTransition.prototype.className = 'java.time.zone.ZoneOffsetTransition';

// class property
Object.defineProperty(ZoneOffsetTransition, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.zone.ZoneOffsetTransition');
	},
	enumerable: true,
	configurable: false
});


// Cast
ZoneOffsetTransition.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ZoneOffsetTransition(Hyperloop.cast('java.time.zone.ZoneOffsetTransition', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#of(java.time.LocalDateTime, java.time.ZoneOffset, java.time.ZoneOffset)}
 **/
ZoneOffsetTransition.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getDateTimeAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#getDateTimeAfter()}
 **/
ZoneOffsetTransition.prototype.getDateTimeAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDateTimeAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDateTimeBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#getDateTimeBefore()}
 **/
ZoneOffsetTransition.prototype.getDateTimeBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDateTimeBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffsetBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#getOffsetBefore()}
 **/
ZoneOffsetTransition.prototype.getOffsetBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOffsetBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffsetAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#getOffsetAfter()}
 **/
ZoneOffsetTransition.prototype.getOffsetAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOffsetAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#compareTo(java.time.zone.ZoneOffsetTransition)}
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#compareTo(java.lang.Object)}
 **/
ZoneOffsetTransition.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInstant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#getInstant()}
 **/
ZoneOffsetTransition.prototype.getInstant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInstant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isGap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#isGap()}
 **/
ZoneOffsetTransition.prototype.isGap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isGap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#getDuration()}
 **/
ZoneOffsetTransition.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toEpochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#toEpochSecond()}
 **/
ZoneOffsetTransition.prototype.toEpochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#hashCode()}
 **/
ZoneOffsetTransition.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#equals(java.lang.Object)}
 **/
ZoneOffsetTransition.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOverlap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#isOverlap()}
 **/
ZoneOffsetTransition.prototype.isOverlap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOverlap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#toString()}
 **/
ZoneOffsetTransition.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isValidOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneOffsetTransition.html#isValidOffset(java.time.ZoneOffset)}
 **/
ZoneOffsetTransition.prototype.isValidOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isValidOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneOffsetTransition') {
			return new ZoneOffsetTransition(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ZoneOffsetTransition;
