/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Comparator
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util');

/**
 * constructor
 * http://developer.android.com/reference/java/util/Comparator.html
 **/
var Comparator = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.Comparator') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.Comparator');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Comparator.prototype = Object.create(SuperClass.prototype);
Comparator.prototype.constructor = Comparator;

Object.defineProperty(Comparator.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Comparator(this.$native.super);
	},
	enumerable: true
});

Comparator.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Comparator.className = "java.util.Comparator";
Comparator.prototype.className = "java.util.Comparator";

// class property
Object.defineProperty(Comparator, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.Comparator');
	},
	enumerable: true,
	configurable: false
});

// Cast
Comparator.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Comparator(Hyperloop.cast('java.util.Comparator', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function comparingDouble
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#comparingDouble(java.util.function.ToDoubleFunction)}
 **/
Comparator.comparingDouble = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'comparingDouble',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function naturalOrder
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#naturalOrder()}
 **/
Comparator.naturalOrder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'naturalOrder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function comparingLong
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#comparingLong(java.util.function.ToLongFunction)}
 **/
Comparator.comparingLong = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'comparingLong',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reverseOrder
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#reverseOrder()}
 **/
Comparator.reverseOrder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'reverseOrder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function comparing
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#comparing(java.util.function.Function, java.util.Comparator)}
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#comparing(java.util.function.Function)}
 **/
Comparator.comparing = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'comparing',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nullsLast
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#nullsLast(java.util.Comparator)}
 **/
Comparator.nullsLast = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'nullsLast',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function comparingInt
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#comparingInt(java.util.function.ToIntFunction)}
 **/
Comparator.comparingInt = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'comparingInt',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nullsFirst
 * @static
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#nullsFirst(java.util.Comparator)}
 **/
Comparator.nullsFirst = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'nullsFirst',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function compare
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#compare(java.lang.Object, java.lang.Object)}
 **/
Comparator.prototype.compare = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compare',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function thenComparingInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#thenComparingInt(java.util.function.ToIntFunction)}
 **/
Comparator.prototype.thenComparingInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'thenComparingInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function thenComparingDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#thenComparingDouble(java.util.function.ToDoubleFunction)}
 **/
Comparator.prototype.thenComparingDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'thenComparingDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function thenComparingLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#thenComparingLong(java.util.function.ToLongFunction)}
 **/
Comparator.prototype.thenComparingLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'thenComparingLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function thenComparing
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#thenComparing(java.util.Comparator)}
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#thenComparing(java.util.function.Function, java.util.Comparator)}
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#thenComparing(java.util.function.Function)}
 **/
Comparator.prototype.thenComparing = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'thenComparing',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#equals(java.lang.Object)}
 **/
Comparator.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function reversed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/Comparator.html#reversed()}
 **/
Comparator.prototype.reversed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reversed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.Comparator') {
			return new Comparator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Comparator.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Comparator.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Comparator;
