/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.concurrent.atomic.AtomicInteger
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.concurrent.atomic');

/**
 * @class java.util.concurrent.atomic.AtomicInteger
 * @extends java.lang.Number 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html}
 **/
var AtomicInteger = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.concurrent.atomic.AtomicInteger')) {
		result = arguments[0];
	}
	else {
		result = AtomicInteger.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Number');
AtomicInteger.prototype = Object.create(SuperClass.prototype);
AtomicInteger.prototype.constructor = AtomicInteger;

Object.defineProperty(AtomicInteger.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AtomicInteger(this.$native.super);
	},
	enumerable: true
});

AtomicInteger.className = 'java.util.concurrent.atomic.AtomicInteger';
AtomicInteger.prototype.className = 'java.util.concurrent.atomic.AtomicInteger';

// class property
Object.defineProperty(AtomicInteger, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.concurrent.atomic.AtomicInteger');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AtomicInteger.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.util.concurrent.atomic.AtomicInteger');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AtomicInteger.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AtomicInteger.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AtomicInteger(Hyperloop.cast('java.util.concurrent.atomic.AtomicInteger', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setPlain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#setPlain(int)}
 **/
AtomicInteger.prototype.setPlain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPlain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndIncrement
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAndIncrement()}
 **/
AtomicInteger.prototype.getAndIncrement = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndIncrement',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetPlain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#weakCompareAndSetPlain(int, int)}
 **/
AtomicInteger.prototype.weakCompareAndSetPlain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetPlain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function incrementAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#incrementAndGet()}
 **/
AtomicInteger.prototype.incrementAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'incrementAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndExchange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#compareAndExchange(int, int)}
 **/
AtomicInteger.prototype.compareAndExchange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndExchange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAcquire
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAcquire()}
 **/
AtomicInteger.prototype.getAcquire = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAcquire',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function decrementAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#decrementAndGet()}
 **/
AtomicInteger.prototype.decrementAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'decrementAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#updateAndGet(java.util.function.IntUnaryOperator)}
 **/
AtomicInteger.prototype.updateAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function longValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#longValue()}
 **/
AtomicInteger.prototype.longValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'longValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOpaque
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getOpaque()}
 **/
AtomicInteger.prototype.getOpaque = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOpaque',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#get()}
 **/
AtomicInteger.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lazySet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#lazySet(int)}
 **/
AtomicInteger.prototype.lazySet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lazySet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndAdd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAndAdd(int)}
 **/
AtomicInteger.prototype.getAndAdd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndAdd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndSet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAndSet(int)}
 **/
AtomicInteger.prototype.getAndSet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndSet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetAcquire
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#weakCompareAndSetAcquire(int, int)}
 **/
AtomicInteger.prototype.weakCompareAndSetAcquire = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetAcquire',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndAccumulate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAndAccumulate(int, java.util.function.IntBinaryOperator)}
 **/
AtomicInteger.prototype.getAndAccumulate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndAccumulate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function accumulateAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#accumulateAndGet(int, java.util.function.IntBinaryOperator)}
 **/
AtomicInteger.prototype.accumulateAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'accumulateAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetVolatile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#weakCompareAndSetVolatile(int, int)}
 **/
AtomicInteger.prototype.weakCompareAndSetVolatile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetVolatile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function set
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#set(int)}
 **/
AtomicInteger.prototype.set = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'set',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetRelease
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#weakCompareAndSetRelease(int, int)}
 **/
AtomicInteger.prototype.weakCompareAndSetRelease = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetRelease',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#weakCompareAndSet(int, int)}
 **/
AtomicInteger.prototype.weakCompareAndSet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function intValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#intValue()}
 **/
AtomicInteger.prototype.intValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'intValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function floatValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#floatValue()}
 **/
AtomicInteger.prototype.floatValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'floatValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doubleValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#doubleValue()}
 **/
AtomicInteger.prototype.doubleValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'doubleValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOpaque
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#setOpaque(int)}
 **/
AtomicInteger.prototype.setOpaque = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOpaque',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPlain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getPlain()}
 **/
AtomicInteger.prototype.getPlain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPlain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndExchangeRelease
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#compareAndExchangeRelease(int, int)}
 **/
AtomicInteger.prototype.compareAndExchangeRelease = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndExchangeRelease',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndSet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#compareAndSet(int, int)}
 **/
AtomicInteger.prototype.compareAndSet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndSet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndExchangeAcquire
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#compareAndExchangeAcquire(int, int)}
 **/
AtomicInteger.prototype.compareAndExchangeAcquire = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndExchangeAcquire',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#addAndGet(int)}
 **/
AtomicInteger.prototype.addAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#toString()}
 **/
AtomicInteger.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRelease
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#setRelease(int)}
 **/
AtomicInteger.prototype.setRelease = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRelease',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndUpdate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAndUpdate(java.util.function.IntUnaryOperator)}
 **/
AtomicInteger.prototype.getAndUpdate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndUpdate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndDecrement
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicInteger.html#getAndDecrement()}
 **/
AtomicInteger.prototype.getAndDecrement = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndDecrement',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicInteger') {
			return new AtomicInteger(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AtomicInteger;
