/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.regex.Matcher
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.regex');

/**
 * @class java.util.regex.Matcher
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html}
 **/
var Matcher = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.regex.Matcher')) {
		result = arguments[0];
	}
	else {
		result = Matcher.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Matcher.prototype = Object.create(SuperClass.prototype);
Matcher.prototype.constructor = Matcher;

Object.defineProperty(Matcher.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Matcher(this.$native.super);
	},
	enumerable: true
});

Matcher.className = 'java.util.regex.Matcher';
Matcher.prototype.className = 'java.util.regex.Matcher';

// class property
Object.defineProperty(Matcher, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.regex.Matcher');
	},
	enumerable: true,
	configurable: false
});


// Cast
Matcher.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Matcher(Hyperloop.cast('java.util.regex.Matcher', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function quoteReplacement
 * @static
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#quoteReplacement(java.lang.String)}
 **/
Matcher.quoteReplacement = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'quoteReplacement',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function hasTransparentBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#hasTransparentBounds()}
 **/
Matcher.prototype.hasTransparentBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasTransparentBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requireEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#requireEnd()}
 **/
Matcher.prototype.requireEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requireEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function useTransparentBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#useTransparentBounds(boolean)}
 **/
Matcher.prototype.useTransparentBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'useTransparentBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pattern
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#pattern()}
 **/
Matcher.prototype.pattern = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pattern',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function replaceFirst
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#replaceFirst(java.lang.String)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#replaceFirst(java.util.function.Function)}
 **/
Matcher.prototype.replaceFirst = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'replaceFirst',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function regionStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#regionStart()}
 **/
Matcher.prototype.regionStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'regionStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function replaceAll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#replaceAll(java.lang.String)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#replaceAll(java.util.function.Function)}
 **/
Matcher.prototype.replaceAll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'replaceAll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lookingAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#lookingAt()}
 **/
Matcher.prototype.lookingAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lookingAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toMatchResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#toMatchResult()}
 **/
Matcher.prototype.toMatchResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toMatchResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function find
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#find()}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#find(int)}
 **/
Matcher.prototype.find = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'find',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function end
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#end()}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#end(int)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#end(java.lang.String)}
 **/
Matcher.prototype.end = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'end',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function results
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#results()}
 **/
Matcher.prototype.results = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'results',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function group
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#group()}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#group(int)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#group(java.lang.String)}
 **/
Matcher.prototype.group = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'group',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function start
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#start()}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#start(int)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#start(java.lang.String)}
 **/
Matcher.prototype.start = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'start',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function regionEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#regionEnd()}
 **/
Matcher.prototype.regionEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'regionEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function matches
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#matches()}
 **/
Matcher.prototype.matches = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'matches',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasAnchoringBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#hasAnchoringBounds()}
 **/
Matcher.prototype.hasAnchoringBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasAnchoringBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function appendReplacement
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#appendReplacement(java.lang.StringBuffer, java.lang.String)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#appendReplacement(java.lang.StringBuilder, java.lang.String)}
 **/
Matcher.prototype.appendReplacement = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'appendReplacement',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function appendTail
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#appendTail(java.lang.StringBuffer)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#appendTail(java.lang.StringBuilder)}
 **/
Matcher.prototype.appendTail = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'appendTail',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function groupCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#groupCount()}
 **/
Matcher.prototype.groupCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'groupCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#reset()}
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#reset(java.lang.CharSequence)}
 **/
Matcher.prototype.reset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#toString()}
 **/
Matcher.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function region
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#region(int, int)}
 **/
Matcher.prototype.region = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'region',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function useAnchoringBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#useAnchoringBounds(boolean)}
 **/
Matcher.prototype.useAnchoringBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'useAnchoringBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hitEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#hitEnd()}
 **/
Matcher.prototype.hitEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hitEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function usePattern
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Matcher.html#usePattern(java.util.regex.Pattern)}
 **/
Matcher.prototype.usePattern = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'usePattern',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Matcher') {
			return new Matcher(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Matcher;
