/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.regex.Pattern
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.regex');

/**
 * @class java.util.regex.Pattern
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html}
 **/
var Pattern = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.regex.Pattern')) {
		result = arguments[0];
	}
	else {
		result = Pattern.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Pattern.prototype = Object.create(SuperClass.prototype);
Pattern.prototype.constructor = Pattern;

Object.defineProperty(Pattern.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Pattern(this.$native.super);
	},
	enumerable: true
});

Pattern.className = 'java.util.regex.Pattern';
Pattern.prototype.className = 'java.util.regex.Pattern';

// class property
Object.defineProperty(Pattern, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.regex.Pattern');
	},
	enumerable: true,
	configurable: false
});


// Cast
Pattern.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Pattern(Hyperloop.cast('java.util.regex.Pattern', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#DOTALL}
 */
Pattern.DOTALL = 32;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#UNICODE_CASE}
 */
Pattern.UNICODE_CASE = 64;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#LITERAL}
 */
Pattern.LITERAL = 16;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#UNICODE_CHARACTER_CLASS}
 */
Pattern.UNICODE_CHARACTER_CLASS = 256;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#CASE_INSENSITIVE}
 */
Pattern.CASE_INSENSITIVE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#CANON_EQ}
 */
Pattern.CANON_EQ = 128;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#COMMENTS}
 */
Pattern.COMMENTS = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#UNIX_LINES}
 */
Pattern.UNIX_LINES = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#MULTILINE}
 */
Pattern.MULTILINE = 8;

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function quote
 * @static
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#quote(java.lang.String)}
 **/
Pattern.quote = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'quote',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compile
 * @static
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#compile(java.lang.String)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#compile(java.lang.String, int)}
 **/
Pattern.compile = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'compile',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function matches
 * @static
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#matches(java.lang.String, java.lang.CharSequence)}
 **/
Pattern.matches = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'matches',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function split
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#split(java.lang.CharSequence, int)}
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#split(java.lang.CharSequence)}
 **/
Pattern.prototype.split = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'split',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pattern
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#pattern()}
 **/
Pattern.prototype.pattern = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pattern',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function flags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#flags()}
 **/
Pattern.prototype.flags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function splitAsStream
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#splitAsStream(java.lang.CharSequence)}
 **/
Pattern.prototype.splitAsStream = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'splitAsStream',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#toString()}
 **/
Pattern.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asPredicate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#asPredicate()}
 **/
Pattern.prototype.asPredicate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asPredicate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asMatchPredicate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#asMatchPredicate()}
 **/
Pattern.prototype.asMatchPredicate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asMatchPredicate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function matcher
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/regex/Pattern.html#matcher(java.lang.CharSequence)}
 **/
Pattern.prototype.matcher = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'matcher',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.regex.Pattern') {
			return new Pattern(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Pattern;
