/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.KrollDict
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.kroll');

/**
 * @class org.appcelerator.kroll.KrollDict
 * @extends java.util.HashMap 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html}
 **/
var KrollDict = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.KrollDict')) {
		result = arguments[0];
	}
	else {
		result = KrollDict.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.util.HashMap');
KrollDict.prototype = Object.create(SuperClass.prototype);
KrollDict.prototype.constructor = KrollDict;

Object.defineProperty(KrollDict.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new KrollDict(this.$native.super);
	},
	enumerable: true
});

KrollDict.className = 'org.appcelerator.kroll.KrollDict';
KrollDict.prototype.className = 'org.appcelerator.kroll.KrollDict';

// class property
Object.defineProperty(KrollDict, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.KrollDict');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
KrollDict.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.KrollDict');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(KrollDict.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
KrollDict.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new KrollDict(Hyperloop.cast('org.appcelerator.kroll.KrollDict', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function fromJSON
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#fromJSON(java.lang.Object)}
 **/
KrollDict.fromJSON = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fromJSON',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function putCodeAndMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#putCodeAndMessage(int, java.lang.String)}
 **/
KrollDict.prototype.putCodeAndMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putCodeAndMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function containsKeyAndNotNull
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#containsKeyAndNotNull(java.lang.String)}
 **/
KrollDict.prototype.containsKeyAndNotNull = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'containsKeyAndNotNull',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getDouble(java.lang.String)}
 **/
KrollDict.prototype.getDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getString(java.lang.String)}
 **/
KrollDict.prototype.getString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optBoolean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#optBoolean(java.lang.String, boolean)}
 **/
KrollDict.prototype.optBoolean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optBoolean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getInt(java.lang.String)}
 **/
KrollDict.prototype.getInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#optInt(java.lang.String, java.lang.Integer)}
 **/
KrollDict.prototype.optInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKrollDict
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getKrollDict(java.lang.String)}
 **/
KrollDict.prototype.getKrollDict = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getKrollDict',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isNull
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#isNull(java.lang.String)}
 **/
KrollDict.prototype.isNull = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNull',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#optString(java.lang.String, java.lang.String)}
 **/
KrollDict.prototype.optString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function containsKeyStartingWith
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#containsKeyStartingWith(java.lang.String)}
 **/
KrollDict.prototype.containsKeyStartingWith = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'containsKeyStartingWith',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoolean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getBoolean(java.lang.String)}
 **/
KrollDict.prototype.getBoolean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoolean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStringArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getStringArray(java.lang.String)}
 **/
KrollDict.prototype.getStringArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStringArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#toString()}
 **/
KrollDict.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getIntArray(java.lang.String)}
 **/
KrollDict.prototype.getIntArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getKrollDictArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollDict.html#getKrollDictArray(java.lang.String)}
 **/
KrollDict.prototype.getKrollDictArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getKrollDictArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollDict') {
			return new KrollDict(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = KrollDict;
