/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.KrollModule
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.kroll');

/**
 * @class org.appcelerator.kroll.KrollModule
 * @extends org.appcelerator.kroll.KrollProxy 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html}
 **/
var KrollModule = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.KrollModule')) {
		result = arguments[0];
	}
	else {
		result = KrollModule.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.kroll.KrollProxy');
KrollModule.prototype = Object.create(SuperClass.prototype);
KrollModule.prototype.constructor = KrollModule;

Object.defineProperty(KrollModule.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new KrollModule(this.$native.super);
	},
	enumerable: true
});

KrollModule.className = 'org.appcelerator.kroll.KrollModule';
KrollModule.prototype.className = 'org.appcelerator.kroll.KrollModule';

// class property
Object.defineProperty(KrollModule, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.KrollModule');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
KrollModule.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.KrollModule');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(KrollModule.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
KrollModule.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new KrollModule(Hyperloop.cast('org.appcelerator.kroll.KrollModule', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#customModuleInfoList
Object.defineProperty(KrollModule, 'customModuleInfoList', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('customModuleInfoList');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
				return new KrollModule(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('customModuleInfoList', newValue);
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getCustomModuleInfoList
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#getCustomModuleInfoList()}
 **/
KrollModule.getCustomModuleInfoList = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCustomModuleInfoList',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addCustomModuleInfo
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#addCustomModuleInfo(org.appcelerator.kroll.KrollModuleInfo)}
 **/
KrollModule.addCustomModuleInfo = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'addCustomModuleInfo',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onDestroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#onDestroy(android.app.Activity)}
 **/
KrollModule.prototype.onDestroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDestroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function listenerAdded
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#listenerAdded(java.lang.String, int, org.appcelerator.kroll.KrollProxy)}
 **/
KrollModule.prototype.listenerAdded = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'listenerAdded',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function propertiesChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#propertiesChanged(java.util.List, org.appcelerator.kroll.KrollProxy)}
 **/
KrollModule.prototype.propertiesChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'propertiesChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#onPause(android.app.Activity)}
 **/
KrollModule.prototype.onPause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function processProperties
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#processProperties(org.appcelerator.kroll.KrollDict)}
 **/
KrollModule.prototype.processProperties = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'processProperties',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#onResume(android.app.Activity)}
 **/
KrollModule.prototype.onResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function listenerRemoved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#listenerRemoved(java.lang.String, int, org.appcelerator.kroll.KrollProxy)}
 **/
KrollModule.prototype.listenerRemoved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'listenerRemoved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function propertyChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#propertyChanged(java.lang.String, java.lang.Object, java.lang.Object, org.appcelerator.kroll.KrollProxy)}
 **/
KrollModule.prototype.propertyChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'propertyChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#onStart(android.app.Activity)}
 **/
KrollModule.prototype.onStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function initActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#initActivity(android.app.Activity)}
 **/
KrollModule.prototype.initActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApiName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#getApiName()}
 **/
KrollModule.prototype.getApiName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApiName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModule.html#onStop(android.app.Activity)}
 **/
KrollModule.prototype.onStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModule') {
			return new KrollModule(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = KrollModule;
