/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.KrollModuleInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.kroll');

/**
 * @class org.appcelerator.kroll.KrollModuleInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html}
 **/
var KrollModuleInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.KrollModuleInfo')) {
		result = arguments[0];
	}
	else {
		result = KrollModuleInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
KrollModuleInfo.prototype = Object.create(SuperClass.prototype);
KrollModuleInfo.prototype.constructor = KrollModuleInfo;

Object.defineProperty(KrollModuleInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new KrollModuleInfo(this.$native.super);
	},
	enumerable: true
});

KrollModuleInfo.className = 'org.appcelerator.kroll.KrollModuleInfo';
KrollModuleInfo.prototype.className = 'org.appcelerator.kroll.KrollModuleInfo';

// class property
Object.defineProperty(KrollModuleInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.KrollModuleInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
KrollModuleInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.KrollModuleInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(KrollModuleInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
KrollModuleInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new KrollModuleInfo(Hyperloop.cast('org.appcelerator.kroll.KrollModuleInfo', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#license
Object.defineProperty(KrollModuleInfo.prototype, 'license', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('license');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('license', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#licenseKey
Object.defineProperty(KrollModuleInfo.prototype, 'licenseKey', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('licenseKey');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('licenseKey', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#copyright
Object.defineProperty(KrollModuleInfo.prototype, 'copyright', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('copyright');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('copyright', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#isJSModule
Object.defineProperty(KrollModuleInfo.prototype, 'isJSModule', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('isJSModule');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('isJSModule', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#author
Object.defineProperty(KrollModuleInfo.prototype, 'author', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('author');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('author', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#name
Object.defineProperty(KrollModuleInfo.prototype, 'name', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('name');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('name', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#guid
Object.defineProperty(KrollModuleInfo.prototype, 'guid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('guid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('guid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#description
Object.defineProperty(KrollModuleInfo.prototype, 'description', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('description');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('description', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#id
Object.defineProperty(KrollModuleInfo.prototype, 'id', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('id');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('id', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#version
Object.defineProperty(KrollModuleInfo.prototype, 'version', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('version');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
				return new KrollModuleInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('version', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getGuid
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getGuid()}
 **/
KrollModuleInfo.prototype.getGuid = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGuid',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getVersion()}
 **/
KrollModuleInfo.prototype.getVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getName()}
 **/
KrollModuleInfo.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCopyright
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getCopyright()}
 **/
KrollModuleInfo.prototype.getCopyright = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCopyright',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLicenseKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getLicenseKey()}
 **/
KrollModuleInfo.prototype.getLicenseKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLicenseKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAuthor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getAuthor()}
 **/
KrollModuleInfo.prototype.getAuthor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAuthor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getId()}
 **/
KrollModuleInfo.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getDescription()}
 **/
KrollModuleInfo.prototype.getDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIsJSModule
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#setIsJSModule(boolean)}
 **/
KrollModuleInfo.prototype.setIsJSModule = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIsJSModule',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLicenseKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#setLicenseKey(java.lang.String)}
 **/
KrollModuleInfo.prototype.setLicenseKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLicenseKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLicense
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getLicense()}
 **/
KrollModuleInfo.prototype.getLicense = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLicense',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIsJSModule
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollModuleInfo.html#getIsJSModule()}
 **/
KrollModuleInfo.prototype.getIsJSModule = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIsJSModule',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollModuleInfo') {
			return new KrollModuleInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = KrollModuleInfo;
