/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.KrollPromise$NullPromise
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.kroll.KrollPromise');

/**
 * @class org.appcelerator.kroll.KrollPromise$NullPromise
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollPromise.NullPromise.html}
 **/
var NullPromise = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.KrollPromise$NullPromise')) {
		result = arguments[0];
	}
	else {
		result = NullPromise.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
NullPromise.prototype = Object.create(SuperClass.prototype);
NullPromise.prototype.constructor = NullPromise;

Object.defineProperty(NullPromise.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new NullPromise(this.$native.super);
	},
	enumerable: true
});

NullPromise.className = 'org.appcelerator.kroll.KrollPromise$NullPromise';
NullPromise.prototype.className = 'org.appcelerator.kroll.KrollPromise$NullPromise';

// class property
Object.defineProperty(NullPromise, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.KrollPromise$NullPromise');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
NullPromise.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.KrollPromise$NullPromise');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(NullPromise.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
NullPromise.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new NullPromise(Hyperloop.cast('org.appcelerator.kroll.KrollPromise$NullPromise', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function resolve
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollPromise.NullPromise.html#resolve(java.lang.Object)}
 **/
NullPromise.prototype.resolve = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resolve',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollPromise$NullPromise') {
			return new NullPromise(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollPromise.NullPromise.html#reject(java.lang.Object)}
 **/
NullPromise.prototype.reject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollPromise$NullPromise') {
			return new NullPromise(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = NullPromise;
