/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.kroll.KrollProxy');

/**
 * @class org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet
 * @extends org.appcelerator.kroll.KrollPropertyChange 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html}
 **/
var KrollPropertyChangeSet = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet')) {
		result = arguments[0];
	}
	else {
		result = KrollPropertyChangeSet.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.kroll.KrollPropertyChange');
KrollPropertyChangeSet.prototype = Object.create(SuperClass.prototype);
KrollPropertyChangeSet.prototype.constructor = KrollPropertyChangeSet;

Object.defineProperty(KrollPropertyChangeSet.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new KrollPropertyChangeSet(this.$native.super);
	},
	enumerable: true
});

KrollPropertyChangeSet.className = 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet';
KrollPropertyChangeSet.prototype.className = 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet';

// class property
Object.defineProperty(KrollPropertyChangeSet, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
KrollPropertyChangeSet.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(KrollPropertyChangeSet.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
KrollPropertyChangeSet.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new KrollPropertyChangeSet(Hyperloop.cast('org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html#entryCount
Object.defineProperty(KrollPropertyChangeSet.prototype, 'entryCount', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('entryCount');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet') {
				return new KrollPropertyChangeSet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('entryCount', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html#keys
Object.defineProperty(KrollPropertyChangeSet.prototype, 'keys', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('keys');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet') {
				return new KrollPropertyChangeSet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('keys', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html#newValues
Object.defineProperty(KrollPropertyChangeSet.prototype, 'newValues', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('newValues');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet') {
				return new KrollPropertyChangeSet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('newValues', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html#oldValues
Object.defineProperty(KrollPropertyChangeSet.prototype, 'oldValues', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('oldValues');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet') {
				return new KrollPropertyChangeSet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('oldValues', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function fireEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html#fireEvent(org.appcelerator.kroll.KrollProxy, org.appcelerator.kroll.KrollProxyListener)}
 **/
KrollPropertyChangeSet.prototype.fireEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fireEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet') {
			return new KrollPropertyChangeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addChange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollProxy.KrollPropertyChangeSet.html#addChange(java.lang.String, java.lang.Object, java.lang.Object)}
 **/
KrollPropertyChangeSet.prototype.addChange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addChange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.KrollProxy$KrollPropertyChangeSet') {
			return new KrollPropertyChangeSet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = KrollPropertyChangeSet;
