/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.common.TiDeployData
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.kroll.common');

/**
 * @class org.appcelerator.kroll.common.TiDeployData
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html}
 **/
var TiDeployData = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.common.TiDeployData')) {
		result = arguments[0];
	}
	else {
		result = TiDeployData.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiDeployData.prototype = Object.create(SuperClass.prototype);
TiDeployData.prototype.constructor = TiDeployData;

Object.defineProperty(TiDeployData.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiDeployData(this.$native.super);
	},
	enumerable: true
});

TiDeployData.className = 'org.appcelerator.kroll.common.TiDeployData';
TiDeployData.prototype.className = 'org.appcelerator.kroll.common.TiDeployData';

// class property
Object.defineProperty(TiDeployData, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.common.TiDeployData');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiDeployData.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.common.TiDeployData');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiDeployData.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiDeployData.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiDeployData(Hyperloop.cast('org.appcelerator.kroll.common.TiDeployData', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#FASTDEV_PORT}
 */
TiDeployData.FASTDEV_PORT = "fastdevPort";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#DEBUGGER_ENABLED}
 */
TiDeployData.DEBUGGER_ENABLED = "debuggerEnabled";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#PROFILER_ENABLED}
 */
TiDeployData.PROFILER_ENABLED = "profilerEnabled";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#DEBUGGER_PORT}
 */
TiDeployData.DEBUGGER_PORT = "debuggerPort";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#PROFILER_PORT}
 */
TiDeployData.PROFILER_PORT = "profilerPort";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#FASTDEV_LISTEN}
 */
TiDeployData.FASTDEV_LISTEN = "fastdevListen";

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getProfilerPort
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#getProfilerPort()}
 **/
TiDeployData.prototype.getProfilerPort = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProfilerPort',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.common.TiDeployData') {
			return new TiDeployData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFastDevPort
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#getFastDevPort()}
 **/
TiDeployData.prototype.getFastDevPort = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFastDevPort',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.common.TiDeployData') {
			return new TiDeployData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFastDevListen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#getFastDevListen()}
 **/
TiDeployData.prototype.getFastDevListen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFastDevListen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.common.TiDeployData') {
			return new TiDeployData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDebuggerEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#isDebuggerEnabled()}
 **/
TiDeployData.prototype.isDebuggerEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDebuggerEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.common.TiDeployData') {
			return new TiDeployData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isProfilerEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#isProfilerEnabled()}
 **/
TiDeployData.prototype.isProfilerEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isProfilerEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.common.TiDeployData') {
			return new TiDeployData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDebuggerPort
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/common/TiDeployData.html#getDebuggerPort()}
 **/
TiDeployData.prototype.getDebuggerPort = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDebuggerPort',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.kroll.common.TiDeployData') {
			return new TiDeployData(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiDeployData;
