/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ITiAppInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * constructor
 * http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html
 **/
var ITiAppInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'org.appcelerator.titanium.ITiAppInfo') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('org.appcelerator.titanium.ITiAppInfo');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ITiAppInfo.prototype = Object.create(SuperClass.prototype);
ITiAppInfo.prototype.constructor = ITiAppInfo;

Object.defineProperty(ITiAppInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ITiAppInfo(this.$native.super);
	},
	enumerable: true
});

ITiAppInfo.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ITiAppInfo.className = "org.appcelerator.titanium.ITiAppInfo";
ITiAppInfo.prototype.className = "org.appcelerator.titanium.ITiAppInfo";

// class property
Object.defineProperty(ITiAppInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.ITiAppInfo');
	},
	enumerable: true,
	configurable: false
});

// Cast
ITiAppInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ITiAppInfo(Hyperloop.cast('org.appcelerator.titanium.ITiAppInfo', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function getVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getVersion()}
 **/
ITiAppInfo.prototype.getVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getGUID
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getGUID()}
 **/
ITiAppInfo.prototype.getGUID = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGUID',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getName()}
 **/
ITiAppInfo.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getCopyright
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getCopyright()}
 **/
ITiAppInfo.prototype.getCopyright = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCopyright',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isAnalyticsEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#isAnalyticsEnabled()}
 **/
ITiAppInfo.prototype.isAnalyticsEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAnalyticsEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDeployType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getDeployType()}
 **/
ITiAppInfo.prototype.getDeployType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDeployType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getId()}
 **/
ITiAppInfo.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getDescription()}
 **/
ITiAppInfo.prototype.getDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getIcon()}
 **/
ITiAppInfo.prototype.getIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getUrl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getUrl()}
 **/
ITiAppInfo.prototype.getUrl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUrl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getPublisher
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getPublisher()}
 **/
ITiAppInfo.prototype.getPublisher = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPublisher',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getBuildType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#getBuildType()}
 **/
ITiAppInfo.prototype.getBuildType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBuildType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isFullscreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/ITiAppInfo.html#isFullscreen()}
 **/
ITiAppInfo.prototype.isFullscreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFullscreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.ITiAppInfo') {
			return new ITiAppInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ITiAppInfo.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ITiAppInfo.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ITiAppInfo;
