/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.TiApplication
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * @class org.appcelerator.titanium.TiApplication
 * @extends android.app.Application 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html}
 **/
var TiApplication = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.TiApplication')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: org.appcelerator.titanium.TiApplication. Create a subclass using org.appcelerator.titanium.TiApplication.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.app.Application');
TiApplication.prototype = Object.create(SuperClass.prototype);
TiApplication.prototype.constructor = TiApplication;

Object.defineProperty(TiApplication.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiApplication(this.$native.super);
	},
	enumerable: true
});

TiApplication.className = 'org.appcelerator.titanium.TiApplication';
TiApplication.prototype.className = 'org.appcelerator.titanium.TiApplication';

// class property
Object.defineProperty(TiApplication, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.TiApplication');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiApplication.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.TiApplication');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiApplication.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiApplication.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiApplication(Hyperloop.cast('org.appcelerator.titanium.TiApplication', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#PROPERTY_FASTDEV}
 */
TiApplication.PROPERTY_FASTDEV = "ti.android.fastdev";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#DEPLOY_TYPE_TEST}
 */
TiApplication.DEPLOY_TYPE_TEST = "test";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#TRIM_MEMORY_RUNNING_LOW}
 */
TiApplication.TRIM_MEMORY_RUNNING_LOW = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#DEPLOY_TYPE_PRODUCTION}
 */
TiApplication.DEPLOY_TYPE_PRODUCTION = "production";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#DEPLOY_TYPE_DEVELOPMENT}
 */
TiApplication.DEPLOY_TYPE_DEVELOPMENT = "development";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#APPLICATION_PREFERENCES_NAME}
 */
TiApplication.APPLICATION_PREFERENCES_NAME = "titanium";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#DEFAULT_THREAD_STACK_SIZE}
 */
TiApplication.DEFAULT_THREAD_STACK_SIZE = 16384;

// Inner classes
Object.defineProperty(TiApplication, 'ActivityTransitionListener', {
	get: function() {
		return require('./org.appcelerator.titanium.TiApplication$ActivityTransitionListener');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#START_TIME_MS
Object.defineProperty(TiApplication, 'START_TIME_MS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('START_TIME_MS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('START_TIME_MS', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#activityStack
Object.defineProperty(TiApplication, 'activityStack', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('activityStack');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('activityStack', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#USE_LEGACY_WINDOW
Object.defineProperty(TiApplication, 'USE_LEGACY_WINDOW', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('USE_LEGACY_WINDOW');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('USE_LEGACY_WINDOW', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isActivityTransition
Object.defineProperty(TiApplication, 'isActivityTransition', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('isActivityTransition');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('isActivityTransition', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#activityTransitionListeners
Object.defineProperty(TiApplication, 'activityTransitionListeners', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('activityTransitionListeners');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('activityTransitionListeners', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#tiApp
Object.defineProperty(TiApplication, 'tiApp', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('tiApp');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('tiApp', newValue);
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#stylesheet
Object.defineProperty(TiApplication.prototype, 'stylesheet', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('stylesheet');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('stylesheet', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#appInfo
Object.defineProperty(TiApplication.prototype, 'appInfo', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('appInfo');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('appInfo', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#filteredAnalyticsEvents
Object.defineProperty(TiApplication.prototype, 'filteredAnalyticsEvents', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('filteredAnalyticsEvents');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('filteredAnalyticsEvents', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#modules
Object.defineProperty(TiApplication.prototype, 'modules', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('modules');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('modules', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#deployData
Object.defineProperty(TiApplication.prototype, 'deployData', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('deployData');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
				return new TiApplication(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('deployData', newValue);
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function terminateActivityStack
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#terminateActivityStack()}
 **/
TiApplication.terminateActivityStack = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'terminateActivityStack',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateActivityTransitionState
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#updateActivityTransitionState(boolean)}
 **/
TiApplication.updateActivityTransitionState = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'updateActivityTransitionState',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeActivityTransitionListener
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#removeActivityTransitionListener(org.appcelerator.titanium.TiApplication$ActivityTransitionListener)}
 **/
TiApplication.removeActivityTransitionListener = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'removeActivityTransitionListener',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isCurrentActivityInForeground
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isCurrentActivityInForeground()}
 **/
TiApplication.isCurrentActivityInForeground = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isCurrentActivityInForeground',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function firstOnActivityStack
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#firstOnActivityStack()}
 **/
TiApplication.firstOnActivityStack = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'firstOnActivityStack',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAppCurrentActivity
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getAppCurrentActivity()}
 **/
TiApplication.getAppCurrentActivity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAppCurrentActivity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addActivityTransitionListener
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#addActivityTransitionListener(org.appcelerator.titanium.TiApplication$ActivityTransitionListener)}
 **/
TiApplication.addActivityTransitionListener = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'addActivityTransitionListener',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAppRootOrCurrentActivity
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getAppRootOrCurrentActivity()}
 **/
TiApplication.getAppRootOrCurrentActivity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAppRootOrCurrentActivity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeFromActivityStack
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#removeFromActivityStack(android.app.Activity)}
 **/
TiApplication.removeFromActivityStack = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'removeFromActivityStack',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addToActivityStack
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#addToActivityStack(android.app.Activity)}
 **/
TiApplication.addToActivityStack = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'addToActivityStack',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isUIThread
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isUIThread()}
 **/
TiApplication.isUIThread = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isUIThread',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function launch
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#launch()}
 **/
TiApplication.launch = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'launch',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInstance
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getInstance()}
 **/
TiApplication.getInstance = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getInstance',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getAppGUID
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getAppGUID()}
 **/
TiApplication.prototype.getAppGUID = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAppGUID',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFastDevMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isFastDevMode()}
 **/
TiApplication.prototype.isFastDevMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFastDevMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function softRestart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#softRestart()}
 **/
TiApplication.prototype.softRestart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'softRestart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addAppEventProxy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#addAppEventProxy(org.appcelerator.kroll.KrollProxy)}
 **/
TiApplication.prototype.addAppEventProxy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addAppEventProxy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function runOnMainThread
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#runOnMainThread()}
 **/
TiApplication.prototype.runOnMainThread = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'runOnMainThread',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeAppEventProxy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#removeAppEventProxy(org.appcelerator.kroll.KrollProxy)}
 **/
TiApplication.prototype.removeAppEventProxy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeAppEventProxy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrentActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getCurrentActivity()}
 **/
TiApplication.prototype.getCurrentActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrentActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLowMemory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#onLowMemory()}
 **/
TiApplication.prototype.onLowMemory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLowMemory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function waitForCurrentActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#waitForCurrentActivity(org.appcelerator.kroll.common.CurrentActivityListener)}
 **/
TiApplication.prototype.waitForCurrentActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'waitForCurrentActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRootActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#setRootActivity(org.appcelerator.titanium.TiRootActivity)}
 **/
TiApplication.prototype.setRootActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRootActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAppProperties
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getAppProperties()}
 **/
TiApplication.prototype.getAppProperties = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAppProperties',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getThreadStackSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getThreadStackSize()}
 **/
TiApplication.prototype.getThreadStackSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getThreadStackSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAnalyticsFiltered
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isAnalyticsFiltered(java.lang.String)}
 **/
TiApplication.prototype.isAnalyticsFiltered = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAnalyticsFiltered',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFilterAnalyticsEvents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#setFilterAnalyticsEvents(java.lang.String[])}
 **/
TiApplication.prototype.setFilterAnalyticsEvents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFilterAnalyticsEvents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireAppEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#fireAppEvent(java.lang.String, org.appcelerator.kroll.KrollDict)}
 **/
TiApplication.prototype.fireAppEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fireAppEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerModuleInstance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#registerModuleInstance(java.lang.String, org.appcelerator.kroll.KrollModule)}
 **/
TiApplication.prototype.registerModuleInstance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerModuleInstance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function postAppInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#postAppInfo()}
 **/
TiApplication.prototype.postAppInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'postAppInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDebuggerEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isDebuggerEnabled()}
 **/
TiApplication.prototype.isDebuggerEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDebuggerEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSDKVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getSDKVersion()}
 **/
TiApplication.prototype.getSDKVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSDKVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCurrentActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#setCurrentActivity(android.app.Activity, android.app.Activity)}
 **/
TiApplication.prototype.setCurrentActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCurrentActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function loadAppProperties
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#loadAppProperties()}
 **/
TiApplication.prototype.loadAppProperties = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'loadAppProperties',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispose
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#dispose()}
 **/
TiApplication.prototype.dispose = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispose',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRootActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getRootActivity()}
 **/
TiApplication.prototype.getRootActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRootActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function cancelTimers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#cancelTimers()}
 **/
TiApplication.prototype.cancelTimers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cancelTimers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTerminate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#onTerminate()}
 **/
TiApplication.prototype.onTerminate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTerminate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAnalyticsEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isAnalyticsEnabled()}
 **/
TiApplication.prototype.isAnalyticsEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAnalyticsEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTiTempDir
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getTiTempDir()}
 **/
TiApplication.prototype.getTiTempDir = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTiTempDir',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function activityStackHasLaunchActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#activityStackHasLaunchActivity()}
 **/
TiApplication.prototype.activityStackHasLaunchActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'activityStackHasLaunchActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAppInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getAppInfo()}
 **/
TiApplication.prototype.getAppInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAppInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRootOrCurrentActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getRootOrCurrentActivity()}
 **/
TiApplication.prototype.getRootOrCurrentActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRootOrCurrentActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTiBuildTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getTiBuildTimestamp()}
 **/
TiApplication.prototype.getTiBuildTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTiBuildTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBaseUrl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getBaseUrl()}
 **/
TiApplication.prototype.getBaseUrl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBaseUrl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerProxy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#registerProxy(org.appcelerator.kroll.KrollProxy)}
 **/
TiApplication.prototype.registerProxy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerProxy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTiBuildVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getTiBuildVersion()}
 **/
TiApplication.prototype.getTiBuildVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTiBuildVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function verifyCustomModules
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#verifyCustomModules(org.appcelerator.titanium.TiRootActivity)}
 **/
TiApplication.prototype.verifyCustomModules = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'verifyCustomModules',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#onCreate()}
 **/
TiApplication.prototype.onCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDefaultUnit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getDefaultUnit()}
 **/
TiApplication.prototype.getDefaultUnit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDefaultUnit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isRootActivityAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#isRootActivityAvailable()}
 **/
TiApplication.prototype.isRootActivityAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isRootActivityAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDeployType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getDeployType()}
 **/
TiApplication.prototype.getDeployType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDeployType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccessibilityManager
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getAccessibilityManager()}
 **/
TiApplication.prototype.getAccessibilityManager = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccessibilityManager',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTrimMemory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#onTrimMemory(int)}
 **/
TiApplication.prototype.onTrimMemory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTrimMemory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStylesheet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getStylesheet(java.lang.String, java.util.Collection, java.lang.String)}
 **/
TiApplication.prototype.getStylesheet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStylesheet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function postOnCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#postOnCreate()}
 **/
TiApplication.prototype.postOnCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'postOnCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDeployData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getDeployData()}
 **/
TiApplication.prototype.getDeployData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDeployData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTiBuildHash
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getTiBuildHash()}
 **/
TiApplication.prototype.getTiBuildHash = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTiBuildHash',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forceCompileJS
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#forceCompileJS()}
 **/
TiApplication.prototype.forceCompileJS = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forceCompileJS',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartUrl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getStartUrl()}
 **/
TiApplication.prototype.getStartUrl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartUrl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unregisterProxy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#unregisterProxy(java.lang.String)}
 **/
TiApplication.prototype.unregisterProxy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterProxy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getModuleByName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiApplication.html#getModuleByName(java.lang.String)}
 **/
TiApplication.prototype.getModuleByName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getModuleByName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiApplication') {
			return new TiApplication(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiApplication;
