/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.TiDimension
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * @class org.appcelerator.titanium.TiDimension
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html}
 **/
var TiDimension = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.TiDimension')) {
		result = arguments[0];
	}
	else {
		result = TiDimension.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiDimension.prototype = Object.create(SuperClass.prototype);
TiDimension.prototype.constructor = TiDimension;

Object.defineProperty(TiDimension.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiDimension(this.$native.super);
	},
	enumerable: true
});

TiDimension.className = 'org.appcelerator.titanium.TiDimension';
TiDimension.prototype.className = 'org.appcelerator.titanium.TiDimension';

// class property
Object.defineProperty(TiDimension, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.TiDimension');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiDimension.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.TiDimension');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiDimension.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiDimension.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiDimension(Hyperloop.cast('org.appcelerator.titanium.TiDimension', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#POINT_DPI}
 */
TiDimension.POINT_DPI = 72.0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#COMPLEX_UNIT_AUTO}
 */
TiDimension.COMPLEX_UNIT_AUTO = 18;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#COMPLEX_UNIT_UNDEFINED}
 */
TiDimension.COMPLEX_UNIT_UNDEFINED = 16;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#MM_INCH}
 */
TiDimension.MM_INCH = 25.4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_MM}
 */
TiDimension.UNIT_MM = "mm";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_SP}
 */
TiDimension.UNIT_SP = "sp";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_DP}
 */
TiDimension.UNIT_DP = "dp";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_CENTER_X}
 */
TiDimension.TYPE_CENTER_X = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_CENTER_Y}
 */
TiDimension.TYPE_CENTER_Y = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_PX}
 */
TiDimension.UNIT_PX = "px";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_UNDEFINED}
 */
TiDimension.TYPE_UNDEFINED = -1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_TOP}
 */
TiDimension.TYPE_TOP = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_PERCENT}
 */
TiDimension.UNIT_PERCENT = "%";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#COMPLEX_UNIT_PERCENT}
 */
TiDimension.COMPLEX_UNIT_PERCENT = 17;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#COMPLEX_UNIT_CM}
 */
TiDimension.COMPLEX_UNIT_CM = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_SYSTEM}
 */
TiDimension.UNIT_SYSTEM = "system";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_LEFT}
 */
TiDimension.TYPE_LEFT = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_RIGHT}
 */
TiDimension.TYPE_RIGHT = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_AUTO}
 */
TiDimension.UNIT_AUTO = "auto";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_BOTTOM}
 */
TiDimension.TYPE_BOTTOM = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_PT}
 */
TiDimension.UNIT_PT = "pt";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_HEIGHT}
 */
TiDimension.TYPE_HEIGHT = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_CM}
 */
TiDimension.UNIT_CM = "cm";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_DIP}
 */
TiDimension.UNIT_DIP = "dip";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_IN}
 */
TiDimension.UNIT_IN = "in";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#UNIT_SIP}
 */
TiDimension.UNIT_SIP = "sip";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#TYPE_WIDTH}
 */
TiDimension.TYPE_WIDTH = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#CM_INCH}
 */
TiDimension.CM_INCH = 2.54;

// Inner classes

// Static fields
// http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#DIMENSION_PATTERN
Object.defineProperty(TiDimension, 'DIMENSION_PATTERN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DIMENSION_PATTERN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
				return new TiDimension(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('DIMENSION_PATTERN', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#metrics
Object.defineProperty(TiDimension, 'metrics', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('metrics');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
				return new TiDimension(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this.class) return;

		this.class.setNativeField('metrics', newValue);
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#units
Object.defineProperty(TiDimension.prototype, 'units', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('units');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
				return new TiDimension(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('units', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#valueType
Object.defineProperty(TiDimension.prototype, 'valueType', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('valueType');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
				return new TiDimension(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('valueType', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#value
Object.defineProperty(TiDimension.prototype, 'value', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('value');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
				return new TiDimension(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('value', newValue);
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function getDisplayMetrics
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getDisplayMetrics(android.view.View)}
 **/
TiDimension.getDisplayMetrics = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getDisplayMetrics',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isUnitAuto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#isUnitAuto()}
 **/
TiDimension.prototype.isUnitAuto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUnitAuto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAsMillimeters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getAsMillimeters(android.view.View)}
 **/
TiDimension.prototype.getAsMillimeters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAsMillimeters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPercentPixels
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getPercentPixels(android.view.View)}
 **/
TiDimension.prototype.getPercentPixels = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPercentPixels',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getIntValue()}
 **/
TiDimension.prototype.getIntValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAsInches
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getAsInches(android.view.View)}
 **/
TiDimension.prototype.getAsInches = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAsInches',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAsCentimeters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getAsCentimeters(android.view.View)}
 **/
TiDimension.prototype.getAsCentimeters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAsCentimeters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAsPixels
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getAsPixels(android.view.View)}
 **/
TiDimension.prototype.getAsPixels = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAsPixels',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDPIForType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getDPIForType(android.view.View)}
 **/
TiDimension.prototype.getDPIForType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDPIForType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAsDIP
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getAsDIP(android.view.View)}
 **/
TiDimension.prototype.getAsDIP = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAsDIP',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getValue()}
 **/
TiDimension.prototype.getValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getScaledPixels
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getScaledPixels(android.view.View)}
 **/
TiDimension.prototype.getScaledPixels = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getScaledPixels',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isUnitPercent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#isUnitPercent()}
 **/
TiDimension.prototype.isUnitPercent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUnitPercent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPixels
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getPixels(android.view.View)}
 **/
TiDimension.prototype.getPixels = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPixels',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAsDefault
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getAsDefault(android.view.View)}
 **/
TiDimension.prototype.getAsDefault = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAsDefault',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#setValue(double)}
 **/
TiDimension.prototype.setValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUnits
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getUnits()}
 **/
TiDimension.prototype.getUnits = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUnits',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#toString()}
 **/
TiDimension.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSizePixels
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#getSizePixels(android.view.View)}
 **/
TiDimension.prototype.getSizePixels = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSizePixels',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setUnits
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#setUnits(int)}
 **/
TiDimension.prototype.setUnits = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setUnits',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isUnitUndefined
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiDimension.html#isUnitUndefined()}
 **/
TiDimension.prototype.isUnitUndefined = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUnitUndefined',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiDimension') {
			return new TiDimension(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiDimension;
