/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.TiFileProxy
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * @class org.appcelerator.titanium.TiFileProxy
 * @extends org.appcelerator.kroll.KrollProxy 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html}
 **/
var TiFileProxy = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.TiFileProxy')) {
		result = arguments[0];
	}
	else {
		result = TiFileProxy.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.kroll.KrollProxy');
TiFileProxy.prototype = Object.create(SuperClass.prototype);
TiFileProxy.prototype.constructor = TiFileProxy;

Object.defineProperty(TiFileProxy.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiFileProxy(this.$native.super);
	},
	enumerable: true
});

TiFileProxy.className = 'org.appcelerator.titanium.TiFileProxy';
TiFileProxy.prototype.className = 'org.appcelerator.titanium.TiFileProxy';

// class property
Object.defineProperty(TiFileProxy, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.TiFileProxy');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiFileProxy.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.TiFileProxy');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiFileProxy.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiFileProxy.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiFileProxy(Hyperloop.cast('org.appcelerator.titanium.TiFileProxy', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#path
Object.defineProperty(TiFileProxy.prototype, 'path', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('path');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
				return new TiFileProxy(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('path', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#tbf
Object.defineProperty(TiFileProxy.prototype, 'tbf', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('tbf');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
				return new TiFileProxy(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('tbf', newValue);
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function join
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#join(java.util.Collection, java.lang.String)}
 **/
TiFileProxy.join = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'join',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function spaceAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#spaceAvailable()}
 **/
TiFileProxy.prototype.spaceAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'spaceAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function extension
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#extension()}
 **/
TiFileProxy.prototype.extension = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'extension',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getName()}
 **/
TiFileProxy.prototype.getName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function resolve
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#resolve()}
 **/
TiFileProxy.prototype.resolve = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resolve',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function modifiedAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#modifiedAt()}
 **/
TiFileProxy.prototype.modifiedAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'modifiedAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getReadonly
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getReadonly()}
 **/
TiFileProxy.prototype.getReadonly = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getReadonly',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createFile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#createFile()}
 **/
TiFileProxy.prototype.createFile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createFile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#createTimestamp()}
 **/
TiFileProxy.prototype.createTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createdAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#createdAt()}
 **/
TiFileProxy.prototype.createdAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createdAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBaseFile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getBaseFile()}
 **/
TiFileProxy.prototype.getBaseFile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBaseFile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSymbolicLink
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getSymbolicLink()}
 **/
TiFileProxy.prototype.getSymbolicLink = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSymbolicLink',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNativePath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getNativePath()}
 **/
TiFileProxy.prototype.getNativePath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNativePath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createDirectory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#createDirectory(java.lang.Object)}
 **/
TiFileProxy.prototype.createDirectory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createDirectory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeLine
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#writeLine(java.lang.String)}
 **/
TiFileProxy.prototype.writeLine = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeLine',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function copy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#copy(java.lang.String)}
 **/
TiFileProxy.prototype.copy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'copy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function write
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#write(java.lang.Object[])}
 **/
TiFileProxy.prototype.write = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'write',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWritable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getWritable()}
 **/
TiFileProxy.prototype.getWritable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWritable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function modificationTimestamp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#modificationTimestamp()}
 **/
TiFileProxy.prototype.modificationTimestamp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'modificationTimestamp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function deleteFile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#deleteFile()}
 **/
TiFileProxy.prototype.deleteFile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'deleteFile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getParent()}
 **/
TiFileProxy.prototype.getParent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function move
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#move(java.lang.String)}
 **/
TiFileProxy.prototype.move = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'move',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function read
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#read()}
 **/
TiFileProxy.prototype.read = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'read',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#isFile()}
 **/
TiFileProxy.prototype.isFile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExecutable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getExecutable()}
 **/
TiFileProxy.prototype.getExecutable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExecutable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHidden
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getHidden()}
 **/
TiFileProxy.prototype.getHidden = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHidden',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDirectoryListing
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getDirectoryListing()}
 **/
TiFileProxy.prototype.getDirectoryListing = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDirectoryListing',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function readLine
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#readLine()}
 **/
TiFileProxy.prototype.readLine = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readLine',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInputStream
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getInputStream()}
 **/
TiFileProxy.prototype.getInputStream = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInputStream',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#getSize()}
 **/
TiFileProxy.prototype.getSize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function rename
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#rename(java.lang.String)}
 **/
TiFileProxy.prototype.rename = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rename',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function exists
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#exists()}
 **/
TiFileProxy.prototype.exists = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'exists',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#toString()}
 **/
TiFileProxy.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function deleteDirectory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#deleteDirectory(java.lang.Object)}
 **/
TiFileProxy.prototype.deleteDirectory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'deleteDirectory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDirectory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#isDirectory()}
 **/
TiFileProxy.prototype.isDirectory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDirectory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function append
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#append(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#append(java.lang.Object[])}
 **/
TiFileProxy.prototype.append = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'append',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function open
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiFileProxy.html#open(int)}
 **/
TiFileProxy.prototype.open = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'open',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiFileProxy') {
			return new TiFileProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiFileProxy;
