/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.TiProperties
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * @class org.appcelerator.titanium.TiProperties
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html}
 **/
var TiProperties = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.TiProperties')) {
		result = arguments[0];
	}
	else {
		result = TiProperties.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiProperties.prototype = Object.create(SuperClass.prototype);
TiProperties.prototype.constructor = TiProperties;

Object.defineProperty(TiProperties.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiProperties(this.$native.super);
	},
	enumerable: true
});

TiProperties.className = 'org.appcelerator.titanium.TiProperties';
TiProperties.prototype.className = 'org.appcelerator.titanium.TiProperties';

// class property
Object.defineProperty(TiProperties, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.TiProperties');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiProperties.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.TiProperties');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiProperties.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiProperties.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiProperties(Hyperloop.cast('org.appcelerator.titanium.TiProperties', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function setSystemProperties
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#setSystemProperties(org.json.JSONObject)}
 **/
TiProperties.setSystemProperties = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'setSystemProperties',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setBool
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#setBool(java.lang.String, boolean)}
 **/
TiProperties.prototype.setBool = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBool',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeAllProperties
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#removeAllProperties()}
 **/
TiProperties.prototype.removeAllProperties = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeAllProperties',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#getDouble(java.lang.String, double)}
 **/
TiProperties.prototype.getDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#getString(java.lang.String, java.lang.String)}
 **/
TiProperties.prototype.getString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPreference
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#getPreference(java.lang.String)}
 **/
TiProperties.prototype.getPreference = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPreference',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#setList(java.lang.String, java.lang.String[])}
 **/
TiProperties.prototype.setList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#hasProperty(java.lang.String)}
 **/
TiProperties.prototype.hasProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function listProperties
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#listProperties()}
 **/
TiProperties.prototype.listProperties = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'listProperties',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#setInt(java.lang.String, int)}
 **/
TiProperties.prototype.setInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#setDouble(java.lang.String, double)}
 **/
TiProperties.prototype.setDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#getInt(java.lang.String, int)}
 **/
TiProperties.prototype.getInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#setString(java.lang.String, java.lang.String)}
 **/
TiProperties.prototype.setString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#getList(java.lang.String, java.lang.String[])}
 **/
TiProperties.prototype.getList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasListProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#hasListProperty(java.lang.String)}
 **/
TiProperties.prototype.hasListProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasListProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBool
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#getBool(java.lang.String, boolean)}
 **/
TiProperties.prototype.getBool = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBool',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeProperty
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiProperties.html#removeProperty(java.lang.String)}
 **/
TiProperties.prototype.removeProperty = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeProperty',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiProperties') {
			return new TiProperties(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiProperties;
