/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.proxy.DecorViewProxy
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.proxy');

/**
 * @class org.appcelerator.titanium.proxy.DecorViewProxy
 * @extends org.appcelerator.titanium.proxy.TiViewProxy 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html}
 **/
var DecorViewProxy = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.proxy.DecorViewProxy')) {
		result = arguments[0];
	}
	else {
		result = DecorViewProxy.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.titanium.proxy.TiViewProxy');
DecorViewProxy.prototype = Object.create(SuperClass.prototype);
DecorViewProxy.prototype.constructor = DecorViewProxy;

Object.defineProperty(DecorViewProxy.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DecorViewProxy(this.$native.super);
	},
	enumerable: true
});

DecorViewProxy.className = 'org.appcelerator.titanium.proxy.DecorViewProxy';
DecorViewProxy.prototype.className = 'org.appcelerator.titanium.proxy.DecorViewProxy';

// class property
Object.defineProperty(DecorViewProxy, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.proxy.DecorViewProxy');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
DecorViewProxy.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.proxy.DecorViewProxy');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(DecorViewProxy.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
DecorViewProxy.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DecorViewProxy(Hyperloop.cast('org.appcelerator.titanium.proxy.DecorViewProxy', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#layout
Object.defineProperty(DecorViewProxy.prototype, 'layout', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('layout');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
				return new DecorViewProxy(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('layout', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#orientationModes
Object.defineProperty(DecorViewProxy.prototype, 'orientationModes', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('orientationModes');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
				return new DecorViewProxy(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('orientationModes', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getOrientationModes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#getOrientationModes()}
 **/
DecorViewProxy.prototype.getOrientationModes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOrientationModes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
			return new DecorViewProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#getLayout()}
 **/
DecorViewProxy.prototype.getLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
			return new DecorViewProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOrientation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#getOrientation()}
 **/
DecorViewProxy.prototype.getOrientation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOrientation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
			return new DecorViewProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOrientationModes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#setOrientationModes(int[])}
 **/
DecorViewProxy.prototype.setOrientationModes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOrientationModes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
			return new DecorViewProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/DecorViewProxy.html#createView(android.app.Activity)}
 **/
DecorViewProxy.prototype.createView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.proxy.DecorViewProxy') {
			return new DecorViewProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DecorViewProxy;
