/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.titanium.util.TiAnimationBuilder');

/**
 * @class org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html}
 **/
var AnimatorHelper = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper')) {
		result = arguments[0];
	}
	else {
		result = AnimatorHelper.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AnimatorHelper.prototype = Object.create(SuperClass.prototype);
AnimatorHelper.prototype.constructor = AnimatorHelper;

Object.defineProperty(AnimatorHelper.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AnimatorHelper(this.$native.super);
	},
	enumerable: true
});

AnimatorHelper.className = 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper';
AnimatorHelper.prototype.className = 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper';

// class property
Object.defineProperty(AnimatorHelper, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AnimatorHelper.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AnimatorHelper.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AnimatorHelper.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AnimatorHelper(Hyperloop.cast('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setTop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setTop(int)}
 **/
AnimatorHelper.prototype.setTop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBottom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setBottom(int)}
 **/
AnimatorHelper.prototype.setBottom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBottom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCenterX
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setCenterX(int)}
 **/
AnimatorHelper.prototype.setCenterX = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCenterX',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLeft
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setLeft(int)}
 **/
AnimatorHelper.prototype.setLeft = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLeft',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCenterY
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setCenterY(int)}
 **/
AnimatorHelper.prototype.setCenterY = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCenterY',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setRight(int)}
 **/
AnimatorHelper.prototype.setRight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setWidth(int)}
 **/
AnimatorHelper.prototype.setWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorHelper.html#setHeight(int)}
 **/
AnimatorHelper.prototype.setHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper') {
			return new AnimatorHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AnimatorHelper;
