/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.titanium.util.TiAnimationBuilder');

/**
 * @class org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorListener.html}
 **/
var AnimatorListener = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener')) {
		result = arguments[0];
	}
	else {
		result = AnimatorListener.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AnimatorListener.prototype = Object.create(SuperClass.prototype);
AnimatorListener.prototype.constructor = AnimatorListener;

Object.defineProperty(AnimatorListener.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AnimatorListener(this.$native.super);
	},
	enumerable: true
});

AnimatorListener.className = 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener';
AnimatorListener.prototype.className = 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener';

// class property
Object.defineProperty(AnimatorListener, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AnimatorListener.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AnimatorListener.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AnimatorListener.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AnimatorListener(Hyperloop.cast('org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onAnimationCancel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorListener.html#onAnimationCancel(android.animation.Animator)}
 **/
AnimatorListener.prototype.onAnimationCancel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationCancel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener') {
			return new AnimatorListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationRepeat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorListener.html#onAnimationRepeat(android.animation.Animator)}
 **/
AnimatorListener.prototype.onAnimationRepeat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationRepeat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener') {
			return new AnimatorListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorListener.html#onAnimationEnd(android.animation.Animator)}
 **/
AnimatorListener.prototype.onAnimationEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener') {
			return new AnimatorListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAnimationStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.AnimatorListener.html#onAnimationStart(android.animation.Animator)}
 **/
AnimatorListener.prototype.onAnimationStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAnimationStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener') {
			return new AnimatorListener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AnimatorListener;
