/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiMenuSupport
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.util');

/**
 * @class org.appcelerator.titanium.util.TiMenuSupport
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html}
 **/
var TiMenuSupport = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiMenuSupport')) {
		result = arguments[0];
	}
	else {
		result = TiMenuSupport.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiMenuSupport.prototype = Object.create(SuperClass.prototype);
TiMenuSupport.prototype.constructor = TiMenuSupport;

Object.defineProperty(TiMenuSupport.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiMenuSupport(this.$native.super);
	},
	enumerable: true
});

TiMenuSupport.className = 'org.appcelerator.titanium.util.TiMenuSupport';
TiMenuSupport.prototype.className = 'org.appcelerator.titanium.util.TiMenuSupport';

// class property
Object.defineProperty(TiMenuSupport, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiMenuSupport');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiMenuSupport.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiMenuSupport');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiMenuSupport.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiMenuSupport.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiMenuSupport(Hyperloop.cast('org.appcelerator.titanium.util.TiMenuSupport', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html#menuProxy
Object.defineProperty(TiMenuSupport.prototype, 'menuProxy', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('menuProxy');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiMenuSupport') {
				return new TiMenuSupport(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('menuProxy', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html#activityProxy
Object.defineProperty(TiMenuSupport.prototype, 'activityProxy', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('activityProxy');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiMenuSupport') {
				return new TiMenuSupport(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('activityProxy', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onPrepareOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html#onPrepareOptionsMenu(boolean, android.view.Menu)}
 **/
TiMenuSupport.prototype.onPrepareOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiMenuSupport') {
			return new TiMenuSupport(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function destroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html#destroy()}
 **/
TiMenuSupport.prototype.destroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'destroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiMenuSupport') {
			return new TiMenuSupport(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreateOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html#onCreateOptionsMenu(boolean, android.view.Menu)}
 **/
TiMenuSupport.prototype.onCreateOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreateOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiMenuSupport') {
			return new TiMenuSupport(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onOptionsItemSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiMenuSupport.html#onOptionsItemSelected(android.view.MenuItem)}
 **/
TiMenuSupport.prototype.onOptionsItemSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onOptionsItemSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiMenuSupport') {
			return new TiMenuSupport(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiMenuSupport;
