/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiWeakList
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.util');

/**
 * @class org.appcelerator.titanium.util.TiWeakList
 * @extends java.util.ArrayList 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html}
 **/
var TiWeakList = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiWeakList')) {
		result = arguments[0];
	}
	else {
		result = TiWeakList.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.util.ArrayList');
TiWeakList.prototype = Object.create(SuperClass.prototype);
TiWeakList.prototype.constructor = TiWeakList;

Object.defineProperty(TiWeakList.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiWeakList(this.$native.super);
	},
	enumerable: true
});

TiWeakList.className = 'org.appcelerator.titanium.util.TiWeakList';
TiWeakList.prototype.className = 'org.appcelerator.titanium.util.TiWeakList';

// class property
Object.defineProperty(TiWeakList, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiWeakList');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiWeakList.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiWeakList');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiWeakList.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiWeakList.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiWeakList(Hyperloop.cast('org.appcelerator.titanium.util.TiWeakList', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(TiWeakList, 'NonNullIterator', {
	get: function() {
		return require('./org.appcelerator.titanium.util.TiWeakList$NonNullIterator');
	},
	enumerable: true
});

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#synchronizedList
Object.defineProperty(TiWeakList.prototype, 'synchronizedList', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('synchronizedList');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
				return new TiWeakList(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('synchronizedList', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function add
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#add(java.lang.ref.WeakReference)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#add(java.lang.Object)}
 **/
TiWeakList.prototype.add = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'add',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeRef
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#removeRef(java.lang.Object)}
 **/
TiWeakList.prototype.removeRef = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeRef',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function contains
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#contains(java.lang.Object)}
 **/
TiWeakList.prototype.contains = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'contains',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nonNullIterator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#nonNullIterator()}
 **/
TiWeakList.prototype.nonNullIterator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nonNullIterator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function synchronizedList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#synchronizedList()}
 **/
TiWeakList.prototype.synchronizedList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'synchronizedList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function refEquals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#refEquals(java.lang.ref.WeakReference, java.lang.Object)}
 **/
TiWeakList.prototype.refEquals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'refEquals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#remove(java.lang.Object)}
 **/
TiWeakList.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nonNull
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#nonNull()}
 **/
TiWeakList.prototype.nonNull = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nonNull',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findRef
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiWeakList.html#findRef(java.lang.Object)}
 **/
TiWeakList.prototype.findRef = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findRef',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiWeakList') {
			return new TiWeakList(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiWeakList;
