/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.view.Ti2DMatrix$Operation
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.titanium.view.Ti2DMatrix');

/**
 * @class org.appcelerator.titanium.view.Ti2DMatrix$Operation
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html}
 **/
var Operation = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.view.Ti2DMatrix$Operation')) {
		result = arguments[0];
	}
	else {
		result = Operation.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Operation.prototype = Object.create(SuperClass.prototype);
Operation.prototype.constructor = Operation;

Object.defineProperty(Operation.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Operation(this.$native.super);
	},
	enumerable: true
});

Operation.className = 'org.appcelerator.titanium.view.Ti2DMatrix$Operation';
Operation.prototype.className = 'org.appcelerator.titanium.view.Ti2DMatrix$Operation';

// class property
Object.defineProperty(Operation, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.view.Ti2DMatrix$Operation');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Operation.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.view.Ti2DMatrix$Operation');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Operation.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Operation.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Operation(Hyperloop.cast('org.appcelerator.titanium.view.Ti2DMatrix$Operation', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#TYPE_INVERT}
 */
Operation.TYPE_INVERT = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#TYPE_ROTATE}
 */
Operation.TYPE_ROTATE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#TYPE_MULTIPLY}
 */
Operation.TYPE_MULTIPLY = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#TYPE_SCALE}
 */
Operation.TYPE_SCALE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#TYPE_TRANSLATE}
 */
Operation.TYPE_TRANSLATE = 1;

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#scaleToY
Object.defineProperty(Operation.prototype, 'scaleToY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('scaleToY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('scaleToY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#scaleToX
Object.defineProperty(Operation.prototype, 'scaleToX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('scaleToX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('scaleToX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#scaleFromValuesSpecified
Object.defineProperty(Operation.prototype, 'scaleFromValuesSpecified', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('scaleFromValuesSpecified');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('scaleFromValuesSpecified', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#rotationFromValueSpecified
Object.defineProperty(Operation.prototype, 'rotationFromValueSpecified', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('rotationFromValueSpecified');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('rotationFromValueSpecified', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#type
Object.defineProperty(Operation.prototype, 'type', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('type');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('type', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#rotateFrom
Object.defineProperty(Operation.prototype, 'rotateFrom', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('rotateFrom');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('rotateFrom', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#rotateTo
Object.defineProperty(Operation.prototype, 'rotateTo', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('rotateTo');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('rotateTo', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#multiplyWith
Object.defineProperty(Operation.prototype, 'multiplyWith', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('multiplyWith');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('multiplyWith', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#anchorY
Object.defineProperty(Operation.prototype, 'anchorY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('anchorY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('anchorY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#scaleFromY
Object.defineProperty(Operation.prototype, 'scaleFromY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('scaleFromY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('scaleFromY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#scaleFromX
Object.defineProperty(Operation.prototype, 'scaleFromX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('scaleFromX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('scaleFromX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#translateY
Object.defineProperty(Operation.prototype, 'translateY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('translateY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('translateY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#anchorX
Object.defineProperty(Operation.prototype, 'anchorX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('anchorX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('anchorX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#translateX
Object.defineProperty(Operation.prototype, 'translateX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('translateX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
				return new Operation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('translateX', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function apply
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.Operation.html#apply(float, android.graphics.Matrix, int, int, float, float)}
 **/
Operation.prototype.apply = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'apply',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix$Operation') {
			return new Operation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Operation;
