/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.view.Ti2DMatrix
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.view');

/**
 * @class org.appcelerator.titanium.view.Ti2DMatrix
 * @extends org.appcelerator.kroll.KrollProxy 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html}
 **/
var Ti2DMatrix = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.view.Ti2DMatrix')) {
		result = arguments[0];
	}
	else {
		result = Ti2DMatrix.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.kroll.KrollProxy');
Ti2DMatrix.prototype = Object.create(SuperClass.prototype);
Ti2DMatrix.prototype.constructor = Ti2DMatrix;

Object.defineProperty(Ti2DMatrix.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Ti2DMatrix(this.$native.super);
	},
	enumerable: true
});

Ti2DMatrix.className = 'org.appcelerator.titanium.view.Ti2DMatrix';
Ti2DMatrix.prototype.className = 'org.appcelerator.titanium.view.Ti2DMatrix';

// class property
Object.defineProperty(Ti2DMatrix, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.view.Ti2DMatrix');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Ti2DMatrix.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.view.Ti2DMatrix');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Ti2DMatrix.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Ti2DMatrix.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Ti2DMatrix(Hyperloop.cast('org.appcelerator.titanium.view.Ti2DMatrix', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#VALUE_UNSPECIFIED}
 */
Ti2DMatrix.VALUE_UNSPECIFIED = 1.4E-45;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#DEFAULT_ANCHOR_VALUE}
 */
Ti2DMatrix.DEFAULT_ANCHOR_VALUE = -1.0;

// Inner classes
Object.defineProperty(Ti2DMatrix, 'Operation', {
	get: function() {
		return require('./org.appcelerator.titanium.view.Ti2DMatrix$Operation');
	},
	enumerable: true
});

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#next
Object.defineProperty(Ti2DMatrix.prototype, 'next', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('next');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
				return new Ti2DMatrix(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('next', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#op
Object.defineProperty(Ti2DMatrix.prototype, 'op', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('op');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
				return new Ti2DMatrix(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('op', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#prev
Object.defineProperty(Ti2DMatrix.prototype, 'prev', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('prev');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
				return new Ti2DMatrix(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('prev', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function rotate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#rotate(java.lang.Object[])}
 **/
Ti2DMatrix.prototype.rotate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rotate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function finalValuesAfterInterpolation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#finalValuesAfterInterpolation(int, int)}
 **/
Ti2DMatrix.prototype.finalValuesAfterInterpolation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'finalValuesAfterInterpolation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasRotateOperation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#hasRotateOperation()}
 **/
Ti2DMatrix.prototype.hasRotateOperation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasRotateOperation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function handleAnchorPoint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#handleAnchorPoint(org.appcelerator.kroll.KrollDict)}
 **/
Ti2DMatrix.prototype.handleAnchorPoint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'handleAnchorPoint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invert
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#invert()}
 **/
Ti2DMatrix.prototype.invert = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invert',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function verifyRotationValues
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#verifyRotationValues(org.appcelerator.titanium.view.TiUIView, boolean)}
 **/
Ti2DMatrix.prototype.verifyRotationValues = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'verifyRotationValues',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scale
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#scale(java.lang.Object[])}
 **/
Ti2DMatrix.prototype.scale = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scale',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function interpolate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#interpolate(float, int, int, float, float)}
 **/
Ti2DMatrix.prototype.interpolate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'interpolate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasScaleOperation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#hasScaleOperation()}
 **/
Ti2DMatrix.prototype.hasScaleOperation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasScaleOperation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function handleCreationDict
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#handleCreationDict(org.appcelerator.kroll.KrollDict)}
 **/
Ti2DMatrix.prototype.handleCreationDict = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'handleCreationDict',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function translate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#translate(double, double)}
 **/
Ti2DMatrix.prototype.translate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'translate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAllOperations
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#getAllOperations()}
 **/
Ti2DMatrix.prototype.getAllOperations = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllOperations',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function verifyScaleValues
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#verifyScaleValues(org.appcelerator.titanium.view.TiUIView, boolean)}
 **/
Ti2DMatrix.prototype.verifyScaleValues = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'verifyScaleValues',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRotateOperationParameters
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#getRotateOperationParameters()}
 **/
Ti2DMatrix.prototype.getRotateOperationParameters = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRotateOperationParameters',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRotationFromDegrees
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#setRotationFromDegrees(float)}
 **/
Ti2DMatrix.prototype.setRotationFromDegrees = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRotationFromDegrees',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function multiply
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#multiply(org.appcelerator.titanium.view.Ti2DMatrix)}
 **/
Ti2DMatrix.prototype.multiply = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'multiply',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function canUsePropertyAnimators
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/Ti2DMatrix.html#canUsePropertyAnimators()}
 **/
Ti2DMatrix.prototype.canUsePropertyAnimators = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canUsePropertyAnimators',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.Ti2DMatrix') {
			return new Ti2DMatrix(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Ti2DMatrix;
