/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.titanium.view.TiCompositeLayout');

/**
 * @class org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams
 * @extends android.view.ViewGroup.LayoutParams 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html}
 **/
var LayoutParams = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams')) {
		result = arguments[0];
	}
	else {
		result = LayoutParams.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.ViewGroup$LayoutParams');
LayoutParams.prototype = Object.create(SuperClass.prototype);
LayoutParams.prototype.constructor = LayoutParams;

Object.defineProperty(LayoutParams.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new LayoutParams(this.$native.super);
	},
	enumerable: true
});

LayoutParams.className = 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams';
LayoutParams.prototype.className = 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams';

// class property
Object.defineProperty(LayoutParams, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
LayoutParams.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(LayoutParams.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
LayoutParams.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new LayoutParams(Hyperloop.cast('org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionRight
Object.defineProperty(LayoutParams.prototype, 'optionRight', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionRight');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionRight', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionZIndex
Object.defineProperty(LayoutParams.prototype, 'optionZIndex', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionZIndex');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionZIndex', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionLeft
Object.defineProperty(LayoutParams.prototype, 'optionLeft', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionLeft');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionLeft', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionHeight
Object.defineProperty(LayoutParams.prototype, 'optionHeight', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionHeight');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionHeight', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#index
Object.defineProperty(LayoutParams.prototype, 'index', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('index');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('index', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#sizeOrFillHeightEnabled
Object.defineProperty(LayoutParams.prototype, 'sizeOrFillHeightEnabled', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('sizeOrFillHeightEnabled');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('sizeOrFillHeightEnabled', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#sizeOrFillWidthEnabled
Object.defineProperty(LayoutParams.prototype, 'sizeOrFillWidthEnabled', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('sizeOrFillWidthEnabled');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('sizeOrFillWidthEnabled', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionBottom
Object.defineProperty(LayoutParams.prototype, 'optionBottom', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionBottom');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionBottom', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#autoFillsWidth
Object.defineProperty(LayoutParams.prototype, 'autoFillsWidth', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('autoFillsWidth');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('autoFillsWidth', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionTransform
Object.defineProperty(LayoutParams.prototype, 'optionTransform', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionTransform');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionTransform', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionCenterY
Object.defineProperty(LayoutParams.prototype, 'optionCenterY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionCenterY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionCenterY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionCenterX
Object.defineProperty(LayoutParams.prototype, 'optionCenterX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionCenterX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionCenterX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionWidth
Object.defineProperty(LayoutParams.prototype, 'optionWidth', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionWidth');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionWidth', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#optionTop
Object.defineProperty(LayoutParams.prototype, 'optionTop', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('optionTop');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('optionTop', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#autoFillsHeight
Object.defineProperty(LayoutParams.prototype, 'autoFillsHeight', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('autoFillsHeight');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
				return new LayoutParams(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('autoFillsHeight', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function hasAutoSizedWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#hasAutoSizedWidth()}
 **/
LayoutParams.prototype.hasAutoSizedWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasAutoSizedWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
			return new LayoutParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasAutoSizedHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiCompositeLayout.LayoutParams.html#hasAutoSizedHeight()}
 **/
LayoutParams.prototype.hasAutoSizedHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasAutoSizedHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams') {
			return new LayoutParams(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = LayoutParams;
