/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.view.TiUIView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.view');

/**
 * @class org.appcelerator.titanium.view.TiUIView
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html}
 **/
var TiUIView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.view.TiUIView')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: org.appcelerator.titanium.view.TiUIView. Create a subclass using org.appcelerator.titanium.view.TiUIView.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiUIView.prototype = Object.create(SuperClass.prototype);
TiUIView.prototype.constructor = TiUIView;

Object.defineProperty(TiUIView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiUIView(this.$native.super);
	},
	enumerable: true
});

TiUIView.className = 'org.appcelerator.titanium.view.TiUIView';
TiUIView.prototype.className = 'org.appcelerator.titanium.view.TiUIView';

// class property
Object.defineProperty(TiUIView, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.view.TiUIView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiUIView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.view.TiUIView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiUIView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiUIView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiUIView(Hyperloop.cast('org.appcelerator.titanium.view.TiUIView', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_SLIDE_RIGHT}
 */
TiUIView.TRANSITION_SLIDE_RIGHT = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#SOFT_KEYBOARD_SHOW_ON_FOCUS}
 */
TiUIView.SOFT_KEYBOARD_SHOW_ON_FOCUS = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_NONE}
 */
TiUIView.TRANSITION_NONE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_CHANGE_BOUNDS}
 */
TiUIView.TRANSITION_CHANGE_BOUNDS = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_CHANGE_TRANSFORM}
 */
TiUIView.TRANSITION_CHANGE_TRANSFORM = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_FADE_IN}
 */
TiUIView.TRANSITION_FADE_IN = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#SOFT_KEYBOARD_DEFAULT_ON_FOCUS}
 */
TiUIView.SOFT_KEYBOARD_DEFAULT_ON_FOCUS = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_EXPLODE}
 */
TiUIView.TRANSITION_EXPLODE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#SOFT_KEYBOARD_HIDE_ON_FOCUS}
 */
TiUIView.SOFT_KEYBOARD_HIDE_ON_FOCUS = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_CHANGE_IMAGE_TRANSFORM}
 */
TiUIView.TRANSITION_CHANGE_IMAGE_TRANSFORM = 11;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_SLIDE_TOP}
 */
TiUIView.TRANSITION_SLIDE_TOP = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_SLIDE_LEFT}
 */
TiUIView.TRANSITION_SLIDE_LEFT = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_CHANGE_CLIP_BOUNDS}
 */
TiUIView.TRANSITION_CHANGE_CLIP_BOUNDS = 9;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_FADE_OUT}
 */
TiUIView.TRANSITION_FADE_OUT = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#TRANSITION_SLIDE_BOTTOM}
 */
TiUIView.TRANSITION_SLIDE_BOTTOM = 6;

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#parent
Object.defineProperty(TiUIView.prototype, 'parent', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('parent');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('parent', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#additionalEventData
Object.defineProperty(TiUIView.prototype, 'additionalEventData', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('additionalEventData');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('additionalEventData', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#children
Object.defineProperty(TiUIView.prototype, 'children', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('children');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('children', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#layoutParams
Object.defineProperty(TiUIView.prototype, 'layoutParams', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('layoutParams');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('layoutParams', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#nativeView
Object.defineProperty(TiUIView.prototype, 'nativeView', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('nativeView');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('nativeView', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#lastUpEvent
Object.defineProperty(TiUIView.prototype, 'lastUpEvent', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('lastUpEvent');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('lastUpEvent', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#animBuilder
Object.defineProperty(TiUIView.prototype, 'animBuilder', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('animBuilder');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('animBuilder', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#proxy
Object.defineProperty(TiUIView.prototype, 'proxy', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('proxy');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('proxy', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#background
Object.defineProperty(TiUIView.prototype, 'background', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('background');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('background', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#borderView
Object.defineProperty(TiUIView.prototype, 'borderView', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('borderView');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('borderView', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#detector
Object.defineProperty(TiUIView.prototype, 'detector', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('detector');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
				return new TiUIView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('detector', newValue);
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function composeContentDescription
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#composeContentDescription(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.composeContentDescription = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'composeContentDescription',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function allowRegisterForKeyPress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#allowRegisterForKeyPress()}
 **/
TiUIView.prototype.allowRegisterForKeyPress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allowRegisterForKeyPress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function release
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#release()}
 **/
TiUIView.prototype.release = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'release',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#fireEvent(java.lang.String, org.appcelerator.kroll.KrollDict)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#fireEvent(java.lang.String, org.appcelerator.kroll.KrollDict, boolean)}
 **/
TiUIView.prototype.fireEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fireEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function insertAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#insertAt(org.appcelerator.titanium.view.TiUIView, int)}
 **/
TiUIView.prototype.insertAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'insertAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnLongClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setOnLongClickListener(android.view.View)}
 **/
TiUIView.prototype.setOnLongClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnLongClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function focus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#focus()}
 **/
TiUIView.prototype.focus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'focus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function processProperties
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#processProperties(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.processProperties = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'processProperties',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setzIndexChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setzIndexChanged(boolean)}
 **/
TiUIView.prototype.setzIndexChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setzIndexChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function animate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#animate()}
 **/
TiUIView.prototype.animate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'animate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOuterView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getOuterView()}
 **/
TiUIView.prototype.getOuterView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOuterView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAnimatedRotationDegrees
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setAnimatedRotationDegrees(float)}
 **/
TiUIView.prototype.setAnimatedRotationDegrees = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAnimatedRotationDegrees',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNativeView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getNativeView()}
 **/
TiUIView.prototype.getNativeView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNativeView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function allowRegisterForTouch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#allowRegisterForTouch()}
 **/
TiUIView.prototype.allowRegisterForTouch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allowRegisterForTouch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerForTouch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerForTouch()}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerForTouch(android.view.View)}
 **/
TiUIView.prototype.registerForTouch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerForTouch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasBorder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#hasBorder(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.hasBorder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasBorder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIMM
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getIMM()}
 **/
TiUIView.prototype.getIMM = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIMM',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function resort
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#resort()}
 **/
TiUIView.prototype.resort = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resort',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function forceLayoutNativeView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#forceLayoutNativeView(boolean)}
 **/
TiUIView.prototype.forceLayoutNativeView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'forceLayoutNativeView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isLayoutPending
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#isLayoutPending()}
 **/
TiUIView.prototype.isLayoutPending = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLayoutPending',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAdditionalEventData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setAdditionalEventData(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.setAdditionalEventData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAdditionalEventData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function add
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#add(org.appcelerator.titanium.view.TiUIView)}
 **/
TiUIView.prototype.add = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'add',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function listenerAdded
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#listenerAdded(java.lang.String, int, org.appcelerator.kroll.KrollProxy)}
 **/
TiUIView.prototype.listenerAdded = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'listenerAdded',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAdditionalEventData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getAdditionalEventData()}
 **/
TiUIView.prototype.getAdditionalEventData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAdditionalEventData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setProxy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setProxy(org.appcelerator.titanium.proxy.TiViewProxy)}
 **/
TiUIView.prototype.setProxy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setProxy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setAlpha(android.view.View, float)}
 **/
TiUIView.prototype.setAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFocused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#isFocused()}
 **/
TiUIView.prototype.isFocused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFocused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnimatedRotationDegrees
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getAnimatedRotationDegrees()}
 **/
TiUIView.prototype.getAnimatedRotationDegrees = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnimatedRotationDegrees',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyContentDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#applyContentDescription()}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#applyContentDescription(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.applyContentDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyContentDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChildren
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getChildren()}
 **/
TiUIView.prototype.getChildren = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChildren',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setOnClickListener(android.view.View)}
 **/
TiUIView.prototype.setOnClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setNativeView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setNativeView(android.view.View)}
 **/
TiUIView.prototype.setNativeView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setNativeView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function listenerRemoved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#listenerRemoved(java.lang.String, int, org.appcelerator.kroll.KrollProxy)}
 **/
TiUIView.prototype.listenerRemoved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'listenerRemoved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnimatedScaleValues
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getAnimatedScaleValues()}
 **/
TiUIView.prototype.getAnimatedScaleValues = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnimatedScaleValues',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerTouchEvents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerTouchEvents(android.view.View)}
 **/
TiUIView.prototype.registerTouchEvents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerTouchEvents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function disableHWAcceleration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#disableHWAcceleration()}
 **/
TiUIView.prototype.disableHWAcceleration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'disableHWAcceleration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAnimatedAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setAnimatedAlpha(float)}
 **/
TiUIView.prototype.setAnimatedAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAnimatedAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getProxy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getProxy()}
 **/
TiUIView.prototype.getProxy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getProxy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasGradient
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#hasGradient(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.hasGradient = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasGradient',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startTransformAfterLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#startTransformAfterLayout(android.view.View)}
 **/
TiUIView.prototype.startTransformAfterLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startTransformAfterLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPreTranslationValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getPreTranslationValue(float[])}
 **/
TiUIView.prototype.getPreTranslationValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPreTranslationValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onFocusChange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#onFocusChange(android.view.View, boolean)}
 **/
TiUIView.prototype.onFocusChange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onFocusChange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function show
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#show()}
 **/
TiUIView.prototype.show = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'show',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireSyncEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#fireSyncEvent(java.lang.String, org.appcelerator.kroll.KrollDict)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#fireSyncEvent(java.lang.String, org.appcelerator.kroll.KrollDict, boolean)}
 **/
TiUIView.prototype.fireSyncEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fireSyncEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function blur
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#blur()}
 **/
TiUIView.prototype.blur = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'blur',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasImage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#hasImage(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.hasImage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasImage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function iszIndexChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#iszIndexChanged()}
 **/
TiUIView.prototype.iszIndexChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'iszIndexChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#remove(org.appcelerator.titanium.view.TiUIView)}
 **/
TiUIView.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setLayoutParams(org.appcelerator.titanium.view.TiCompositeLayout$LayoutParams)}
 **/
TiUIView.prototype.setLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toImage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#toImage()}
 **/
TiUIView.prototype.toImage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toImage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setParent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setParent(org.appcelerator.titanium.proxy.TiViewProxy)}
 **/
TiUIView.prototype.setParent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setParent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerForKeyPress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerForKeyPress()}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerForKeyPress(android.view.View)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerForKeyPress(android.view.View, boolean)}
 **/
TiUIView.prototype.registerForKeyPress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerForKeyPress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function layoutNativeView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#layoutNativeView()}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#layoutNativeView(boolean)}
 **/
TiUIView.prototype.layoutNativeView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'layoutNativeView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getParent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getParent()}
 **/
TiUIView.prototype.getParent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getParent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasColorState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#hasColorState(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.hasColorState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasColorState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnimatedAlpha
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getAnimatedAlpha()}
 **/
TiUIView.prototype.getAnimatedAlpha = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnimatedAlpha',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function composeContentDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#composeContentDescription()}
 **/
TiUIView.prototype.composeContentDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'composeContentDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function propertiesChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#propertiesChanged(java.util.List, org.appcelerator.kroll.KrollProxy)}
 **/
TiUIView.prototype.propertiesChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'propertiesChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyTransform
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#applyTransform(org.appcelerator.titanium.view.Ti2DMatrix)}
 **/
TiUIView.prototype.applyTransform = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyTransform',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function canApplyTouchFeedback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#canApplyTouchFeedback(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.canApplyTouchFeedback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canApplyTouchFeedback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAnimatedScaleValues
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setAnimatedScaleValues(android.util.Pair)}
 **/
TiUIView.prototype.setAnimatedScaleValues = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAnimatedScaleValues',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLastUpEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getLastUpEvent()}
 **/
TiUIView.prototype.getLastUpEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLastUpEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dictFromEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#dictFromEvent(android.view.MotionEvent)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#dictFromEvent(org.appcelerator.kroll.KrollDict)}
 **/
TiUIView.prototype.dictFromEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dictFromEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function propertyChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#propertyChanged(java.lang.String, java.lang.Object, java.lang.Object, org.appcelerator.kroll.KrollProxy)}
 **/
TiUIView.prototype.propertyChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'propertyChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFocusEventObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getFocusEventObject(boolean)}
 **/
TiUIView.prototype.getFocusEventObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFocusEventObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hide
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#hide()}
 **/
TiUIView.prototype.hide = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hide',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clearOpacity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#clearOpacity(android.view.View)}
 **/
TiUIView.prototype.clearOpacity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clearOpacity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getLayoutParams()}
 **/
TiUIView.prototype.getLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerForKeyPressEvents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#registerForKeyPressEvents(android.view.View)}
 **/
TiUIView.prototype.registerForKeyPressEvents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerForKeyPressEvents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBackground
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getBackground()}
 **/
TiUIView.prototype.getBackground = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBackground',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNativeContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#getNativeContentView()}
 **/
TiUIView.prototype.getNativeContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNativeContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOpacity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setOpacity(float)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/view/TiUIView.html#setOpacity(android.view.View, float)}
 **/
TiUIView.prototype.setOpacity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOpacity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.view.TiUIView') {
			return new TiUIView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiUIView;
