/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.json.JSONObject
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.json');

/**
 * @class org.json.JSONObject
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html}
 **/
var JSONObject = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.json.JSONObject')) {
		result = arguments[0];
	}
	else {
		result = JSONObject.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
JSONObject.prototype = Object.create(SuperClass.prototype);
JSONObject.prototype.constructor = JSONObject;

Object.defineProperty(JSONObject.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new JSONObject(this.$native.super);
	},
	enumerable: true
});

JSONObject.className = 'org.json.JSONObject';
JSONObject.prototype.className = 'org.json.JSONObject';

// class property
Object.defineProperty(JSONObject, 'class', {
	get: function() {
		return Hyperloop.getClass('org.json.JSONObject');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
JSONObject.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.json.JSONObject');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(JSONObject.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
JSONObject.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new JSONObject(Hyperloop.cast('org.json.JSONObject', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(JSONObject, 'Null', {
	get: function() {
		return require('./org.json.JSONObject$Null');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/org/json/JSONObject.html#NULL
Object.defineProperty(JSONObject, 'NULL', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('NULL');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.json.JSONObject') {
				return new JSONObject(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function doubleToString
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#doubleToString(double)}
 **/
JSONObject.doubleToString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'doubleToString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNames
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getNames(org.json.JSONObject)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getNames(java.lang.Object)}
 **/
JSONObject.getNames = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getNames',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function valueToString
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#valueToString(java.lang.Object)}
 **/
JSONObject.valueToString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueToString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function quote
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#quote(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#quote(java.lang.String, java.io.Writer)}
 **/
JSONObject.quote = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'quote',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function stringToValue
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#stringToValue(java.lang.String)}
 **/
JSONObject.stringToValue = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'stringToValue',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function numberToString
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#numberToString(java.lang.Number)}
 **/
JSONObject.numberToString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'numberToString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function testValidity
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#testValidity(java.lang.Object)}
 **/
JSONObject.testValidity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'testValidity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function wrap
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#wrap(java.lang.Object)}
 **/
JSONObject.wrap = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'wrap',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function toJSONArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#toJSONArray(org.json.JSONArray)}
 **/
JSONObject.prototype.toJSONArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toJSONArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function keys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#keys()}
 **/
JSONObject.prototype.keys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'keys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getDouble(java.lang.String)}
 **/
JSONObject.prototype.getDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function increment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#increment(java.lang.String)}
 **/
JSONObject.prototype.increment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'increment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function put
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, boolean)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, java.util.Collection)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, double)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, long)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, java.util.Map)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#put(java.lang.String, java.lang.Object)}
 **/
JSONObject.prototype.put = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'put',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#remove(java.lang.String)}
 **/
JSONObject.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getJSONArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getJSONArray(java.lang.String)}
 **/
JSONObject.prototype.getJSONArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getJSONArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optBoolean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optBoolean(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optBoolean(java.lang.String, boolean)}
 **/
JSONObject.prototype.optBoolean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optBoolean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#get(java.lang.String)}
 **/
JSONObject.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optString(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optString(java.lang.String, java.lang.String)}
 **/
JSONObject.prototype.optString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function accumulate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#accumulate(java.lang.String, java.lang.Object)}
 **/
JSONObject.prototype.accumulate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'accumulate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putOnce
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#putOnce(java.lang.String, java.lang.Object)}
 **/
JSONObject.prototype.putOnce = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putOnce',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoolean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getBoolean(java.lang.String)}
 **/
JSONObject.prototype.getBoolean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoolean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function has
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#has(java.lang.String)}
 **/
JSONObject.prototype.has = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'has',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function keySet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#keySet()}
 **/
JSONObject.prototype.keySet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'keySet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function write
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#write(java.io.Writer)}
 **/
JSONObject.prototype.write = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'write',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putOpt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#putOpt(java.lang.String, java.lang.Object)}
 **/
JSONObject.prototype.putOpt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putOpt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optJSONObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optJSONObject(java.lang.String)}
 **/
JSONObject.prototype.optJSONObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optJSONObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function length
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#length()}
 **/
JSONObject.prototype.length = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'length',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getString(java.lang.String)}
 **/
JSONObject.prototype.getString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optJSONArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optJSONArray(java.lang.String)}
 **/
JSONObject.prototype.optJSONArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optJSONArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getLong(java.lang.String)}
 **/
JSONObject.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getInt(java.lang.String)}
 **/
JSONObject.prototype.getInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function opt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#opt(java.lang.String)}
 **/
JSONObject.prototype.opt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'opt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function names
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#names()}
 **/
JSONObject.prototype.names = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'names',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optInt(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optInt(java.lang.String, int)}
 **/
JSONObject.prototype.optInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optLong(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optLong(java.lang.String, long)}
 **/
JSONObject.prototype.optLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isNull
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#isNull(java.lang.String)}
 **/
JSONObject.prototype.isNull = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNull',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#toString()}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#toString(int)}
 **/
JSONObject.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optDouble(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#optDouble(java.lang.String, double)}
 **/
JSONObject.prototype.optDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function append
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#append(java.lang.String, java.lang.Object)}
 **/
JSONObject.prototype.append = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'append',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getJSONObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONObject.html#getJSONObject(java.lang.String)}
 **/
JSONObject.prototype.getJSONObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getJSONObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONObject') {
			return new JSONObject(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = JSONObject;
