/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.json.JSONTokener
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.json');

/**
 * @class org.json.JSONTokener
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html}
 **/
var JSONTokener = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.json.JSONTokener')) {
		result = arguments[0];
	}
	else {
		result = JSONTokener.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
JSONTokener.prototype = Object.create(SuperClass.prototype);
JSONTokener.prototype.constructor = JSONTokener;

Object.defineProperty(JSONTokener.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new JSONTokener(this.$native.super);
	},
	enumerable: true
});

JSONTokener.className = 'org.json.JSONTokener';
JSONTokener.prototype.className = 'org.json.JSONTokener';

// class property
Object.defineProperty(JSONTokener, 'class', {
	get: function() {
		return Hyperloop.getClass('org.json.JSONTokener');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
JSONTokener.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.json.JSONTokener');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(JSONTokener.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
JSONTokener.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new JSONTokener(Hyperloop.cast('org.json.JSONTokener', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function dehexchar
 * @static
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#dehexchar(char)}
 **/
JSONTokener.dehexchar = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'dehexchar',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function next
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#next()}
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#next(char)}
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#next(int)}
 **/
JSONTokener.prototype.next = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'next',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function syntaxError
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#syntaxError(java.lang.String)}
 **/
JSONTokener.prototype.syntaxError = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'syntaxError',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function more
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#more()}
 **/
JSONTokener.prototype.more = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'more',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function skipTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#skipTo(char)}
 **/
JSONTokener.prototype.skipTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'skipTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function back
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#back()}
 **/
JSONTokener.prototype.back = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'back',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextClean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#nextClean()}
 **/
JSONTokener.prototype.nextClean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextClean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#nextString(char)}
 **/
JSONTokener.prototype.nextString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#nextTo(char)}
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#nextTo(java.lang.String)}
 **/
JSONTokener.prototype.nextTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function end
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#end()}
 **/
JSONTokener.prototype.end = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'end',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#toString()}
 **/
JSONTokener.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONTokener.html#nextValue()}
 **/
JSONTokener.prototype.nextValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONTokener') {
			return new JSONTokener(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = JSONTokener;
