/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ti.modules.titanium.stream.FileStreamProxy
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./ti.modules.titanium.stream');

/**
 * @class ti.modules.titanium.stream.FileStreamProxy
 * @extends org.appcelerator.kroll.KrollProxy 
 * @constructor
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html}
 **/
var FileStreamProxy = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('ti.modules.titanium.stream.FileStreamProxy')) {
		result = arguments[0];
	}
	else {
		result = FileStreamProxy.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.kroll.KrollProxy');
FileStreamProxy.prototype = Object.create(SuperClass.prototype);
FileStreamProxy.prototype.constructor = FileStreamProxy;

Object.defineProperty(FileStreamProxy.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FileStreamProxy(this.$native.super);
	},
	enumerable: true
});

FileStreamProxy.className = 'ti.modules.titanium.stream.FileStreamProxy';
FileStreamProxy.prototype.className = 'ti.modules.titanium.stream.FileStreamProxy';

// class property
Object.defineProperty(FileStreamProxy, 'class', {
	get: function() {
		return Hyperloop.getClass('ti.modules.titanium.stream.FileStreamProxy');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FileStreamProxy.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('ti.modules.titanium.stream.FileStreamProxy');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FileStreamProxy.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FileStreamProxy.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FileStreamProxy(Hyperloop.cast('ti.modules.titanium.stream.FileStreamProxy', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function read
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#read(java.lang.Object[])}
 **/
FileStreamProxy.prototype.read = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'read',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeSync
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#writeSync(java.lang.Object, int, int)}
 **/
FileStreamProxy.prototype.writeSync = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeSync',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApiName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#getApiName()}
 **/
FileStreamProxy.prototype.getApiName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApiName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function readSync
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#readSync(java.lang.Object, int, int)}
 **/
FileStreamProxy.prototype.readSync = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readSync',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isWritable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#isWritable()}
 **/
FileStreamProxy.prototype.isWritable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWritable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function write
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#write(java.lang.Object[])}
 **/
FileStreamProxy.prototype.write = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'write',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isReadable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#isReadable()}
 **/
FileStreamProxy.prototype.isReadable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isReadable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/ti/modules/titanium/stream/FileStreamProxy.html#close()}
 **/
FileStreamProxy.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'ti.modules.titanium.stream.FileStreamProxy') {
			return new FileStreamProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FileStreamProxy;
