/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.app.ActivityManager$ProcessErrorStateInfo
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.app.ActivityManager');

/**
 * @class android.app.ActivityManager$ProcessErrorStateInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html}
 **/
var ProcessErrorStateInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.app.ActivityManager$ProcessErrorStateInfo')) {
		result = arguments[0];
	}
	else {
		result = ProcessErrorStateInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ProcessErrorStateInfo.prototype = Object.create(SuperClass.prototype);
ProcessErrorStateInfo.prototype.constructor = ProcessErrorStateInfo;

Object.defineProperty(ProcessErrorStateInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ProcessErrorStateInfo(this.$native.super);
	},
	enumerable: true
});

ProcessErrorStateInfo.className = 'android.app.ActivityManager$ProcessErrorStateInfo';
ProcessErrorStateInfo.prototype.className = 'android.app.ActivityManager$ProcessErrorStateInfo';

// class property
Object.defineProperty(ProcessErrorStateInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.app.ActivityManager$ProcessErrorStateInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ProcessErrorStateInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.app.ActivityManager$ProcessErrorStateInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ProcessErrorStateInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ProcessErrorStateInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ProcessErrorStateInfo(Hyperloop.cast('android.app.ActivityManager$ProcessErrorStateInfo', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#NOT_RESPONDING}
 */
ProcessErrorStateInfo.NOT_RESPONDING = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#CRASHED}
 */
ProcessErrorStateInfo.CRASHED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#NO_ERROR}
 */
ProcessErrorStateInfo.NO_ERROR = 0;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#CREATOR
Object.defineProperty(ProcessErrorStateInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#crashData
Object.defineProperty(ProcessErrorStateInfo.prototype, 'crashData', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('crashData');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('crashData', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#pid
Object.defineProperty(ProcessErrorStateInfo.prototype, 'pid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('pid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('pid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#longMsg
Object.defineProperty(ProcessErrorStateInfo.prototype, 'longMsg', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('longMsg');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('longMsg', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#shortMsg
Object.defineProperty(ProcessErrorStateInfo.prototype, 'shortMsg', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('shortMsg');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('shortMsg', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#uid
Object.defineProperty(ProcessErrorStateInfo.prototype, 'uid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('uid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('uid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#condition
Object.defineProperty(ProcessErrorStateInfo.prototype, 'condition', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('condition');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('condition', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#processName
Object.defineProperty(ProcessErrorStateInfo.prototype, 'processName', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('processName');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('processName', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#stackTrace
Object.defineProperty(ProcessErrorStateInfo.prototype, 'stackTrace', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('stackTrace');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('stackTrace', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#tag
Object.defineProperty(ProcessErrorStateInfo.prototype, 'tag', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('tag');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
				return new ProcessErrorStateInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('tag', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function readFromParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#readFromParcel(android.os.Parcel)}
 **/
ProcessErrorStateInfo.prototype.readFromParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readFromParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
			return new ProcessErrorStateInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#describeContents()}
 **/
ProcessErrorStateInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
			return new ProcessErrorStateInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.ProcessErrorStateInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
ProcessErrorStateInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$ProcessErrorStateInfo') {
			return new ProcessErrorStateInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ProcessErrorStateInfo;
