/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.app.ActivityManager$RunningAppProcessInfo
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.app.ActivityManager');

/**
 * @class android.app.ActivityManager$RunningAppProcessInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html}
 **/
var RunningAppProcessInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.app.ActivityManager$RunningAppProcessInfo')) {
		result = arguments[0];
	}
	else {
		result = RunningAppProcessInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
RunningAppProcessInfo.prototype = Object.create(SuperClass.prototype);
RunningAppProcessInfo.prototype.constructor = RunningAppProcessInfo;

Object.defineProperty(RunningAppProcessInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new RunningAppProcessInfo(this.$native.super);
	},
	enumerable: true
});

RunningAppProcessInfo.className = 'android.app.ActivityManager$RunningAppProcessInfo';
RunningAppProcessInfo.prototype.className = 'android.app.ActivityManager$RunningAppProcessInfo';

// class property
Object.defineProperty(RunningAppProcessInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.app.ActivityManager$RunningAppProcessInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
RunningAppProcessInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.app.ActivityManager$RunningAppProcessInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(RunningAppProcessInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
RunningAppProcessInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new RunningAppProcessInfo(Hyperloop.cast('android.app.ActivityManager$RunningAppProcessInfo', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_PERCEPTIBLE}
 */
RunningAppProcessInfo.IMPORTANCE_PERCEPTIBLE = 230;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_FOREGROUND_SERVICE}
 */
RunningAppProcessInfo.IMPORTANCE_FOREGROUND_SERVICE = 125;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_SERVICE}
 */
RunningAppProcessInfo.IMPORTANCE_SERVICE = 300;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_CACHED}
 */
RunningAppProcessInfo.IMPORTANCE_CACHED = 400;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_TOP_SLEEPING}
 */
RunningAppProcessInfo.IMPORTANCE_TOP_SLEEPING = 325;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_VISIBLE}
 */
RunningAppProcessInfo.IMPORTANCE_VISIBLE = 200;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#REASON_PROVIDER_IN_USE}
 */
RunningAppProcessInfo.REASON_PROVIDER_IN_USE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_CANT_SAVE_STATE}
 */
RunningAppProcessInfo.IMPORTANCE_CANT_SAVE_STATE = 350;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#REASON_UNKNOWN}
 */
RunningAppProcessInfo.REASON_UNKNOWN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_EMPTY}
 */
RunningAppProcessInfo.IMPORTANCE_EMPTY = 500;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_BACKGROUND}
 */
RunningAppProcessInfo.IMPORTANCE_BACKGROUND = 400;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_FOREGROUND}
 */
RunningAppProcessInfo.IMPORTANCE_FOREGROUND = 100;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_GONE}
 */
RunningAppProcessInfo.IMPORTANCE_GONE = 1000;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_TOP_SLEEPING_PRE_28}
 */
RunningAppProcessInfo.IMPORTANCE_TOP_SLEEPING_PRE_28 = 150;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#REASON_SERVICE_IN_USE}
 */
RunningAppProcessInfo.REASON_SERVICE_IN_USE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#IMPORTANCE_PERCEPTIBLE_PRE_26}
 */
RunningAppProcessInfo.IMPORTANCE_PERCEPTIBLE_PRE_26 = 130;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#CREATOR
Object.defineProperty(RunningAppProcessInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#importance
Object.defineProperty(RunningAppProcessInfo.prototype, 'importance', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('importance');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('importance', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#pid
Object.defineProperty(RunningAppProcessInfo.prototype, 'pid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('pid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('pid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#importanceReasonCode
Object.defineProperty(RunningAppProcessInfo.prototype, 'importanceReasonCode', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('importanceReasonCode');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('importanceReasonCode', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#importanceReasonComponent
Object.defineProperty(RunningAppProcessInfo.prototype, 'importanceReasonComponent', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('importanceReasonComponent');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('importanceReasonComponent', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#uid
Object.defineProperty(RunningAppProcessInfo.prototype, 'uid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('uid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('uid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#processName
Object.defineProperty(RunningAppProcessInfo.prototype, 'processName', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('processName');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('processName', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#importanceReasonPid
Object.defineProperty(RunningAppProcessInfo.prototype, 'importanceReasonPid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('importanceReasonPid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('importanceReasonPid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#pkgList
Object.defineProperty(RunningAppProcessInfo.prototype, 'pkgList', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('pkgList');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('pkgList', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#lastTrimLevel
Object.defineProperty(RunningAppProcessInfo.prototype, 'lastTrimLevel', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('lastTrimLevel');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('lastTrimLevel', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#lru
Object.defineProperty(RunningAppProcessInfo.prototype, 'lru', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('lru');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
				return new RunningAppProcessInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('lru', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function readFromParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#readFromParcel(android.os.Parcel)}
 **/
RunningAppProcessInfo.prototype.readFromParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readFromParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
			return new RunningAppProcessInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#describeContents()}
 **/
RunningAppProcessInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
			return new RunningAppProcessInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningAppProcessInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
RunningAppProcessInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$RunningAppProcessInfo') {
			return new RunningAppProcessInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = RunningAppProcessInfo;
