/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.app.ActivityManager$RunningServiceInfo
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.app.ActivityManager');

/**
 * @class android.app.ActivityManager$RunningServiceInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html}
 **/
var RunningServiceInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.app.ActivityManager$RunningServiceInfo')) {
		result = arguments[0];
	}
	else {
		result = RunningServiceInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
RunningServiceInfo.prototype = Object.create(SuperClass.prototype);
RunningServiceInfo.prototype.constructor = RunningServiceInfo;

Object.defineProperty(RunningServiceInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new RunningServiceInfo(this.$native.super);
	},
	enumerable: true
});

RunningServiceInfo.className = 'android.app.ActivityManager$RunningServiceInfo';
RunningServiceInfo.prototype.className = 'android.app.ActivityManager$RunningServiceInfo';

// class property
Object.defineProperty(RunningServiceInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.app.ActivityManager$RunningServiceInfo');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
RunningServiceInfo.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.app.ActivityManager$RunningServiceInfo');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(RunningServiceInfo.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
RunningServiceInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new RunningServiceInfo(Hyperloop.cast('android.app.ActivityManager$RunningServiceInfo', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#FLAG_FOREGROUND}
 */
RunningServiceInfo.FLAG_FOREGROUND = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#FLAG_PERSISTENT_PROCESS}
 */
RunningServiceInfo.FLAG_PERSISTENT_PROCESS = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#FLAG_STARTED}
 */
RunningServiceInfo.FLAG_STARTED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#FLAG_SYSTEM_PROCESS}
 */
RunningServiceInfo.FLAG_SYSTEM_PROCESS = 4;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#CREATOR
Object.defineProperty(RunningServiceInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#process
Object.defineProperty(RunningServiceInfo.prototype, 'process', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('process');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('process', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#restarting
Object.defineProperty(RunningServiceInfo.prototype, 'restarting', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('restarting');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('restarting', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#flags
Object.defineProperty(RunningServiceInfo.prototype, 'flags', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('flags');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('flags', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#clientPackage
Object.defineProperty(RunningServiceInfo.prototype, 'clientPackage', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('clientPackage');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('clientPackage', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#pid
Object.defineProperty(RunningServiceInfo.prototype, 'pid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('pid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('pid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#started
Object.defineProperty(RunningServiceInfo.prototype, 'started', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('started');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('started', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#foreground
Object.defineProperty(RunningServiceInfo.prototype, 'foreground', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('foreground');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('foreground', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#uid
Object.defineProperty(RunningServiceInfo.prototype, 'uid', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('uid');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('uid', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#activeSince
Object.defineProperty(RunningServiceInfo.prototype, 'activeSince', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('activeSince');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('activeSince', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#crashCount
Object.defineProperty(RunningServiceInfo.prototype, 'crashCount', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('crashCount');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('crashCount', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#service
Object.defineProperty(RunningServiceInfo.prototype, 'service', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('service');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('service', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#clientLabel
Object.defineProperty(RunningServiceInfo.prototype, 'clientLabel', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('clientLabel');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('clientLabel', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#lastActivityTime
Object.defineProperty(RunningServiceInfo.prototype, 'lastActivityTime', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('lastActivityTime');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('lastActivityTime', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#clientCount
Object.defineProperty(RunningServiceInfo.prototype, 'clientCount', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('clientCount');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
				return new RunningServiceInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('clientCount', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function readFromParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#readFromParcel(android.os.Parcel)}
 **/
RunningServiceInfo.prototype.readFromParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'readFromParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
			return new RunningServiceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#describeContents()}
 **/
RunningServiceInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
			return new RunningServiceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/app/ActivityManager.RunningServiceInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
RunningServiceInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.app.ActivityManager$RunningServiceInfo') {
			return new RunningServiceInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = RunningServiceInfo;
