/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.RecordingCanvas
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics');

/**
 * @class android.graphics.RecordingCanvas
 * @extends android.graphics.Canvas 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html}
 **/
var RecordingCanvas = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.RecordingCanvas')) {
		result = arguments[0];
	}
	else {
		result = RecordingCanvas.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.graphics.Canvas');
RecordingCanvas.prototype = Object.create(SuperClass.prototype);
RecordingCanvas.prototype.constructor = RecordingCanvas;

Object.defineProperty(RecordingCanvas.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new RecordingCanvas(this.$native.super);
	},
	enumerable: true
});

RecordingCanvas.className = 'android.graphics.RecordingCanvas';
RecordingCanvas.prototype.className = 'android.graphics.RecordingCanvas';

// class property
Object.defineProperty(RecordingCanvas, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.RecordingCanvas');
	},
	enumerable: true,
	configurable: false
});


// Cast
RecordingCanvas.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new RecordingCanvas(Hyperloop.cast('android.graphics.RecordingCanvas', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function drawTextOnPath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawTextOnPath(char[], int, int, android.graphics.Path, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawTextOnPath(java.lang.String, android.graphics.Path, float, float, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawTextOnPath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawTextOnPath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPosText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPosText(char[], int, int, float[], android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPosText(java.lang.String, float[], android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawPosText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPosText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawOval
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawOval(float, float, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawOval(android.graphics.RectF, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawOval = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawOval',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawDoubleRoundRect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawDoubleRoundRect(android.graphics.RectF, float, float, android.graphics.RectF, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawDoubleRoundRect(android.graphics.RectF, float[], android.graphics.RectF, float[], android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawDoubleRoundRect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawDoubleRoundRect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOpaque
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#isOpaque()}
 **/
RecordingCanvas.prototype.isOpaque = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOpaque',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPoint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPoint(float, float, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawPoint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPoint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPatch
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPatch(android.graphics.NinePatch, android.graphics.Rect, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPatch(android.graphics.NinePatch, android.graphics.RectF, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawPatch = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPatch',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawRenderNode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRenderNode(android.graphics.RenderNode)}
 **/
RecordingCanvas.prototype.drawRenderNode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawRenderNode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#getWidth()}
 **/
RecordingCanvas.prototype.getWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawBitmap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmap(android.graphics.Bitmap, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmap(android.graphics.Bitmap, android.graphics.Matrix, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmap(android.graphics.Bitmap, android.graphics.Rect, android.graphics.Rect, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmap(android.graphics.Bitmap, android.graphics.Rect, android.graphics.RectF, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmap(int[], int, int, float, float, int, int, boolean, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmap(int[], int, int, int, int, int, int, boolean, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawBitmap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawBitmap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawColor(int)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawColor(int, android.graphics.PorterDuff$Mode)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawColor(int, android.graphics.BlendMode)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawColor(long, android.graphics.BlendMode)}
 **/
RecordingCanvas.prototype.drawColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#getHeight()}
 **/
RecordingCanvas.prototype.getHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function disableZ
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#disableZ()}
 **/
RecordingCanvas.prototype.disableZ = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'disableZ',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPoints
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPoints(float[], int, int, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPoints(float[], android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawPoints = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPoints',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawRoundRect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRoundRect(float, float, float, float, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRoundRect(android.graphics.RectF, float, float, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawRoundRect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawRoundRect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPaint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPaint(android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawPaint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPaint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawBitmapMesh
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawBitmapMesh(android.graphics.Bitmap, int, int, float[], int, int[], int, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawBitmapMesh = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawBitmapMesh',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawTextRun
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawTextRun(char[], int, int, int, int, float, float, boolean, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawTextRun(java.lang.CharSequence, int, int, int, int, float, float, boolean, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawTextRun(android.graphics.text.MeasuredText, int, int, int, int, float, float, boolean, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawTextRun = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawTextRun',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawCircle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawCircle(float, float, float, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawCircle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawCircle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawText(char[], int, int, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawText(java.lang.CharSequence, int, int, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawText(java.lang.String, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawText(java.lang.String, int, int, float, float, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawArc
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawArc(float, float, float, float, float, float, boolean, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawArc(android.graphics.RectF, float, float, boolean, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawArc = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawArc',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawLine
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawLine(float, float, float, float, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawLine = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawLine',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawVertices
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawVertices(android.graphics.Canvas$VertexMode, int, float[], int, float[], int, int[], int, short[], int, int, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawVertices = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawVertices',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawRGB
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRGB(int, int, int)}
 **/
RecordingCanvas.prototype.drawRGB = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawRGB',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDensity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#setDensity(int)}
 **/
RecordingCanvas.prototype.setDensity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDensity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBitmap
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#setBitmap(android.graphics.Bitmap)}
 **/
RecordingCanvas.prototype.setBitmap = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBitmap',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawLines
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawLines(float[], int, int, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawLines(float[], android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawLines = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawLines',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMaximumBitmapHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#getMaximumBitmapHeight()}
 **/
RecordingCanvas.prototype.getMaximumBitmapHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaximumBitmapHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPicture
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPicture(android.graphics.Picture)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPicture(android.graphics.Picture, android.graphics.Rect)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPicture(android.graphics.Picture, android.graphics.RectF)}
 **/
RecordingCanvas.prototype.drawPicture = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPicture',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isHardwareAccelerated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#isHardwareAccelerated()}
 **/
RecordingCanvas.prototype.isHardwareAccelerated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isHardwareAccelerated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function enableZ
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#enableZ()}
 **/
RecordingCanvas.prototype.enableZ = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'enableZ',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMaximumBitmapWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#getMaximumBitmapWidth()}
 **/
RecordingCanvas.prototype.getMaximumBitmapWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaximumBitmapWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawARGB
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawARGB(int, int, int, int)}
 **/
RecordingCanvas.prototype.drawARGB = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawARGB',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawPath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawPath(android.graphics.Path, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawPath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawPath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function drawRect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRect(float, float, float, float, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRect(android.graphics.Rect, android.graphics.Paint)}
 * @see {@link http://developer.android.com/reference/android/graphics/RecordingCanvas.html#drawRect(android.graphics.RectF, android.graphics.Paint)}
 **/
RecordingCanvas.prototype.drawRect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'drawRect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.RecordingCanvas') {
			return new RecordingCanvas(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = RecordingCanvas;
