/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.graphics.text.MeasuredText
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.graphics.text');

/**
 * @class android.graphics.text.MeasuredText
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/graphics/text/MeasuredText.html}
 **/
var MeasuredText = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.graphics.text.MeasuredText')) {
		result = arguments[0];
	}
	else {
		result = MeasuredText.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MeasuredText.prototype = Object.create(SuperClass.prototype);
MeasuredText.prototype.constructor = MeasuredText;

Object.defineProperty(MeasuredText.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MeasuredText(this.$native.super);
	},
	enumerable: true
});

MeasuredText.className = 'android.graphics.text.MeasuredText';
MeasuredText.prototype.className = 'android.graphics.text.MeasuredText';

// class property
Object.defineProperty(MeasuredText, 'class', {
	get: function() {
		return Hyperloop.getClass('android.graphics.text.MeasuredText');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MeasuredText.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.graphics.text.MeasuredText');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MeasuredText.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MeasuredText.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MeasuredText(Hyperloop.cast('android.graphics.text.MeasuredText', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(MeasuredText, 'Builder', {
	get: function() {
		return require('./android.graphics.text.MeasuredText$Builder');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/text/MeasuredText.html#getWidth(int, int)}
 **/
MeasuredText.prototype.getWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.text.MeasuredText') {
			return new MeasuredText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/text/MeasuredText.html#getBounds(int, int, android.graphics.Rect)}
 **/
MeasuredText.prototype.getBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.text.MeasuredText') {
			return new MeasuredText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCharWidthAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/graphics/text/MeasuredText.html#getCharWidthAt(int)}
 **/
MeasuredText.prototype.getCharWidthAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCharWidthAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.graphics.text.MeasuredText') {
			return new MeasuredText(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MeasuredText;
