/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.hardware.HardwareBuffer
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.hardware');

/**
 * @class android.hardware.HardwareBuffer
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html}
 **/
var HardwareBuffer = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.hardware.HardwareBuffer')) {
		result = arguments[0];
	}
	else {
		result = HardwareBuffer.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
HardwareBuffer.prototype = Object.create(SuperClass.prototype);
HardwareBuffer.prototype.constructor = HardwareBuffer;

Object.defineProperty(HardwareBuffer.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new HardwareBuffer(this.$native.super);
	},
	enumerable: true
});

HardwareBuffer.className = 'android.hardware.HardwareBuffer';
HardwareBuffer.prototype.className = 'android.hardware.HardwareBuffer';

// class property
Object.defineProperty(HardwareBuffer, 'class', {
	get: function() {
		return Hyperloop.getClass('android.hardware.HardwareBuffer');
	},
	enumerable: true,
	configurable: false
});


// Cast
HardwareBuffer.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new HardwareBuffer(Hyperloop.cast('android.hardware.HardwareBuffer', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#BLOB}
 */
HardwareBuffer.BLOB = 33;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_VIDEO_ENCODE}
 */
HardwareBuffer.USAGE_VIDEO_ENCODE = 65536;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#S_UI8}
 */
HardwareBuffer.S_UI8 = 53;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_CPU_WRITE_RARELY}
 */
HardwareBuffer.USAGE_CPU_WRITE_RARELY = 32;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_GPU_CUBE_MAP}
 */
HardwareBuffer.USAGE_GPU_CUBE_MAP = 33554432;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_CPU_WRITE_OFTEN}
 */
HardwareBuffer.USAGE_CPU_WRITE_OFTEN = 48;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_GPU_MIPMAP_COMPLETE}
 */
HardwareBuffer.USAGE_GPU_MIPMAP_COMPLETE = 67108864;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#DS_FP32UI8}
 */
HardwareBuffer.DS_FP32UI8 = 52;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#RGBX_8888}
 */
HardwareBuffer.RGBX_8888 = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#YCBCR_420_888}
 */
HardwareBuffer.YCBCR_420_888 = 35;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#RGBA_8888}
 */
HardwareBuffer.RGBA_8888 = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_GPU_SAMPLED_IMAGE}
 */
HardwareBuffer.USAGE_GPU_SAMPLED_IMAGE = 256;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#RGB_888}
 */
HardwareBuffer.RGB_888 = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#RGB_565}
 */
HardwareBuffer.RGB_565 = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#DS_24UI8}
 */
HardwareBuffer.DS_24UI8 = 50;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#RGBA_FP16}
 */
HardwareBuffer.RGBA_FP16 = 22;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#RGBA_1010102}
 */
HardwareBuffer.RGBA_1010102 = 43;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#D_16}
 */
HardwareBuffer.D_16 = 48;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_PROTECTED_CONTENT}
 */
HardwareBuffer.USAGE_PROTECTED_CONTENT = 16384;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#D_FP32}
 */
HardwareBuffer.D_FP32 = 51;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_CPU_READ_RARELY}
 */
HardwareBuffer.USAGE_CPU_READ_RARELY = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_GPU_COLOR_OUTPUT}
 */
HardwareBuffer.USAGE_GPU_COLOR_OUTPUT = 512;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_GPU_DATA_BUFFER}
 */
HardwareBuffer.USAGE_GPU_DATA_BUFFER = 16777216;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_SENSOR_DIRECT_DATA}
 */
HardwareBuffer.USAGE_SENSOR_DIRECT_DATA = 8388608;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#USAGE_CPU_READ_OFTEN}
 */
HardwareBuffer.USAGE_CPU_READ_OFTEN = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#D_24}
 */
HardwareBuffer.D_24 = 49;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/hardware/HardwareBuffer.html#CREATOR
Object.defineProperty(HardwareBuffer, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.hardware.HardwareBuffer') {
				return new HardwareBuffer(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function create
 * @static
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#create(int, int, int, int, long)}
 **/
HardwareBuffer.create = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'create',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupported
 * @static
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#isSupported(int, int, int, int, long)}
 **/
HardwareBuffer.isSupported = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isSupported',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#getHeight()}
 **/
HardwareBuffer.prototype.getHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isClosed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#isClosed()}
 **/
HardwareBuffer.prototype.isClosed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isClosed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLayers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#getLayers()}
 **/
HardwareBuffer.prototype.getLayers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLayers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function finalize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#finalize()}
 **/
HardwareBuffer.prototype.finalize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'finalize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFormat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#getFormat()}
 **/
HardwareBuffer.prototype.getFormat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFormat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#getWidth()}
 **/
HardwareBuffer.prototype.getWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#close()}
 **/
HardwareBuffer.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#describeContents()}
 **/
HardwareBuffer.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#writeToParcel(android.os.Parcel, int)}
 **/
HardwareBuffer.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUsage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/hardware/HardwareBuffer.html#getUsage()}
 **/
HardwareBuffer.prototype.getUsage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUsage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.hardware.HardwareBuffer') {
			return new HardwareBuffer(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = HardwareBuffer;
