/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.VolumeProvider
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media');

/**
 * @class android.media.VolumeProvider
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html}
 **/
var VolumeProvider = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.VolumeProvider')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.media.VolumeProvider. Create a subclass using android.media.VolumeProvider.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
VolumeProvider.prototype = Object.create(SuperClass.prototype);
VolumeProvider.prototype.constructor = VolumeProvider;

Object.defineProperty(VolumeProvider.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new VolumeProvider(this.$native.super);
	},
	enumerable: true
});

VolumeProvider.className = 'android.media.VolumeProvider';
VolumeProvider.prototype.className = 'android.media.VolumeProvider';

// class property
Object.defineProperty(VolumeProvider, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.VolumeProvider');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
VolumeProvider.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.media.VolumeProvider');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(VolumeProvider.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
VolumeProvider.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new VolumeProvider(Hyperloop.cast('android.media.VolumeProvider', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#VOLUME_CONTROL_FIXED}
 */
VolumeProvider.VOLUME_CONTROL_FIXED = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#VOLUME_CONTROL_ABSOLUTE}
 */
VolumeProvider.VOLUME_CONTROL_ABSOLUTE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#VOLUME_CONTROL_RELATIVE}
 */
VolumeProvider.VOLUME_CONTROL_RELATIVE = 1;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setCurrentVolume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#setCurrentVolume(int)}
 **/
VolumeProvider.prototype.setCurrentVolume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCurrentVolume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMaxVolume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#getMaxVolume()}
 **/
VolumeProvider.prototype.getMaxVolume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaxVolume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrentVolume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#getCurrentVolume()}
 **/
VolumeProvider.prototype.getCurrentVolume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrentVolume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSetVolumeTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#onSetVolumeTo(int)}
 **/
VolumeProvider.prototype.onSetVolumeTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSetVolumeTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAdjustVolume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#onAdjustVolume(int)}
 **/
VolumeProvider.prototype.onAdjustVolume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAdjustVolume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVolumeControl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#getVolumeControl()}
 **/
VolumeProvider.prototype.getVolumeControl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVolumeControl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getVolumeControlId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/VolumeProvider.html#getVolumeControlId()}
 **/
VolumeProvider.prototype.getVolumeControlId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getVolumeControlId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.VolumeProvider') {
			return new VolumeProvider(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = VolumeProvider;
