/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.session.MediaSession$QueueItem
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.media.session.MediaSession');

/**
 * @class android.media.session.MediaSession$QueueItem
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html}
 **/
var QueueItem = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.session.MediaSession$QueueItem')) {
		result = arguments[0];
	}
	else {
		result = QueueItem.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
QueueItem.prototype = Object.create(SuperClass.prototype);
QueueItem.prototype.constructor = QueueItem;

Object.defineProperty(QueueItem.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new QueueItem(this.$native.super);
	},
	enumerable: true
});

QueueItem.className = 'android.media.session.MediaSession$QueueItem';
QueueItem.prototype.className = 'android.media.session.MediaSession$QueueItem';

// class property
Object.defineProperty(QueueItem, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.session.MediaSession$QueueItem');
	},
	enumerable: true,
	configurable: false
});


// Cast
QueueItem.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new QueueItem(Hyperloop.cast('android.media.session.MediaSession$QueueItem', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#UNKNOWN_ID}
 */
QueueItem.UNKNOWN_ID = -1;

// Inner classes

// Static fields
// http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#CREATOR
Object.defineProperty(QueueItem, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
				return new QueueItem(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#equals(java.lang.Object)}
 **/
QueueItem.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
			return new QueueItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#toString()}
 **/
QueueItem.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
			return new QueueItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getQueueId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#getQueueId()}
 **/
QueueItem.prototype.getQueueId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getQueueId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
			return new QueueItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDescription
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#getDescription()}
 **/
QueueItem.prototype.getDescription = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDescription',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
			return new QueueItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#writeToParcel(android.os.Parcel, int)}
 **/
QueueItem.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
			return new QueueItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSession.QueueItem.html#describeContents()}
 **/
QueueItem.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSession$QueueItem') {
			return new QueueItem(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = QueueItem;
