/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.media.session.MediaSessionManager
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.media.session');

/**
 * @class android.media.session.MediaSessionManager
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html}
 **/
var MediaSessionManager = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.media.session.MediaSessionManager')) {
		result = arguments[0];
	}
	else {
		result = MediaSessionManager.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MediaSessionManager.prototype = Object.create(SuperClass.prototype);
MediaSessionManager.prototype.constructor = MediaSessionManager;

Object.defineProperty(MediaSessionManager.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MediaSessionManager(this.$native.super);
	},
	enumerable: true
});

MediaSessionManager.className = 'android.media.session.MediaSessionManager';
MediaSessionManager.prototype.className = 'android.media.session.MediaSessionManager';

// class property
Object.defineProperty(MediaSessionManager, 'class', {
	get: function() {
		return Hyperloop.getClass('android.media.session.MediaSessionManager');
	},
	enumerable: true,
	configurable: false
});


// Cast
MediaSessionManager.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MediaSessionManager(Hyperloop.cast('android.media.session.MediaSessionManager', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(MediaSessionManager, 'OnSession2TokensChangedListener', {
	get: function() {
		return require('./android.media.session.MediaSessionManager$OnSession2TokensChangedListener');
	},
	enumerable: true
});
Object.defineProperty(MediaSessionManager, 'RemoteUserInfo', {
	get: function() {
		return require('./android.media.session.MediaSessionManager$RemoteUserInfo');
	},
	enumerable: true
});
Object.defineProperty(MediaSessionManager, 'OnActiveSessionsChangedListener', {
	get: function() {
		return require('./android.media.session.MediaSessionManager$OnActiveSessionsChangedListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSession2Tokens
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#getSession2Tokens()}
 **/
MediaSessionManager.prototype.getSession2Tokens = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSession2Tokens',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnActiveSessionsChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#addOnActiveSessionsChangedListener(android.media.session.MediaSessionManager$OnActiveSessionsChangedListener, android.content.ComponentName)}
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#addOnActiveSessionsChangedListener(android.media.session.MediaSessionManager$OnActiveSessionsChangedListener, android.content.ComponentName, android.os.Handler)}
 **/
MediaSessionManager.prototype.addOnActiveSessionsChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnActiveSessionsChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActiveSessions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#getActiveSessions(android.content.ComponentName)}
 **/
MediaSessionManager.prototype.getActiveSessions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActiveSessions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeOnActiveSessionsChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#removeOnActiveSessionsChangedListener(android.media.session.MediaSessionManager$OnActiveSessionsChangedListener)}
 **/
MediaSessionManager.prototype.removeOnActiveSessionsChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeOnActiveSessionsChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeOnSession2TokensChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#removeOnSession2TokensChangedListener(android.media.session.MediaSessionManager$OnSession2TokensChangedListener)}
 **/
MediaSessionManager.prototype.removeOnSession2TokensChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeOnSession2TokensChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isTrustedForMediaControl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#isTrustedForMediaControl(android.media.session.MediaSessionManager$RemoteUserInfo)}
 **/
MediaSessionManager.prototype.isTrustedForMediaControl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isTrustedForMediaControl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifySession2Created
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#notifySession2Created(android.media.Session2Token)}
 **/
MediaSessionManager.prototype.notifySession2Created = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifySession2Created',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnSession2TokensChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#addOnSession2TokensChangedListener(android.media.session.MediaSessionManager$OnSession2TokensChangedListener)}
 * @see {@link http://developer.android.com/reference/android/media/session/MediaSessionManager.html#addOnSession2TokensChangedListener(android.media.session.MediaSessionManager$OnSession2TokensChangedListener, android.os.Handler)}
 **/
MediaSessionManager.prototype.addOnSession2TokensChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnSession2TokensChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.media.session.MediaSessionManager') {
			return new MediaSessionManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = MediaSessionManager;
