/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.os.Binder
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.os');

/**
 * @class android.os.Binder
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/os/Binder.html}
 **/
var Binder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.os.Binder')) {
		result = arguments[0];
	}
	else {
		result = Binder.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Binder.prototype = Object.create(SuperClass.prototype);
Binder.prototype.constructor = Binder;

Object.defineProperty(Binder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Binder(this.$native.super);
	},
	enumerable: true
});

Binder.className = 'android.os.Binder';
Binder.prototype.className = 'android.os.Binder';

// class property
Object.defineProperty(Binder, 'class', {
	get: function() {
		return Hyperloop.getClass('android.os.Binder');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Binder.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.os.Binder');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Binder.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Binder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Binder(Hyperloop.cast('android.os.Binder', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getCallingUid
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#getCallingUid()}
 **/
Binder.getCallingUid = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCallingUid',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function restoreCallingIdentity
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#restoreCallingIdentity(long)}
 **/
Binder.restoreCallingIdentity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'restoreCallingIdentity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function joinThreadPool
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#joinThreadPool()}
 **/
Binder.joinThreadPool = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'joinThreadPool',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCallingUserHandle
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#getCallingUserHandle()}
 **/
Binder.getCallingUserHandle = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCallingUserHandle',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function flushPendingCommands
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#flushPendingCommands()}
 **/
Binder.flushPendingCommands = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'flushPendingCommands',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clearCallingWorkSource
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#clearCallingWorkSource()}
 **/
Binder.clearCallingWorkSource = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'clearCallingWorkSource',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function restoreCallingWorkSource
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#restoreCallingWorkSource(long)}
 **/
Binder.restoreCallingWorkSource = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'restoreCallingWorkSource',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCallingUidOrThrow
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#getCallingUidOrThrow()}
 **/
Binder.getCallingUidOrThrow = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCallingUidOrThrow',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clearCallingIdentity
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#clearCallingIdentity()}
 **/
Binder.clearCallingIdentity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'clearCallingIdentity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCallingWorkSourceUid
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#setCallingWorkSourceUid(int)}
 **/
Binder.setCallingWorkSourceUid = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'setCallingWorkSourceUid',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCallingPid
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#getCallingPid()}
 **/
Binder.getCallingPid = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCallingPid',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCallingWorkSourceUid
 * @static
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#getCallingWorkSourceUid()}
 **/
Binder.getCallingWorkSourceUid = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCallingWorkSourceUid',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function queryLocalInterface
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#queryLocalInterface(java.lang.String)}
 **/
Binder.prototype.queryLocalInterface = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'queryLocalInterface',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function attachInterface
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#attachInterface(android.os.IInterface, java.lang.String)}
 **/
Binder.prototype.attachInterface = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'attachInterface',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pingBinder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#pingBinder()}
 **/
Binder.prototype.pingBinder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pingBinder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInterfaceDescriptor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#getInterfaceDescriptor()}
 **/
Binder.prototype.getInterfaceDescriptor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInterfaceDescriptor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function transact
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#transact(int, android.os.Parcel, android.os.Parcel, int)}
 **/
Binder.prototype.transact = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'transact',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isBinderAlive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#isBinderAlive()}
 **/
Binder.prototype.isBinderAlive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBinderAlive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTransact
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#onTransact(int, android.os.Parcel, android.os.Parcel, int)}
 **/
Binder.prototype.onTransact = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTransact',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#dump(java.io.FileDescriptor, java.lang.String[])}
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#dump(java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
Binder.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dumpAsync
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#dumpAsync(java.io.FileDescriptor, java.lang.String[])}
 **/
Binder.prototype.dumpAsync = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dumpAsync',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function linkToDeath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#linkToDeath(android.os.IBinder$DeathRecipient, int)}
 **/
Binder.prototype.linkToDeath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'linkToDeath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unlinkToDeath
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/os/Binder.html#unlinkToDeath(android.os.IBinder$DeathRecipient, int)}
 **/
Binder.prototype.unlinkToDeath = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unlinkToDeath',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.os.Binder') {
			return new Binder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Binder;
