/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Spannable
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.text');

/**
 * constructor
 * http://developer.android.com/reference/android/text/Spannable.html
 **/
var Spannable = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.text.Spannable') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.text.Spannable');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Spannable.prototype = Object.create(SuperClass.prototype);
Spannable.prototype.constructor = Spannable;

Object.defineProperty(Spannable.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Spannable(this.$native.super);
	},
	enumerable: true
});

Spannable.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Spannable.className = "android.text.Spannable";
Spannable.prototype.className = "android.text.Spannable";

// class property
Object.defineProperty(Spannable, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.Spannable');
	},
	enumerable: true,
	configurable: false
});

// Cast
Spannable.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Spannable(Hyperloop.cast('android.text.Spannable', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function removeSpan
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#removeSpan(java.lang.Object)}
 **/
Spannable.prototype.removeSpan = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeSpan',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpans
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#getSpans(int, int, java.lang.Class)}
 **/
Spannable.prototype.getSpans = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpans',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpanEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#getSpanEnd(java.lang.Object)}
 **/
Spannable.prototype.getSpanEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpanStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#getSpanStart(java.lang.Object)}
 **/
Spannable.prototype.getSpanStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpanFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#getSpanFlags(java.lang.Object)}
 **/
Spannable.prototype.getSpanFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setSpan
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#setSpan(java.lang.Object, int, int, int)}
 **/
Spannable.prototype.setSpan = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSpan',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextSpanTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spannable.html#nextSpanTransition(int, int, java.lang.Class)}
 **/
Spannable.prototype.nextSpanTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextSpanTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spannable') {
			return new Spannable(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Spannable.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Spannable.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Spannable;
