/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Spanned
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.text');

/**
 * constructor
 * http://developer.android.com/reference/android/text/Spanned.html
 **/
var Spanned = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.text.Spanned') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.text.Spanned');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Spanned.prototype = Object.create(SuperClass.prototype);
Spanned.prototype.constructor = Spanned;

Object.defineProperty(Spanned.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Spanned(this.$native.super);
	},
	enumerable: true
});

Spanned.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Spanned.className = "android.text.Spanned";
Spanned.prototype.className = "android.text.Spanned";

// class property
Object.defineProperty(Spanned, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.Spanned');
	},
	enumerable: true,
	configurable: false
});

// Cast
Spanned.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Spanned(Hyperloop.cast('android.text.Spanned', object.$native));
};

// Constants
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_PRIORITY_SHIFT
Spanned.SPAN_PRIORITY_SHIFT = 16;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_INCLUSIVE_INCLUSIVE
Spanned.SPAN_INCLUSIVE_INCLUSIVE = 18;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_POINT_MARK
Spanned.SPAN_POINT_MARK = 33;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_INCLUSIVE_EXCLUSIVE
Spanned.SPAN_INCLUSIVE_EXCLUSIVE = 17;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_USER_SHIFT
Spanned.SPAN_USER_SHIFT = 24;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_EXCLUSIVE_EXCLUSIVE
Spanned.SPAN_EXCLUSIVE_EXCLUSIVE = 33;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_POINT_MARK_MASK
Spanned.SPAN_POINT_MARK_MASK = 51;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_COMPOSING
Spanned.SPAN_COMPOSING = 256;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_MARK_MARK
Spanned.SPAN_MARK_MARK = 17;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_PARAGRAPH
Spanned.SPAN_PARAGRAPH = 51;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_POINT_POINT
Spanned.SPAN_POINT_POINT = 34;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_EXCLUSIVE_INCLUSIVE
Spanned.SPAN_EXCLUSIVE_INCLUSIVE = 34;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_MARK_POINT
Spanned.SPAN_MARK_POINT = 18;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_PRIORITY
Spanned.SPAN_PRIORITY = 16711680;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_INTERMEDIATE
Spanned.SPAN_INTERMEDIATE = 512;
// http://developer.android.com/reference/android/text/Spanned.html#SPAN_USER
Spanned.SPAN_USER = -16777216;

// Static methods

// Instance methods
/**
 * @function getSpans
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spanned.html#getSpans(int, int, java.lang.Class)}
 **/
Spanned.prototype.getSpans = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpans',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spanned') {
			return new Spanned(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpanEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spanned.html#getSpanEnd(java.lang.Object)}
 **/
Spanned.prototype.getSpanEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spanned') {
			return new Spanned(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpanStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spanned.html#getSpanStart(java.lang.Object)}
 **/
Spanned.prototype.getSpanStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spanned') {
			return new Spanned(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getSpanFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spanned.html#getSpanFlags(java.lang.Object)}
 **/
Spanned.prototype.getSpanFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSpanFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spanned') {
			return new Spanned(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function nextSpanTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/Spanned.html#nextSpanTransition(int, int, java.lang.Class)}
 **/
Spanned.prototype.nextSpanTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextSpanTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.Spanned') {
			return new Spanned(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Spanned.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Spanned.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Spanned;
