/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.text.TextUtils
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.text');

/**
 * @class android.text.TextUtils
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html}
 **/
var TextUtils = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.text.TextUtils')) {
		result = arguments[0];
	}
	else {
		result = TextUtils.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TextUtils.prototype = Object.create(SuperClass.prototype);
TextUtils.prototype.constructor = TextUtils;

Object.defineProperty(TextUtils.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextUtils(this.$native.super);
	},
	enumerable: true
});

TextUtils.className = 'android.text.TextUtils';
TextUtils.prototype.className = 'android.text.TextUtils';

// class property
Object.defineProperty(TextUtils, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.TextUtils');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TextUtils.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.text.TextUtils');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TextUtils.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TextUtils.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextUtils(Hyperloop.cast('android.text.TextUtils', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#SAFE_STRING_FLAG_FIRST_LINE}
 */
TextUtils.SAFE_STRING_FLAG_FIRST_LINE = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#CAP_MODE_CHARACTERS}
 */
TextUtils.CAP_MODE_CHARACTERS = 4096;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#SAFE_STRING_FLAG_TRIM}
 */
TextUtils.SAFE_STRING_FLAG_TRIM = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#CAP_MODE_SENTENCES}
 */
TextUtils.CAP_MODE_SENTENCES = 16384;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#CAP_MODE_WORDS}
 */
TextUtils.CAP_MODE_WORDS = 8192;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#SAFE_STRING_FLAG_SINGLE_LINE}
 */
TextUtils.SAFE_STRING_FLAG_SINGLE_LINE = 2;

// Inner classes
Object.defineProperty(TextUtils, 'SimpleStringSplitter', {
	get: function() {
		return require('./android.text.TextUtils$SimpleStringSplitter');
	},
	enumerable: true
});
Object.defineProperty(TextUtils, 'EllipsizeCallback', {
	get: function() {
		return require('./android.text.TextUtils$EllipsizeCallback');
	},
	enumerable: true
});
Object.defineProperty(TextUtils, 'TruncateAt', {
	get: function() {
		return require('./android.text.TextUtils$TruncateAt');
	},
	enumerable: true
});
Object.defineProperty(TextUtils, 'StringSplitter', {
	get: function() {
		return require('./android.text.TextUtils$StringSplitter');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/text/TextUtils.html#CHAR_SEQUENCE_CREATOR
Object.defineProperty(TextUtils, 'CHAR_SEQUENCE_CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CHAR_SEQUENCE_CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.text.TextUtils') {
				return new TextUtils(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function makeSafeForPresentation
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#makeSafeForPresentation(java.lang.String, int, float, int)}
 **/
TextUtils.makeSafeForPresentation = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeSafeForPresentation',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dumpSpans
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#dumpSpans(java.lang.CharSequence, android.util.Printer, java.lang.String)}
 **/
TextUtils.dumpSpans = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'dumpSpans',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLayoutDirectionFromLocale
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getLayoutDirectionFromLocale(java.util.Locale)}
 **/
TextUtils.getLayoutDirectionFromLocale = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getLayoutDirectionFromLocale',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function replace
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#replace(java.lang.CharSequence, java.lang.String[], java.lang.CharSequence[])}
 **/
TextUtils.replace = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'replace',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function regionMatches
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#regionMatches(java.lang.CharSequence, int, java.lang.CharSequence, int, int)}
 **/
TextUtils.regionMatches = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'regionMatches',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffsetBefore
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getOffsetBefore(java.lang.CharSequence, int)}
 **/
TextUtils.getOffsetBefore = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getOffsetBefore',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function listEllipsize
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#listEllipsize(android.content.Context, java.util.List, java.lang.String, android.text.TextPaint, float, int)}
 **/
TextUtils.listEllipsize = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'listEllipsize',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function substring
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#substring(java.lang.CharSequence, int, int)}
 **/
TextUtils.substring = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'substring',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function split
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#split(java.lang.String, java.lang.String)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#split(java.lang.String, java.util.regex.Pattern)}
 **/
TextUtils.split = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'split',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCapsMode
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getCapsMode(java.lang.CharSequence, int, int)}
 **/
TextUtils.getCapsMode = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCapsMode',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function join
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#join(java.lang.CharSequence, java.lang.Object[])}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#join(java.lang.CharSequence, java.lang.Iterable)}
 **/
TextUtils.join = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'join',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDigitsOnly
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#isDigitsOnly(java.lang.CharSequence)}
 **/
TextUtils.isDigitsOnly = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isDigitsOnly',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function indexOf
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#indexOf(java.lang.CharSequence, char)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#indexOf(java.lang.CharSequence, char, int)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#indexOf(java.lang.CharSequence, char, int, int)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#indexOf(java.lang.CharSequence, java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#indexOf(java.lang.CharSequence, java.lang.CharSequence, int)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#indexOf(java.lang.CharSequence, java.lang.CharSequence, int, int)}
 **/
TextUtils.indexOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'indexOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function expandTemplate
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#expandTemplate(java.lang.CharSequence, java.lang.CharSequence[])}
 **/
TextUtils.expandTemplate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'expandTemplate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ellipsize
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#ellipsize(java.lang.CharSequence, android.text.TextPaint, float, android.text.TextUtils$TruncateAt)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#ellipsize(java.lang.CharSequence, android.text.TextPaint, float, android.text.TextUtils$TruncateAt, boolean, android.text.TextUtils$EllipsizeCallback)}
 **/
TextUtils.ellipsize = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ellipsize',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChars
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getChars(java.lang.CharSequence, int, int, char[], int)}
 **/
TextUtils.getChars = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getChars',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEmpty
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#isEmpty(java.lang.CharSequence)}
 **/
TextUtils.isEmpty = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isEmpty',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffsetAfter
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getOffsetAfter(java.lang.CharSequence, int)}
 **/
TextUtils.getOffsetAfter = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getOffsetAfter',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function concat
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#concat(java.lang.CharSequence[])}
 **/
TextUtils.concat = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'concat',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function copySpansFrom
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#copySpansFrom(android.text.Spanned, int, int, java.lang.Class, android.text.Spannable, int)}
 **/
TextUtils.copySpansFrom = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'copySpansFrom',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lastIndexOf
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#lastIndexOf(java.lang.CharSequence, char)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#lastIndexOf(java.lang.CharSequence, char, int)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#lastIndexOf(java.lang.CharSequence, char, int, int)}
 **/
TextUtils.lastIndexOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'lastIndexOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTrimmedLength
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getTrimmedLength(java.lang.CharSequence)}
 **/
TextUtils.getTrimmedLength = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getTrimmedLength',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function commaEllipsize
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#commaEllipsize(java.lang.CharSequence, android.text.TextPaint, float, java.lang.String, java.lang.String)}
 **/
TextUtils.commaEllipsize = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'commaEllipsize',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function htmlEncode
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#htmlEncode(java.lang.String)}
 **/
TextUtils.htmlEncode = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'htmlEncode',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#equals(java.lang.CharSequence, java.lang.CharSequence)}
 **/
TextUtils.equals = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'equals',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getReverse
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#getReverse(java.lang.CharSequence, int, int)}
 **/
TextUtils.getReverse = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getReverse',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isGraphic
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#isGraphic(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#isGraphic(char)}
 **/
TextUtils.isGraphic = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isGraphic',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function stringOrSpannedString
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#stringOrSpannedString(java.lang.CharSequence)}
 **/
TextUtils.stringOrSpannedString = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'stringOrSpannedString',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @static
 * @see {@link http://developer.android.com/reference/android/text/TextUtils.html#writeToParcel(java.lang.CharSequence, android.os.Parcel, int)}
 **/
TextUtils.writeToParcel = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.TextUtils') {
			return new TextUtils(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = TextUtils;
