/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module MovementMethod
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.text.method');

/**
 * constructor
 * http://developer.android.com/reference/android/text/method/MovementMethod.html
 **/
var MovementMethod = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'android.text.method.MovementMethod') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('android.text.method.MovementMethod');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
MovementMethod.prototype = Object.create(SuperClass.prototype);
MovementMethod.prototype.constructor = MovementMethod;

Object.defineProperty(MovementMethod.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MovementMethod(this.$native.super);
	},
	enumerable: true
});

MovementMethod.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

MovementMethod.className = "android.text.method.MovementMethod";
MovementMethod.prototype.className = "android.text.method.MovementMethod";

// class property
Object.defineProperty(MovementMethod, 'class', {
	get: function() {
		return Hyperloop.getClass('android.text.method.MovementMethod');
	},
	enumerable: true,
	configurable: false
});

// Cast
MovementMethod.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MovementMethod(Hyperloop.cast('android.text.method.MovementMethod', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function onKeyDown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onKeyDown(android.widget.TextView, android.text.Spannable, int, android.view.KeyEvent)}
 **/
MovementMethod.prototype.onKeyDown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onKeyDown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onKeyUp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onKeyUp(android.widget.TextView, android.text.Spannable, int, android.view.KeyEvent)}
 **/
MovementMethod.prototype.onKeyUp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onKeyUp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onTrackballEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onTrackballEvent(android.widget.TextView, android.text.Spannable, android.view.MotionEvent)}
 **/
MovementMethod.prototype.onTrackballEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTrackballEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onTakeFocus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onTakeFocus(android.widget.TextView, android.text.Spannable, int)}
 **/
MovementMethod.prototype.onTakeFocus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTakeFocus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onTouchEvent(android.widget.TextView, android.text.Spannable, android.view.MotionEvent)}
 **/
MovementMethod.prototype.onTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onGenericMotionEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onGenericMotionEvent(android.widget.TextView, android.text.Spannable, android.view.MotionEvent)}
 **/
MovementMethod.prototype.onGenericMotionEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onGenericMotionEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onKeyOther
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#onKeyOther(android.widget.TextView, android.text.Spannable, android.view.KeyEvent)}
 **/
MovementMethod.prototype.onKeyOther = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onKeyOther',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function canSelectArbitrarily
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#canSelectArbitrarily()}
 **/
MovementMethod.prototype.canSelectArbitrarily = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canSelectArbitrarily',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function initialize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/text/method/MovementMethod.html#initialize(android.widget.TextView, android.text.Spannable)}
 **/
MovementMethod.prototype.initialize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initialize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.text.method.MovementMethod') {
			return new MovementMethod(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

MovementMethod.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

MovementMethod.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = MovementMethod;
