/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.AbsSavedState
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.AbsSavedState
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/AbsSavedState.html}
 **/
var AbsSavedState = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.AbsSavedState')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.view.AbsSavedState. Create a subclass using android.view.AbsSavedState.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AbsSavedState.prototype = Object.create(SuperClass.prototype);
AbsSavedState.prototype.constructor = AbsSavedState;

Object.defineProperty(AbsSavedState.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AbsSavedState(this.$native.super);
	},
	enumerable: true
});

AbsSavedState.className = 'android.view.AbsSavedState';
AbsSavedState.prototype.className = 'android.view.AbsSavedState';

// class property
Object.defineProperty(AbsSavedState, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.AbsSavedState');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AbsSavedState.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.AbsSavedState');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AbsSavedState.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AbsSavedState.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AbsSavedState(Hyperloop.cast('android.view.AbsSavedState', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/view/AbsSavedState.html#CREATOR
Object.defineProperty(AbsSavedState, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.AbsSavedState') {
				return new AbsSavedState(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/android/view/AbsSavedState.html#EMPTY_STATE
Object.defineProperty(AbsSavedState, 'EMPTY_STATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('EMPTY_STATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.AbsSavedState') {
				return new AbsSavedState(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSuperState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/AbsSavedState.html#getSuperState()}
 **/
AbsSavedState.prototype.getSuperState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSuperState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.AbsSavedState') {
			return new AbsSavedState(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/AbsSavedState.html#describeContents()}
 **/
AbsSavedState.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.AbsSavedState') {
			return new AbsSavedState(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/AbsSavedState.html#writeToParcel(android.os.Parcel, int)}
 **/
AbsSavedState.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.AbsSavedState') {
			return new AbsSavedState(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AbsSavedState;
