/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.WindowInsetsAnimation$Callback
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.view.WindowInsetsAnimation');

/**
 * @class android.view.WindowInsetsAnimation$Callback
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html}
 **/
var Callback = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.WindowInsetsAnimation$Callback')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.view.WindowInsetsAnimation$Callback. Create a subclass using android.view.WindowInsetsAnimation$Callback.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Callback.prototype = Object.create(SuperClass.prototype);
Callback.prototype.constructor = Callback;

Object.defineProperty(Callback.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Callback(this.$native.super);
	},
	enumerable: true
});

Callback.className = 'android.view.WindowInsetsAnimation$Callback';
Callback.prototype.className = 'android.view.WindowInsetsAnimation$Callback';

// class property
Object.defineProperty(Callback, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.WindowInsetsAnimation$Callback');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Callback.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.WindowInsetsAnimation$Callback');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Callback.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Callback.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Callback(Hyperloop.cast('android.view.WindowInsetsAnimation$Callback', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#DISPATCH_MODE_CONTINUE_ON_SUBTREE}
 */
Callback.DISPATCH_MODE_CONTINUE_ON_SUBTREE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#DISPATCH_MODE_STOP}
 */
Callback.DISPATCH_MODE_STOP = 0;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onProgress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#onProgress(android.view.WindowInsets, java.util.List)}
 **/
Callback.prototype.onProgress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onProgress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#onStart(android.view.WindowInsetsAnimation, android.view.WindowInsetsAnimation$Bounds)}
 **/
Callback.prototype.onStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#onEnd(android.view.WindowInsetsAnimation)}
 **/
Callback.prototype.onEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepare
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#onPrepare(android.view.WindowInsetsAnimation)}
 **/
Callback.prototype.onPrepare = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepare',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDispatchMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowInsetsAnimation.Callback.html#getDispatchMode()}
 **/
Callback.prototype.getDispatchMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDispatchMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowInsetsAnimation$Callback') {
			return new Callback(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Callback;
