/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.WindowMetrics
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view');

/**
 * @class android.view.WindowMetrics
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/WindowMetrics.html}
 **/
var WindowMetrics = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.WindowMetrics')) {
		result = arguments[0];
	}
	else {
		result = WindowMetrics.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
WindowMetrics.prototype = Object.create(SuperClass.prototype);
WindowMetrics.prototype.constructor = WindowMetrics;

Object.defineProperty(WindowMetrics.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new WindowMetrics(this.$native.super);
	},
	enumerable: true
});

WindowMetrics.className = 'android.view.WindowMetrics';
WindowMetrics.prototype.className = 'android.view.WindowMetrics';

// class property
Object.defineProperty(WindowMetrics, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.WindowMetrics');
	},
	enumerable: true,
	configurable: false
});


// Cast
WindowMetrics.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new WindowMetrics(Hyperloop.cast('android.view.WindowMetrics', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getWindowInsets
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowMetrics.html#getWindowInsets()}
 **/
WindowMetrics.prototype.getWindowInsets = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWindowInsets',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowMetrics') {
			return new WindowMetrics(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/WindowMetrics.html#getBounds()}
 **/
WindowMetrics.prototype.getBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.WindowMetrics') {
			return new WindowMetrics(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = WindowMetrics;
