/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.contentcapture.ContentCaptureContext
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.contentcapture');

/**
 * @class android.view.contentcapture.ContentCaptureContext
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html}
 **/
var ContentCaptureContext = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.contentcapture.ContentCaptureContext')) {
		result = arguments[0];
	}
	else {
		result = ContentCaptureContext.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ContentCaptureContext.prototype = Object.create(SuperClass.prototype);
ContentCaptureContext.prototype.constructor = ContentCaptureContext;

Object.defineProperty(ContentCaptureContext.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ContentCaptureContext(this.$native.super);
	},
	enumerable: true
});

ContentCaptureContext.className = 'android.view.contentcapture.ContentCaptureContext';
ContentCaptureContext.prototype.className = 'android.view.contentcapture.ContentCaptureContext';

// class property
Object.defineProperty(ContentCaptureContext, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.contentcapture.ContentCaptureContext');
	},
	enumerable: true,
	configurable: false
});


// Cast
ContentCaptureContext.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ContentCaptureContext(Hyperloop.cast('android.view.contentcapture.ContentCaptureContext', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ContentCaptureContext, 'Builder', {
	get: function() {
		return require('./android.view.contentcapture.ContentCaptureContext$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#CREATOR
Object.defineProperty(ContentCaptureContext, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
				return new ContentCaptureContext(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function forLocusId
 * @static
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#forLocusId(java.lang.String)}
 **/
ContentCaptureContext.forLocusId = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'forLocusId',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
			return new ContentCaptureContext(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getLocusId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#getLocusId()}
 **/
ContentCaptureContext.prototype.getLocusId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocusId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
			return new ContentCaptureContext(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#toString()}
 **/
ContentCaptureContext.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
			return new ContentCaptureContext(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtras
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#getExtras()}
 **/
ContentCaptureContext.prototype.getExtras = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtras',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
			return new ContentCaptureContext(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#describeContents()}
 **/
ContentCaptureContext.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
			return new ContentCaptureContext(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureContext.html#writeToParcel(android.os.Parcel, int)}
 **/
ContentCaptureContext.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureContext') {
			return new ContentCaptureContext(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ContentCaptureContext;
