/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.contentcapture.ContentCaptureSession
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.contentcapture');

/**
 * @class android.view.contentcapture.ContentCaptureSession
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html}
 **/
var ContentCaptureSession = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.contentcapture.ContentCaptureSession')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.view.contentcapture.ContentCaptureSession. Create a subclass using android.view.contentcapture.ContentCaptureSession.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ContentCaptureSession.prototype = Object.create(SuperClass.prototype);
ContentCaptureSession.prototype.constructor = ContentCaptureSession;

Object.defineProperty(ContentCaptureSession.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ContentCaptureSession(this.$native.super);
	},
	enumerable: true
});

ContentCaptureSession.className = 'android.view.contentcapture.ContentCaptureSession';
ContentCaptureSession.prototype.className = 'android.view.contentcapture.ContentCaptureSession';

// class property
Object.defineProperty(ContentCaptureSession, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.contentcapture.ContentCaptureSession');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ContentCaptureSession.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.view.contentcapture.ContentCaptureSession');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ContentCaptureSession.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ContentCaptureSession.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ContentCaptureSession(Hyperloop.cast('android.view.contentcapture.ContentCaptureSession', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function notifyViewAppeared
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifyViewAppeared(android.view.ViewStructure)}
 **/
ContentCaptureSession.prototype.notifyViewAppeared = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyViewAppeared',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getContentCaptureContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#getContentCaptureContext()}
 **/
ContentCaptureSession.prototype.getContentCaptureContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContentCaptureContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyViewInsetsChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifyViewInsetsChanged(android.graphics.Insets)}
 **/
ContentCaptureSession.prototype.notifyViewInsetsChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyViewInsetsChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function destroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#destroy()}
 **/
ContentCaptureSession.prototype.destroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'destroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function newVirtualViewStructure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#newVirtualViewStructure(android.view.autofill.AutofillId, long)}
 **/
ContentCaptureSession.prototype.newVirtualViewStructure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'newVirtualViewStructure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function newViewStructure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#newViewStructure(android.view.View)}
 **/
ContentCaptureSession.prototype.newViewStructure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'newViewStructure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function newAutofillId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#newAutofillId(android.view.autofill.AutofillId, long)}
 **/
ContentCaptureSession.prototype.newAutofillId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'newAutofillId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getContentCaptureSessionId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#getContentCaptureSessionId()}
 **/
ContentCaptureSession.prototype.getContentCaptureSessionId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContentCaptureSessionId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifySessionResumed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifySessionResumed()}
 **/
ContentCaptureSession.prototype.notifySessionResumed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifySessionResumed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyViewDisappeared
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifyViewDisappeared(android.view.autofill.AutofillId)}
 **/
ContentCaptureSession.prototype.notifyViewDisappeared = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyViewDisappeared',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createContentCaptureSession
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#createContentCaptureSession(android.view.contentcapture.ContentCaptureContext)}
 **/
ContentCaptureSession.prototype.createContentCaptureSession = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createContentCaptureSession',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifySessionPaused
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifySessionPaused()}
 **/
ContentCaptureSession.prototype.notifySessionPaused = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifySessionPaused',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#toString()}
 **/
ContentCaptureSession.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContentCaptureContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#setContentCaptureContext(android.view.contentcapture.ContentCaptureContext)}
 **/
ContentCaptureSession.prototype.setContentCaptureContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentCaptureContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function close
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#close()}
 **/
ContentCaptureSession.prototype.close = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'close',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyViewsDisappeared
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifyViewsDisappeared(android.view.autofill.AutofillId, long[])}
 **/
ContentCaptureSession.prototype.notifyViewsDisappeared = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyViewsDisappeared',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function notifyViewTextChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSession.html#notifyViewTextChanged(android.view.autofill.AutofillId, java.lang.CharSequence)}
 **/
ContentCaptureSession.prototype.notifyViewTextChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'notifyViewTextChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSession') {
			return new ContentCaptureSession(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ContentCaptureSession;
