/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.contentcapture.ContentCaptureSessionId
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.contentcapture');

/**
 * @class android.view.contentcapture.ContentCaptureSessionId
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html}
 **/
var ContentCaptureSessionId = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.contentcapture.ContentCaptureSessionId')) {
		result = arguments[0];
	}
	else {
		result = ContentCaptureSessionId.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ContentCaptureSessionId.prototype = Object.create(SuperClass.prototype);
ContentCaptureSessionId.prototype.constructor = ContentCaptureSessionId;

Object.defineProperty(ContentCaptureSessionId.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ContentCaptureSessionId(this.$native.super);
	},
	enumerable: true
});

ContentCaptureSessionId.className = 'android.view.contentcapture.ContentCaptureSessionId';
ContentCaptureSessionId.prototype.className = 'android.view.contentcapture.ContentCaptureSessionId';

// class property
Object.defineProperty(ContentCaptureSessionId, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.contentcapture.ContentCaptureSessionId');
	},
	enumerable: true,
	configurable: false
});


// Cast
ContentCaptureSessionId.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ContentCaptureSessionId(Hyperloop.cast('android.view.contentcapture.ContentCaptureSessionId', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html#CREATOR
Object.defineProperty(ContentCaptureSessionId, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.contentcapture.ContentCaptureSessionId') {
				return new ContentCaptureSessionId(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html#hashCode()}
 **/
ContentCaptureSessionId.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSessionId') {
			return new ContentCaptureSessionId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html#equals(java.lang.Object)}
 **/
ContentCaptureSessionId.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSessionId') {
			return new ContentCaptureSessionId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html#toString()}
 **/
ContentCaptureSessionId.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSessionId') {
			return new ContentCaptureSessionId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html#describeContents()}
 **/
ContentCaptureSessionId.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSessionId') {
			return new ContentCaptureSessionId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/contentcapture/ContentCaptureSessionId.html#writeToParcel(android.os.Parcel, int)}
 **/
ContentCaptureSessionId.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.contentcapture.ContentCaptureSessionId') {
			return new ContentCaptureSessionId(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ContentCaptureSessionId;
