/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.inputmethod.CursorAnchorInfo
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.inputmethod');

/**
 * @class android.view.inputmethod.CursorAnchorInfo
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html}
 **/
var CursorAnchorInfo = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.inputmethod.CursorAnchorInfo')) {
		result = arguments[0];
	}
	else {
		result = CursorAnchorInfo.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
CursorAnchorInfo.prototype = Object.create(SuperClass.prototype);
CursorAnchorInfo.prototype.constructor = CursorAnchorInfo;

Object.defineProperty(CursorAnchorInfo.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new CursorAnchorInfo(this.$native.super);
	},
	enumerable: true
});

CursorAnchorInfo.className = 'android.view.inputmethod.CursorAnchorInfo';
CursorAnchorInfo.prototype.className = 'android.view.inputmethod.CursorAnchorInfo';

// class property
Object.defineProperty(CursorAnchorInfo, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.inputmethod.CursorAnchorInfo');
	},
	enumerable: true,
	configurable: false
});


// Cast
CursorAnchorInfo.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new CursorAnchorInfo(Hyperloop.cast('android.view.inputmethod.CursorAnchorInfo', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#FLAG_IS_RTL}
 */
CursorAnchorInfo.FLAG_IS_RTL = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#FLAG_HAS_VISIBLE_REGION}
 */
CursorAnchorInfo.FLAG_HAS_VISIBLE_REGION = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#FLAG_HAS_INVISIBLE_REGION}
 */
CursorAnchorInfo.FLAG_HAS_INVISIBLE_REGION = 2;

// Inner classes
Object.defineProperty(CursorAnchorInfo, 'Builder', {
	get: function() {
		return require('./android.view.inputmethod.CursorAnchorInfo$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#CREATOR
Object.defineProperty(CursorAnchorInfo, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
				return new CursorAnchorInfo(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getSelectionStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getSelectionStart()}
 **/
CursorAnchorInfo.prototype.getSelectionStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectionStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInsertionMarkerTop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getInsertionMarkerTop()}
 **/
CursorAnchorInfo.prototype.getInsertionMarkerTop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInsertionMarkerTop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInsertionMarkerHorizontal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getInsertionMarkerHorizontal()}
 **/
CursorAnchorInfo.prototype.getInsertionMarkerHorizontal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInsertionMarkerHorizontal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInsertionMarkerBottom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getInsertionMarkerBottom()}
 **/
CursorAnchorInfo.prototype.getInsertionMarkerBottom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInsertionMarkerBottom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInsertionMarkerBaseline
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getInsertionMarkerBaseline()}
 **/
CursorAnchorInfo.prototype.getInsertionMarkerBaseline = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInsertionMarkerBaseline',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#describeContents()}
 **/
CursorAnchorInfo.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getComposingTextStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getComposingTextStart()}
 **/
CursorAnchorInfo.prototype.getComposingTextStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComposingTextStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMatrix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getMatrix()}
 **/
CursorAnchorInfo.prototype.getMatrix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMatrix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#hashCode()}
 **/
CursorAnchorInfo.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#equals(java.lang.Object)}
 **/
CursorAnchorInfo.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInsertionMarkerFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getInsertionMarkerFlags()}
 **/
CursorAnchorInfo.prototype.getInsertionMarkerFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInsertionMarkerFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#toString()}
 **/
CursorAnchorInfo.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getComposingText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getComposingText()}
 **/
CursorAnchorInfo.prototype.getComposingText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getComposingText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectionEnd
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getSelectionEnd()}
 **/
CursorAnchorInfo.prototype.getSelectionEnd = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectionEnd',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#writeToParcel(android.os.Parcel, int)}
 **/
CursorAnchorInfo.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCharacterBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getCharacterBounds(int)}
 **/
CursorAnchorInfo.prototype.getCharacterBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCharacterBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCharacterBoundsFlags
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/CursorAnchorInfo.html#getCharacterBoundsFlags(int)}
 **/
CursorAnchorInfo.prototype.getCharacterBoundsFlags = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCharacterBoundsFlags',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.CursorAnchorInfo') {
			return new CursorAnchorInfo(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = CursorAnchorInfo;
