/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.inputmethod.InputMethodManager
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.inputmethod');

/**
 * @class android.view.inputmethod.InputMethodManager
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html}
 **/
var InputMethodManager = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.inputmethod.InputMethodManager')) {
		result = arguments[0];
	}
	else {
		result = InputMethodManager.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
InputMethodManager.prototype = Object.create(SuperClass.prototype);
InputMethodManager.prototype.constructor = InputMethodManager;

Object.defineProperty(InputMethodManager.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new InputMethodManager(this.$native.super);
	},
	enumerable: true
});

InputMethodManager.className = 'android.view.inputmethod.InputMethodManager';
InputMethodManager.prototype.className = 'android.view.inputmethod.InputMethodManager';

// class property
Object.defineProperty(InputMethodManager, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.inputmethod.InputMethodManager');
	},
	enumerable: true,
	configurable: false
});


// Cast
InputMethodManager.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new InputMethodManager(Hyperloop.cast('android.view.inputmethod.InputMethodManager', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#HIDE_IMPLICIT_ONLY}
 */
InputMethodManager.HIDE_IMPLICIT_ONLY = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#RESULT_SHOWN}
 */
InputMethodManager.RESULT_SHOWN = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#RESULT_UNCHANGED_SHOWN}
 */
InputMethodManager.RESULT_UNCHANGED_SHOWN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#RESULT_UNCHANGED_HIDDEN}
 */
InputMethodManager.RESULT_UNCHANGED_HIDDEN = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#RESULT_HIDDEN}
 */
InputMethodManager.RESULT_HIDDEN = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#HIDE_NOT_ALWAYS}
 */
InputMethodManager.HIDE_NOT_ALWAYS = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#SHOW_FORCED}
 */
InputMethodManager.SHOW_FORCED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#SHOW_IMPLICIT}
 */
InputMethodManager.SHOW_IMPLICIT = 1;

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getCurrentInputMethodSubtype
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#getCurrentInputMethodSubtype()}
 **/
InputMethodManager.prototype.getCurrentInputMethodSubtype = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrentInputMethodSubtype',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function switchToNextInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#switchToNextInputMethod(android.os.IBinder, boolean)}
 **/
InputMethodManager.prototype.switchToNextInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'switchToNextInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toggleSoftInputFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#toggleSoftInputFromWindow(android.os.IBinder, int, int)}
 **/
InputMethodManager.prototype.toggleSoftInputFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toggleSoftInputFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateCursor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#updateCursor(android.view.View, int, int, int, int)}
 **/
InputMethodManager.prototype.updateCursor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateCursor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function switchToLastInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#switchToLastInputMethod(android.os.IBinder)}
 **/
InputMethodManager.prototype.switchToLastInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'switchToLastInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isActive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#isActive(android.view.View)}
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#isActive()}
 **/
InputMethodManager.prototype.isActive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isActive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function sendAppPrivateCommand
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#sendAppPrivateCommand(android.view.View, java.lang.String, android.os.Bundle)}
 **/
InputMethodManager.prototype.sendAppPrivateCommand = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'sendAppPrivateCommand',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showSoftInput
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#showSoftInput(android.view.View, int)}
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#showSoftInput(android.view.View, int, android.os.ResultReceiver)}
 **/
InputMethodManager.prototype.showSoftInput = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showSoftInput',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateSelection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#updateSelection(android.view.View, int, int, int, int)}
 **/
InputMethodManager.prototype.updateSelection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateSelection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInputMethodList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#getInputMethodList()}
 **/
InputMethodManager.prototype.getInputMethodList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInputMethodList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function shouldOfferSwitchingToNextInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#shouldOfferSwitchingToNextInputMethod(android.os.IBinder)}
 **/
InputMethodManager.prototype.shouldOfferSwitchingToNextInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shouldOfferSwitchingToNextInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCurrentInputMethodSubtype
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#setCurrentInputMethodSubtype(android.view.inputmethod.InputMethodSubtype)}
 **/
InputMethodManager.prototype.setCurrentInputMethodSubtype = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCurrentInputMethodSubtype',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLastInputMethodSubtype
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#getLastInputMethodSubtype()}
 **/
InputMethodManager.prototype.getLastInputMethodSubtype = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLastInputMethodSubtype',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function restartInput
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#restartInput(android.view.View)}
 **/
InputMethodManager.prototype.restartInput = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'restartInput',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchKeyEventFromInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#dispatchKeyEventFromInputMethod(android.view.View, android.view.KeyEvent)}
 **/
InputMethodManager.prototype.dispatchKeyEventFromInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchKeyEventFromInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getShortcutInputMethodsAndSubtypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#getShortcutInputMethodsAndSubtypes()}
 **/
InputMethodManager.prototype.getShortcutInputMethodsAndSubtypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getShortcutInputMethodsAndSubtypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAdditionalInputMethodSubtypes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#setAdditionalInputMethodSubtypes(java.lang.String, android.view.inputmethod.InputMethodSubtype[])}
 **/
InputMethodManager.prototype.setAdditionalInputMethodSubtypes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAdditionalInputMethodSubtypes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateExtractedText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#updateExtractedText(android.view.View, int, android.view.inputmethod.ExtractedText)}
 **/
InputMethodManager.prototype.updateExtractedText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateExtractedText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showSoftInputFromInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#showSoftInputFromInputMethod(android.os.IBinder, int)}
 **/
InputMethodManager.prototype.showSoftInputFromInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showSoftInputFromInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showInputMethodAndSubtypeEnabler
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#showInputMethodAndSubtypeEnabler(java.lang.String)}
 **/
InputMethodManager.prototype.showInputMethodAndSubtypeEnabler = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showInputMethodAndSubtypeEnabler',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hideStatusIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#hideStatusIcon(android.os.IBinder)}
 **/
InputMethodManager.prototype.hideStatusIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hideStatusIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#setInputMethod(android.os.IBinder, java.lang.String)}
 **/
InputMethodManager.prototype.setInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEnabledInputMethodList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#getEnabledInputMethodList()}
 **/
InputMethodManager.prototype.getEnabledInputMethodList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEnabledInputMethodList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInputMethodAndSubtype
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#setInputMethodAndSubtype(android.os.IBinder, java.lang.String, android.view.inputmethod.InputMethodSubtype)}
 **/
InputMethodManager.prototype.setInputMethodAndSubtype = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInputMethodAndSubtype',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAcceptingText
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#isAcceptingText()}
 **/
InputMethodManager.prototype.isAcceptingText = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAcceptingText',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isWatchingCursor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#isWatchingCursor(android.view.View)}
 **/
InputMethodManager.prototype.isWatchingCursor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isWatchingCursor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEnabledInputMethodSubtypeList
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#getEnabledInputMethodSubtypeList(android.view.inputmethod.InputMethodInfo, boolean)}
 **/
InputMethodManager.prototype.getEnabledInputMethodSubtypeList = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEnabledInputMethodSubtypeList',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showStatusIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#showStatusIcon(android.os.IBinder, java.lang.String, int)}
 **/
InputMethodManager.prototype.showStatusIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showStatusIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hideSoftInputFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#hideSoftInputFromWindow(android.os.IBinder, int)}
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#hideSoftInputFromWindow(android.os.IBinder, int, android.os.ResultReceiver)}
 **/
InputMethodManager.prototype.hideSoftInputFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hideSoftInputFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function displayCompletions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#displayCompletions(android.view.View, android.view.inputmethod.CompletionInfo[])}
 **/
InputMethodManager.prototype.displayCompletions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'displayCompletions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hideSoftInputFromInputMethod
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#hideSoftInputFromInputMethod(android.os.IBinder, int)}
 **/
InputMethodManager.prototype.hideSoftInputFromInputMethod = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hideSoftInputFromInputMethod',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toggleSoftInput
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#toggleSoftInput(int, int)}
 **/
InputMethodManager.prototype.toggleSoftInput = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toggleSoftInput',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function viewClicked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#viewClicked(android.view.View)}
 **/
InputMethodManager.prototype.viewClicked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'viewClicked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showInputMethodPicker
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#showInputMethodPicker()}
 **/
InputMethodManager.prototype.showInputMethodPicker = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showInputMethodPicker',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFullscreenMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#isFullscreenMode()}
 **/
InputMethodManager.prototype.isFullscreenMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFullscreenMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateCursorAnchorInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodManager.html#updateCursorAnchorInfo(android.view.View, android.view.inputmethod.CursorAnchorInfo)}
 **/
InputMethodManager.prototype.updateCursorAnchorInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateCursorAnchorInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodManager') {
			return new InputMethodManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = InputMethodManager;
