/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.inputmethod.InputMethodSubtype
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.view.inputmethod');

/**
 * @class android.view.inputmethod.InputMethodSubtype
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html}
 **/
var InputMethodSubtype = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.inputmethod.InputMethodSubtype')) {
		result = arguments[0];
	}
	else {
		result = InputMethodSubtype.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
InputMethodSubtype.prototype = Object.create(SuperClass.prototype);
InputMethodSubtype.prototype.constructor = InputMethodSubtype;

Object.defineProperty(InputMethodSubtype.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new InputMethodSubtype(this.$native.super);
	},
	enumerable: true
});

InputMethodSubtype.className = 'android.view.inputmethod.InputMethodSubtype';
InputMethodSubtype.prototype.className = 'android.view.inputmethod.InputMethodSubtype';

// class property
Object.defineProperty(InputMethodSubtype, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.inputmethod.InputMethodSubtype');
	},
	enumerable: true,
	configurable: false
});


// Cast
InputMethodSubtype.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new InputMethodSubtype(Hyperloop.cast('android.view.inputmethod.InputMethodSubtype', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(InputMethodSubtype, 'InputMethodSubtypeBuilder', {
	get: function() {
		return require('./android.view.inputmethod.InputMethodSubtype$InputMethodSubtypeBuilder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#CREATOR
Object.defineProperty(InputMethodSubtype, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
				return new InputMethodSubtype(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getNameResId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getNameResId()}
 **/
InputMethodSubtype.prototype.getNameResId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNameResId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIconResId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getIconResId()}
 **/
InputMethodSubtype.prototype.getIconResId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIconResId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLanguageTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getLanguageTag()}
 **/
InputMethodSubtype.prototype.getLanguageTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLanguageTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAuxiliary
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#isAuxiliary()}
 **/
InputMethodSubtype.prototype.isAuxiliary = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAuxiliary',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#describeContents()}
 **/
InputMethodSubtype.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function overridesImplicitlyEnabledSubtype
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#overridesImplicitlyEnabledSubtype()}
 **/
InputMethodSubtype.prototype.overridesImplicitlyEnabledSubtype = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'overridesImplicitlyEnabledSubtype',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getDisplayName(android.content.Context, java.lang.String, android.content.pm.ApplicationInfo)}
 **/
InputMethodSubtype.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#hashCode()}
 **/
InputMethodSubtype.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#equals(java.lang.Object)}
 **/
InputMethodSubtype.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getMode()}
 **/
InputMethodSubtype.prototype.getMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtraValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getExtraValue()}
 **/
InputMethodSubtype.prototype.getExtraValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtraValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAsciiCapable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#isAsciiCapable()}
 **/
InputMethodSubtype.prototype.isAsciiCapable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAsciiCapable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function containsExtraValueKey
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#containsExtraValueKey(java.lang.String)}
 **/
InputMethodSubtype.prototype.containsExtraValueKey = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'containsExtraValueKey',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtraValueOf
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getExtraValueOf(java.lang.String)}
 **/
InputMethodSubtype.prototype.getExtraValueOf = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtraValueOf',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLocale
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#getLocale()}
 **/
InputMethodSubtype.prototype.getLocale = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocale',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/inputmethod/InputMethodSubtype.html#writeToParcel(android.os.Parcel, int)}
 **/
InputMethodSubtype.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.inputmethod.InputMethodSubtype') {
			return new InputMethodSubtype(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = InputMethodSubtype;
