/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.view.textclassifier.TextClassifierEvent$TextSelectionEvent
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./android.view.textclassifier.TextClassifierEvent');

/**
 * @class android.view.textclassifier.TextClassifierEvent$TextSelectionEvent
 * @extends android.view.textclassifier.TextClassifierEvent 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html}
 **/
var TextSelectionEvent = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.view.textclassifier.TextClassifierEvent$TextSelectionEvent')) {
		result = arguments[0];
	}
	else {
		result = TextSelectionEvent.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.textclassifier.TextClassifierEvent');
TextSelectionEvent.prototype = Object.create(SuperClass.prototype);
TextSelectionEvent.prototype.constructor = TextSelectionEvent;

Object.defineProperty(TextSelectionEvent.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextSelectionEvent(this.$native.super);
	},
	enumerable: true
});

TextSelectionEvent.className = 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent';
TextSelectionEvent.prototype.className = 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent';

// class property
Object.defineProperty(TextSelectionEvent, 'class', {
	get: function() {
		return Hyperloop.getClass('android.view.textclassifier.TextClassifierEvent$TextSelectionEvent');
	},
	enumerable: true,
	configurable: false
});


// Cast
TextSelectionEvent.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextSelectionEvent(Hyperloop.cast('android.view.textclassifier.TextClassifierEvent$TextSelectionEvent', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(TextSelectionEvent, 'Builder', {
	get: function() {
		return require('./android.view.textclassifier.TextClassifierEvent$TextSelectionEvent$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html#CREATOR
Object.defineProperty(TextSelectionEvent, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent') {
				return new TextSelectionEvent(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getRelativeSuggestedWordEndIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html#getRelativeSuggestedWordEndIndex()}
 **/
TextSelectionEvent.prototype.getRelativeSuggestedWordEndIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRelativeSuggestedWordEndIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent') {
			return new TextSelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRelativeWordEndIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html#getRelativeWordEndIndex()}
 **/
TextSelectionEvent.prototype.getRelativeWordEndIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRelativeWordEndIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent') {
			return new TextSelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html#writeToParcel(android.os.Parcel, int)}
 **/
TextSelectionEvent.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent') {
			return new TextSelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRelativeSuggestedWordStartIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html#getRelativeSuggestedWordStartIndex()}
 **/
TextSelectionEvent.prototype.getRelativeSuggestedWordStartIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRelativeSuggestedWordStartIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent') {
			return new TextSelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRelativeWordStartIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/view/textclassifier/TextClassifierEvent.TextSelectionEvent.html#getRelativeWordStartIndex()}
 **/
TextSelectionEvent.prototype.getRelativeWordStartIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRelativeWordStartIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.view.textclassifier.TextClassifierEvent$TextSelectionEvent') {
			return new TextSelectionEvent(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TextSelectionEvent;
