/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.widget.AdapterView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.widget');

/**
 * @class android.widget.AdapterView
 * @extends android.view.ViewGroup 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html}
 **/
var AdapterView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.widget.AdapterView')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: android.widget.AdapterView. Create a subclass using android.widget.AdapterView.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.ViewGroup');
AdapterView.prototype = Object.create(SuperClass.prototype);
AdapterView.prototype.constructor = AdapterView;

Object.defineProperty(AdapterView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AdapterView(this.$native.super);
	},
	enumerable: true
});

AdapterView.className = 'android.widget.AdapterView';
AdapterView.prototype.className = 'android.widget.AdapterView';

// class property
Object.defineProperty(AdapterView, 'class', {
	get: function() {
		return Hyperloop.getClass('android.widget.AdapterView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AdapterView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.widget.AdapterView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AdapterView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AdapterView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AdapterView(Hyperloop.cast('android.widget.AdapterView', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#INVALID_ROW_ID}
 */
AdapterView.INVALID_ROW_ID = -9223372036854775808;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#ITEM_VIEW_TYPE_HEADER_OR_FOOTER}
 */
AdapterView.ITEM_VIEW_TYPE_HEADER_OR_FOOTER = -2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#ITEM_VIEW_TYPE_IGNORE}
 */
AdapterView.ITEM_VIEW_TYPE_IGNORE = -1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#INVALID_POSITION}
 */
AdapterView.INVALID_POSITION = -1;

// Inner classes
Object.defineProperty(AdapterView, 'AdapterContextMenuInfo', {
	get: function() {
		return require('./android.widget.AdapterView$AdapterContextMenuInfo');
	},
	enumerable: true
});
Object.defineProperty(AdapterView, 'OnItemSelectedListener', {
	get: function() {
		return require('./android.widget.AdapterView$OnItemSelectedListener');
	},
	enumerable: true
});
Object.defineProperty(AdapterView, 'OnItemLongClickListener', {
	get: function() {
		return require('./android.widget.AdapterView$OnItemLongClickListener');
	},
	enumerable: true
});
Object.defineProperty(AdapterView, 'OnItemClickListener', {
	get: function() {
		return require('./android.widget.AdapterView$OnItemClickListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function dispatchRestoreInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#dispatchRestoreInstanceState(android.util.SparseArray)}
 **/
AdapterView.prototype.dispatchRestoreInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchRestoreInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeViewAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#removeViewAt(int)}
 **/
AdapterView.prototype.removeViewAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeViewAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFirstVisiblePosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getFirstVisiblePosition()}
 **/
AdapterView.prototype.getFirstVisiblePosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFirstVisiblePosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnItemClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setOnItemClickListener(android.widget.AdapterView$OnItemClickListener)}
 **/
AdapterView.prototype.setOnItemClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnItemClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function canAnimate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#canAnimate()}
 **/
AdapterView.prototype.canAnimate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'canAnimate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOnItemLongClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getOnItemLongClickListener()}
 **/
AdapterView.prototype.getOnItemLongClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOnItemLongClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccessibilityClassName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getAccessibilityClassName()}
 **/
AdapterView.prototype.getAccessibilityClassName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccessibilityClassName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEmptyView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setEmptyView(android.view.View)}
 **/
AdapterView.prototype.setEmptyView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEmptyView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnItemLongClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setOnItemLongClickListener(android.widget.AdapterView$OnItemLongClickListener)}
 **/
AdapterView.prototype.setOnItemLongClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnItemLongClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPositionForView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getPositionForView(android.view.View)}
 **/
AdapterView.prototype.getPositionForView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPositionForView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeAllViews
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#removeAllViews()}
 **/
AdapterView.prototype.removeAllViews = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeAllViews',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectedItemPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getSelectedItemPosition()}
 **/
AdapterView.prototype.getSelectedItemPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectedItemPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFocusableInTouchMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setFocusableInTouchMode(boolean)}
 **/
AdapterView.prototype.setFocusableInTouchMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFocusableInTouchMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectedItemId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getSelectedItemId()}
 **/
AdapterView.prototype.getSelectedItemId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectedItemId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLastVisiblePosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getLastVisiblePosition()}
 **/
AdapterView.prototype.getLastVisiblePosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLastVisiblePosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getItemIdAtPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getItemIdAtPosition(int)}
 **/
AdapterView.prototype.getItemIdAtPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItemIdAtPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function performItemClick
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#performItemClick(android.view.View, int, long)}
 **/
AdapterView.prototype.performItemClick = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'performItemClick',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEmptyView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getEmptyView()}
 **/
AdapterView.prototype.getEmptyView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEmptyView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getItemAtPosition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getItemAtPosition(int)}
 **/
AdapterView.prototype.getItemAtPosition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getItemAtPosition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getCount()}
 **/
AdapterView.prototype.getCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOnItemClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getOnItemClickListener()}
 **/
AdapterView.prototype.getOnItemClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOnItemClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectedItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getSelectedItem()}
 **/
AdapterView.prototype.getSelectedItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectedItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAdapter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getAdapter()}
 **/
AdapterView.prototype.getAdapter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAdapter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnItemSelectedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setOnItemSelectedListener(android.widget.AdapterView$OnItemSelectedListener)}
 **/
AdapterView.prototype.setOnItemSelectedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnItemSelectedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#dispatchSaveInstanceState(android.util.SparseArray)}
 **/
AdapterView.prototype.dispatchSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAdapter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setAdapter(android.widget.Adapter)}
 **/
AdapterView.prototype.setAdapter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAdapter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#onLayout(boolean, int, int, int, int)}
 **/
AdapterView.prototype.onLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOnItemSelectedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getOnItemSelectedListener()}
 **/
AdapterView.prototype.getOnItemSelectedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOnItemSelectedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFocusable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setFocusable(int)}
 **/
AdapterView.prototype.setFocusable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFocusable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#addView(android.view.View)}
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#addView(android.view.View, int)}
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#addView(android.view.View, android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#addView(android.view.View, int, android.view.ViewGroup$LayoutParams)}
 **/
AdapterView.prototype.addView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setOnClickListener(android.view.View$OnClickListener)}
 **/
AdapterView.prototype.setOnClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#removeView(android.view.View)}
 **/
AdapterView.prototype.removeView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSelection
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#setSelection(int)}
 **/
AdapterView.prototype.setSelection = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSelection',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectedView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#getSelectedView()}
 **/
AdapterView.prototype.getSelectedView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectedView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onProvideAutofillStructure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#onProvideAutofillStructure(android.view.ViewStructure, int)}
 **/
AdapterView.prototype.onProvideAutofillStructure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onProvideAutofillStructure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDetachedFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/AdapterView.html#onDetachedFromWindow()}
 **/
AdapterView.prototype.onDetachedFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDetachedFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.AdapterView') {
			return new AdapterView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AdapterView;
