/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.widget.HorizontalScrollView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.widget');

/**
 * @class android.widget.HorizontalScrollView
 * @extends android.widget.FrameLayout 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html}
 **/
var HorizontalScrollView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.widget.HorizontalScrollView')) {
		result = arguments[0];
	}
	else {
		result = HorizontalScrollView.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.widget.FrameLayout');
HorizontalScrollView.prototype = Object.create(SuperClass.prototype);
HorizontalScrollView.prototype.constructor = HorizontalScrollView;

Object.defineProperty(HorizontalScrollView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new HorizontalScrollView(this.$native.super);
	},
	enumerable: true
});

HorizontalScrollView.className = 'android.widget.HorizontalScrollView';
HorizontalScrollView.prototype.className = 'android.widget.HorizontalScrollView';

// class property
Object.defineProperty(HorizontalScrollView, 'class', {
	get: function() {
		return Hyperloop.getClass('android.widget.HorizontalScrollView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
HorizontalScrollView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.widget.HorizontalScrollView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(HorizontalScrollView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
HorizontalScrollView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new HorizontalScrollView(Hyperloop.cast('android.widget.HorizontalScrollView', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onInterceptTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onInterceptTouchEvent(android.view.MotionEvent)}
 **/
HorizontalScrollView.prototype.onInterceptTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInterceptTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeHorizontalScrollOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#computeHorizontalScrollOffset()}
 **/
HorizontalScrollView.prototype.computeHorizontalScrollOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeHorizontalScrollOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function smoothScrollBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#smoothScrollBy(int, int)}
 **/
HorizontalScrollView.prototype.smoothScrollBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'smoothScrollBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLeftEdgeEffectColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#getLeftEdgeEffectColor()}
 **/
HorizontalScrollView.prototype.getLeftEdgeEffectColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLeftEdgeEffectColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function measureChild
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#measureChild(android.view.View, int, int)}
 **/
HorizontalScrollView.prototype.measureChild = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'measureChild',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRestoreInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onRestoreInstanceState(android.os.Parcelable)}
 **/
HorizontalScrollView.prototype.onRestoreInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRestoreInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function measureChildWithMargins
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#measureChildWithMargins(android.view.View, int, int, int, int)}
 **/
HorizontalScrollView.prototype.measureChildWithMargins = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'measureChildWithMargins',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#computeScroll()}
 **/
HorizontalScrollView.prototype.computeScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEdgeEffectColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#setEdgeEffectColor(int)}
 **/
HorizontalScrollView.prototype.setEdgeEffectColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEdgeEffectColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchKeyEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#dispatchKeyEvent(android.view.KeyEvent)}
 **/
HorizontalScrollView.prototype.dispatchKeyEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchKeyEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fullScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#fullScroll(int)}
 **/
HorizontalScrollView.prototype.fullScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fullScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccessibilityClassName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#getAccessibilityClassName()}
 **/
HorizontalScrollView.prototype.getAccessibilityClassName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccessibilityClassName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fling
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#fling(int)}
 **/
HorizontalScrollView.prototype.fling = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'fling',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRightEdgeEffectColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#getRightEdgeEffectColor()}
 **/
HorizontalScrollView.prototype.getRightEdgeEffectColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRightEdgeEffectColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRightEdgeEffectColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#setRightEdgeEffectColor(int)}
 **/
HorizontalScrollView.prototype.setRightEdgeEffectColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRightEdgeEffectColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFillViewport
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#setFillViewport(boolean)}
 **/
HorizontalScrollView.prototype.setFillViewport = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFillViewport',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function executeKeyEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#executeKeyEvent(android.view.KeyEvent)}
 **/
HorizontalScrollView.prototype.executeKeyEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'executeKeyEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onOverScrolled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onOverScrolled(int, int, boolean, boolean)}
 **/
HorizontalScrollView.prototype.onOverScrolled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onOverScrolled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function shouldDelayChildPressedState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#shouldDelayChildPressedState()}
 **/
HorizontalScrollView.prototype.shouldDelayChildPressedState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shouldDelayChildPressedState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSmoothScrollingEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#setSmoothScrollingEnabled(boolean)}
 **/
HorizontalScrollView.prototype.setSmoothScrollingEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSmoothScrollingEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeHorizontalScrollRange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#computeHorizontalScrollRange()}
 **/
HorizontalScrollView.prototype.computeHorizontalScrollRange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeHorizontalScrollRange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function computeScrollDeltaToGetChildRectOnScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#computeScrollDeltaToGetChildRectOnScreen(android.graphics.Rect)}
 **/
HorizontalScrollView.prototype.computeScrollDeltaToGetChildRectOnScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'computeScrollDeltaToGetChildRectOnScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onTouchEvent(android.view.MotionEvent)}
 **/
HorizontalScrollView.prototype.onTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onLayout(boolean, int, int, int, int)}
 **/
HorizontalScrollView.prototype.onLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function smoothScrollTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#smoothScrollTo(int, int)}
 **/
HorizontalScrollView.prototype.smoothScrollTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'smoothScrollTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function draw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#draw(android.graphics.Canvas)}
 **/
HorizontalScrollView.prototype.draw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'draw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLeftEdgeEffectColor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#setLeftEdgeEffectColor(int)}
 **/
HorizontalScrollView.prototype.setLeftEdgeEffectColor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLeftEdgeEffectColor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#addView(android.view.View)}
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#addView(android.view.View, int)}
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#addView(android.view.View, android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#addView(android.view.View, int, android.view.ViewGroup$LayoutParams)}
 **/
HorizontalScrollView.prototype.addView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onMeasure(int, int)}
 **/
HorizontalScrollView.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRightFadingEdgeStrength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#getRightFadingEdgeStrength()}
 **/
HorizontalScrollView.prototype.getRightFadingEdgeStrength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRightFadingEdgeStrength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFillViewport
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#isFillViewport()}
 **/
HorizontalScrollView.prototype.isFillViewport = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFillViewport',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestChildRectangleOnScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#requestChildRectangleOnScreen(android.view.View, android.graphics.Rect, boolean)}
 **/
HorizontalScrollView.prototype.requestChildRectangleOnScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestChildRectangleOnScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function scrollTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#scrollTo(int, int)}
 **/
HorizontalScrollView.prototype.scrollTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'scrollTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function pageScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#pageScroll(int)}
 **/
HorizontalScrollView.prototype.pageScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'pageScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#requestLayout()}
 **/
HorizontalScrollView.prototype.requestLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSizeChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onSizeChanged(int, int, int, int)}
 **/
HorizontalScrollView.prototype.onSizeChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSizeChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onGenericMotionEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onGenericMotionEvent(android.view.MotionEvent)}
 **/
HorizontalScrollView.prototype.onGenericMotionEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onGenericMotionEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestChildFocus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#requestChildFocus(android.view.View, android.view.View)}
 **/
HorizontalScrollView.prototype.requestChildFocus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestChildFocus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLeftFadingEdgeStrength
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#getLeftFadingEdgeStrength()}
 **/
HorizontalScrollView.prototype.getLeftFadingEdgeStrength = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLeftFadingEdgeStrength',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMaxScrollAmount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#getMaxScrollAmount()}
 **/
HorizontalScrollView.prototype.getMaxScrollAmount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaxScrollAmount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSmoothScrollingEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#isSmoothScrollingEnabled()}
 **/
HorizontalScrollView.prototype.isSmoothScrollingEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSmoothScrollingEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requestDisallowInterceptTouchEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#requestDisallowInterceptTouchEvent(boolean)}
 **/
HorizontalScrollView.prototype.requestDisallowInterceptTouchEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestDisallowInterceptTouchEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onSaveInstanceState()}
 **/
HorizontalScrollView.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRequestFocusInDescendants
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#onRequestFocusInDescendants(int, android.graphics.Rect)}
 **/
HorizontalScrollView.prototype.onRequestFocusInDescendants = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRequestFocusInDescendants',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function arrowScroll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/HorizontalScrollView.html#arrowScroll(int)}
 **/
HorizontalScrollView.prototype.arrowScroll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'arrowScroll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.HorizontalScrollView') {
			return new HorizontalScrollView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = HorizontalScrollView;
