/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module android.widget.PopupWindow
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./android.widget');

/**
 * @class android.widget.PopupWindow
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html}
 **/
var PopupWindow = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('android.widget.PopupWindow')) {
		result = arguments[0];
	}
	else {
		result = PopupWindow.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
PopupWindow.prototype = Object.create(SuperClass.prototype);
PopupWindow.prototype.constructor = PopupWindow;

Object.defineProperty(PopupWindow.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new PopupWindow(this.$native.super);
	},
	enumerable: true
});

PopupWindow.className = 'android.widget.PopupWindow';
PopupWindow.prototype.className = 'android.widget.PopupWindow';

// class property
Object.defineProperty(PopupWindow, 'class', {
	get: function() {
		return Hyperloop.getClass('android.widget.PopupWindow');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
PopupWindow.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('android.widget.PopupWindow');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(PopupWindow.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
PopupWindow.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new PopupWindow(Hyperloop.cast('android.widget.PopupWindow', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#INPUT_METHOD_NEEDED}
 */
PopupWindow.INPUT_METHOD_NEEDED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#INPUT_METHOD_FROM_FOCUSABLE}
 */
PopupWindow.INPUT_METHOD_FROM_FOCUSABLE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#INPUT_METHOD_NOT_NEEDED}
 */
PopupWindow.INPUT_METHOD_NOT_NEEDED = 2;

// Inner classes
Object.defineProperty(PopupWindow, 'OnDismissListener', {
	get: function() {
		return require('./android.widget.PopupWindow$OnDismissListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setTouchModal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setTouchModal(boolean)}
 **/
PopupWindow.prototype.setTouchModal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTouchModal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAboveAnchor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isAboveAnchor()}
 **/
PopupWindow.prototype.isAboveAnchor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAboveAnchor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExitTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getExitTransition()}
 **/
PopupWindow.prototype.getExitTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExitTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isClippingEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isClippingEnabled()}
 **/
PopupWindow.prototype.isClippingEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isClippingEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getElevation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getElevation()}
 **/
PopupWindow.prototype.getElevation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getElevation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEnterTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getEnterTransition()}
 **/
PopupWindow.prototype.getEnterTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEnterTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setExitTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setExitTransition(android.transition.Transition)}
 **/
PopupWindow.prototype.setExitTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setExitTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isShowing
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isShowing()}
 **/
PopupWindow.prototype.isShowing = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isShowing',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setInputMethodMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setInputMethodMode(int)}
 **/
PopupWindow.prototype.setInputMethodMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setInputMethodMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEpicenterBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setEpicenterBounds(android.graphics.Rect)}
 **/
PopupWindow.prototype.setEpicenterBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEpicenterBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSoftInputMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getSoftInputMode()}
 **/
PopupWindow.prototype.getSoftInputMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSoftInputMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTouchable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setTouchable(boolean)}
 **/
PopupWindow.prototype.setTouchable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTouchable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOutsideTouchable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isOutsideTouchable()}
 **/
PopupWindow.prototype.isOutsideTouchable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOutsideTouchable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFocusable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setFocusable(boolean)}
 **/
PopupWindow.prototype.setFocusable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFocusable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dismiss
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#dismiss()}
 **/
PopupWindow.prototype.dismiss = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dismiss',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAnimationStyle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setAnimationStyle(int)}
 **/
PopupWindow.prototype.setAnimationStyle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAnimationStyle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getContentView()}
 **/
PopupWindow.prototype.getContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setHeight(int)}
 **/
PopupWindow.prototype.setHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAnimationStyle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getAnimationStyle()}
 **/
PopupWindow.prototype.getAnimationStyle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAnimationStyle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWindowLayoutType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getWindowLayoutType()}
 **/
PopupWindow.prototype.getWindowLayoutType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWindowLayoutType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBackgroundDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setBackgroundDrawable(android.graphics.drawable.Drawable)}
 **/
PopupWindow.prototype.setBackgroundDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBackgroundDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAttachedInDecor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setAttachedInDecor(boolean)}
 **/
PopupWindow.prototype.setAttachedInDecor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAttachedInDecor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOverlapAnchor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getOverlapAnchor()}
 **/
PopupWindow.prototype.getOverlapAnchor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOverlapAnchor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setWindowLayoutType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setWindowLayoutType(int)}
 **/
PopupWindow.prototype.setWindowLayoutType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setWindowLayoutType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showAsDropDown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#showAsDropDown(android.view.View)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#showAsDropDown(android.view.View, int, int)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#showAsDropDown(android.view.View, int, int, int)}
 **/
PopupWindow.prototype.showAsDropDown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showAsDropDown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSplitTouchEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isSplitTouchEnabled()}
 **/
PopupWindow.prototype.isSplitTouchEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSplitTouchEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isTouchModal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isTouchModal()}
 **/
PopupWindow.prototype.isTouchModal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isTouchModal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIsLaidOutInScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setIsLaidOutInScreen(boolean)}
 **/
PopupWindow.prototype.setIsLaidOutInScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIsLaidOutInScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnDismissListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setOnDismissListener(android.widget.PopupWindow$OnDismissListener)}
 **/
PopupWindow.prototype.setOnDismissListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnDismissListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function update
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#update()}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#update(int, int)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#update(int, int, int, int)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#update(int, int, int, int, boolean)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#update(android.view.View, int, int)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#update(android.view.View, int, int, int, int)}
 **/
PopupWindow.prototype.update = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'update',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getWidth()}
 **/
PopupWindow.prototype.getWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setClippingEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setClippingEnabled(boolean)}
 **/
PopupWindow.prototype.setClippingEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setClippingEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInputMethodMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getInputMethodMode()}
 **/
PopupWindow.prototype.getInputMethodMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInputMethodMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getHeight()}
 **/
PopupWindow.prototype.getHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEpicenterBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getEpicenterBounds()}
 **/
PopupWindow.prototype.getEpicenterBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEpicenterBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIgnoreCheekPress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setIgnoreCheekPress()}
 **/
PopupWindow.prototype.setIgnoreCheekPress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIgnoreCheekPress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMaxAvailableHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getMaxAvailableHeight(android.view.View)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getMaxAvailableHeight(android.view.View, int)}
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getMaxAvailableHeight(android.view.View, int, boolean)}
 **/
PopupWindow.prototype.getMaxAvailableHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMaxAvailableHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setWindowLayoutMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setWindowLayoutMode(int, int)}
 **/
PopupWindow.prototype.setWindowLayoutMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setWindowLayoutMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showAtLocation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#showAtLocation(android.view.View, int, int, int)}
 **/
PopupWindow.prototype.showAtLocation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showAtLocation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setElevation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setElevation(float)}
 **/
PopupWindow.prototype.setElevation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setElevation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSoftInputMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setSoftInputMode(int)}
 **/
PopupWindow.prototype.setSoftInputMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSoftInputMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setWidth(int)}
 **/
PopupWindow.prototype.setWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAttachedInDecor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isAttachedInDecor()}
 **/
PopupWindow.prototype.isAttachedInDecor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAttachedInDecor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setIsClippedToScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setIsClippedToScreen(boolean)}
 **/
PopupWindow.prototype.setIsClippedToScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setIsClippedToScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isLaidOutInScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isLaidOutInScreen()}
 **/
PopupWindow.prototype.isLaidOutInScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLaidOutInScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOverlapAnchor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setOverlapAnchor(boolean)}
 **/
PopupWindow.prototype.setOverlapAnchor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOverlapAnchor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTouchInterceptor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setTouchInterceptor(android.view.View$OnTouchListener)}
 **/
PopupWindow.prototype.setTouchInterceptor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTouchInterceptor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSplitTouchEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setSplitTouchEnabled(boolean)}
 **/
PopupWindow.prototype.setSplitTouchEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSplitTouchEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setContentView(android.view.View)}
 **/
PopupWindow.prototype.setContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isClippedToScreen
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isClippedToScreen()}
 **/
PopupWindow.prototype.isClippedToScreen = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isClippedToScreen',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setEnterTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setEnterTransition(android.transition.Transition)}
 **/
PopupWindow.prototype.setEnterTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEnterTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOutsideTouchable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#setOutsideTouchable(boolean)}
 **/
PopupWindow.prototype.setOutsideTouchable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOutsideTouchable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBackground
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#getBackground()}
 **/
PopupWindow.prototype.getBackground = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBackground',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFocusable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isFocusable()}
 **/
PopupWindow.prototype.isFocusable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFocusable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isTouchable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/android/widget/PopupWindow.html#isTouchable()}
 **/
PopupWindow.prototype.isTouchable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isTouchable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'android.widget.PopupWindow') {
			return new PopupWindow(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = PopupWindow;
