/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.ComponentActivity
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity');

/**
 * @class androidx.activity.ComponentActivity
 * @extends androidx.core.app.ComponentActivity 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html}
 **/
var ComponentActivity = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.ComponentActivity')) {
		result = arguments[0];
	}
	else {
		result = ComponentActivity.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./androidx.core.app.ComponentActivity');
ComponentActivity.prototype = Object.create(SuperClass.prototype);
ComponentActivity.prototype.constructor = ComponentActivity;

Object.defineProperty(ComponentActivity.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ComponentActivity(this.$native.super);
	},
	enumerable: true
});

ComponentActivity.className = 'androidx.activity.ComponentActivity';
ComponentActivity.prototype.className = 'androidx.activity.ComponentActivity';

// class property
Object.defineProperty(ComponentActivity, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.ComponentActivity');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ComponentActivity.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.activity.ComponentActivity');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ComponentActivity.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ComponentActivity.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ComponentActivity(Hyperloop.cast('androidx.activity.ComponentActivity', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ComponentActivity, 'NonConfigurationInstances', {
	get: function() {
		return require('./androidx.activity.ComponentActivity$NonConfigurationInstances');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onCreate(android.os.Bundle)}
 **/
ComponentActivity.prototype.onCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function peekAvailableContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#peekAvailableContext()}
 **/
ComponentActivity.prototype.peekAvailableContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'peekAvailableContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerForActivityResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#registerForActivityResult(androidx.activity.result.contract.ActivityResultContract, androidx.activity.result.ActivityResultRegistry, androidx.activity.result.ActivityResultCallback)}
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#registerForActivityResult(androidx.activity.result.contract.ActivityResultContract, androidx.activity.result.ActivityResultCallback)}
 **/
ComponentActivity.prototype.registerForActivityResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerForActivityResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeOnContextAvailableListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#removeOnContextAvailableListener(androidx.activity.contextaware.OnContextAvailableListener)}
 **/
ComponentActivity.prototype.removeOnContextAvailableListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeOnContextAvailableListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getViewModelStore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getViewModelStore()}
 **/
ComponentActivity.prototype.getViewModelStore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getViewModelStore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRequestPermissionsResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onRequestPermissionsResult(int, java.lang.String[], int[])}
 **/
ComponentActivity.prototype.onRequestPermissionsResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRequestPermissionsResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#addContentView(android.view.View, android.view.ViewGroup$LayoutParams)}
 **/
ComponentActivity.prototype.addContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOnBackPressedDispatcher
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getOnBackPressedDispatcher()}
 **/
ComponentActivity.prototype.getOnBackPressedDispatcher = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOnBackPressedDispatcher',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getActivityResultRegistry
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getActivityResultRegistry()}
 **/
ComponentActivity.prototype.getActivityResultRegistry = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getActivityResultRegistry',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSavedStateRegistry
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getSavedStateRegistry()}
 **/
ComponentActivity.prototype.getSavedStateRegistry = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSavedStateRegistry',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startIntentSenderForResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#startIntentSenderForResult(android.content.IntentSender, int, android.content.Intent, int, int, int)}
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#startIntentSenderForResult(android.content.IntentSender, int, android.content.Intent, int, int, int, android.os.Bundle)}
 **/
ComponentActivity.prototype.startIntentSenderForResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startIntentSenderForResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onActivityResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onActivityResult(int, int, android.content.Intent)}
 **/
ComponentActivity.prototype.onActivityResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLastCustomNonConfigurationInstance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getLastCustomNonConfigurationInstance()}
 **/
ComponentActivity.prototype.getLastCustomNonConfigurationInstance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLastCustomNonConfigurationInstance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startActivityForResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#startActivityForResult(android.content.Intent, int)}
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#startActivityForResult(android.content.Intent, int, android.os.Bundle)}
 **/
ComponentActivity.prototype.startActivityForResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startActivityForResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#setContentView(int)}
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#setContentView(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#setContentView(android.view.View, android.view.ViewGroup$LayoutParams)}
 **/
ComponentActivity.prototype.setContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reportFullyDrawn
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#reportFullyDrawn()}
 **/
ComponentActivity.prototype.reportFullyDrawn = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'reportFullyDrawn',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnContextAvailableListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#addOnContextAvailableListener(androidx.activity.contextaware.OnContextAvailableListener)}
 **/
ComponentActivity.prototype.addOnContextAvailableListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnContextAvailableListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onSaveInstanceState(android.os.Bundle)}
 **/
ComponentActivity.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRetainNonConfigurationInstance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onRetainNonConfigurationInstance()}
 **/
ComponentActivity.prototype.onRetainNonConfigurationInstance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRetainNonConfigurationInstance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLifecycle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getLifecycle()}
 **/
ComponentActivity.prototype.getLifecycle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLifecycle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRetainCustomNonConfigurationInstance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onRetainCustomNonConfigurationInstance()}
 **/
ComponentActivity.prototype.onRetainCustomNonConfigurationInstance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRetainCustomNonConfigurationInstance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDefaultViewModelProviderFactory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#getDefaultViewModelProviderFactory()}
 **/
ComponentActivity.prototype.getDefaultViewModelProviderFactory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDefaultViewModelProviderFactory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onBackPressed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/ComponentActivity.html#onBackPressed()}
 **/
ComponentActivity.prototype.onBackPressed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onBackPressed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ComponentActivity;
