/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.activity.result.IntentSenderRequest
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.activity.result');

/**
 * @class androidx.activity.result.IntentSenderRequest
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html}
 **/
var IntentSenderRequest = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.activity.result.IntentSenderRequest')) {
		result = arguments[0];
	}
	else {
		result = IntentSenderRequest.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
IntentSenderRequest.prototype = Object.create(SuperClass.prototype);
IntentSenderRequest.prototype.constructor = IntentSenderRequest;

Object.defineProperty(IntentSenderRequest.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new IntentSenderRequest(this.$native.super);
	},
	enumerable: true
});

IntentSenderRequest.className = 'androidx.activity.result.IntentSenderRequest';
IntentSenderRequest.prototype.className = 'androidx.activity.result.IntentSenderRequest';

// class property
Object.defineProperty(IntentSenderRequest, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.activity.result.IntentSenderRequest');
	},
	enumerable: true,
	configurable: false
});


// Cast
IntentSenderRequest.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new IntentSenderRequest(Hyperloop.cast('androidx.activity.result.IntentSenderRequest', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(IntentSenderRequest, 'Builder', {
	get: function() {
		return require('./androidx.activity.result.IntentSenderRequest$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#CREATOR
Object.defineProperty(IntentSenderRequest, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
				return new IntentSenderRequest(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getFillInIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#getFillInIntent()}
 **/
IntentSenderRequest.prototype.getFillInIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFillInIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
			return new IntentSenderRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIntentSender
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#getIntentSender()}
 **/
IntentSenderRequest.prototype.getIntentSender = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIntentSender',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
			return new IntentSenderRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFlagsMask
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#getFlagsMask()}
 **/
IntentSenderRequest.prototype.getFlagsMask = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFlagsMask',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
			return new IntentSenderRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFlagsValues
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#getFlagsValues()}
 **/
IntentSenderRequest.prototype.getFlagsValues = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFlagsValues',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
			return new IntentSenderRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function describeContents
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#describeContents()}
 **/
IntentSenderRequest.prototype.describeContents = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'describeContents',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
			return new IntentSenderRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/activity/result/IntentSenderRequest.html#writeToParcel(android.os.Parcel, int)}
 **/
IntentSenderRequest.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.activity.result.IntentSenderRequest') {
			return new IntentSenderRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = IntentSenderRequest;
