/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.app.ActionBarDrawerToggle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.app');

/**
 * @class androidx.appcompat.app.ActionBarDrawerToggle
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html}
 **/
var ActionBarDrawerToggle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.app.ActionBarDrawerToggle')) {
		result = arguments[0];
	}
	else {
		result = ActionBarDrawerToggle.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ActionBarDrawerToggle.prototype = Object.create(SuperClass.prototype);
ActionBarDrawerToggle.prototype.constructor = ActionBarDrawerToggle;

Object.defineProperty(ActionBarDrawerToggle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActionBarDrawerToggle(this.$native.super);
	},
	enumerable: true
});

ActionBarDrawerToggle.className = 'androidx.appcompat.app.ActionBarDrawerToggle';
ActionBarDrawerToggle.prototype.className = 'androidx.appcompat.app.ActionBarDrawerToggle';

// class property
Object.defineProperty(ActionBarDrawerToggle, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.app.ActionBarDrawerToggle');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ActionBarDrawerToggle.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.app.ActionBarDrawerToggle');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ActionBarDrawerToggle.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ActionBarDrawerToggle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActionBarDrawerToggle(Hyperloop.cast('androidx.appcompat.app.ActionBarDrawerToggle', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ActionBarDrawerToggle, 'Delegate', {
	get: function() {
		return require('./androidx.appcompat.app.ActionBarDrawerToggle$Delegate');
	},
	enumerable: true
});
Object.defineProperty(ActionBarDrawerToggle, 'DelegateProvider', {
	get: function() {
		return require('./androidx.appcompat.app.ActionBarDrawerToggle$DelegateProvider');
	},
	enumerable: true
});
Object.defineProperty(ActionBarDrawerToggle, 'FrameworkActionBarDelegate', {
	get: function() {
		return require('./androidx.appcompat.app.ActionBarDrawerToggle$FrameworkActionBarDelegate');
	},
	enumerable: true
});
Object.defineProperty(ActionBarDrawerToggle, 'ToolbarCompatDelegate', {
	get: function() {
		return require('./androidx.appcompat.app.ActionBarDrawerToggle$ToolbarCompatDelegate');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setDrawerSlideAnimationEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#setDrawerSlideAnimationEnabled(boolean)}
 **/
ActionBarDrawerToggle.prototype.setDrawerSlideAnimationEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerSlideAnimationEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrawerIndicatorEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#setDrawerIndicatorEnabled(boolean)}
 **/
ActionBarDrawerToggle.prototype.setDrawerIndicatorEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerIndicatorEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDrawerClosed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#onDrawerClosed(android.view.View)}
 **/
ActionBarDrawerToggle.prototype.onDrawerClosed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerClosed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function syncState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#syncState()}
 **/
ActionBarDrawerToggle.prototype.syncState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'syncState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrawerArrowDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#getDrawerArrowDrawable()}
 **/
ActionBarDrawerToggle.prototype.getDrawerArrowDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrawerArrowDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDrawerSlideAnimationEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#isDrawerSlideAnimationEnabled()}
 **/
ActionBarDrawerToggle.prototype.isDrawerSlideAnimationEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDrawerSlideAnimationEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDrawerIndicatorEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#isDrawerIndicatorEnabled()}
 **/
ActionBarDrawerToggle.prototype.isDrawerIndicatorEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDrawerIndicatorEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onOptionsItemSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#onOptionsItemSelected(android.view.MenuItem)}
 **/
ActionBarDrawerToggle.prototype.onOptionsItemSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onOptionsItemSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDrawerOpened
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#onDrawerOpened(android.view.View)}
 **/
ActionBarDrawerToggle.prototype.onDrawerOpened = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerOpened',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setToolbarNavigationClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#setToolbarNavigationClickListener(android.view.View$OnClickListener)}
 **/
ActionBarDrawerToggle.prototype.setToolbarNavigationClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setToolbarNavigationClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDrawerSlide
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#onDrawerSlide(android.view.View, float)}
 **/
ActionBarDrawerToggle.prototype.onDrawerSlide = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerSlide',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDrawerArrowDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#setDrawerArrowDrawable(androidx.appcompat.graphics.drawable.DrawerArrowDrawable)}
 **/
ActionBarDrawerToggle.prototype.setDrawerArrowDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDrawerArrowDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConfigurationChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#onConfigurationChanged(android.content.res.Configuration)}
 **/
ActionBarDrawerToggle.prototype.onConfigurationChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConfigurationChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHomeAsUpIndicator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#setHomeAsUpIndicator(android.graphics.drawable.Drawable)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#setHomeAsUpIndicator(int)}
 **/
ActionBarDrawerToggle.prototype.setHomeAsUpIndicator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHomeAsUpIndicator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getToolbarNavigationClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#getToolbarNavigationClickListener()}
 **/
ActionBarDrawerToggle.prototype.getToolbarNavigationClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getToolbarNavigationClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDrawerStateChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/ActionBarDrawerToggle.html#onDrawerStateChanged(int)}
 **/
ActionBarDrawerToggle.prototype.onDrawerStateChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDrawerStateChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.ActionBarDrawerToggle') {
			return new ActionBarDrawerToggle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ActionBarDrawerToggle;
