/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.app.AppCompatActivity
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.app');

/**
 * @class androidx.appcompat.app.AppCompatActivity
 * @extends androidx.fragment.app.FragmentActivity 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html}
 **/
var AppCompatActivity = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.app.AppCompatActivity')) {
		result = arguments[0];
	}
	else {
		result = AppCompatActivity.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./androidx.fragment.app.FragmentActivity');
AppCompatActivity.prototype = Object.create(SuperClass.prototype);
AppCompatActivity.prototype.constructor = AppCompatActivity;

Object.defineProperty(AppCompatActivity.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AppCompatActivity(this.$native.super);
	},
	enumerable: true
});

AppCompatActivity.className = 'androidx.appcompat.app.AppCompatActivity';
AppCompatActivity.prototype.className = 'androidx.appcompat.app.AppCompatActivity';

// class property
Object.defineProperty(AppCompatActivity, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.app.AppCompatActivity');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AppCompatActivity.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.app.AppCompatActivity');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AppCompatActivity.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AppCompatActivity.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AppCompatActivity(Hyperloop.cast('androidx.appcompat.app.AppCompatActivity', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onKeyDown
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onKeyDown(int, android.view.KeyEvent)}
 **/
AppCompatActivity.prototype.onKeyDown = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onKeyDown',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onNightModeChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onNightModeChanged(int)}
 **/
AppCompatActivity.prototype.onNightModeChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onNightModeChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#addContentView(android.view.View, android.view.ViewGroup$LayoutParams)}
 **/
AppCompatActivity.prototype.addContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findViewById
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#findViewById(int)}
 **/
AppCompatActivity.prototype.findViewById = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findViewById',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startSupportActionMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#startSupportActionMode(androidx.appcompat.view.ActionMode$Callback)}
 **/
AppCompatActivity.prototype.startSupportActionMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startSupportActionMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchKeyEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#dispatchKeyEvent(android.view.KeyEvent)}
 **/
AppCompatActivity.prototype.dispatchKeyEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchKeyEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function attachBaseContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#attachBaseContext(android.content.Context)}
 **/
AppCompatActivity.prototype.attachBaseContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'attachBaseContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSupportNavigateUp
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onSupportNavigateUp()}
 **/
AppCompatActivity.prototype.onSupportNavigateUp = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSupportNavigateUp',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDelegate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#getDelegate()}
 **/
AppCompatActivity.prototype.getDelegate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDelegate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportActionBar
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#getSupportActionBar()}
 **/
AppCompatActivity.prototype.getSupportActionBar = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportActionBar',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportInvalidateOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#supportInvalidateOptionsMenu()}
 **/
AppCompatActivity.prototype.supportInvalidateOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportInvalidateOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportProgressBarIndeterminate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setSupportProgressBarIndeterminate(boolean)}
 **/
AppCompatActivity.prototype.setSupportProgressBarIndeterminate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportProgressBarIndeterminate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onStart()}
 **/
AppCompatActivity.prototype.onStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPostCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onPostCreate(android.os.Bundle)}
 **/
AppCompatActivity.prototype.onPostCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPostCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResources
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#getResources()}
 **/
AppCompatActivity.prototype.getResources = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResources',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportActionBar
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setSupportActionBar(androidx.appcompat.widget.Toolbar)}
 **/
AppCompatActivity.prototype.setSupportActionBar = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportActionBar',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportParentActivityIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#getSupportParentActivityIntent()}
 **/
AppCompatActivity.prototype.getSupportParentActivityIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportParentActivityIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportProgress
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setSupportProgress(int)}
 **/
AppCompatActivity.prototype.setSupportProgress = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportProgress',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onStop()}
 **/
AppCompatActivity.prototype.onStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSupportActionModeStarted
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onSupportActionModeStarted(androidx.appcompat.view.ActionMode)}
 **/
AppCompatActivity.prototype.onSupportActionModeStarted = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSupportActionModeStarted',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportProgressBarVisibility
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setSupportProgressBarVisibility(boolean)}
 **/
AppCompatActivity.prototype.setSupportProgressBarVisibility = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportProgressBarVisibility',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSupportContentChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onSupportContentChanged()}
 **/
AppCompatActivity.prototype.onSupportContentChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSupportContentChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDrawerToggleDelegate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#getDrawerToggleDelegate()}
 **/
AppCompatActivity.prototype.getDrawerToggleDelegate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDrawerToggleDelegate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDestroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onDestroy()}
 **/
AppCompatActivity.prototype.onDestroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDestroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSupportActionModeFinished
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onSupportActionModeFinished(androidx.appcompat.view.ActionMode)}
 **/
AppCompatActivity.prototype.onSupportActionModeFinished = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSupportActionModeFinished',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportShouldUpRecreateTask
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#supportShouldUpRecreateTask(android.content.Intent)}
 **/
AppCompatActivity.prototype.supportShouldUpRecreateTask = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportShouldUpRecreateTask',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMenuOpened
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onMenuOpened(int, android.view.Menu)}
 **/
AppCompatActivity.prototype.onMenuOpened = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMenuOpened',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepareSupportNavigateUpTaskStack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onPrepareSupportNavigateUpTaskStack(androidx.core.app.TaskStackBuilder)}
 **/
AppCompatActivity.prototype.onPrepareSupportNavigateUpTaskStack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareSupportNavigateUpTaskStack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportNavigateUpTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#supportNavigateUpTo(android.content.Intent)}
 **/
AppCompatActivity.prototype.supportNavigateUpTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportNavigateUpTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMenuItemSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onMenuItemSelected(int, android.view.MenuItem)}
 **/
AppCompatActivity.prototype.onMenuItemSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMenuItemSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportRequestWindowFeature
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#supportRequestWindowFeature(int)}
 **/
AppCompatActivity.prototype.supportRequestWindowFeature = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportRequestWindowFeature',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreateSupportNavigateUpTaskStack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onCreateSupportNavigateUpTaskStack(androidx.core.app.TaskStackBuilder)}
 **/
AppCompatActivity.prototype.onCreateSupportNavigateUpTaskStack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreateSupportNavigateUpTaskStack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function closeOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#closeOptionsMenu()}
 **/
AppCompatActivity.prototype.closeOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'closeOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onWindowStartingSupportActionMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onWindowStartingSupportActionMode(androidx.appcompat.view.ActionMode$Callback)}
 **/
AppCompatActivity.prototype.onWindowStartingSupportActionMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onWindowStartingSupportActionMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTitleChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onTitleChanged(java.lang.CharSequence, int)}
 **/
AppCompatActivity.prototype.onTitleChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTitleChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function openOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#openOptionsMenu()}
 **/
AppCompatActivity.prototype.openOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'openOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContentView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setContentView(int)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setContentView(android.view.View)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setContentView(android.view.View, android.view.ViewGroup$LayoutParams)}
 **/
AppCompatActivity.prototype.setContentView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMenuInflater
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#getMenuInflater()}
 **/
AppCompatActivity.prototype.getMenuInflater = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMenuInflater',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTheme
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setTheme(int)}
 **/
AppCompatActivity.prototype.setTheme = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTheme',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setSupportProgressBarIndeterminateVisibility
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#setSupportProgressBarIndeterminateVisibility(boolean)}
 **/
AppCompatActivity.prototype.setSupportProgressBarIndeterminateVisibility = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setSupportProgressBarIndeterminateVisibility',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPostResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onPostResume()}
 **/
AppCompatActivity.prototype.onPostResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPostResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPanelClosed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onPanelClosed(int, android.view.Menu)}
 **/
AppCompatActivity.prototype.onPanelClosed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPanelClosed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConfigurationChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onConfigurationChanged(android.content.res.Configuration)}
 **/
AppCompatActivity.prototype.onConfigurationChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConfigurationChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onContentChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#onContentChanged()}
 **/
AppCompatActivity.prototype.onContentChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onContentChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invalidateOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity.html#invalidateOptionsMenu()}
 **/
AppCompatActivity.prototype.invalidateOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invalidateOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.app.AppCompatActivity') {
			return new AppCompatActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AppCompatActivity;
