/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module MenuPresenter
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.view.menu');

/**
 * constructor
 * http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html
 **/
var MenuPresenter = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('androidx.appcompat.view.menu.MenuPresenter');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
MenuPresenter.prototype = Object.create(SuperClass.prototype);
MenuPresenter.prototype.constructor = MenuPresenter;

Object.defineProperty(MenuPresenter.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MenuPresenter(this.$native.super);
	},
	enumerable: true
});

MenuPresenter.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

MenuPresenter.className = "androidx.appcompat.view.menu.MenuPresenter";
MenuPresenter.prototype.className = "androidx.appcompat.view.menu.MenuPresenter";

// class property
Object.defineProperty(MenuPresenter, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.view.menu.MenuPresenter');
	},
	enumerable: true,
	configurable: false
});

// Cast
MenuPresenter.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MenuPresenter(Hyperloop.cast('androidx.appcompat.view.menu.MenuPresenter', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function collapseItemActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#collapseItemActionView(androidx.appcompat.view.menu.MenuBuilder, androidx.appcompat.view.menu.MenuItemImpl)}
 **/
MenuPresenter.prototype.collapseItemActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'collapseItemActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getMenuView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#getMenuView(android.view.ViewGroup)}
 **/
MenuPresenter.prototype.getMenuView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMenuView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onRestoreInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#onRestoreInstanceState(android.os.Parcelable)}
 **/
MenuPresenter.prototype.onRestoreInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRestoreInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function initForMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#initForMenu(android.content.Context, androidx.appcompat.view.menu.MenuBuilder)}
 **/
MenuPresenter.prototype.initForMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initForMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onSubMenuSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#onSubMenuSelected(androidx.appcompat.view.menu.SubMenuBuilder)}
 **/
MenuPresenter.prototype.onSubMenuSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSubMenuSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function setCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#setCallback(androidx.appcompat.view.menu.MenuPresenter$Callback)}
 **/
MenuPresenter.prototype.setCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function expandItemActionView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#expandItemActionView(androidx.appcompat.view.menu.MenuBuilder, androidx.appcompat.view.menu.MenuItemImpl)}
 **/
MenuPresenter.prototype.expandItemActionView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'expandItemActionView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#getId()}
 **/
MenuPresenter.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#onSaveInstanceState()}
 **/
MenuPresenter.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function flagActionItems
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#flagActionItems()}
 **/
MenuPresenter.prototype.flagActionItems = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'flagActionItems',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function updateMenuView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#updateMenuView(boolean)}
 **/
MenuPresenter.prototype.updateMenuView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateMenuView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function onCloseMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/view/menu/MenuPresenter.html#onCloseMenu(androidx.appcompat.view.menu.MenuBuilder, boolean)}
 **/
MenuPresenter.prototype.onCloseMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCloseMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.view.menu.MenuPresenter') {
			return new MenuPresenter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

MenuPresenter.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

MenuPresenter.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = MenuPresenter;
