/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.widget.ActionMenuView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.widget');

/**
 * @class androidx.appcompat.widget.ActionMenuView
 * @extends androidx.appcompat.widget.LinearLayoutCompat 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html}
 **/
var ActionMenuView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.widget.ActionMenuView')) {
		result = arguments[0];
	}
	else {
		result = ActionMenuView.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./androidx.appcompat.widget.LinearLayoutCompat');
ActionMenuView.prototype = Object.create(SuperClass.prototype);
ActionMenuView.prototype.constructor = ActionMenuView;

Object.defineProperty(ActionMenuView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActionMenuView(this.$native.super);
	},
	enumerable: true
});

ActionMenuView.className = 'androidx.appcompat.widget.ActionMenuView';
ActionMenuView.prototype.className = 'androidx.appcompat.widget.ActionMenuView';

// class property
Object.defineProperty(ActionMenuView, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.widget.ActionMenuView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ActionMenuView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.widget.ActionMenuView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ActionMenuView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ActionMenuView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActionMenuView(Hyperloop.cast('androidx.appcompat.widget.ActionMenuView', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ActionMenuView, 'ActionMenuChildView', {
	get: function() {
		return require('./androidx.appcompat.widget.ActionMenuView$ActionMenuChildView');
	},
	enumerable: true
});
Object.defineProperty(ActionMenuView, 'ActionMenuPresenterCallback', {
	get: function() {
		return require('./androidx.appcompat.widget.ActionMenuView$ActionMenuPresenterCallback');
	},
	enumerable: true
});
Object.defineProperty(ActionMenuView, 'LayoutParams', {
	get: function() {
		return require('./androidx.appcompat.widget.ActionMenuView$LayoutParams');
	},
	enumerable: true
});
Object.defineProperty(ActionMenuView, 'MenuBuilderCallback', {
	get: function() {
		return require('./androidx.appcompat.widget.ActionMenuView$MenuBuilderCallback');
	},
	enumerable: true
});
Object.defineProperty(ActionMenuView, 'OnMenuItemClickListener', {
	get: function() {
		return require('./androidx.appcompat.widget.ActionMenuView$OnMenuItemClickListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function generateOverflowButtonLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateOverflowButtonLayoutParams()}
 **/
ActionMenuView.prototype.generateOverflowButtonLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateOverflowButtonLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasSupportDividerBeforeChildAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#hasSupportDividerBeforeChildAt(int)}
 **/
ActionMenuView.prototype.hasSupportDividerBeforeChildAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasSupportDividerBeforeChildAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generateLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateLayoutParams(android.util.AttributeSet)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateLayoutParams(android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateLayoutParams(android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateLayoutParams(android.util.AttributeSet)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateLayoutParams(android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateLayoutParams(android.util.AttributeSet)}
 **/
ActionMenuView.prototype.generateLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invokeItem
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#invokeItem(androidx.appcompat.view.menu.MenuItemImpl)}
 **/
ActionMenuView.prototype.invokeItem = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invokeItem',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setMenuCallbacks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setMenuCallbacks(androidx.appcompat.view.menu.MenuPresenter$Callback, androidx.appcompat.view.menu.MenuBuilder$Callback)}
 **/
ActionMenuView.prototype.setMenuCallbacks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setMenuCallbacks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPopupTheme
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#getPopupTheme()}
 **/
ActionMenuView.prototype.getPopupTheme = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPopupTheme',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOverflowIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setOverflowIcon(android.graphics.drawable.Drawable)}
 **/
ActionMenuView.prototype.setOverflowIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOverflowIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generateDefaultLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateDefaultLayoutParams()}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateDefaultLayoutParams()}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#generateDefaultLayoutParams()}
 **/
ActionMenuView.prototype.generateDefaultLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateDefaultLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dismissPopupMenus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#dismissPopupMenus()}
 **/
ActionMenuView.prototype.dismissPopupMenus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dismissPopupMenus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setExpandedActionViewsExclusive
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setExpandedActionViewsExclusive(boolean)}
 **/
ActionMenuView.prototype.setExpandedActionViewsExclusive = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setExpandedActionViewsExclusive',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOverflowMenuShowPending
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#isOverflowMenuShowPending()}
 **/
ActionMenuView.prototype.isOverflowMenuShowPending = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOverflowMenuShowPending',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOverflowReserved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#isOverflowReserved()}
 **/
ActionMenuView.prototype.isOverflowReserved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOverflowReserved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#getMenu()}
 **/
ActionMenuView.prototype.getMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOverflowIcon
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#getOverflowIcon()}
 **/
ActionMenuView.prototype.getOverflowIcon = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOverflowIcon',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#checkLayoutParams(android.view.ViewGroup$LayoutParams)}
 **/
ActionMenuView.prototype.checkLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isOverflowMenuShowing
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#isOverflowMenuShowing()}
 **/
ActionMenuView.prototype.isOverflowMenuShowing = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isOverflowMenuShowing',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOnMenuItemClickListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setOnMenuItemClickListener(androidx.appcompat.widget.ActionMenuView$OnMenuItemClickListener)}
 **/
ActionMenuView.prototype.setOnMenuItemClickListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOnMenuItemClickListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hideOverflowMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#hideOverflowMenu()}
 **/
ActionMenuView.prototype.hideOverflowMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hideOverflowMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function peekMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#peekMenu()}
 **/
ActionMenuView.prototype.peekMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'peekMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPopupTheme
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setPopupTheme(int)}
 **/
ActionMenuView.prototype.setPopupTheme = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPopupTheme',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#onLayout(boolean, int, int, int, int)}
 **/
ActionMenuView.prototype.onLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchPopulateAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#dispatchPopulateAccessibilityEvent(android.view.accessibility.AccessibilityEvent)}
 **/
ActionMenuView.prototype.dispatchPopulateAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchPopulateAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setPresenter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setPresenter(androidx.appcompat.widget.ActionMenuPresenter)}
 **/
ActionMenuView.prototype.setPresenter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPresenter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#onMeasure(int, int)}
 **/
ActionMenuView.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWindowAnimations
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#getWindowAnimations()}
 **/
ActionMenuView.prototype.getWindowAnimations = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWindowAnimations',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function initialize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#initialize(androidx.appcompat.view.menu.MenuBuilder)}
 **/
ActionMenuView.prototype.initialize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initialize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConfigurationChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#onConfigurationChanged(android.content.res.Configuration)}
 **/
ActionMenuView.prototype.onConfigurationChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConfigurationChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDetachedFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#onDetachedFromWindow()}
 **/
ActionMenuView.prototype.onDetachedFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDetachedFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function showOverflowMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#showOverflowMenu()}
 **/
ActionMenuView.prototype.showOverflowMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'showOverflowMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOverflowReserved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ActionMenuView.html#setOverflowReserved(boolean)}
 **/
ActionMenuView.prototype.setOverflowReserved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOverflowReserved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ActionMenuView') {
			return new ActionMenuView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ActionMenuView;
