/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.widget.LinearLayoutCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.widget');

/**
 * @class androidx.appcompat.widget.LinearLayoutCompat
 * @extends android.view.ViewGroup 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html}
 **/
var LinearLayoutCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.widget.LinearLayoutCompat')) {
		result = arguments[0];
	}
	else {
		result = LinearLayoutCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.ViewGroup');
LinearLayoutCompat.prototype = Object.create(SuperClass.prototype);
LinearLayoutCompat.prototype.constructor = LinearLayoutCompat;

Object.defineProperty(LinearLayoutCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new LinearLayoutCompat(this.$native.super);
	},
	enumerable: true
});

LinearLayoutCompat.className = 'androidx.appcompat.widget.LinearLayoutCompat';
LinearLayoutCompat.prototype.className = 'androidx.appcompat.widget.LinearLayoutCompat';

// class property
Object.defineProperty(LinearLayoutCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.widget.LinearLayoutCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
LinearLayoutCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.widget.LinearLayoutCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(LinearLayoutCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
LinearLayoutCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new LinearLayoutCompat(Hyperloop.cast('androidx.appcompat.widget.LinearLayoutCompat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#VERTICAL}
 */
LinearLayoutCompat.VERTICAL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#SHOW_DIVIDER_MIDDLE}
 */
LinearLayoutCompat.SHOW_DIVIDER_MIDDLE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#HORIZONTAL}
 */
LinearLayoutCompat.HORIZONTAL = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#SHOW_DIVIDER_END}
 */
LinearLayoutCompat.SHOW_DIVIDER_END = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#SHOW_DIVIDER_NONE}
 */
LinearLayoutCompat.SHOW_DIVIDER_NONE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#SHOW_DIVIDER_BEGINNING}
 */
LinearLayoutCompat.SHOW_DIVIDER_BEGINNING = 1;

// Inner classes
Object.defineProperty(LinearLayoutCompat, 'DividerMode', {
	get: function() {
		return require('./androidx.appcompat.widget.LinearLayoutCompat$DividerMode');
	},
	enumerable: true
});
Object.defineProperty(LinearLayoutCompat, 'LayoutParams', {
	get: function() {
		return require('./androidx.appcompat.widget.LinearLayoutCompat$LayoutParams');
	},
	enumerable: true
});
Object.defineProperty(LinearLayoutCompat, 'OrientationMode', {
	get: function() {
		return require('./androidx.appcompat.widget.LinearLayoutCompat$OrientationMode');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function generateLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#generateLayoutParams(android.util.AttributeSet)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#generateLayoutParams(android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#generateLayoutParams(android.view.ViewGroup$LayoutParams)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#generateLayoutParams(android.util.AttributeSet)}
 **/
LinearLayoutCompat.prototype.generateLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isBaselineAligned
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#isBaselineAligned()}
 **/
LinearLayoutCompat.prototype.isBaselineAligned = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBaselineAligned',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setMeasureWithLargestChildEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setMeasureWithLargestChildEnabled(boolean)}
 **/
LinearLayoutCompat.prototype.setMeasureWithLargestChildEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setMeasureWithLargestChildEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDividerPadding
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setDividerPadding(int)}
 **/
LinearLayoutCompat.prototype.setDividerPadding = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDividerPadding',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#onInitializeAccessibilityEvent(android.view.accessibility.AccessibilityEvent)}
 **/
LinearLayoutCompat.prototype.onInitializeAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBaselineAlignedChildIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setBaselineAlignedChildIndex(int)}
 **/
LinearLayoutCompat.prototype.setBaselineAlignedChildIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBaselineAlignedChildIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getWeightSum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getWeightSum()}
 **/
LinearLayoutCompat.prototype.getWeightSum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getWeightSum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function generateDefaultLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#generateDefaultLayoutParams()}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#generateDefaultLayoutParams()}
 **/
LinearLayoutCompat.prototype.generateDefaultLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'generateDefaultLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDividerDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getDividerDrawable()}
 **/
LinearLayoutCompat.prototype.getDividerDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDividerDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBaselineAlignedChildIndex
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getBaselineAlignedChildIndex()}
 **/
LinearLayoutCompat.prototype.getBaselineAlignedChildIndex = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBaselineAlignedChildIndex',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setDividerDrawable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setDividerDrawable(android.graphics.drawable.Drawable)}
 **/
LinearLayoutCompat.prototype.setDividerDrawable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setDividerDrawable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setHorizontalGravity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setHorizontalGravity(int)}
 **/
LinearLayoutCompat.prototype.setHorizontalGravity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setHorizontalGravity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOrientation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getOrientation()}
 **/
LinearLayoutCompat.prototype.getOrientation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOrientation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkLayoutParams
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#checkLayoutParams(android.view.ViewGroup$LayoutParams)}
 **/
LinearLayoutCompat.prototype.checkLayoutParams = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkLayoutParams',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setBaselineAligned
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setBaselineAligned(boolean)}
 **/
LinearLayoutCompat.prototype.setBaselineAligned = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setBaselineAligned',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDraw
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#onDraw(android.graphics.Canvas)}
 **/
LinearLayoutCompat.prototype.onDraw = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDraw',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGravity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getGravity()}
 **/
LinearLayoutCompat.prototype.getGravity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGravity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function shouldDelayChildPressedState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#shouldDelayChildPressedState()}
 **/
LinearLayoutCompat.prototype.shouldDelayChildPressedState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'shouldDelayChildPressedState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOrientation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setOrientation(int)}
 **/
LinearLayoutCompat.prototype.setOrientation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOrientation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLayout
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#onLayout(boolean, int, int, int, int)}
 **/
LinearLayoutCompat.prototype.onLayout = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLayout',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDividerPadding
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getDividerPadding()}
 **/
LinearLayoutCompat.prototype.getDividerPadding = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDividerPadding',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasDividerBeforeChildAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#hasDividerBeforeChildAt(int)}
 **/
LinearLayoutCompat.prototype.hasDividerBeforeChildAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasDividerBeforeChildAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#onMeasure(int, int)}
 **/
LinearLayoutCompat.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getShowDividers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getShowDividers()}
 **/
LinearLayoutCompat.prototype.getShowDividers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getShowDividers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isMeasureWithLargestChildEnabled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#isMeasureWithLargestChildEnabled()}
 **/
LinearLayoutCompat.prototype.isMeasureWithLargestChildEnabled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isMeasureWithLargestChildEnabled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setShowDividers
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setShowDividers(int)}
 **/
LinearLayoutCompat.prototype.setShowDividers = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setShowDividers',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBaseline
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getBaseline()}
 **/
LinearLayoutCompat.prototype.getBaseline = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBaseline',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setVerticalGravity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setVerticalGravity(int)}
 **/
LinearLayoutCompat.prototype.setVerticalGravity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setVerticalGravity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setWeightSum
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setWeightSum(float)}
 **/
LinearLayoutCompat.prototype.setWeightSum = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setWeightSum',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setGravity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#setGravity(int)}
 **/
LinearLayoutCompat.prototype.setGravity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setGravity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDividerWidth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#getDividerWidth()}
 **/
LinearLayoutCompat.prototype.getDividerWidth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDividerWidth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityNodeInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/LinearLayoutCompat.html#onInitializeAccessibilityNodeInfo(android.view.accessibility.AccessibilityNodeInfo)}
 **/
LinearLayoutCompat.prototype.onInitializeAccessibilityNodeInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityNodeInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.LinearLayoutCompat') {
			return new LinearLayoutCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = LinearLayoutCompat;
