/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.appcompat.widget.ScrollingTabContainerView
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.appcompat.widget');

/**
 * @class androidx.appcompat.widget.ScrollingTabContainerView
 * @extends android.widget.HorizontalScrollView 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html}
 **/
var ScrollingTabContainerView = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.appcompat.widget.ScrollingTabContainerView')) {
		result = arguments[0];
	}
	else {
		result = ScrollingTabContainerView.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.widget.HorizontalScrollView');
ScrollingTabContainerView.prototype = Object.create(SuperClass.prototype);
ScrollingTabContainerView.prototype.constructor = ScrollingTabContainerView;

Object.defineProperty(ScrollingTabContainerView.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ScrollingTabContainerView(this.$native.super);
	},
	enumerable: true
});

ScrollingTabContainerView.className = 'androidx.appcompat.widget.ScrollingTabContainerView';
ScrollingTabContainerView.prototype.className = 'androidx.appcompat.widget.ScrollingTabContainerView';

// class property
Object.defineProperty(ScrollingTabContainerView, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.appcompat.widget.ScrollingTabContainerView');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ScrollingTabContainerView.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.appcompat.widget.ScrollingTabContainerView');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ScrollingTabContainerView.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ScrollingTabContainerView.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ScrollingTabContainerView(Hyperloop.cast('androidx.appcompat.widget.ScrollingTabContainerView', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ScrollingTabContainerView, 'TabAdapter', {
	get: function() {
		return require('./androidx.appcompat.widget.ScrollingTabContainerView$TabAdapter');
	},
	enumerable: true
});
Object.defineProperty(ScrollingTabContainerView, 'TabClickListener', {
	get: function() {
		return require('./androidx.appcompat.widget.ScrollingTabContainerView$TabClickListener');
	},
	enumerable: true
});
Object.defineProperty(ScrollingTabContainerView, 'TabView', {
	get: function() {
		return require('./androidx.appcompat.widget.ScrollingTabContainerView$TabView');
	},
	enumerable: true
});
Object.defineProperty(ScrollingTabContainerView, 'VisibilityAnimListener', {
	get: function() {
		return require('./androidx.appcompat.widget.ScrollingTabContainerView$VisibilityAnimListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields
// http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#mVisAnimListener
Object.defineProperty(ScrollingTabContainerView.prototype, 'mVisAnimListener', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('mVisAnimListener');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
				return new ScrollingTabContainerView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#mVisibilityAnim
Object.defineProperty(ScrollingTabContainerView.prototype, 'mVisibilityAnim', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('mVisibilityAnim');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
				return new ScrollingTabContainerView(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('mVisibilityAnim', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function addTab
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#addTab(androidx.appcompat.app.ActionBar$Tab, boolean)}
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#addTab(androidx.appcompat.app.ActionBar$Tab, int, boolean)}
 **/
ScrollingTabContainerView.prototype.addTab = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addTab',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onNothingSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#onNothingSelected(android.widget.AdapterView)}
 **/
ScrollingTabContainerView.prototype.onNothingSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onNothingSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setAllowCollapse
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#setAllowCollapse(boolean)}
 **/
ScrollingTabContainerView.prototype.setAllowCollapse = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setAllowCollapse',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMeasure
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#onMeasure(int, int)}
 **/
ScrollingTabContainerView.prototype.onMeasure = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMeasure',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setTabSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#setTabSelected(int)}
 **/
ScrollingTabContainerView.prototype.setTabSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setTabSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onItemSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#onItemSelected(android.widget.AdapterView, android.view.View, int, long)}
 **/
ScrollingTabContainerView.prototype.onItemSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onItemSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function animateToTab
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#animateToTab(int)}
 **/
ScrollingTabContainerView.prototype.animateToTab = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'animateToTab',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeAllTabs
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#removeAllTabs()}
 **/
ScrollingTabContainerView.prototype.removeAllTabs = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeAllTabs',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeTabAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#removeTabAt(int)}
 **/
ScrollingTabContainerView.prototype.removeTabAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeTabAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setContentHeight
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#setContentHeight(int)}
 **/
ScrollingTabContainerView.prototype.setContentHeight = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setContentHeight',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function animateToVisibility
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#animateToVisibility(int)}
 **/
ScrollingTabContainerView.prototype.animateToVisibility = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'animateToVisibility',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConfigurationChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#onConfigurationChanged(android.content.res.Configuration)}
 **/
ScrollingTabContainerView.prototype.onConfigurationChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConfigurationChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDetachedFromWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#onDetachedFromWindow()}
 **/
ScrollingTabContainerView.prototype.onDetachedFromWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDetachedFromWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateTab
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#updateTab(int)}
 **/
ScrollingTabContainerView.prototype.updateTab = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateTab',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAttachedToWindow
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/appcompat/widget/ScrollingTabContainerView.html#onAttachedToWindow()}
 **/
ScrollingTabContainerView.prototype.onAttachedToWindow = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAttachedToWindow',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.appcompat.widget.ScrollingTabContainerView') {
			return new ScrollingTabContainerView(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ScrollingTabContainerView;
