/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.app.ActivityOptionsCompat
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.app');

/**
 * @class androidx.core.app.ActivityOptionsCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html}
 **/
var ActivityOptionsCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.app.ActivityOptionsCompat')) {
		result = arguments[0];
	}
	else {
		result = ActivityOptionsCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ActivityOptionsCompat.prototype = Object.create(SuperClass.prototype);
ActivityOptionsCompat.prototype.constructor = ActivityOptionsCompat;

Object.defineProperty(ActivityOptionsCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ActivityOptionsCompat(this.$native.super);
	},
	enumerable: true
});

ActivityOptionsCompat.className = 'androidx.core.app.ActivityOptionsCompat';
ActivityOptionsCompat.prototype.className = 'androidx.core.app.ActivityOptionsCompat';

// class property
Object.defineProperty(ActivityOptionsCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.app.ActivityOptionsCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ActivityOptionsCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.app.ActivityOptionsCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ActivityOptionsCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ActivityOptionsCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ActivityOptionsCompat(Hyperloop.cast('androidx.core.app.ActivityOptionsCompat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#EXTRA_USAGE_TIME_REPORT}
 */
ActivityOptionsCompat.EXTRA_USAGE_TIME_REPORT = "android.activity.usage_time";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#EXTRA_USAGE_TIME_REPORT_PACKAGES}
 */
ActivityOptionsCompat.EXTRA_USAGE_TIME_REPORT_PACKAGES = "android.usage_time_packages";

// Inner classes
Object.defineProperty(ActivityOptionsCompat, 'ActivityOptionsCompatImpl', {
	get: function() {
		return require('./androidx.core.app.ActivityOptionsCompat$ActivityOptionsCompatImpl');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function makeScaleUpAnimation
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeScaleUpAnimation(android.view.View, int, int, int, int)}
 **/
ActivityOptionsCompat.makeScaleUpAnimation = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeScaleUpAnimation',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeCustomAnimation
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeCustomAnimation(android.content.Context, int, int)}
 **/
ActivityOptionsCompat.makeCustomAnimation = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeCustomAnimation',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeClipRevealAnimation
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeClipRevealAnimation(android.view.View, int, int, int, int)}
 **/
ActivityOptionsCompat.makeClipRevealAnimation = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeClipRevealAnimation',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeSceneTransitionAnimation
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeSceneTransitionAnimation(android.app.Activity, android.view.View, java.lang.String)}
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeSceneTransitionAnimation(android.app.Activity, androidx.core.util.Pair[])}
 **/
ActivityOptionsCompat.makeSceneTransitionAnimation = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeSceneTransitionAnimation',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeThumbnailScaleUpAnimation
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeThumbnailScaleUpAnimation(android.view.View, android.graphics.Bitmap, int, int)}
 **/
ActivityOptionsCompat.makeThumbnailScaleUpAnimation = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeThumbnailScaleUpAnimation',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeTaskLaunchBehind
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeTaskLaunchBehind()}
 **/
ActivityOptionsCompat.makeTaskLaunchBehind = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeTaskLaunchBehind',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function makeBasic
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#makeBasic()}
 **/
ActivityOptionsCompat.makeBasic = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'makeBasic',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function requestUsageTimeReport
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#requestUsageTimeReport(android.app.PendingIntent)}
 **/
ActivityOptionsCompat.prototype.requestUsageTimeReport = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestUsageTimeReport',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function update
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#update(androidx.core.app.ActivityOptionsCompat)}
 **/
ActivityOptionsCompat.prototype.update = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'update',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLaunchBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#getLaunchBounds()}
 **/
ActivityOptionsCompat.prototype.getLaunchBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLaunchBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setLaunchBounds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#setLaunchBounds(android.graphics.Rect)}
 **/
ActivityOptionsCompat.prototype.setLaunchBounds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setLaunchBounds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toBundle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ActivityOptionsCompat.html#toBundle()}
 **/
ActivityOptionsCompat.prototype.toBundle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toBundle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ActivityOptionsCompat') {
			return new ActivityOptionsCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ActivityOptionsCompat;
