/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.app.ComponentActivity
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.core.app');

/**
 * @class androidx.core.app.ComponentActivity
 * @extends android.app.Activity 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html}
 **/
var ComponentActivity = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.app.ComponentActivity')) {
		result = arguments[0];
	}
	else {
		result = ComponentActivity.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.app.Activity');
ComponentActivity.prototype = Object.create(SuperClass.prototype);
ComponentActivity.prototype.constructor = ComponentActivity;

Object.defineProperty(ComponentActivity.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ComponentActivity(this.$native.super);
	},
	enumerable: true
});

ComponentActivity.className = 'androidx.core.app.ComponentActivity';
ComponentActivity.prototype.className = 'androidx.core.app.ComponentActivity';

// class property
Object.defineProperty(ComponentActivity, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.app.ComponentActivity');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
ComponentActivity.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.app.ComponentActivity');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(ComponentActivity.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
ComponentActivity.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ComponentActivity(Hyperloop.cast('androidx.core.app.ComponentActivity', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ComponentActivity, 'ExtraData', {
	get: function() {
		return require('./androidx.core.app.ComponentActivity$ExtraData');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function dispatchKeyShortcutEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#dispatchKeyShortcutEvent(android.view.KeyEvent)}
 **/
ComponentActivity.prototype.dispatchKeyShortcutEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchKeyShortcutEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#onCreate(android.os.Bundle)}
 **/
ComponentActivity.prototype.onCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getExtraData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#getExtraData(java.lang.Class)}
 **/
ComponentActivity.prototype.getExtraData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getExtraData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchKeyEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#dispatchKeyEvent(android.view.KeyEvent)}
 **/
ComponentActivity.prototype.dispatchKeyEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchKeyEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSaveInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#onSaveInstanceState(android.os.Bundle)}
 **/
ComponentActivity.prototype.onSaveInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSaveInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLifecycle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#getLifecycle()}
 **/
ComponentActivity.prototype.getLifecycle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLifecycle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function superDispatchKeyEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#superDispatchKeyEvent(android.view.KeyEvent)}
 **/
ComponentActivity.prototype.superDispatchKeyEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'superDispatchKeyEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putExtraData
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/app/ComponentActivity.html#putExtraData(androidx.core.app.ComponentActivity$ExtraData)}
 **/
ComponentActivity.prototype.putExtraData = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putExtraData',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.app.ComponentActivity') {
			return new ComponentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ComponentActivity;
