/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.core.view.accessibility.AccessibilityNodeInfoCompat');

/**
 * @class androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html}
 **/
var AccessibilityActionCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat')) {
		result = arguments[0];
	}
	else {
		result = AccessibilityActionCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AccessibilityActionCompat.prototype = Object.create(SuperClass.prototype);
AccessibilityActionCompat.prototype.constructor = AccessibilityActionCompat;

Object.defineProperty(AccessibilityActionCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityActionCompat(this.$native.super);
	},
	enumerable: true
});

AccessibilityActionCompat.className = 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat';
AccessibilityActionCompat.prototype.className = 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat';

// class property
Object.defineProperty(AccessibilityActionCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AccessibilityActionCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AccessibilityActionCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AccessibilityActionCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityActionCompat(Hyperloop.cast('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_CLEAR_FOCUS
Object.defineProperty(AccessibilityActionCompat, 'ACTION_CLEAR_FOCUS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_CLEAR_FOCUS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_LONG_CLICK
Object.defineProperty(AccessibilityActionCompat, 'ACTION_LONG_CLICK', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_LONG_CLICK');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_CLEAR_SELECTION
Object.defineProperty(AccessibilityActionCompat, 'ACTION_CLEAR_SELECTION', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_CLEAR_SELECTION');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_CUT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_CUT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_CUT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SET_SELECTION
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SET_SELECTION', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SET_SELECTION');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_RIGHT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_RIGHT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_RIGHT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_BACKWARD
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_BACKWARD', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_BACKWARD');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_CONTEXT_CLICK
Object.defineProperty(AccessibilityActionCompat, 'ACTION_CONTEXT_CLICK', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_CONTEXT_CLICK');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PAGE_LEFT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PAGE_LEFT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PAGE_LEFT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PAGE_UP
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PAGE_UP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PAGE_UP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PAGE_DOWN
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PAGE_DOWN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PAGE_DOWN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_LEFT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_LEFT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_LEFT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SET_PROGRESS
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SET_PROGRESS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SET_PROGRESS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_TO_POSITION
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_TO_POSITION', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_TO_POSITION');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_FORWARD
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_FORWARD', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_FORWARD');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SHOW_ON_SCREEN
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SHOW_ON_SCREEN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SHOW_ON_SCREEN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_UP
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_UP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_UP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SELECT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SELECT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SELECT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PREVIOUS_HTML_ELEMENT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PREVIOUS_HTML_ELEMENT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PREVIOUS_HTML_ELEMENT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_NEXT_HTML_ELEMENT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_NEXT_HTML_ELEMENT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_NEXT_HTML_ELEMENT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_CLEAR_ACCESSIBILITY_FOCUS
Object.defineProperty(AccessibilityActionCompat, 'ACTION_CLEAR_ACCESSIBILITY_FOCUS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_CLEAR_ACCESSIBILITY_FOCUS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PAGE_RIGHT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PAGE_RIGHT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PAGE_RIGHT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_IME_ENTER
Object.defineProperty(AccessibilityActionCompat, 'ACTION_IME_ENTER', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_IME_ENTER');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SHOW_TOOLTIP
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SHOW_TOOLTIP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SHOW_TOOLTIP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_EXPAND
Object.defineProperty(AccessibilityActionCompat, 'ACTION_EXPAND', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_EXPAND');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SCROLL_DOWN
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SCROLL_DOWN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SCROLL_DOWN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_COPY
Object.defineProperty(AccessibilityActionCompat, 'ACTION_COPY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_COPY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_COLLAPSE
Object.defineProperty(AccessibilityActionCompat, 'ACTION_COLLAPSE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_COLLAPSE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PRESS_AND_HOLD
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PRESS_AND_HOLD', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PRESS_AND_HOLD');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_HIDE_TOOLTIP
Object.defineProperty(AccessibilityActionCompat, 'ACTION_HIDE_TOOLTIP', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_HIDE_TOOLTIP');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_NEXT_AT_MOVEMENT_GRANULARITY
Object.defineProperty(AccessibilityActionCompat, 'ACTION_NEXT_AT_MOVEMENT_GRANULARITY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_NEXT_AT_MOVEMENT_GRANULARITY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_CLICK
Object.defineProperty(AccessibilityActionCompat, 'ACTION_CLICK', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_CLICK');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_SET_TEXT
Object.defineProperty(AccessibilityActionCompat, 'ACTION_SET_TEXT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_SET_TEXT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_ACCESSIBILITY_FOCUS
Object.defineProperty(AccessibilityActionCompat, 'ACTION_ACCESSIBILITY_FOCUS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_ACCESSIBILITY_FOCUS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PASTE
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PASTE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PASTE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_MOVE_WINDOW
Object.defineProperty(AccessibilityActionCompat, 'ACTION_MOVE_WINDOW', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_MOVE_WINDOW');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_FOCUS
Object.defineProperty(AccessibilityActionCompat, 'ACTION_FOCUS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_FOCUS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_PREVIOUS_AT_MOVEMENT_GRANULARITY
Object.defineProperty(AccessibilityActionCompat, 'ACTION_PREVIOUS_AT_MOVEMENT_GRANULARITY', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_PREVIOUS_AT_MOVEMENT_GRANULARITY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#ACTION_DISMISS
Object.defineProperty(AccessibilityActionCompat, 'ACTION_DISMISS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ACTION_DISMISS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#mCommand
Object.defineProperty(AccessibilityActionCompat.prototype, 'mCommand', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('mCommand');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
				return new AccessibilityActionCompat(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function createReplacementAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#createReplacementAction(java.lang.CharSequence, androidx.core.view.accessibility.AccessibilityViewCommand)}
 **/
AccessibilityActionCompat.prototype.createReplacementAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createReplacementAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
			return new AccessibilityActionCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLabel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#getLabel()}
 **/
AccessibilityActionCompat.prototype.getLabel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLabel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
			return new AccessibilityActionCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#hashCode()}
 **/
AccessibilityActionCompat.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
			return new AccessibilityActionCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#equals(java.lang.Object)}
 **/
AccessibilityActionCompat.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
			return new AccessibilityActionCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function perform
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#perform(android.view.View, android.os.Bundle)}
 **/
AccessibilityActionCompat.prototype.perform = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'perform',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
			return new AccessibilityActionCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.AccessibilityActionCompat.html#getId()}
 **/
AccessibilityActionCompat.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$AccessibilityActionCompat') {
			return new AccessibilityActionCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityActionCompat;
