/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.core.view.accessibility.AccessibilityNodeInfoCompat');

/**
 * @class androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html}
 **/
var CollectionInfoCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat')) {
		result = arguments[0];
	}
	else {
		result = CollectionInfoCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
CollectionInfoCompat.prototype = Object.create(SuperClass.prototype);
CollectionInfoCompat.prototype.constructor = CollectionInfoCompat;

Object.defineProperty(CollectionInfoCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new CollectionInfoCompat(this.$native.super);
	},
	enumerable: true
});

CollectionInfoCompat.className = 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat';
CollectionInfoCompat.prototype.className = 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat';

// class property
Object.defineProperty(CollectionInfoCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
CollectionInfoCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(CollectionInfoCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
CollectionInfoCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new CollectionInfoCompat(Hyperloop.cast('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#SELECTION_MODE_NONE}
 */
CollectionInfoCompat.SELECTION_MODE_NONE = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#SELECTION_MODE_SINGLE}
 */
CollectionInfoCompat.SELECTION_MODE_SINGLE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#SELECTION_MODE_MULTIPLE}
 */
CollectionInfoCompat.SELECTION_MODE_MULTIPLE = 2;

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function obtain
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#obtain(int, int, boolean, int)}
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#obtain(int, int, boolean)}
 **/
CollectionInfoCompat.obtain = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'obtain',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat') {
			return new CollectionInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getRowCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#getRowCount()}
 **/
CollectionInfoCompat.prototype.getRowCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRowCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat') {
			return new CollectionInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSelectionMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#getSelectionMode()}
 **/
CollectionInfoCompat.prototype.getSelectionMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSelectionMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat') {
			return new CollectionInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getColumnCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#getColumnCount()}
 **/
CollectionInfoCompat.prototype.getColumnCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getColumnCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat') {
			return new CollectionInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isHierarchical
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.CollectionInfoCompat.html#isHierarchical()}
 **/
CollectionInfoCompat.prototype.isHierarchical = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isHierarchical',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$CollectionInfoCompat') {
			return new CollectionInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = CollectionInfoCompat;
