/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.core.view.accessibility.AccessibilityNodeInfoCompat');

/**
 * @class androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html}
 **/
var RangeInfoCompat = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat')) {
		result = arguments[0];
	}
	else {
		result = RangeInfoCompat.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
RangeInfoCompat.prototype = Object.create(SuperClass.prototype);
RangeInfoCompat.prototype.constructor = RangeInfoCompat;

Object.defineProperty(RangeInfoCompat.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new RangeInfoCompat(this.$native.super);
	},
	enumerable: true
});

RangeInfoCompat.className = 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat';
RangeInfoCompat.prototype.className = 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat';

// class property
Object.defineProperty(RangeInfoCompat, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
RangeInfoCompat.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(RangeInfoCompat.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
RangeInfoCompat.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new RangeInfoCompat(Hyperloop.cast('androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#RANGE_TYPE_PERCENT}
 */
RangeInfoCompat.RANGE_TYPE_PERCENT = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#RANGE_TYPE_FLOAT}
 */
RangeInfoCompat.RANGE_TYPE_FLOAT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#RANGE_TYPE_INT}
 */
RangeInfoCompat.RANGE_TYPE_INT = 0;

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function obtain
 * @static
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#obtain(int, float, float, float)}
 **/
RangeInfoCompat.obtain = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'obtain',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat') {
			return new RangeInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getMin
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#getMin()}
 **/
RangeInfoCompat.prototype.getMin = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMin',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat') {
			return new RangeInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#getType()}
 **/
RangeInfoCompat.prototype.getType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat') {
			return new RangeInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMax
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#getMax()}
 **/
RangeInfoCompat.prototype.getMax = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMax',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat') {
			return new RangeInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCurrent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/core/view/accessibility/AccessibilityNodeInfoCompat.RangeInfoCompat.html#getCurrent()}
 **/
RangeInfoCompat.prototype.getCurrent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCurrent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.core.view.accessibility.AccessibilityNodeInfoCompat$RangeInfoCompat') {
			return new RangeInfoCompat(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = RangeInfoCompat;
