/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./androidx.drawerlayout.widget.DrawerLayout');

/**
 * @class androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate
 * @extends androidx.core.view.AccessibilityDelegateCompat 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.AccessibilityDelegate.html}
 **/
var AccessibilityDelegate = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate')) {
		result = arguments[0];
	}
	else {
		result = AccessibilityDelegate.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./androidx.core.view.AccessibilityDelegateCompat');
AccessibilityDelegate.prototype = Object.create(SuperClass.prototype);
AccessibilityDelegate.prototype.constructor = AccessibilityDelegate;

Object.defineProperty(AccessibilityDelegate.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AccessibilityDelegate(this.$native.super);
	},
	enumerable: true
});

AccessibilityDelegate.className = 'androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate';
AccessibilityDelegate.prototype.className = 'androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate';

// class property
Object.defineProperty(AccessibilityDelegate, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate');
	},
	enumerable: true,
	configurable: false
});


// Cast
AccessibilityDelegate.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AccessibilityDelegate(Hyperloop.cast('androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.AccessibilityDelegate.html#onInitializeAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegate.prototype.onInitializeAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate') {
			return new AccessibilityDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dispatchPopulateAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.AccessibilityDelegate.html#dispatchPopulateAccessibilityEvent(android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegate.prototype.dispatchPopulateAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchPopulateAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate') {
			return new AccessibilityDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRequestSendAccessibilityEvent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.AccessibilityDelegate.html#onRequestSendAccessibilityEvent(android.view.ViewGroup, android.view.View, android.view.accessibility.AccessibilityEvent)}
 **/
AccessibilityDelegate.prototype.onRequestSendAccessibilityEvent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRequestSendAccessibilityEvent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate') {
			return new AccessibilityDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onInitializeAccessibilityNodeInfo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/drawerlayout/widget/DrawerLayout.AccessibilityDelegate.html#onInitializeAccessibilityNodeInfo(android.view.View, androidx.core.view.accessibility.AccessibilityNodeInfoCompat)}
 **/
AccessibilityDelegate.prototype.onInitializeAccessibilityNodeInfo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onInitializeAccessibilityNodeInfo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.drawerlayout.widget.DrawerLayout$AccessibilityDelegate') {
			return new AccessibilityDelegate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AccessibilityDelegate;
