/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.fragment.app.FragmentActivity
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.fragment.app');

/**
 * @class androidx.fragment.app.FragmentActivity
 * @extends androidx.activity.ComponentActivity 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html}
 **/
var FragmentActivity = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.fragment.app.FragmentActivity')) {
		result = arguments[0];
	}
	else {
		result = FragmentActivity.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./androidx.activity.ComponentActivity');
FragmentActivity.prototype = Object.create(SuperClass.prototype);
FragmentActivity.prototype.constructor = FragmentActivity;

Object.defineProperty(FragmentActivity.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FragmentActivity(this.$native.super);
	},
	enumerable: true
});

FragmentActivity.className = 'androidx.fragment.app.FragmentActivity';
FragmentActivity.prototype.className = 'androidx.fragment.app.FragmentActivity';

// class property
Object.defineProperty(FragmentActivity, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.fragment.app.FragmentActivity');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FragmentActivity.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.fragment.app.FragmentActivity');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FragmentActivity.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FragmentActivity.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FragmentActivity(Hyperloop.cast('androidx.fragment.app.FragmentActivity', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(FragmentActivity, 'HostCallbacks', {
	get: function() {
		return require('./androidx.fragment.app.FragmentActivity$HostCallbacks');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setEnterSharedElementCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#setEnterSharedElementCallback(androidx.core.app.SharedElementCallback)}
 **/
FragmentActivity.prototype.setEnterSharedElementCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setEnterSharedElementCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportLoaderManager
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#getSupportLoaderManager()}
 **/
FragmentActivity.prototype.getSupportLoaderManager = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportLoaderManager',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function validateRequestPermissionsRequestCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#validateRequestPermissionsRequestCode(int)}
 **/
FragmentActivity.prototype.validateRequestPermissionsRequestCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'validateRequestPermissionsRequestCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMultiWindowModeChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onMultiWindowModeChanged(boolean)}
 **/
FragmentActivity.prototype.onMultiWindowModeChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMultiWindowModeChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportStartPostponedEnterTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#supportStartPostponedEnterTransition()}
 **/
FragmentActivity.prototype.supportStartPostponedEnterTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportStartPostponedEnterTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onRequestPermissionsResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onRequestPermissionsResult(int, java.lang.String[], int[])}
 **/
FragmentActivity.prototype.onRequestPermissionsResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onRequestPermissionsResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPause
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onPause()}
 **/
FragmentActivity.prototype.onPause = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPause',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onActivityResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onActivityResult(int, int, android.content.Intent)}
 **/
FragmentActivity.prototype.onActivityResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onLowMemory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onLowMemory()}
 **/
FragmentActivity.prototype.onLowMemory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onLowMemory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportPostponeEnterTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#supportPostponeEnterTransition()}
 **/
FragmentActivity.prototype.supportPostponeEnterTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportPostponeEnterTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportInvalidateOptionsMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#supportInvalidateOptionsMenu()}
 **/
FragmentActivity.prototype.supportInvalidateOptionsMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportInvalidateOptionsMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onStart()}
 **/
FragmentActivity.prototype.onStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPrepareOptionsPanel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onPrepareOptionsPanel(android.view.View, android.view.Menu)}
 **/
FragmentActivity.prototype.onPrepareOptionsPanel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPrepareOptionsPanel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startActivityFromFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#startActivityFromFragment(androidx.fragment.app.Fragment, android.content.Intent, int)}
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#startActivityFromFragment(androidx.fragment.app.Fragment, android.content.Intent, int, android.os.Bundle)}
 **/
FragmentActivity.prototype.startActivityFromFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startActivityFromFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#dump(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
FragmentActivity.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStop
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onStop()}
 **/
FragmentActivity.prototype.onStop = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStop',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onCreate(android.os.Bundle)}
 **/
FragmentActivity.prototype.onCreate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onDestroy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onDestroy()}
 **/
FragmentActivity.prototype.onDestroy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onDestroy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onMenuItemSelected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onMenuItemSelected(int, android.view.MenuItem)}
 **/
FragmentActivity.prototype.onMenuItemSelected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onMenuItemSelected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSupportFragmentManager
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#getSupportFragmentManager()}
 **/
FragmentActivity.prototype.getSupportFragmentManager = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSupportFragmentManager',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function supportFinishAfterTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#supportFinishAfterTransition()}
 **/
FragmentActivity.prototype.supportFinishAfterTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'supportFinishAfterTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPictureInPictureModeChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onPictureInPictureModeChanged(boolean)}
 **/
FragmentActivity.prototype.onPictureInPictureModeChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPictureInPictureModeChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onResume()}
 **/
FragmentActivity.prototype.onResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setExitSharedElementCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#setExitSharedElementCallback(androidx.core.app.SharedElementCallback)}
 **/
FragmentActivity.prototype.setExitSharedElementCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setExitSharedElementCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startIntentSenderFromFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#startIntentSenderFromFragment(androidx.fragment.app.Fragment, android.content.IntentSender, int, android.content.Intent, int, int, int, android.os.Bundle)}
 **/
FragmentActivity.prototype.startIntentSenderFromFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startIntentSenderFromFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onNewIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onNewIntent(android.content.Intent)}
 **/
FragmentActivity.prototype.onNewIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onNewIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onResumeFragments
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onResumeFragments()}
 **/
FragmentActivity.prototype.onResumeFragments = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onResumeFragments',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onAttachFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onAttachFragment(androidx.fragment.app.Fragment)}
 **/
FragmentActivity.prototype.onAttachFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onAttachFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreateView
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onCreateView(android.view.View, java.lang.String, android.content.Context, android.util.AttributeSet)}
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onCreateView(java.lang.String, android.content.Context, android.util.AttributeSet)}
 **/
FragmentActivity.prototype.onCreateView = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreateView',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onCreatePanelMenu
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onCreatePanelMenu(int, android.view.Menu)}
 **/
FragmentActivity.prototype.onCreatePanelMenu = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onCreatePanelMenu',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPanelClosed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onPanelClosed(int, android.view.Menu)}
 **/
FragmentActivity.prototype.onPanelClosed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPanelClosed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPostResume
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onPostResume()}
 **/
FragmentActivity.prototype.onPostResume = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPostResume',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConfigurationChanged
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onConfigurationChanged(android.content.res.Configuration)}
 **/
FragmentActivity.prototype.onConfigurationChanged = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConfigurationChanged',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onStateNotSaved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onStateNotSaved()}
 **/
FragmentActivity.prototype.onStateNotSaved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onStateNotSaved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPreparePanel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentActivity.html#onPreparePanel(int, android.view.View, android.view.Menu)}
 **/
FragmentActivity.prototype.onPreparePanel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPreparePanel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentActivity') {
			return new FragmentActivity(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FragmentActivity;
