/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module androidx.fragment.app.FragmentManager
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./androidx.fragment.app');

/**
 * @class androidx.fragment.app.FragmentManager
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html}
 **/
var FragmentManager = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('androidx.fragment.app.FragmentManager')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: androidx.fragment.app.FragmentManager. Create a subclass using androidx.fragment.app.FragmentManager.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FragmentManager.prototype = Object.create(SuperClass.prototype);
FragmentManager.prototype.constructor = FragmentManager;

Object.defineProperty(FragmentManager.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FragmentManager(this.$native.super);
	},
	enumerable: true
});

FragmentManager.className = 'androidx.fragment.app.FragmentManager';
FragmentManager.prototype.className = 'androidx.fragment.app.FragmentManager';

// class property
Object.defineProperty(FragmentManager, 'class', {
	get: function() {
		return Hyperloop.getClass('androidx.fragment.app.FragmentManager');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FragmentManager.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('androidx.fragment.app.FragmentManager');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FragmentManager.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FragmentManager.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FragmentManager(Hyperloop.cast('androidx.fragment.app.FragmentManager', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#POP_BACK_STACK_INCLUSIVE}
 */
FragmentManager.POP_BACK_STACK_INCLUSIVE = 1;

// Inner classes
Object.defineProperty(FragmentManager, 'BackStackEntry', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$BackStackEntry');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'FragmentIntentSenderContract', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$FragmentIntentSenderContract');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'FragmentLifecycleCallbacks', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$FragmentLifecycleCallbacks');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'LaunchedFragmentInfo', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$LaunchedFragmentInfo');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'LifecycleAwareResultListener', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$LifecycleAwareResultListener');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'OnBackStackChangedListener', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$OnBackStackChangedListener');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'OpGenerator', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$OpGenerator');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'PopBackStackState', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$PopBackStackState');
	},
	enumerable: true
});
Object.defineProperty(FragmentManager, 'StartEnterTransitionListener', {
	get: function() {
		return require('./androidx.fragment.app.FragmentManager$StartEnterTransitionListener');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function enableNewStateManager
 * @static
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#enableNewStateManager(boolean)}
 **/
FragmentManager.enableNewStateManager = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'enableNewStateManager',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findFragment
 * @static
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#findFragment(android.view.View)}
 **/
FragmentManager.findFragment = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'findFragment',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function enableDebugLogging
 * @static
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#enableDebugLogging(boolean)}
 **/
FragmentManager.enableDebugLogging = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'enableDebugLogging',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getBackStackEntryAt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#getBackStackEntryAt(int)}
 **/
FragmentManager.prototype.getBackStackEntryAt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBackStackEntryAt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBackStackEntryCount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#getBackStackEntryCount()}
 **/
FragmentManager.prototype.getBackStackEntryCount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBackStackEntryCount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function openTransaction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#openTransaction()}
 **/
FragmentManager.prototype.openTransaction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'openTransaction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerFragmentLifecycleCallbacks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#registerFragmentLifecycleCallbacks(androidx.fragment.app.FragmentManager$FragmentLifecycleCallbacks, boolean)}
 **/
FragmentManager.prototype.registerFragmentLifecycleCallbacks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerFragmentLifecycleCallbacks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnBackStackChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#addOnBackStackChangedListener(androidx.fragment.app.FragmentManager$OnBackStackChangedListener)}
 **/
FragmentManager.prototype.addOnBackStackChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnBackStackChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFragments
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#getFragments()}
 **/
FragmentManager.prototype.getFragments = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFragments',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function saveFragmentInstanceState
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#saveFragmentInstanceState(androidx.fragment.app.Fragment)}
 **/
FragmentManager.prototype.saveFragmentInstanceState = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'saveFragmentInstanceState',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFragmentResultListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#setFragmentResultListener(java.lang.String, androidx.lifecycle.LifecycleOwner, androidx.fragment.app.FragmentResultListener)}
 **/
FragmentManager.prototype.setFragmentResultListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFragmentResultListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPrimaryNavigationFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#getPrimaryNavigationFragment()}
 **/
FragmentManager.prototype.getPrimaryNavigationFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPrimaryNavigationFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function unregisterFragmentLifecycleCallbacks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#unregisterFragmentLifecycleCallbacks(androidx.fragment.app.FragmentManager$FragmentLifecycleCallbacks)}
 **/
FragmentManager.prototype.unregisterFragmentLifecycleCallbacks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'unregisterFragmentLifecycleCallbacks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeFragmentOnAttachListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#removeFragmentOnAttachListener(androidx.fragment.app.FragmentOnAttachListener)}
 **/
FragmentManager.prototype.removeFragmentOnAttachListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeFragmentOnAttachListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function executePendingTransactions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#executePendingTransactions()}
 **/
FragmentManager.prototype.executePendingTransactions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'executePendingTransactions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findFragmentById
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#findFragmentById(int)}
 **/
FragmentManager.prototype.findFragmentById = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findFragmentById',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#dump(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
FragmentManager.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function findFragmentByTag
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#findFragmentByTag(java.lang.String)}
 **/
FragmentManager.prototype.findFragmentByTag = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'findFragmentByTag',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#putFragment(android.os.Bundle, java.lang.String, androidx.fragment.app.Fragment)}
 **/
FragmentManager.prototype.putFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'putFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addFragmentOnAttachListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#addFragmentOnAttachListener(androidx.fragment.app.FragmentOnAttachListener)}
 **/
FragmentManager.prototype.addFragmentOnAttachListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addFragmentOnAttachListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeOnBackStackChangedListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#removeOnBackStackChangedListener(androidx.fragment.app.FragmentManager$OnBackStackChangedListener)}
 **/
FragmentManager.prototype.removeOnBackStackChangedListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeOnBackStackChangedListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDestroyed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#isDestroyed()}
 **/
FragmentManager.prototype.isDestroyed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDestroyed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isStateSaved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#isStateSaved()}
 **/
FragmentManager.prototype.isStateSaved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isStateSaved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function popBackStackImmediate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#popBackStackImmediate()}
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#popBackStackImmediate(java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#popBackStackImmediate(int, int)}
 **/
FragmentManager.prototype.popBackStackImmediate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'popBackStackImmediate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFragmentResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#setFragmentResult(java.lang.String, android.os.Bundle)}
 **/
FragmentManager.prototype.setFragmentResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFragmentResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setFragmentFactory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#setFragmentFactory(androidx.fragment.app.FragmentFactory)}
 **/
FragmentManager.prototype.setFragmentFactory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setFragmentFactory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function popBackStack
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#popBackStack()}
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#popBackStack(java.lang.String, int)}
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#popBackStack(int, int)}
 **/
FragmentManager.prototype.popBackStack = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'popBackStack',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clearFragmentResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#clearFragmentResult(java.lang.String)}
 **/
FragmentManager.prototype.clearFragmentResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clearFragmentResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function beginTransaction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#beginTransaction()}
 **/
FragmentManager.prototype.beginTransaction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'beginTransaction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#toString()}
 **/
FragmentManager.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFragmentFactory
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#getFragmentFactory()}
 **/
FragmentManager.prototype.getFragmentFactory = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFragmentFactory',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFragment
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#getFragment(android.os.Bundle, java.lang.String)}
 **/
FragmentManager.prototype.getFragment = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFragment',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function clearFragmentResultListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/androidx/fragment/app/FragmentManager.html#clearFragmentResultListener(java.lang.String)}
 **/
FragmentManager.prototype.clearFragmentResultListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'clearFragmentResultListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'androidx.fragment.app.FragmentManager') {
			return new FragmentManager(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FragmentManager;
