/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.auth.api.signin.GoogleSignInAccount
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.auth.api.signin');

/**
 * @class com.google.android.gms.auth.api.signin.GoogleSignInAccount
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html}
 **/
var GoogleSignInAccount = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.auth.api.signin.GoogleSignInAccount')) {
		result = arguments[0];
	}
	else {
		result = GoogleSignInAccount.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
GoogleSignInAccount.prototype = Object.create(SuperClass.prototype);
GoogleSignInAccount.prototype.constructor = GoogleSignInAccount;

Object.defineProperty(GoogleSignInAccount.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GoogleSignInAccount(this.$native.super);
	},
	enumerable: true
});

GoogleSignInAccount.className = 'com.google.android.gms.auth.api.signin.GoogleSignInAccount';
GoogleSignInAccount.prototype.className = 'com.google.android.gms.auth.api.signin.GoogleSignInAccount';

// class property
Object.defineProperty(GoogleSignInAccount, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.auth.api.signin.GoogleSignInAccount');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GoogleSignInAccount.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.auth.api.signin.GoogleSignInAccount');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GoogleSignInAccount.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GoogleSignInAccount.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GoogleSignInAccount(Hyperloop.cast('com.google.android.gms.auth.api.signin.GoogleSignInAccount', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#CREATOR
Object.defineProperty(GoogleSignInAccount, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
				return new GoogleSignInAccount(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function zaa
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#zaa(java.lang.String)}
 **/
GoogleSignInAccount.zaa = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'zaa',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createDefault
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#createDefault()}
 **/
GoogleSignInAccount.createDefault = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createDefault',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function requestExtraScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#requestExtraScopes(com.google.android.gms.common.api.Scope[])}
 **/
GoogleSignInAccount.prototype.requestExtraScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requestExtraScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getId()}
 **/
GoogleSignInAccount.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGivenName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getGivenName()}
 **/
GoogleSignInAccount.prototype.getGivenName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGivenName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getDisplayName()}
 **/
GoogleSignInAccount.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPhotoUrl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getPhotoUrl()}
 **/
GoogleSignInAccount.prototype.getPhotoUrl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPhotoUrl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#hashCode()}
 **/
GoogleSignInAccount.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getAccount()}
 **/
GoogleSignInAccount.prototype.getAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#equals(java.lang.Object)}
 **/
GoogleSignInAccount.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEmail
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getEmail()}
 **/
GoogleSignInAccount.prototype.getEmail = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEmail',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zab
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#zab()}
 **/
GoogleSignInAccount.prototype.zab = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zab',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getIdToken
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getIdToken()}
 **/
GoogleSignInAccount.prototype.getIdToken = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getIdToken',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getServerAuthCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getServerAuthCode()}
 **/
GoogleSignInAccount.prototype.getServerAuthCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getServerAuthCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getFamilyName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getFamilyName()}
 **/
GoogleSignInAccount.prototype.getFamilyName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFamilyName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isExpired
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#isExpired()}
 **/
GoogleSignInAccount.prototype.isExpired = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isExpired',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#writeToParcel(android.os.Parcel, int)}
 **/
GoogleSignInAccount.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zac
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#zac()}
 **/
GoogleSignInAccount.prototype.zac = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zac',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGrantedScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getGrantedScopes()}
 **/
GoogleSignInAccount.prototype.getGrantedScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGrantedScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRequestedScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/auth/api/signin/GoogleSignInAccount.html#getRequestedScopes()}
 **/
GoogleSignInAccount.prototype.getRequestedScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRequestedScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.auth.api.signin.GoogleSignInAccount') {
			return new GoogleSignInAccount(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GoogleSignInAccount;
