/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.ConnectionResult
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common');

/**
 * @class com.google.android.gms.common.ConnectionResult
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html}
 **/
var ConnectionResult = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.ConnectionResult')) {
		result = arguments[0];
	}
	else {
		result = ConnectionResult.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
ConnectionResult.prototype = Object.create(SuperClass.prototype);
ConnectionResult.prototype.constructor = ConnectionResult;

Object.defineProperty(ConnectionResult.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ConnectionResult(this.$native.super);
	},
	enumerable: true
});

ConnectionResult.className = 'com.google.android.gms.common.ConnectionResult';
ConnectionResult.prototype.className = 'com.google.android.gms.common.ConnectionResult';

// class property
Object.defineProperty(ConnectionResult, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.ConnectionResult');
	},
	enumerable: true,
	configurable: false
});


// Cast
ConnectionResult.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ConnectionResult(Hyperloop.cast('com.google.android.gms.common.ConnectionResult', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SUCCESS}
 */
ConnectionResult.SUCCESS = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#RESTRICTED_PROFILE}
 */
ConnectionResult.RESTRICTED_PROFILE = 20;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SIGN_IN_FAILED}
 */
ConnectionResult.SIGN_IN_FAILED = 17;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#INTERNAL_ERROR}
 */
ConnectionResult.INTERNAL_ERROR = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#RESOLUTION_REQUIRED}
 */
ConnectionResult.RESOLUTION_REQUIRED = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SERVICE_INVALID}
 */
ConnectionResult.SERVICE_INVALID = 9;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#DRIVE_EXTERNAL_STORAGE_REQUIRED}
 */
ConnectionResult.DRIVE_EXTERNAL_STORAGE_REQUIRED = 1500;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#INVALID_ACCOUNT}
 */
ConnectionResult.INVALID_ACCOUNT = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#DEVELOPER_ERROR}
 */
ConnectionResult.DEVELOPER_ERROR = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SERVICE_MISSING_PERMISSION}
 */
ConnectionResult.SERVICE_MISSING_PERMISSION = 19;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SERVICE_MISSING}
 */
ConnectionResult.SERVICE_MISSING = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#CANCELED}
 */
ConnectionResult.CANCELED = 13;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#NETWORK_ERROR}
 */
ConnectionResult.NETWORK_ERROR = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#LICENSE_CHECK_FAILED}
 */
ConnectionResult.LICENSE_CHECK_FAILED = 11;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#UNKNOWN}
 */
ConnectionResult.UNKNOWN = -1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SERVICE_DISABLED}
 */
ConnectionResult.SERVICE_DISABLED = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#TIMEOUT}
 */
ConnectionResult.TIMEOUT = 14;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SERVICE_VERSION_UPDATE_REQUIRED}
 */
ConnectionResult.SERVICE_VERSION_UPDATE_REQUIRED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SIGN_IN_REQUIRED}
 */
ConnectionResult.SIGN_IN_REQUIRED = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#API_UNAVAILABLE}
 */
ConnectionResult.API_UNAVAILABLE = 16;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#SERVICE_UPDATING}
 */
ConnectionResult.SERVICE_UPDATING = 18;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#INTERRUPTED}
 */
ConnectionResult.INTERRUPTED = 15;

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#RESULT_SUCCESS
Object.defineProperty(ConnectionResult, 'RESULT_SUCCESS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RESULT_SUCCESS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
				return new ConnectionResult(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#CREATOR
Object.defineProperty(ConnectionResult, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
				return new ConnectionResult(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getResolution
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#getResolution()}
 **/
ConnectionResult.prototype.getResolution = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResolution',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#getErrorCode()}
 **/
ConnectionResult.prototype.getErrorCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function startResolutionForResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#startResolutionForResult(android.app.Activity, int)}
 **/
ConnectionResult.prototype.startResolutionForResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'startResolutionForResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#hashCode()}
 **/
ConnectionResult.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#equals(java.lang.Object)}
 **/
ConnectionResult.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#toString()}
 **/
ConnectionResult.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#writeToParcel(android.os.Parcel, int)}
 **/
ConnectionResult.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hasResolution
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#hasResolution()}
 **/
ConnectionResult.prototype.hasResolution = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hasResolution',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSuccess
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#isSuccess()}
 **/
ConnectionResult.prototype.isSuccess = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSuccess',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/ConnectionResult.html#getErrorMessage()}
 **/
ConnectionResult.prototype.getErrorMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.ConnectionResult') {
			return new ConnectionResult(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ConnectionResult;
