/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.GoogleApiAvailabilityLight
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common');

/**
 * @class com.google.android.gms.common.GoogleApiAvailabilityLight
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html}
 **/
var GoogleApiAvailabilityLight = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.GoogleApiAvailabilityLight')) {
		result = arguments[0];
	}
	else {
		result = GoogleApiAvailabilityLight.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
GoogleApiAvailabilityLight.prototype = Object.create(SuperClass.prototype);
GoogleApiAvailabilityLight.prototype.constructor = GoogleApiAvailabilityLight;

Object.defineProperty(GoogleApiAvailabilityLight.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GoogleApiAvailabilityLight(this.$native.super);
	},
	enumerable: true
});

GoogleApiAvailabilityLight.className = 'com.google.android.gms.common.GoogleApiAvailabilityLight';
GoogleApiAvailabilityLight.prototype.className = 'com.google.android.gms.common.GoogleApiAvailabilityLight';

// class property
Object.defineProperty(GoogleApiAvailabilityLight, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.GoogleApiAvailabilityLight');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GoogleApiAvailabilityLight.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.GoogleApiAvailabilityLight');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GoogleApiAvailabilityLight.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GoogleApiAvailabilityLight.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GoogleApiAvailabilityLight(Hyperloop.cast('com.google.android.gms.common.GoogleApiAvailabilityLight', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#GOOGLE_PLAY_SERVICES_PACKAGE}
 */
GoogleApiAvailabilityLight.GOOGLE_PLAY_SERVICES_PACKAGE = "com.google.android.gms";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#GOOGLE_PLAY_STORE_PACKAGE}
 */
GoogleApiAvailabilityLight.GOOGLE_PLAY_STORE_PACKAGE = "com.android.vending";

// Inner classes

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#GOOGLE_PLAY_SERVICES_VERSION_CODE
Object.defineProperty(GoogleApiAvailabilityLight, 'GOOGLE_PLAY_SERVICES_VERSION_CODE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('GOOGLE_PLAY_SERVICES_VERSION_CODE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
				return new GoogleApiAvailabilityLight(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getInstance
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getInstance()}
 **/
GoogleApiAvailabilityLight.getInstance = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getInstance',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isUserResolvableError
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#isUserResolvableError(int)}
 **/
GoogleApiAvailabilityLight.prototype.isUserResolvableError = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUserResolvableError',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApkVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getApkVersion(android.content.Context)}
 **/
GoogleApiAvailabilityLight.prototype.getApkVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApkVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isPlayStorePossiblyUpdating
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#isPlayStorePossiblyUpdating(android.content.Context, int)}
 **/
GoogleApiAvailabilityLight.prototype.isPlayStorePossiblyUpdating = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isPlayStorePossiblyUpdating',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getErrorString(int)}
 **/
GoogleApiAvailabilityLight.prototype.getErrorString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function verifyGooglePlayServicesIsAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#verifyGooglePlayServicesIsAvailable(android.content.Context, int)}
 **/
GoogleApiAvailabilityLight.prototype.verifyGooglePlayServicesIsAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'verifyGooglePlayServicesIsAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorResolutionPendingIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getErrorResolutionPendingIntent(android.content.Context, int, int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getErrorResolutionPendingIntent(android.content.Context, int, int, java.lang.String)}
 **/
GoogleApiAvailabilityLight.prototype.getErrorResolutionPendingIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorResolutionPendingIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function cancelAvailabilityErrorNotifications
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#cancelAvailabilityErrorNotifications(android.content.Context)}
 **/
GoogleApiAvailabilityLight.prototype.cancelAvailabilityErrorNotifications = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cancelAvailabilityErrorNotifications',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isPlayServicesPossiblyUpdating
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#isPlayServicesPossiblyUpdating(android.content.Context, int)}
 **/
GoogleApiAvailabilityLight.prototype.isPlayServicesPossiblyUpdating = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isPlayServicesPossiblyUpdating',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isGooglePlayServicesAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#isGooglePlayServicesAvailable(android.content.Context)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#isGooglePlayServicesAvailable(android.content.Context, int)}
 **/
GoogleApiAvailabilityLight.prototype.isGooglePlayServicesAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isGooglePlayServicesAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getClientVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getClientVersion(android.content.Context)}
 **/
GoogleApiAvailabilityLight.prototype.getClientVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClientVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getErrorResolutionIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getErrorResolutionIntent(int)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#getErrorResolutionIntent(android.content.Context, int, java.lang.String)}
 **/
GoogleApiAvailabilityLight.prototype.getErrorResolutionIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getErrorResolutionIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isUninstalledAppPossiblyUpdating
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/GoogleApiAvailabilityLight.html#isUninstalledAppPossiblyUpdating(android.content.Context, java.lang.String)}
 **/
GoogleApiAvailabilityLight.prototype.isUninstalledAppPossiblyUpdating = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUninstalledAppPossiblyUpdating',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.GoogleApiAvailabilityLight') {
			return new GoogleApiAvailabilityLight(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GoogleApiAvailabilityLight;
