/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.internal.BaseGmsClient
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.internal');

/**
 * @class com.google.android.gms.common.internal.BaseGmsClient
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html}
 **/
var BaseGmsClient = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.internal.BaseGmsClient')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.common.internal.BaseGmsClient. Create a subclass using com.google.android.gms.common.internal.BaseGmsClient.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
BaseGmsClient.prototype = Object.create(SuperClass.prototype);
BaseGmsClient.prototype.constructor = BaseGmsClient;

Object.defineProperty(BaseGmsClient.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new BaseGmsClient(this.$native.super);
	},
	enumerable: true
});

BaseGmsClient.className = 'com.google.android.gms.common.internal.BaseGmsClient';
BaseGmsClient.prototype.className = 'com.google.android.gms.common.internal.BaseGmsClient';

// class property
Object.defineProperty(BaseGmsClient, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.internal.BaseGmsClient');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
BaseGmsClient.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.internal.BaseGmsClient');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(BaseGmsClient.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
BaseGmsClient.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new BaseGmsClient(Hyperloop.cast('com.google.android.gms.common.internal.BaseGmsClient', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#DEFAULT_ACCOUNT}
 */
BaseGmsClient.DEFAULT_ACCOUNT = "<<default account>>";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#CONNECT_STATE_CONNECTED}
 */
BaseGmsClient.CONNECT_STATE_CONNECTED = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#CONNECT_STATE_DISCONNECTED}
 */
BaseGmsClient.CONNECT_STATE_DISCONNECTED = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#KEY_PENDING_INTENT}
 */
BaseGmsClient.KEY_PENDING_INTENT = "pendingIntent";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#CONNECT_STATE_DISCONNECTING}
 */
BaseGmsClient.CONNECT_STATE_DISCONNECTING = 5;

// Inner classes
Object.defineProperty(BaseGmsClient, 'BaseConnectionCallbacks', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$BaseConnectionCallbacks');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'BaseOnConnectionFailedListener', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$BaseOnConnectionFailedListener');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'ConnectionProgressReportCallbacks', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$ConnectionProgressReportCallbacks');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'LegacyClientCallbackAdapter', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$LegacyClientCallbackAdapter');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'SignOutCallbacks', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$SignOutCallbacks');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zza', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zza');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zzb', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zzb');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zzc', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zzc');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zzd', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zzd');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zze', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zze');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zzf', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zzf');
	},
	enumerable: true
});
Object.defineProperty(BaseGmsClient, 'zzg', {
	get: function() {
		return require('./com.google.android.gms.common.internal.BaseGmsClient$zzg');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#GOOGLE_PLUS_REQUIRED_FEATURES
Object.defineProperty(BaseGmsClient, 'GOOGLE_PLUS_REQUIRED_FEATURES', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('GOOGLE_PLUS_REQUIRED_FEATURES');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
				return new BaseGmsClient(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields
// http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#zzcr
Object.defineProperty(BaseGmsClient.prototype, 'zzcr', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('zzcr');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
				return new BaseGmsClient(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('zzcr', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#zzcf
Object.defineProperty(BaseGmsClient.prototype, 'zzcf', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('zzcf');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
				return new BaseGmsClient(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('zzcf', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function disconnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#disconnect()}
 **/
BaseGmsClient.prototype.disconnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'disconnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function triggerConnectionSuspended
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#triggerConnectionSuspended(int)}
 **/
BaseGmsClient.prototype.triggerConnectionSuspended = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'triggerConnectionSuspended',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkConnected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#checkConnected()}
 **/
BaseGmsClient.prototype.checkConnected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkConnected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRemoteService
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getRemoteService(com.google.android.gms.common.internal.IAccountAccessor, java.util.Set)}
 **/
BaseGmsClient.prototype.getRemoteService = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRemoteService',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isConnected
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#isConnected()}
 **/
BaseGmsClient.prototype.isConnected = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnected',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLocalStartServiceAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getLocalStartServiceAction()}
 **/
BaseGmsClient.prototype.getLocalStartServiceAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocalStartServiceAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requiresSignIn
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#requiresSignIn()}
 **/
BaseGmsClient.prototype.requiresSignIn = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requiresSignIn',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getSignInIntent
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getSignInIntent()}
 **/
BaseGmsClient.prototype.getSignInIntent = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getSignInIntent',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartServiceAction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getStartServiceAction()}
 **/
BaseGmsClient.prototype.getStartServiceAction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartServiceAction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getAccount()}
 **/
BaseGmsClient.prototype.getAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEndpointPackageName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getEndpointPackageName()}
 **/
BaseGmsClient.prototype.getEndpointPackageName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEndpointPackageName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dump
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#dump(java.lang.String, java.io.FileDescriptor, java.io.PrintWriter, java.lang.String[])}
 **/
BaseGmsClient.prototype.dump = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dump',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function enableLocalFallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#enableLocalFallback()}
 **/
BaseGmsClient.prototype.enableLocalFallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'enableLocalFallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function connect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#connect(com.google.android.gms.common.internal.BaseGmsClient$ConnectionProgressReportCallbacks)}
 **/
BaseGmsClient.prototype.connect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'connect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function providesSignIn
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#providesSignIn()}
 **/
BaseGmsClient.prototype.providesSignIn = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'providesSignIn',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStartServicePackage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getStartServicePackage()}
 **/
BaseGmsClient.prototype.getStartServicePackage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStartServicePackage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zza
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#zza(int, android.os.Bundle, int)}
 **/
BaseGmsClient.prototype.zza = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'zza',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function triggerNotAvailable
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#triggerNotAvailable(com.google.android.gms.common.internal.BaseGmsClient$ConnectionProgressReportCallbacks, int, android.app.PendingIntent)}
 **/
BaseGmsClient.prototype.triggerNotAvailable = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'triggerNotAvailable',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConnectedLocked
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#onConnectedLocked(android.os.IInterface)}
 **/
BaseGmsClient.prototype.onConnectedLocked = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConnectedLocked',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConnectionFailed
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#onConnectionFailed(com.google.android.gms.common.ConnectionResult)}
 **/
BaseGmsClient.prototype.onConnectionFailed = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConnectionFailed',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isConnecting
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#isConnecting()}
 **/
BaseGmsClient.prototype.isConnecting = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isConnecting',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getService
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getService()}
 **/
BaseGmsClient.prototype.getService = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getService',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requiresAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#requiresAccount()}
 **/
BaseGmsClient.prototype.requiresAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requiresAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getScopes()}
 **/
BaseGmsClient.prototype.getScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getServiceDescriptor
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getServiceDescriptor()}
 **/
BaseGmsClient.prototype.getServiceDescriptor = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getServiceDescriptor',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createServiceInterface
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#createServiceInterface(android.os.IBinder)}
 **/
BaseGmsClient.prototype.createServiceInterface = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createServiceInterface',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onConnectionSuspended
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#onConnectionSuspended(int)}
 **/
BaseGmsClient.prototype.onConnectionSuspended = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onConnectionSuspended',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGetServiceRequestExtraArgs
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getGetServiceRequestExtraArgs()}
 **/
BaseGmsClient.prototype.getGetServiceRequestExtraArgs = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGetServiceRequestExtraArgs',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onUserSignOut
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#onUserSignOut(com.google.android.gms.common.internal.BaseGmsClient$SignOutCallbacks)}
 **/
BaseGmsClient.prototype.onUserSignOut = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onUserSignOut',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getServiceBrokerBinder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getServiceBrokerBinder()}
 **/
BaseGmsClient.prototype.getServiceBrokerBinder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getServiceBrokerBinder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function checkAvailabilityAndConnect
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#checkAvailabilityAndConnect()}
 **/
BaseGmsClient.prototype.checkAvailabilityAndConnect = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'checkAvailabilityAndConnect',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinApkVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getMinApkVersion()}
 **/
BaseGmsClient.prototype.getMinApkVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinApkVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLooper
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getLooper()}
 **/
BaseGmsClient.prototype.getLooper = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLooper',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onPostInitHandler
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#onPostInitHandler(int, android.os.IBinder, android.os.Bundle, int)}
 **/
BaseGmsClient.prototype.onPostInitHandler = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onPostInitHandler',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function requiresGooglePlayServices
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#requiresGooglePlayServices()}
 **/
BaseGmsClient.prototype.requiresGooglePlayServices = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'requiresGooglePlayServices',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getApiFeatures
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getApiFeatures()}
 **/
BaseGmsClient.prototype.getApiFeatures = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getApiFeatures',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getConnectionHint
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getConnectionHint()}
 **/
BaseGmsClient.prototype.getConnectionHint = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getConnectionHint',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getContext
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getContext()}
 **/
BaseGmsClient.prototype.getContext = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getContext',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAvailableFeatures
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/BaseGmsClient.html#getAvailableFeatures()}
 **/
BaseGmsClient.prototype.getAvailableFeatures = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAvailableFeatures',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.BaseGmsClient') {
			return new BaseGmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = BaseGmsClient;
