/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.common.internal.GmsClient
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.common.internal');

/**
 * @class com.google.android.gms.common.internal.GmsClient
 * @extends com.google.android.gms.common.internal.BaseGmsClient 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html}
 **/
var GmsClient = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.common.internal.GmsClient')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.common.internal.GmsClient. Create a subclass using com.google.android.gms.common.internal.GmsClient.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.BaseGmsClient');
GmsClient.prototype = Object.create(SuperClass.prototype);
GmsClient.prototype.constructor = GmsClient;

Object.defineProperty(GmsClient.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new GmsClient(this.$native.super);
	},
	enumerable: true
});

GmsClient.className = 'com.google.android.gms.common.internal.GmsClient';
GmsClient.prototype.className = 'com.google.android.gms.common.internal.GmsClient';

// class property
Object.defineProperty(GmsClient, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.common.internal.GmsClient');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
GmsClient.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.common.internal.GmsClient');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(GmsClient.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
GmsClient.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new GmsClient(Hyperloop.cast('com.google.android.gms.common.internal.GmsClient', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function validateScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html#validateScopes(java.util.Set)}
 **/
GmsClient.prototype.validateScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'validateScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.GmsClient') {
			return new GmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRequiredFeatures
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html#getRequiredFeatures()}
 **/
GmsClient.prototype.getRequiredFeatures = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRequiredFeatures',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.GmsClient') {
			return new GmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMinApkVersion
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html#getMinApkVersion()}
 **/
GmsClient.prototype.getMinApkVersion = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMinApkVersion',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.GmsClient') {
			return new GmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAccount
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html#getAccount()}
 **/
GmsClient.prototype.getAccount = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAccount',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.GmsClient') {
			return new GmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getClientSettings
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html#getClientSettings()}
 **/
GmsClient.prototype.getClientSettings = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getClientSettings',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.GmsClient') {
			return new GmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getScopes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/common/internal/GmsClient.html#getScopes()}
 **/
GmsClient.prototype.getScopes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getScopes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.common.internal.GmsClient') {
			return new GmsClient(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = GmsClient;
