/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.internal.base.zab
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.internal.base');

/**
 * @class com.google.android.gms.internal.base.zab
 * @extends android.os.Binder 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/internal/base/zab.html}
 **/
var zab = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.internal.base.zab')) {
		result = arguments[0];
	}
	else {
		result = zab.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.os.Binder');
zab.prototype = Object.create(SuperClass.prototype);
zab.prototype.constructor = zab;

Object.defineProperty(zab.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new zab(this.$native.super);
	},
	enumerable: true
});

zab.className = 'com.google.android.gms.internal.base.zab';
zab.prototype.className = 'com.google.android.gms.internal.base.zab';

// class property
Object.defineProperty(zab, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.internal.base.zab');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
zab.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.internal.base.zab');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(zab.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
zab.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new zab(Hyperloop.cast('com.google.android.gms.internal.base.zab', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function dispatchTransaction
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/internal/base/zab.html#dispatchTransaction(int, android.os.Parcel, android.os.Parcel, int)}
 **/
zab.prototype.dispatchTransaction = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchTransaction',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.internal.base.zab') {
			return new zab(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asBinder
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/internal/base/zab.html#asBinder()}
 **/
zab.prototype.asBinder = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asBinder',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.internal.base.zab') {
			return new zab(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onTransact
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/internal/base/zab.html#onTransact(int, android.os.Parcel, android.os.Parcel, int)}
 **/
zab.prototype.onTransact = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onTransact',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.internal.base.zab') {
			return new zab(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = zab;
