/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.internal.common.zze
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.internal.common');

/**
 * @class com.google.android.gms.internal.common.zze
 * @extends android.os.Handler 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/internal/common/zze.html}
 **/
var zze = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.internal.common.zze')) {
		result = arguments[0];
	}
	else {
		result = zze.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.os.Handler');
zze.prototype = Object.create(SuperClass.prototype);
zze.prototype.constructor = zze;

Object.defineProperty(zze.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new zze(this.$native.super);
	},
	enumerable: true
});

zze.className = 'com.google.android.gms.internal.common.zze';
zze.prototype.className = 'com.google.android.gms.internal.common.zze';

// class property
Object.defineProperty(zze, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.internal.common.zze');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
zze.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.internal.common.zze');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(zze.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
zze.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new zze(Hyperloop.cast('com.google.android.gms.internal.common.zze', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function dispatchMessage
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/internal/common/zze.html#dispatchMessage(android.os.Message)}
 **/
zze.prototype.dispatchMessage = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'dispatchMessage',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.internal.common.zze') {
			return new zze(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = zze;
