/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.tasks.Task
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.tasks');

/**
 * @class com.google.android.gms.tasks.Task
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html}
 **/
var Task = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.tasks.Task')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: com.google.android.gms.tasks.Task. Create a subclass using com.google.android.gms.tasks.Task.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Task.prototype = Object.create(SuperClass.prototype);
Task.prototype.constructor = Task;

Object.defineProperty(Task.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Task(this.$native.super);
	},
	enumerable: true
});

Task.className = 'com.google.android.gms.tasks.Task';
Task.prototype.className = 'com.google.android.gms.tasks.Task';

// class property
Object.defineProperty(Task, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.tasks.Task');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Task.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.tasks.Task');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Task.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Task.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Task(Hyperloop.cast('com.google.android.gms.tasks.Task', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function addOnFailureListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnFailureListener(com.google.android.gms.tasks.OnFailureListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnFailureListener(java.util.concurrent.Executor, com.google.android.gms.tasks.OnFailureListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnFailureListener(android.app.Activity, com.google.android.gms.tasks.OnFailureListener)}
 **/
Task.prototype.addOnFailureListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnFailureListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isCanceled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#isCanceled()}
 **/
Task.prototype.isCanceled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isCanceled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function continueWithTask
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#continueWithTask(com.google.android.gms.tasks.Continuation)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#continueWithTask(java.util.concurrent.Executor, com.google.android.gms.tasks.Continuation)}
 **/
Task.prototype.continueWithTask = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'continueWithTask',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getException
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#getException()}
 **/
Task.prototype.getException = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getException',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnCanceledListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnCanceledListener(com.google.android.gms.tasks.OnCanceledListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnCanceledListener(java.util.concurrent.Executor, com.google.android.gms.tasks.OnCanceledListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnCanceledListener(android.app.Activity, com.google.android.gms.tasks.OnCanceledListener)}
 **/
Task.prototype.addOnCanceledListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnCanceledListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSuccessful
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#isSuccessful()}
 **/
Task.prototype.isSuccessful = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSuccessful',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnCompleteListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnCompleteListener(com.google.android.gms.tasks.OnCompleteListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnCompleteListener(java.util.concurrent.Executor, com.google.android.gms.tasks.OnCompleteListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnCompleteListener(android.app.Activity, com.google.android.gms.tasks.OnCompleteListener)}
 **/
Task.prototype.addOnCompleteListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnCompleteListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addOnSuccessListener
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnSuccessListener(com.google.android.gms.tasks.OnSuccessListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnSuccessListener(java.util.concurrent.Executor, com.google.android.gms.tasks.OnSuccessListener)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#addOnSuccessListener(android.app.Activity, com.google.android.gms.tasks.OnSuccessListener)}
 **/
Task.prototype.addOnSuccessListener = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addOnSuccessListener',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#getResult()}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#getResult(java.lang.Class)}
 **/
Task.prototype.getResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function continueWith
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#continueWith(com.google.android.gms.tasks.Continuation)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#continueWith(java.util.concurrent.Executor, com.google.android.gms.tasks.Continuation)}
 **/
Task.prototype.continueWith = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'continueWith',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onSuccessTask
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#onSuccessTask(com.google.android.gms.tasks.SuccessContinuation)}
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#onSuccessTask(java.util.concurrent.Executor, com.google.android.gms.tasks.SuccessContinuation)}
 **/
Task.prototype.onSuccessTask = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onSuccessTask',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isComplete
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/tasks/Task.html#isComplete()}
 **/
Task.prototype.isComplete = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isComplete',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.tasks.Task') {
			return new Task(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Task;
