/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.AutoResolveHelper
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.AutoResolveHelper
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/AutoResolveHelper.html}
 **/
var AutoResolveHelper = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.AutoResolveHelper')) {
		result = arguments[0];
	}
	else {
		result = AutoResolveHelper.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AutoResolveHelper.prototype = Object.create(SuperClass.prototype);
AutoResolveHelper.prototype.constructor = AutoResolveHelper;

Object.defineProperty(AutoResolveHelper.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AutoResolveHelper(this.$native.super);
	},
	enumerable: true
});

AutoResolveHelper.className = 'com.google.android.gms.wallet.AutoResolveHelper';
AutoResolveHelper.prototype.className = 'com.google.android.gms.wallet.AutoResolveHelper';

// class property
Object.defineProperty(AutoResolveHelper, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.AutoResolveHelper');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AutoResolveHelper.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('com.google.android.gms.wallet.AutoResolveHelper');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AutoResolveHelper.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AutoResolveHelper.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AutoResolveHelper(Hyperloop.cast('com.google.android.gms.wallet.AutoResolveHelper', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/AutoResolveHelper.html#RESULT_ERROR}
 */
AutoResolveHelper.RESULT_ERROR = 1;

// Inner classes
Object.defineProperty(AutoResolveHelper, 'zza', {
	get: function() {
		return require('./com.google.android.gms.wallet.AutoResolveHelper$zza');
	},
	enumerable: true
});
Object.defineProperty(AutoResolveHelper, 'zzb', {
	get: function() {
		return require('./com.google.android.gms.wallet.AutoResolveHelper$zzb');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function getStatusFromIntent
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/AutoResolveHelper.html#getStatusFromIntent(android.content.Intent)}
 **/
AutoResolveHelper.getStatusFromIntent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getStatusFromIntent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.AutoResolveHelper') {
			return new AutoResolveHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zza
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/AutoResolveHelper.html#zza(com.google.android.gms.common.api.Status, java.lang.Object, com.google.android.gms.tasks.TaskCompletionSource)}
 **/
AutoResolveHelper.zza = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'zza',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.AutoResolveHelper') {
			return new AutoResolveHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function resolveTask
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/AutoResolveHelper.html#resolveTask(com.google.android.gms.tasks.Task, android.app.Activity, int)}
 **/
AutoResolveHelper.resolveTask = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'resolveTask',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.AutoResolveHelper') {
			return new AutoResolveHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function putStatusIntoIntent
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/AutoResolveHelper.html#putStatusIntoIntent(android.content.Intent, com.google.android.gms.common.api.Status)}
 **/
AutoResolveHelper.putStatusIntoIntent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'putStatusIntoIntent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.AutoResolveHelper') {
			return new AutoResolveHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = AutoResolveHelper;
