/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.CardRequirements
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.CardRequirements
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html}
 **/
var CardRequirements = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.CardRequirements')) {
		result = arguments[0];
	}
	else {
		result = CardRequirements.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
CardRequirements.prototype = Object.create(SuperClass.prototype);
CardRequirements.prototype.constructor = CardRequirements;

Object.defineProperty(CardRequirements.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new CardRequirements(this.$native.super);
	},
	enumerable: true
});

CardRequirements.className = 'com.google.android.gms.wallet.CardRequirements';
CardRequirements.prototype.className = 'com.google.android.gms.wallet.CardRequirements';

// class property
Object.defineProperty(CardRequirements, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.CardRequirements');
	},
	enumerable: true,
	configurable: false
});


// Cast
CardRequirements.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new CardRequirements(Hyperloop.cast('com.google.android.gms.wallet.CardRequirements', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(CardRequirements, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.CardRequirements$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#CREATOR
Object.defineProperty(CardRequirements, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
				return new CardRequirements(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#newBuilder()}
 **/
CardRequirements.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
			return new CardRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isBillingAddressRequired
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#isBillingAddressRequired()}
 **/
CardRequirements.prototype.isBillingAddressRequired = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBillingAddressRequired',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
			return new CardRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBillingAddressFormat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#getBillingAddressFormat()}
 **/
CardRequirements.prototype.getBillingAddressFormat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBillingAddressFormat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
			return new CardRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#writeToParcel(android.os.Parcel, int)}
 **/
CardRequirements.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
			return new CardRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAllowedCardNetworks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#getAllowedCardNetworks()}
 **/
CardRequirements.prototype.getAllowedCardNetworks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllowedCardNetworks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
			return new CardRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function allowPrepaidCards
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CardRequirements.html#allowPrepaidCards()}
 **/
CardRequirements.prototype.allowPrepaidCards = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'allowPrepaidCards',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CardRequirements') {
			return new CardRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = CardRequirements;
