/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.CreateWalletObjectsRequest
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.CreateWalletObjectsRequest
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html}
 **/
var CreateWalletObjectsRequest = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.CreateWalletObjectsRequest')) {
		result = arguments[0];
	}
	else {
		result = CreateWalletObjectsRequest.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
CreateWalletObjectsRequest.prototype = Object.create(SuperClass.prototype);
CreateWalletObjectsRequest.prototype.constructor = CreateWalletObjectsRequest;

Object.defineProperty(CreateWalletObjectsRequest.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new CreateWalletObjectsRequest(this.$native.super);
	},
	enumerable: true
});

CreateWalletObjectsRequest.className = 'com.google.android.gms.wallet.CreateWalletObjectsRequest';
CreateWalletObjectsRequest.prototype.className = 'com.google.android.gms.wallet.CreateWalletObjectsRequest';

// class property
Object.defineProperty(CreateWalletObjectsRequest, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.CreateWalletObjectsRequest');
	},
	enumerable: true,
	configurable: false
});


// Cast
CreateWalletObjectsRequest.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new CreateWalletObjectsRequest(Hyperloop.cast('com.google.android.gms.wallet.CreateWalletObjectsRequest', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#REQUEST_IMMEDIATE_SAVE}
 */
CreateWalletObjectsRequest.REQUEST_IMMEDIATE_SAVE = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#SHOW_SAVE_PROMPT}
 */
CreateWalletObjectsRequest.SHOW_SAVE_PROMPT = 0;

// Inner classes
Object.defineProperty(CreateWalletObjectsRequest, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.CreateWalletObjectsRequest$Builder');
	},
	enumerable: true
});
Object.defineProperty(CreateWalletObjectsRequest, 'CreateMode', {
	get: function() {
		return require('./com.google.android.gms.wallet.CreateWalletObjectsRequest$CreateMode');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#CREATOR
Object.defineProperty(CreateWalletObjectsRequest, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
				return new CreateWalletObjectsRequest(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#newBuilder()}
 **/
CreateWalletObjectsRequest.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
			return new CreateWalletObjectsRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getLoyaltyWalletObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#getLoyaltyWalletObject()}
 **/
CreateWalletObjectsRequest.prototype.getLoyaltyWalletObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLoyaltyWalletObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
			return new CreateWalletObjectsRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getGiftCardWalletObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#getGiftCardWalletObject()}
 **/
CreateWalletObjectsRequest.prototype.getGiftCardWalletObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getGiftCardWalletObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
			return new CreateWalletObjectsRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#writeToParcel(android.os.Parcel, int)}
 **/
CreateWalletObjectsRequest.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
			return new CreateWalletObjectsRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOfferWalletObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#getOfferWalletObject()}
 **/
CreateWalletObjectsRequest.prototype.getOfferWalletObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOfferWalletObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
			return new CreateWalletObjectsRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCreateMode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/CreateWalletObjectsRequest.html#getCreateMode()}
 **/
CreateWalletObjectsRequest.prototype.getCreateMode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getCreateMode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.CreateWalletObjectsRequest') {
			return new CreateWalletObjectsRequest(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = CreateWalletObjectsRequest;
