/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.ShippingAddressRequirements
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.ShippingAddressRequirements
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/ShippingAddressRequirements.html}
 **/
var ShippingAddressRequirements = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.ShippingAddressRequirements')) {
		result = arguments[0];
	}
	else {
		result = ShippingAddressRequirements.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
ShippingAddressRequirements.prototype = Object.create(SuperClass.prototype);
ShippingAddressRequirements.prototype.constructor = ShippingAddressRequirements;

Object.defineProperty(ShippingAddressRequirements.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ShippingAddressRequirements(this.$native.super);
	},
	enumerable: true
});

ShippingAddressRequirements.className = 'com.google.android.gms.wallet.ShippingAddressRequirements';
ShippingAddressRequirements.prototype.className = 'com.google.android.gms.wallet.ShippingAddressRequirements';

// class property
Object.defineProperty(ShippingAddressRequirements, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.ShippingAddressRequirements');
	},
	enumerable: true,
	configurable: false
});


// Cast
ShippingAddressRequirements.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ShippingAddressRequirements(Hyperloop.cast('com.google.android.gms.wallet.ShippingAddressRequirements', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(ShippingAddressRequirements, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.ShippingAddressRequirements$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/ShippingAddressRequirements.html#CREATOR
Object.defineProperty(ShippingAddressRequirements, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.ShippingAddressRequirements') {
				return new ShippingAddressRequirements(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/ShippingAddressRequirements.html#newBuilder()}
 **/
ShippingAddressRequirements.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.ShippingAddressRequirements') {
			return new ShippingAddressRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getAllowedCountryCodes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/ShippingAddressRequirements.html#getAllowedCountryCodes()}
 **/
ShippingAddressRequirements.prototype.getAllowedCountryCodes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllowedCountryCodes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.ShippingAddressRequirements') {
			return new ShippingAddressRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/ShippingAddressRequirements.html#writeToParcel(android.os.Parcel, int)}
 **/
ShippingAddressRequirements.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.ShippingAddressRequirements') {
			return new ShippingAddressRequirements(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ShippingAddressRequirements;
