/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.WalletConstants
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet');

/**
 * @class com.google.android.gms.wallet.WalletConstants
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html}
 **/
var WalletConstants = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.WalletConstants')) {
		result = arguments[0];
	}
	else {
		result = WalletConstants.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
WalletConstants.prototype = Object.create(SuperClass.prototype);
WalletConstants.prototype.constructor = WalletConstants;

Object.defineProperty(WalletConstants.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new WalletConstants(this.$native.super);
	},
	enumerable: true
});

WalletConstants.className = 'com.google.android.gms.wallet.WalletConstants';
WalletConstants.prototype.className = 'com.google.android.gms.wallet.WalletConstants';

// class property
Object.defineProperty(WalletConstants, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.WalletConstants');
	},
	enumerable: true,
	configurable: false
});


// Cast
WalletConstants.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new WalletConstants(Hyperloop.cast('com.google.android.gms.wallet.WalletConstants', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_AMEX}
 */
WalletConstants.CARD_NETWORK_AMEX = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#RESULT_ERROR}
 */
WalletConstants.RESULT_ERROR = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_DISCOVER}
 */
WalletConstants.CARD_NETWORK_DISCOVER = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_DEVELOPER_ERROR}
 */
WalletConstants.ERROR_CODE_DEVELOPER_ERROR = 10;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#THEME_HOLO_LIGHT}
 */
WalletConstants.THEME_HOLO_LIGHT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_CLASS_UNKNOWN}
 */
WalletConstants.CARD_CLASS_UNKNOWN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_SERVICE_UNAVAILABLE}
 */
WalletConstants.ERROR_CODE_SERVICE_UNAVAILABLE = 402;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#BILLING_ADDRESS_FORMAT_FULL}
 */
WalletConstants.BILLING_ADDRESS_FORMAT_FULL = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#BILLING_ADDRESS_FORMAT_MIN}
 */
WalletConstants.BILLING_ADDRESS_FORMAT_MIN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_MASTERCARD}
 */
WalletConstants.CARD_NETWORK_MASTERCARD = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ACTION_ENABLE_WALLET_OPTIMIZATION}
 */
WalletConstants.ACTION_ENABLE_WALLET_OPTIMIZATION = "com.google.android.gms.wallet.ENABLE_WALLET_OPTIMIZATION";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ENVIRONMENT_TEST}
 */
WalletConstants.ENVIRONMENT_TEST = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ENVIRONMENT_STRICT_SANDBOX}
 */
WalletConstants.ENVIRONMENT_STRICT_SANDBOX = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#EXTRA_IS_USER_PREAUTHORIZED}
 */
WalletConstants.EXTRA_IS_USER_PREAUTHORIZED = "com.google.android.gm.wallet.EXTRA_IS_USER_PREAUTHORIZED";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#PAYMENT_METHOD_UNKNOWN}
 */
WalletConstants.PAYMENT_METHOD_UNKNOWN = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_BUYER_ACCOUNT_ERROR}
 */
WalletConstants.ERROR_CODE_BUYER_ACCOUNT_ERROR = 409;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#METADATA_TAG_WALLET_API_ENABLED}
 */
WalletConstants.METADATA_TAG_WALLET_API_ENABLED = "com.google.android.gms.wallet.api.enabled";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_INVALID_TRANSACTION}
 */
WalletConstants.ERROR_CODE_INVALID_TRANSACTION = 410;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_AUTHENTICATION_FAILURE}
 */
WalletConstants.ERROR_CODE_AUTHENTICATION_FAILURE = 411;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_CLASS_PREPAID}
 */
WalletConstants.CARD_CLASS_PREPAID = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#TOTAL_PRICE_STATUS_NOT_CURRENTLY_KNOWN}
 */
WalletConstants.TOTAL_PRICE_STATUS_NOT_CURRENTLY_KNOWN = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_INTERNAL_ERROR}
 */
WalletConstants.ERROR_CODE_INTERNAL_ERROR = 8;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#TOTAL_PRICE_STATUS_FINAL}
 */
WalletConstants.TOTAL_PRICE_STATUS_FINAL = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_CLASS_DEBIT}
 */
WalletConstants.CARD_CLASS_DEBIT = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_VISA}
 */
WalletConstants.CARD_NETWORK_VISA = 5;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_JCB}
 */
WalletConstants.CARD_NETWORK_JCB = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_OTHER}
 */
WalletConstants.CARD_NETWORK_OTHER = 1000;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#PAYMENT_METHOD_TOKENIZATION_TYPE_DIRECT}
 */
WalletConstants.PAYMENT_METHOD_TOKENIZATION_TYPE_DIRECT = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#EXTRA_IS_READY_TO_PAY}
 */
WalletConstants.EXTRA_IS_READY_TO_PAY = "com.google.android.gms.wallet.EXTRA_IS_READY_TO_PAY";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#PAYMENT_METHOD_TOKENIZED_CARD}
 */
WalletConstants.PAYMENT_METHOD_TOKENIZED_CARD = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_INVALID_PARAMETERS}
 */
WalletConstants.ERROR_CODE_INVALID_PARAMETERS = 404;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#THEME_DARK}
 */
WalletConstants.THEME_DARK = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_NETWORK_INTERAC}
 */
WalletConstants.CARD_NETWORK_INTERAC = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_MERCHANT_ACCOUNT_ERROR}
 */
WalletConstants.ERROR_CODE_MERCHANT_ACCOUNT_ERROR = 405;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#PAYMENT_METHOD_CARD}
 */
WalletConstants.PAYMENT_METHOD_CARD = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#EXTRA_ERROR_CODE}
 */
WalletConstants.EXTRA_ERROR_CODE = "com.google.android.gms.wallet.EXTRA_ERROR_CODE";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#TOTAL_PRICE_STATUS_ESTIMATED}
 */
WalletConstants.TOTAL_PRICE_STATUS_ESTIMATED = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_UNKNOWN}
 */
WalletConstants.ERROR_CODE_UNKNOWN = 413;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ENVIRONMENT_PRODUCTION}
 */
WalletConstants.ENVIRONMENT_PRODUCTION = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#THEME_HOLO_DARK}
 */
WalletConstants.THEME_HOLO_DARK = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#THEME_LIGHT}
 */
WalletConstants.THEME_LIGHT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ENVIRONMENT_SANDBOX}
 */
WalletConstants.ENVIRONMENT_SANDBOX = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_SPENDING_LIMIT_EXCEEDED}
 */
WalletConstants.ERROR_CODE_SPENDING_LIMIT_EXCEEDED = 406;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#ERROR_CODE_UNSUPPORTED_API_VERSION}
 */
WalletConstants.ERROR_CODE_UNSUPPORTED_API_VERSION = 412;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#CARD_CLASS_CREDIT}
 */
WalletConstants.CARD_CLASS_CREDIT = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#PAYMENT_METHOD_TOKENIZATION_TYPE_NETWORK_TOKEN}
 */
WalletConstants.PAYMENT_METHOD_TOKENIZATION_TYPE_NETWORK_TOKEN = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/WalletConstants.html#PAYMENT_METHOD_TOKENIZATION_TYPE_PAYMENT_GATEWAY}
 */
WalletConstants.PAYMENT_METHOD_TOKENIZATION_TYPE_PAYMENT_GATEWAY = 1;

// Inner classes
Object.defineProperty(WalletConstants, 'BillingAddressFormat', {
	get: function() {
		return require('./com.google.android.gms.wallet.WalletConstants$BillingAddressFormat');
	},
	enumerable: true
});
Object.defineProperty(WalletConstants, 'CardClass', {
	get: function() {
		return require('./com.google.android.gms.wallet.WalletConstants$CardClass');
	},
	enumerable: true
});
Object.defineProperty(WalletConstants, 'CardNetwork', {
	get: function() {
		return require('./com.google.android.gms.wallet.WalletConstants$CardNetwork');
	},
	enumerable: true
});
Object.defineProperty(WalletConstants, 'PaymentMethod', {
	get: function() {
		return require('./com.google.android.gms.wallet.WalletConstants$PaymentMethod');
	},
	enumerable: true
});
Object.defineProperty(WalletConstants, 'PaymentMethodTokenizationType', {
	get: function() {
		return require('./com.google.android.gms.wallet.WalletConstants$PaymentMethodTokenizationType');
	},
	enumerable: true
});
Object.defineProperty(WalletConstants, 'TotalPriceStatus', {
	get: function() {
		return require('./com.google.android.gms.wallet.WalletConstants$TotalPriceStatus');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods

// Instance methods

// export the class
module.exports = WalletConstants;
