/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module com.google.android.gms.wallet.wobs.LoyaltyPoints
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./com.google.android.gms.wallet.wobs');

/**
 * @class com.google.android.gms.wallet.wobs.LoyaltyPoints
 * @extends com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable 
 * @constructor
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html}
 **/
var LoyaltyPoints = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('com.google.android.gms.wallet.wobs.LoyaltyPoints')) {
		result = arguments[0];
	}
	else {
		result = LoyaltyPoints.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./com.google.android.gms.common.internal.safeparcel.AbstractSafeParcelable');
LoyaltyPoints.prototype = Object.create(SuperClass.prototype);
LoyaltyPoints.prototype.constructor = LoyaltyPoints;

Object.defineProperty(LoyaltyPoints.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new LoyaltyPoints(this.$native.super);
	},
	enumerable: true
});

LoyaltyPoints.className = 'com.google.android.gms.wallet.wobs.LoyaltyPoints';
LoyaltyPoints.prototype.className = 'com.google.android.gms.wallet.wobs.LoyaltyPoints';

// class property
Object.defineProperty(LoyaltyPoints, 'class', {
	get: function() {
		return Hyperloop.getClass('com.google.android.gms.wallet.wobs.LoyaltyPoints');
	},
	enumerable: true,
	configurable: false
});


// Cast
LoyaltyPoints.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new LoyaltyPoints(Hyperloop.cast('com.google.android.gms.wallet.wobs.LoyaltyPoints', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(LoyaltyPoints, 'Builder', {
	get: function() {
		return require('./com.google.android.gms.wallet.wobs.LoyaltyPoints$Builder');
	},
	enumerable: true
});

// Static fields
// http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#CREATOR
Object.defineProperty(LoyaltyPoints, 'CREATOR', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CREATOR');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
				return new LoyaltyPoints(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function newBuilder
 * @static
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#newBuilder()}
 **/
LoyaltyPoints.newBuilder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'newBuilder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
			return new LoyaltyPoints(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getLabel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#getLabel()}
 **/
LoyaltyPoints.prototype.getLabel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLabel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
			return new LoyaltyPoints(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBalance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#getBalance()}
 **/
LoyaltyPoints.prototype.getBalance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBalance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
			return new LoyaltyPoints(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getType
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#getType()}
 **/
LoyaltyPoints.prototype.getType = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getType',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
			return new LoyaltyPoints(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getValidTimeInterval
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#getValidTimeInterval()}
 **/
LoyaltyPoints.prototype.getValidTimeInterval = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getValidTimeInterval',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
			return new LoyaltyPoints(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function writeToParcel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/com/google/android/gms/wallet/wobs/LoyaltyPoints.html#writeToParcel(android.os.Parcel, int)}
 **/
LoyaltyPoints.prototype.writeToParcel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'writeToParcel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'com.google.android.gms.wallet.wobs.LoyaltyPoints') {
			return new LoyaltyPoints(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = LoyaltyPoints;
