/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.lang.invoke.MethodHandles
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.lang.invoke');

/**
 * @class java.lang.invoke.MethodHandles
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html}
 **/
var MethodHandles = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.lang.invoke.MethodHandles')) {
		result = arguments[0];
	}
	else {
		result = MethodHandles.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
MethodHandles.prototype = Object.create(SuperClass.prototype);
MethodHandles.prototype.constructor = MethodHandles;

Object.defineProperty(MethodHandles.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new MethodHandles(this.$native.super);
	},
	enumerable: true
});

MethodHandles.className = 'java.lang.invoke.MethodHandles';
MethodHandles.prototype.className = 'java.lang.invoke.MethodHandles';

// class property
Object.defineProperty(MethodHandles, 'class', {
	get: function() {
		return Hyperloop.getClass('java.lang.invoke.MethodHandles');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
MethodHandles.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.lang.invoke.MethodHandles');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(MethodHandles.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
MethodHandles.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new MethodHandles(Hyperloop.cast('java.lang.invoke.MethodHandles', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(MethodHandles, 'Lookup', {
	get: function() {
		return require('./java.lang.invoke.MethodHandles$Lookup');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function whileLoop
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#whileLoop(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.whileLoop = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'whileLoop',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function constant
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#constant(java.lang.Class, java.lang.Object)}
 **/
MethodHandles.constant = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'constant',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function tryFinally
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#tryFinally(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.tryFinally = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'tryFinally',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function filterArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#filterArguments(java.lang.invoke.MethodHandle, int, java.lang.invoke.MethodHandle[])}
 **/
MethodHandles.filterArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'filterArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function arrayElementVarHandle
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#arrayElementVarHandle(java.lang.Class)}
 **/
MethodHandles.arrayElementVarHandle = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'arrayElementVarHandle',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function varHandleInvoker
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#varHandleInvoker(java.lang.invoke.VarHandle$AccessMode, java.lang.invoke.MethodType)}
 **/
MethodHandles.varHandleInvoker = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'varHandleInvoker',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function empty
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#empty(java.lang.invoke.MethodType)}
 **/
MethodHandles.empty = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'empty',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function spreadInvoker
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#spreadInvoker(java.lang.invoke.MethodType, int)}
 **/
MethodHandles.spreadInvoker = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'spreadInvoker',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function zero
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#zero(java.lang.Class)}
 **/
MethodHandles.zero = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'zero',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function foldArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#foldArguments(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#foldArguments(java.lang.invoke.MethodHandle, int, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.foldArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'foldArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function countedLoop
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#countedLoop(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#countedLoop(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.countedLoop = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'countedLoop',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function byteBufferViewVarHandle
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#byteBufferViewVarHandle(java.lang.Class, java.nio.ByteOrder)}
 **/
MethodHandles.byteBufferViewVarHandle = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'byteBufferViewVarHandle',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function arrayElementSetter
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#arrayElementSetter(java.lang.Class)}
 **/
MethodHandles.arrayElementSetter = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'arrayElementSetter',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dropArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#dropArguments(java.lang.invoke.MethodHandle, int, java.util.List)}
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#dropArguments(java.lang.invoke.MethodHandle, int, java.lang.Class[])}
 **/
MethodHandles.dropArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'dropArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function arrayElementGetter
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#arrayElementGetter(java.lang.Class)}
 **/
MethodHandles.arrayElementGetter = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'arrayElementGetter',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function identity
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#identity(java.lang.Class)}
 **/
MethodHandles.identity = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'identity',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function loop
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#loop(java.lang.invoke.MethodHandle[][])}
 **/
MethodHandles.loop = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'loop',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function exactInvoker
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#exactInvoker(java.lang.invoke.MethodType)}
 **/
MethodHandles.exactInvoker = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'exactInvoker',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function explicitCastArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#explicitCastArguments(java.lang.invoke.MethodHandle, java.lang.invoke.MethodType)}
 **/
MethodHandles.explicitCastArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'explicitCastArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function permuteArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#permuteArguments(java.lang.invoke.MethodHandle, java.lang.invoke.MethodType, int[])}
 **/
MethodHandles.permuteArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'permuteArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function reflectAs
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#reflectAs(java.lang.Class, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.reflectAs = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'reflectAs',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function publicLookup
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#publicLookup()}
 **/
MethodHandles.publicLookup = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'publicLookup',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function collectArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#collectArguments(java.lang.invoke.MethodHandle, int, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.collectArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'collectArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function dropArgumentsToMatch
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#dropArgumentsToMatch(java.lang.invoke.MethodHandle, int, java.util.List, int)}
 **/
MethodHandles.dropArgumentsToMatch = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'dropArgumentsToMatch',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function privateLookupIn
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#privateLookupIn(java.lang.Class, java.lang.invoke.MethodHandles$Lookup)}
 **/
MethodHandles.privateLookupIn = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'privateLookupIn',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lookup
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#lookup()}
 **/
MethodHandles.lookup = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'lookup',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function filterReturnValue
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#filterReturnValue(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.filterReturnValue = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'filterReturnValue',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function catchException
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#catchException(java.lang.invoke.MethodHandle, java.lang.Class, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.catchException = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'catchException',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function insertArguments
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#insertArguments(java.lang.invoke.MethodHandle, int, java.lang.Object[])}
 **/
MethodHandles.insertArguments = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'insertArguments',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invoker
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#invoker(java.lang.invoke.MethodType)}
 **/
MethodHandles.invoker = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'invoker',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function throwException
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#throwException(java.lang.Class, java.lang.Class)}
 **/
MethodHandles.throwException = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'throwException',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function arrayLength
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#arrayLength(java.lang.Class)}
 **/
MethodHandles.arrayLength = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'arrayLength',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function arrayConstructor
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#arrayConstructor(java.lang.Class)}
 **/
MethodHandles.arrayConstructor = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'arrayConstructor',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function guardWithTest
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#guardWithTest(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.guardWithTest = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'guardWithTest',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function iteratedLoop
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#iteratedLoop(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.iteratedLoop = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'iteratedLoop',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function byteArrayViewVarHandle
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#byteArrayViewVarHandle(java.lang.Class, java.nio.ByteOrder)}
 **/
MethodHandles.byteArrayViewVarHandle = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'byteArrayViewVarHandle',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function doWhileLoop
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#doWhileLoop(java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle, java.lang.invoke.MethodHandle)}
 **/
MethodHandles.doWhileLoop = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'doWhileLoop',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function varHandleExactInvoker
 * @static
 * @see {@link http://developer.android.com/reference/java/lang/invoke/MethodHandles.html#varHandleExactInvoker(java.lang.invoke.VarHandle$AccessMode, java.lang.invoke.MethodType)}
 **/
MethodHandles.varHandleExactInvoker = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'varHandleExactInvoker',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.lang.invoke.MethodHandles') {
			return new MethodHandles(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = MethodHandles;
