/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module AttributedCharacterIterator
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.text');

/**
 * constructor
 * http://developer.android.com/reference/java/text/AttributedCharacterIterator.html
 **/
var AttributedCharacterIterator = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.text.AttributedCharacterIterator') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.text.AttributedCharacterIterator');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
AttributedCharacterIterator.prototype = Object.create(SuperClass.prototype);
AttributedCharacterIterator.prototype.constructor = AttributedCharacterIterator;

Object.defineProperty(AttributedCharacterIterator.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AttributedCharacterIterator(this.$native.super);
	},
	enumerable: true
});

AttributedCharacterIterator.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

AttributedCharacterIterator.className = "java.text.AttributedCharacterIterator";
AttributedCharacterIterator.prototype.className = "java.text.AttributedCharacterIterator";

// class property
Object.defineProperty(AttributedCharacterIterator, 'class', {
	get: function() {
		return Hyperloop.getClass('java.text.AttributedCharacterIterator');
	},
	enumerable: true,
	configurable: false
});

// Cast
AttributedCharacterIterator.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AttributedCharacterIterator(Hyperloop.cast('java.text.AttributedCharacterIterator', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function getAttributes
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getAttributes()}
 **/
AttributedCharacterIterator.prototype.getAttributes = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttributes',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator') {
			return new AttributedCharacterIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAttribute
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getAttribute(java.text.AttributedCharacterIterator$Attribute)}
 **/
AttributedCharacterIterator.prototype.getAttribute = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAttribute',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator') {
			return new AttributedCharacterIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getRunLimit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getRunLimit()}
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getRunLimit(java.text.AttributedCharacterIterator$Attribute)}
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getRunLimit(java.util.Set)}
 **/
AttributedCharacterIterator.prototype.getRunLimit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRunLimit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator') {
			return new AttributedCharacterIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getRunStart
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getRunStart()}
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getRunStart(java.text.AttributedCharacterIterator$Attribute)}
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getRunStart(java.util.Set)}
 **/
AttributedCharacterIterator.prototype.getRunStart = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRunStart',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator') {
			return new AttributedCharacterIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getAllAttributeKeys
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/text/AttributedCharacterIterator.html#getAllAttributeKeys()}
 **/
AttributedCharacterIterator.prototype.getAllAttributeKeys = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAllAttributeKeys',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.text.AttributedCharacterIterator') {
			return new AttributedCharacterIterator(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

AttributedCharacterIterator.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

AttributedCharacterIterator.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = AttributedCharacterIterator;
