/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.Clock
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.Clock
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/Clock.html}
 **/
var Clock = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.Clock')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: java.time.Clock. Create a subclass using java.time.Clock.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
Clock.prototype = Object.create(SuperClass.prototype);
Clock.prototype.constructor = Clock;

Object.defineProperty(Clock.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Clock(this.$native.super);
	},
	enumerable: true
});

Clock.className = 'java.time.Clock';
Clock.prototype.className = 'java.time.Clock';

// class property
Object.defineProperty(Clock, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.Clock');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
Clock.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.time.Clock');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(Clock.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
Clock.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Clock(Hyperloop.cast('java.time.Clock', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function tickMillis
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#tickMillis(java.time.ZoneId)}
 **/
Clock.tickMillis = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'tickMillis',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function tickMinutes
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#tickMinutes(java.time.ZoneId)}
 **/
Clock.tickMinutes = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'tickMinutes',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function offset
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#offset(java.time.Clock, java.time.Duration)}
 **/
Clock.offset = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'offset',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function tick
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#tick(java.time.Clock, java.time.Duration)}
 **/
Clock.tick = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'tick',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function system
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#system(java.time.ZoneId)}
 **/
Clock.system = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'system',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function systemDefaultZone
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#systemDefaultZone()}
 **/
Clock.systemDefaultZone = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'systemDefaultZone',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function tickSeconds
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#tickSeconds(java.time.ZoneId)}
 **/
Clock.tickSeconds = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'tickSeconds',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function systemUTC
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#systemUTC()}
 **/
Clock.systemUTC = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'systemUTC',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fixed
 * @static
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#fixed(java.time.Instant, java.time.ZoneId)}
 **/
Clock.fixed = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fixed',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function withZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#withZone(java.time.ZoneId)}
 **/
Clock.prototype.withZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#getZone()}
 **/
Clock.prototype.getZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function instant
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#instant()}
 **/
Clock.prototype.instant = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'instant',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#hashCode()}
 **/
Clock.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#equals(java.lang.Object)}
 **/
Clock.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function millis
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/Clock.html#millis()}
 **/
Clock.prototype.millis = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'millis',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.Clock') {
			return new Clock(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = Clock;
