/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.LocalDate
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.LocalDate
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html}
 **/
var LocalDate = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.LocalDate')) {
		result = arguments[0];
	}
	else {
		result = LocalDate.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
LocalDate.prototype = Object.create(SuperClass.prototype);
LocalDate.prototype.constructor = LocalDate;

Object.defineProperty(LocalDate.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new LocalDate(this.$native.super);
	},
	enumerable: true
});

LocalDate.className = 'java.time.LocalDate';
LocalDate.prototype.className = 'java.time.LocalDate';

// class property
Object.defineProperty(LocalDate, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.LocalDate');
	},
	enumerable: true,
	configurable: false
});


// Cast
LocalDate.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new LocalDate(Hyperloop.cast('java.time.LocalDate', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/LocalDate.html#MIN
Object.defineProperty(LocalDate, 'MIN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MIN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.LocalDate') {
				return new LocalDate(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/LocalDate.html#MAX
Object.defineProperty(LocalDate, 'MAX', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MAX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.LocalDate') {
				return new LocalDate(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/LocalDate.html#EPOCH
Object.defineProperty(LocalDate, 'EPOCH', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('EPOCH');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.LocalDate') {
				return new LocalDate(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#from(java.time.temporal.TemporalAccessor)}
 **/
LocalDate.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofYearDay
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#ofYearDay(int, int)}
 **/
LocalDate.ofYearDay = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofYearDay',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofInstant
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#ofInstant(java.time.Instant, java.time.ZoneId)}
 **/
LocalDate.ofInstant = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofInstant',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function now
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#now()}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#now(java.time.ZoneId)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#now(java.time.Clock)}
 **/
LocalDate.now = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'now',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#of(int, java.time.Month, int)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#of(int, int, int)}
 **/
LocalDate.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofEpochDay
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#ofEpochDay(long)}
 **/
LocalDate.ofEpochDay = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofEpochDay',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parse
 * @static
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#parse(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#parse(java.lang.CharSequence, java.time.format.DateTimeFormatter)}
 **/
LocalDate.parse = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parse',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function atStartOfDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atStartOfDay()}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atStartOfDay(java.time.ZoneId)}
 **/
LocalDate.prototype.atStartOfDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atStartOfDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toEpochDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#toEpochDay()}
 **/
LocalDate.prototype.toEpochDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isEqual
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#isEqual(java.time.chrono.ChronoLocalDate)}
 **/
LocalDate.prototype.isEqual = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEqual',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#compareTo(java.time.chrono.ChronoLocalDate)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#compareTo(java.lang.Object)}
 **/
LocalDate.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfWeek
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getDayOfWeek()}
 **/
LocalDate.prototype.getDayOfWeek = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfWeek',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lengthOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#lengthOfMonth()}
 **/
LocalDate.prototype.lengthOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lengthOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getEra
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getEra()}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getEra()}
 **/
LocalDate.prototype.getEra = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEra',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getMonth()}
 **/
LocalDate.prototype.getMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plusMonths(long)}
 **/
LocalDate.prototype.plusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plusYears(long)}
 **/
LocalDate.prototype.plusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#query(java.time.temporal.TemporalQuery)}
 **/
LocalDate.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#format(java.time.format.DateTimeFormatter)}
 **/
LocalDate.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
LocalDate.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plus(java.time.temporal.TemporalAmount)}
 **/
LocalDate.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function atTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atTime(java.time.LocalTime)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atTime(int, int)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atTime(int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atTime(int, int, int, int)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atTime(java.time.OffsetTime)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#atTime(java.time.LocalTime)}
 **/
LocalDate.prototype.atTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getYear()}
 **/
LocalDate.prototype.getYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toEpochSecond
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#toEpochSecond(java.time.LocalTime, java.time.ZoneOffset)}
 **/
LocalDate.prototype.toEpochSecond = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochSecond',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDayOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#withDayOfMonth(int)}
 **/
LocalDate.prototype.withDayOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDayOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#withMonth(int)}
 **/
LocalDate.prototype.withMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#isAfter(java.time.chrono.ChronoLocalDate)}
 **/
LocalDate.prototype.isAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minus(java.time.temporal.TemporalAmount)}
 **/
LocalDate.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function datesUntil
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#datesUntil(java.time.LocalDate)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#datesUntil(java.time.LocalDate, java.time.Period)}
 **/
LocalDate.prototype.datesUntil = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'datesUntil',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#adjustInto(java.time.temporal.Temporal)}
 **/
LocalDate.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#range(java.time.temporal.TemporalField)}
 **/
LocalDate.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#withYear(int)}
 **/
LocalDate.prototype.withYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lengthOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#lengthOfYear()}
 **/
LocalDate.prototype.lengthOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lengthOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plusDays(long)}
 **/
LocalDate.prototype.plusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#hashCode()}
 **/
LocalDate.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#get(java.time.temporal.TemporalField)}
 **/
LocalDate.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getDayOfYear()}
 **/
LocalDate.prototype.getDayOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function plusWeeks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#plusWeeks(long)}
 **/
LocalDate.prototype.plusWeeks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plusWeeks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getChronology()}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getChronology()}
 **/
LocalDate.prototype.getChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getMonthValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getMonthValue()}
 **/
LocalDate.prototype.getMonthValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getMonthValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusYears
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minusYears(long)}
 **/
LocalDate.prototype.minusYears = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusYears',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusWeeks
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minusWeeks(long)}
 **/
LocalDate.prototype.minusWeeks = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusWeeks',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isLeapYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#isLeapYear()}
 **/
LocalDate.prototype.isLeapYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLeapYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDayOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#withDayOfYear(int)}
 **/
LocalDate.prototype.withDayOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDayOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#isBefore(java.time.chrono.ChronoLocalDate)}
 **/
LocalDate.prototype.isBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusDays
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minusDays(long)}
 **/
LocalDate.prototype.minusDays = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusDays',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getLong(java.time.temporal.TemporalField)}
 **/
LocalDate.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#with(java.time.temporal.TemporalAdjuster)}
 **/
LocalDate.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function minusMonths
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#minusMonths(long)}
 **/
LocalDate.prototype.minusMonths = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minusMonths',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#equals(java.lang.Object)}
 **/
LocalDate.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#until(java.time.chrono.ChronoLocalDate)}
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#until(java.time.chrono.ChronoLocalDate)}
 **/
LocalDate.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#toString()}
 **/
LocalDate.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDayOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/LocalDate.html#getDayOfMonth()}
 **/
LocalDate.prototype.getDayOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDayOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.LocalDate') {
			return new LocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = LocalDate;
