/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.ZoneOffset
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time');

/**
 * @class java.time.ZoneOffset
 * @extends java.time.ZoneId 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html}
 **/
var ZoneOffset = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.ZoneOffset')) {
		result = arguments[0];
	}
	else {
		result = ZoneOffset.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.time.ZoneId');
ZoneOffset.prototype = Object.create(SuperClass.prototype);
ZoneOffset.prototype.constructor = ZoneOffset;

Object.defineProperty(ZoneOffset.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ZoneOffset(this.$native.super);
	},
	enumerable: true
});

ZoneOffset.className = 'java.time.ZoneOffset';
ZoneOffset.prototype.className = 'java.time.ZoneOffset';

// class property
Object.defineProperty(ZoneOffset, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.ZoneOffset');
	},
	enumerable: true,
	configurable: false
});


// Cast
ZoneOffset.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ZoneOffset(Hyperloop.cast('java.time.ZoneOffset', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/ZoneOffset.html#MIN
Object.defineProperty(ZoneOffset, 'MIN', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MIN');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.ZoneOffset') {
				return new ZoneOffset(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/ZoneOffset.html#UTC
Object.defineProperty(ZoneOffset, 'UTC', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('UTC');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.ZoneOffset') {
				return new ZoneOffset(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/ZoneOffset.html#MAX
Object.defineProperty(ZoneOffset, 'MAX', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MAX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.ZoneOffset') {
				return new ZoneOffset(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofHoursMinutes
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#ofHoursMinutes(int, int)}
 **/
ZoneOffset.ofHoursMinutes = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofHoursMinutes',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofHours
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#ofHours(int)}
 **/
ZoneOffset.ofHours = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofHours',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#of(java.lang.String)}
 **/
ZoneOffset.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#from(java.time.temporal.TemporalAccessor)}
 **/
ZoneOffset.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofHoursMinutesSeconds
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#ofHoursMinutesSeconds(int, int, int)}
 **/
ZoneOffset.ofHoursMinutesSeconds = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofHoursMinutesSeconds',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofTotalSeconds
 * @static
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#ofTotalSeconds(int)}
 **/
ZoneOffset.ofTotalSeconds = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofTotalSeconds',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getTotalSeconds
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#getTotalSeconds()}
 **/
ZoneOffset.prototype.getTotalSeconds = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTotalSeconds',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#query(java.time.temporal.TemporalQuery)}
 **/
ZoneOffset.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#adjustInto(java.time.temporal.Temporal)}
 **/
ZoneOffset.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#range(java.time.temporal.TemporalField)}
 **/
ZoneOffset.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getId
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#getId()}
 **/
ZoneOffset.prototype.getId = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getId',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#isSupported(java.time.temporal.TemporalField)}
 **/
ZoneOffset.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#compareTo(java.time.ZoneOffset)}
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#compareTo(java.lang.Object)}
 **/
ZoneOffset.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#getLong(java.time.temporal.TemporalField)}
 **/
ZoneOffset.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#hashCode()}
 **/
ZoneOffset.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#get(java.time.temporal.TemporalField)}
 **/
ZoneOffset.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#equals(java.lang.Object)}
 **/
ZoneOffset.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#toString()}
 **/
ZoneOffset.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getRules
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/ZoneOffset.html#getRules()}
 **/
ZoneOffset.prototype.getRules = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRules',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.ZoneOffset') {
			return new ZoneOffset(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ZoneOffset;
