/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module ChronoLocalDate
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.chrono');

/**
 * constructor
 * http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html
 **/
var ChronoLocalDate = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.chrono.ChronoLocalDate') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.chrono.ChronoLocalDate');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
ChronoLocalDate.prototype = Object.create(SuperClass.prototype);
ChronoLocalDate.prototype.constructor = ChronoLocalDate;

Object.defineProperty(ChronoLocalDate.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ChronoLocalDate(this.$native.super);
	},
	enumerable: true
});

ChronoLocalDate.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

ChronoLocalDate.className = "java.time.chrono.ChronoLocalDate";
ChronoLocalDate.prototype.className = "java.time.chrono.ChronoLocalDate";

// class property
Object.defineProperty(ChronoLocalDate, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.chrono.ChronoLocalDate');
	},
	enumerable: true,
	configurable: false
});

// Cast
ChronoLocalDate.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ChronoLocalDate(Hyperloop.cast('java.time.chrono.ChronoLocalDate', object.$native));
};

// Constants

// Static methods
/**
 * TODO Fill out docs more...
 * @function from
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#from(java.time.temporal.TemporalAccessor)}
 **/
ChronoLocalDate.from = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'from',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function timeLineOrder
 * @static
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#timeLineOrder()}
 **/
ChronoLocalDate.timeLineOrder = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'timeLineOrder',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * @function minus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#minus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#minus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#minus(long, java.time.temporal.TemporalUnit)}
 **/
ChronoLocalDate.prototype.minus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'minus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toEpochDay
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#toEpochDay()}
 **/
ChronoLocalDate.prototype.toEpochDay = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toEpochDay',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isEqual
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isEqual(java.time.chrono.ChronoLocalDate)}
 **/
ChronoLocalDate.prototype.isEqual = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isEqual',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#adjustInto(java.time.temporal.Temporal)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#adjustInto(java.time.temporal.Temporal)}
 **/
ChronoLocalDate.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#range(java.time.temporal.TemporalField)}
 **/
ChronoLocalDate.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function compareTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#compareTo(java.time.chrono.ChronoLocalDate)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#compareTo(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#compareTo(java.lang.Object)}
 **/
ChronoLocalDate.prototype.compareTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function lengthOfYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#lengthOfYear()}
 **/
ChronoLocalDate.prototype.lengthOfYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lengthOfYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function lengthOfMonth
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#lengthOfMonth()}
 **/
ChronoLocalDate.prototype.lengthOfMonth = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lengthOfMonth',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getEra
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#getEra()}
 **/
ChronoLocalDate.prototype.getEra = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getEra',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#hashCode()}
 **/
ChronoLocalDate.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#get(java.time.temporal.TemporalField)}
 **/
ChronoLocalDate.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#getChronology()}
 **/
ChronoLocalDate.prototype.getChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#query(java.time.temporal.TemporalQuery)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#query(java.time.temporal.TemporalQuery)}
 **/
ChronoLocalDate.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#format(java.time.format.DateTimeFormatter)}
 **/
ChronoLocalDate.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isLeapYear
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isLeapYear()}
 **/
ChronoLocalDate.prototype.isLeapYear = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isLeapYear',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isSupported(java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isSupported(java.time.temporal.TemporalUnit)}
 **/
ChronoLocalDate.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function plus
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#plus(long, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#plus(java.time.temporal.TemporalAmount)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#plus(long, java.time.temporal.TemporalUnit)}
 **/
ChronoLocalDate.prototype.plus = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'plus',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isBefore
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isBefore(java.time.chrono.ChronoLocalDate)}
 **/
ChronoLocalDate.prototype.isBefore = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isBefore',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function atTime
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#atTime(java.time.LocalTime)}
 **/
ChronoLocalDate.prototype.atTime = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'atTime',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#getLong(java.time.temporal.TemporalField)}
 **/
ChronoLocalDate.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function with
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#with(java.time.temporal.TemporalField, long)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#with(java.time.temporal.TemporalAdjuster)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#with(java.time.temporal.TemporalField, long)}
 **/
ChronoLocalDate.prototype.with = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'with',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#equals(java.lang.Object)}
 **/
ChronoLocalDate.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function until
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#until(java.time.chrono.ChronoLocalDate)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#until(java.time.temporal.Temporal, java.time.temporal.TemporalUnit)}
 **/
ChronoLocalDate.prototype.until = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'until',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#toString()}
 **/
ChronoLocalDate.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isAfter
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/ChronoLocalDate.html#isAfter(java.time.chrono.ChronoLocalDate)}
 **/
ChronoLocalDate.prototype.isAfter = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isAfter',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.ChronoLocalDate') {
			return new ChronoLocalDate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

ChronoLocalDate.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

ChronoLocalDate.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = ChronoLocalDate;
