/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module Era
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.chrono');

/**
 * constructor
 * http://developer.android.com/reference/java/time/chrono/Era.html
 **/
var Era = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.chrono.Era') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.chrono.Era');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
Era.prototype = Object.create(SuperClass.prototype);
Era.prototype.constructor = Era;

Object.defineProperty(Era.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new Era(this.$native.super);
	},
	enumerable: true
});

Era.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

Era.className = "java.time.chrono.Era";
Era.prototype.className = "java.time.chrono.Era";

// class property
Object.defineProperty(Era, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.chrono.Era');
	},
	enumerable: true,
	configurable: false
});

// Cast
Era.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new Era(Hyperloop.cast('java.time.chrono.Era', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#getLong(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#getLong(java.time.temporal.TemporalField)}
 **/
Era.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getValue
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#getValue()}
 **/
Era.prototype.getValue = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getValue',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#getDisplayName(java.time.format.TextStyle, java.util.Locale)}
 **/
Era.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#get(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#get(java.time.temporal.TemporalField)}
 **/
Era.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function query
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#query(java.time.temporal.TemporalQuery)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#query(java.time.temporal.TemporalQuery)}
 **/
Era.prototype.query = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'query',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#adjustInto(java.time.temporal.Temporal)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#adjustInto(java.time.temporal.Temporal)}
 **/
Era.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#range(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#range(java.time.temporal.TemporalField)}
 **/
Era.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isSupported
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#isSupported(java.time.temporal.TemporalField)}
 * @see {@link http://developer.android.com/reference/java/time/chrono/Era.html#isSupported(java.time.temporal.TemporalField)}
 **/
Era.prototype.isSupported = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupported',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.chrono.Era') {
			return new Era(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

Era.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

Era.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = Era;
