/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.format.DateTimeFormatter
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.format');

/**
 * @class java.time.format.DateTimeFormatter
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html}
 **/
var DateTimeFormatter = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.format.DateTimeFormatter')) {
		result = arguments[0];
	}
	else {
		result = DateTimeFormatter.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
DateTimeFormatter.prototype = Object.create(SuperClass.prototype);
DateTimeFormatter.prototype.constructor = DateTimeFormatter;

Object.defineProperty(DateTimeFormatter.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DateTimeFormatter(this.$native.super);
	},
	enumerable: true
});

DateTimeFormatter.className = 'java.time.format.DateTimeFormatter';
DateTimeFormatter.prototype.className = 'java.time.format.DateTimeFormatter';

// class property
Object.defineProperty(DateTimeFormatter, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.format.DateTimeFormatter');
	},
	enumerable: true,
	configurable: false
});


// Cast
DateTimeFormatter.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DateTimeFormatter(Hyperloop.cast('java.time.format.DateTimeFormatter', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_OFFSET_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_OFFSET_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_OFFSET_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_LOCAL_DATE_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_LOCAL_DATE_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_LOCAL_DATE_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#RFC_1123_DATE_TIME
Object.defineProperty(DateTimeFormatter, 'RFC_1123_DATE_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('RFC_1123_DATE_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_INSTANT
Object.defineProperty(DateTimeFormatter, 'ISO_INSTANT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_INSTANT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_ZONED_DATE_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_ZONED_DATE_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_ZONED_DATE_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_OFFSET_DATE_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_OFFSET_DATE_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_OFFSET_DATE_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_DATE_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_DATE_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_DATE_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_DATE
Object.defineProperty(DateTimeFormatter, 'ISO_DATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_DATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_LOCAL_TIME
Object.defineProperty(DateTimeFormatter, 'ISO_LOCAL_TIME', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_LOCAL_TIME');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_OFFSET_DATE
Object.defineProperty(DateTimeFormatter, 'ISO_OFFSET_DATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_OFFSET_DATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_ORDINAL_DATE
Object.defineProperty(DateTimeFormatter, 'ISO_ORDINAL_DATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_ORDINAL_DATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_LOCAL_DATE
Object.defineProperty(DateTimeFormatter, 'ISO_LOCAL_DATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_LOCAL_DATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#BASIC_ISO_DATE
Object.defineProperty(DateTimeFormatter, 'BASIC_ISO_DATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('BASIC_ISO_DATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ISO_WEEK_DATE
Object.defineProperty(DateTimeFormatter, 'ISO_WEEK_DATE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ISO_WEEK_DATE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DateTimeFormatter') {
				return new DateTimeFormatter(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofLocalizedDateTime
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ofLocalizedDateTime(java.time.format.FormatStyle)}
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ofLocalizedDateTime(java.time.format.FormatStyle, java.time.format.FormatStyle)}
 **/
DateTimeFormatter.ofLocalizedDateTime = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofLocalizedDateTime',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofPattern
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ofPattern(java.lang.String)}
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ofPattern(java.lang.String, java.util.Locale)}
 **/
DateTimeFormatter.ofPattern = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofPattern',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofLocalizedDate
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ofLocalizedDate(java.time.format.FormatStyle)}
 **/
DateTimeFormatter.ofLocalizedDate = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofLocalizedDate',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parsedLeapSecond
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parsedLeapSecond()}
 **/
DateTimeFormatter.parsedLeapSecond = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parsedLeapSecond',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parsedExcessDays
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parsedExcessDays()}
 **/
DateTimeFormatter.parsedExcessDays = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parsedExcessDays',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function ofLocalizedTime
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#ofLocalizedTime(java.time.format.FormatStyle)}
 **/
DateTimeFormatter.ofLocalizedTime = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofLocalizedTime',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function withLocale
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withLocale(java.util.Locale)}
 **/
DateTimeFormatter.prototype.withLocale = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withLocale',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parseBest
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parseBest(java.lang.CharSequence, java.time.temporal.TemporalQuery[])}
 **/
DateTimeFormatter.prototype.parseBest = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parseBest',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResolverFields
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#getResolverFields()}
 **/
DateTimeFormatter.prototype.getResolverFields = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResolverFields',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function formatTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#formatTo(java.time.temporal.TemporalAccessor, java.lang.Appendable)}
 **/
DateTimeFormatter.prototype.formatTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'formatTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#getChronology()}
 **/
DateTimeFormatter.prototype.getChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDecimalStyle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withDecimalStyle(java.time.format.DecimalStyle)}
 **/
DateTimeFormatter.prototype.withDecimalStyle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDecimalStyle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withChronology
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withChronology(java.time.chrono.Chronology)}
 **/
DateTimeFormatter.prototype.withChronology = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withChronology',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function localizedBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#localizedBy(java.util.Locale)}
 **/
DateTimeFormatter.prototype.localizedBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'localizedBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withZone(java.time.ZoneId)}
 **/
DateTimeFormatter.prototype.withZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getResolverStyle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#getResolverStyle()}
 **/
DateTimeFormatter.prototype.getResolverStyle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getResolverStyle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withResolverStyle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withResolverStyle(java.time.format.ResolverStyle)}
 **/
DateTimeFormatter.prototype.withResolverStyle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withResolverStyle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function format
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#format(java.time.temporal.TemporalAccessor)}
 **/
DateTimeFormatter.prototype.format = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'format',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getZone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#getZone()}
 **/
DateTimeFormatter.prototype.getZone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getZone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parse
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parse(java.lang.CharSequence)}
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parse(java.lang.CharSequence, java.text.ParsePosition)}
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parse(java.lang.CharSequence, java.time.temporal.TemporalQuery)}
 **/
DateTimeFormatter.prototype.parse = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parse',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDecimalStyle
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#getDecimalStyle()}
 **/
DateTimeFormatter.prototype.getDecimalStyle = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDecimalStyle',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toFormat
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#toFormat()}
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#toFormat(java.time.temporal.TemporalQuery)}
 **/
DateTimeFormatter.prototype.toFormat = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toFormat',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#toString()}
 **/
DateTimeFormatter.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withResolverFields
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withResolverFields(java.time.temporal.TemporalField[])}
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#withResolverFields(java.util.Set)}
 **/
DateTimeFormatter.prototype.withResolverFields = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withResolverFields',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLocale
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#getLocale()}
 **/
DateTimeFormatter.prototype.getLocale = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLocale',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parseUnresolved
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DateTimeFormatter.html#parseUnresolved(java.lang.CharSequence, java.text.ParsePosition)}
 **/
DateTimeFormatter.prototype.parseUnresolved = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'parseUnresolved',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DateTimeFormatter') {
			return new DateTimeFormatter(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DateTimeFormatter;
