/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.format.DecimalStyle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.format');

/**
 * @class java.time.format.DecimalStyle
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html}
 **/
var DecimalStyle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.format.DecimalStyle')) {
		result = arguments[0];
	}
	else {
		result = DecimalStyle.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
DecimalStyle.prototype = Object.create(SuperClass.prototype);
DecimalStyle.prototype.constructor = DecimalStyle;

Object.defineProperty(DecimalStyle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DecimalStyle(this.$native.super);
	},
	enumerable: true
});

DecimalStyle.className = 'java.time.format.DecimalStyle';
DecimalStyle.prototype.className = 'java.time.format.DecimalStyle';

// class property
Object.defineProperty(DecimalStyle, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.format.DecimalStyle');
	},
	enumerable: true,
	configurable: false
});


// Cast
DecimalStyle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DecimalStyle(Hyperloop.cast('java.time.format.DecimalStyle', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/format/DecimalStyle.html#STANDARD
Object.defineProperty(DecimalStyle, 'STANDARD', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('STANDARD');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.DecimalStyle') {
				return new DecimalStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function ofDefaultLocale
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#ofDefaultLocale()}
 **/
DecimalStyle.ofDefaultLocale = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'ofDefaultLocale',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#of(java.util.Locale)}
 **/
DecimalStyle.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAvailableLocales
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#getAvailableLocales()}
 **/
DecimalStyle.getAvailableLocales = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getAvailableLocales',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getPositiveSign
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#getPositiveSign()}
 **/
DecimalStyle.prototype.getPositiveSign = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPositiveSign',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDecimalSeparator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#getDecimalSeparator()}
 **/
DecimalStyle.prototype.getDecimalSeparator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDecimalSeparator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNegativeSign
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#getNegativeSign()}
 **/
DecimalStyle.prototype.getNegativeSign = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNegativeSign',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getZeroDigit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#getZeroDigit()}
 **/
DecimalStyle.prototype.getZeroDigit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getZeroDigit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withPositiveSign
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#withPositiveSign(char)}
 **/
DecimalStyle.prototype.withPositiveSign = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withPositiveSign',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#hashCode()}
 **/
DecimalStyle.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withDecimalSeparator
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#withDecimalSeparator(char)}
 **/
DecimalStyle.prototype.withDecimalSeparator = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withDecimalSeparator',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#equals(java.lang.Object)}
 **/
DecimalStyle.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#toString()}
 **/
DecimalStyle.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withNegativeSign
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#withNegativeSign(char)}
 **/
DecimalStyle.prototype.withNegativeSign = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withNegativeSign',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function withZeroDigit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/DecimalStyle.html#withZeroDigit(char)}
 **/
DecimalStyle.prototype.withZeroDigit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'withZeroDigit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.DecimalStyle') {
			return new DecimalStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = DecimalStyle;
