/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.format.TextStyle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.format');

/**
 * @class java.time.format.TextStyle
 * @extends java.lang.Enum 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/format/TextStyle.html}
 **/
var TextStyle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.format.TextStyle')) {
		result = arguments[0];
	}
	else {
		result = TextStyle.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Enum');
TextStyle.prototype = Object.create(SuperClass.prototype);
TextStyle.prototype.constructor = TextStyle;

Object.defineProperty(TextStyle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TextStyle(this.$native.super);
	},
	enumerable: true
});

TextStyle.className = 'java.time.format.TextStyle';
TextStyle.prototype.className = 'java.time.format.TextStyle';

// class property
Object.defineProperty(TextStyle, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.format.TextStyle');
	},
	enumerable: true,
	configurable: false
});


// Cast
TextStyle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TextStyle(Hyperloop.cast('java.time.format.TextStyle', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/format/TextStyle.html#SHORT_STANDALONE
Object.defineProperty(TextStyle, 'SHORT_STANDALONE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SHORT_STANDALONE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.TextStyle') {
				return new TextStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/TextStyle.html#NARROW_STANDALONE
Object.defineProperty(TextStyle, 'NARROW_STANDALONE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('NARROW_STANDALONE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.TextStyle') {
				return new TextStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/TextStyle.html#FULL_STANDALONE
Object.defineProperty(TextStyle, 'FULL_STANDALONE', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('FULL_STANDALONE');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.TextStyle') {
				return new TextStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/TextStyle.html#FULL
Object.defineProperty(TextStyle, 'FULL', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('FULL');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.TextStyle') {
				return new TextStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/TextStyle.html#SHORT
Object.defineProperty(TextStyle, 'SHORT', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SHORT');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.TextStyle') {
				return new TextStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/format/TextStyle.html#NARROW
Object.defineProperty(TextStyle, 'NARROW', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('NARROW');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.format.TextStyle') {
				return new TextStyle(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/TextStyle.html#valueOf(java.lang.String)}
 **/
TextStyle.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.TextStyle') {
			return new TextStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @static
 * @see {@link http://developer.android.com/reference/java/time/format/TextStyle.html#values()}
 **/
TextStyle.values = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'values',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.TextStyle') {
			return new TextStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function asNormal
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/TextStyle.html#asNormal()}
 **/
TextStyle.prototype.asNormal = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asNormal',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.TextStyle') {
			return new TextStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isStandalone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/TextStyle.html#isStandalone()}
 **/
TextStyle.prototype.isStandalone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isStandalone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.TextStyle') {
			return new TextStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function asStandalone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/format/TextStyle.html#asStandalone()}
 **/
TextStyle.prototype.asStandalone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'asStandalone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.format.TextStyle') {
			return new TextStyle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TextStyle;
