/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.temporal.ChronoUnit
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.temporal');

/**
 * @class java.time.temporal.ChronoUnit
 * @extends java.lang.Enum 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html}
 **/
var ChronoUnit = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.temporal.ChronoUnit')) {
		result = arguments[0];
	}
	else {
		result = ChronoUnit.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Enum');
ChronoUnit.prototype = Object.create(SuperClass.prototype);
ChronoUnit.prototype.constructor = ChronoUnit;

Object.defineProperty(ChronoUnit.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ChronoUnit(this.$native.super);
	},
	enumerable: true
});

ChronoUnit.className = 'java.time.temporal.ChronoUnit';
ChronoUnit.prototype.className = 'java.time.temporal.ChronoUnit';

// class property
Object.defineProperty(ChronoUnit, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.temporal.ChronoUnit');
	},
	enumerable: true,
	configurable: false
});


// Cast
ChronoUnit.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ChronoUnit(Hyperloop.cast('java.time.temporal.ChronoUnit', object.$native));
};

// Constants

// Inner classes

// Static fields
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#FOREVER
Object.defineProperty(ChronoUnit, 'FOREVER', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('FOREVER');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#MICROS
Object.defineProperty(ChronoUnit, 'MICROS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MICROS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#SECONDS
Object.defineProperty(ChronoUnit, 'SECONDS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('SECONDS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#DECADES
Object.defineProperty(ChronoUnit, 'DECADES', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DECADES');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#MILLENNIA
Object.defineProperty(ChronoUnit, 'MILLENNIA', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MILLENNIA');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#DAYS
Object.defineProperty(ChronoUnit, 'DAYS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('DAYS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#MILLIS
Object.defineProperty(ChronoUnit, 'MILLIS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MILLIS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#HALF_DAYS
Object.defineProperty(ChronoUnit, 'HALF_DAYS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('HALF_DAYS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#MONTHS
Object.defineProperty(ChronoUnit, 'MONTHS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MONTHS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#YEARS
Object.defineProperty(ChronoUnit, 'YEARS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('YEARS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#HOURS
Object.defineProperty(ChronoUnit, 'HOURS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('HOURS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#WEEKS
Object.defineProperty(ChronoUnit, 'WEEKS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('WEEKS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#NANOS
Object.defineProperty(ChronoUnit, 'NANOS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('NANOS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#CENTURIES
Object.defineProperty(ChronoUnit, 'CENTURIES', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('CENTURIES');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#MINUTES
Object.defineProperty(ChronoUnit, 'MINUTES', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('MINUTES');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#ERAS
Object.defineProperty(ChronoUnit, 'ERAS', {
	get: function() {
		if (!this.class) return null;

		var result = this.class.getNativeField('ERAS');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'java.time.temporal.ChronoUnit') {
				return new ChronoUnit(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function valueOf
 * @static
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#valueOf(java.lang.String)}
 **/
ChronoUnit.valueOf = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'valueOf',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function values
 * @static
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#values()}
 **/
ChronoUnit.values = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'values',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function isDurationEstimated
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#isDurationEstimated()}
 **/
ChronoUnit.prototype.isDurationEstimated = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDurationEstimated',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDuration
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#getDuration()}
 **/
ChronoUnit.prototype.getDuration = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDuration',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isTimeBased
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#isTimeBased()}
 **/
ChronoUnit.prototype.isTimeBased = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isTimeBased',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function addTo
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#addTo(java.time.temporal.Temporal, long)}
 **/
ChronoUnit.prototype.addTo = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addTo',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#toString()}
 **/
ChronoUnit.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDateBased
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#isDateBased()}
 **/
ChronoUnit.prototype.isDateBased = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDateBased',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function between
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#between(java.time.temporal.Temporal, java.time.temporal.Temporal)}
 **/
ChronoUnit.prototype.between = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'between',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isSupportedBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/ChronoUnit.html#isSupportedBy(java.time.temporal.Temporal)}
 **/
ChronoUnit.prototype.isSupportedBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupportedBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.ChronoUnit') {
			return new ChronoUnit(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ChronoUnit;
