/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module TemporalField
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.temporal');

/**
 * constructor
 * http://developer.android.com/reference/java/time/temporal/TemporalField.html
 **/
var TemporalField = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.time.temporal.TemporalField') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.time.temporal.TemporalField');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
TemporalField.prototype = Object.create(SuperClass.prototype);
TemporalField.prototype.constructor = TemporalField;

Object.defineProperty(TemporalField.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TemporalField(this.$native.super);
	},
	enumerable: true
});

TemporalField.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

TemporalField.className = "java.time.temporal.TemporalField";
TemporalField.prototype.className = "java.time.temporal.TemporalField";

// class property
Object.defineProperty(TemporalField, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.temporal.TemporalField');
	},
	enumerable: true,
	configurable: false
});

// Cast
TemporalField.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TemporalField(Hyperloop.cast('java.time.temporal.TemporalField', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function resolve
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#resolve(java.util.Map, java.time.temporal.TemporalAccessor, java.time.format.ResolverStyle)}
 **/
TemporalField.prototype.resolve = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resolve',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getDisplayName
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#getDisplayName(java.util.Locale)}
 **/
TemporalField.prototype.getDisplayName = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDisplayName',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getBaseUnit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#getBaseUnit()}
 **/
TemporalField.prototype.getBaseUnit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBaseUnit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function rangeRefinedBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#rangeRefinedBy(java.time.temporal.TemporalAccessor)}
 **/
TemporalField.prototype.rangeRefinedBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'rangeRefinedBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isTimeBased
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#isTimeBased()}
 **/
TemporalField.prototype.isTimeBased = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isTimeBased',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function adjustInto
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#adjustInto(java.time.temporal.Temporal, long)}
 **/
TemporalField.prototype.adjustInto = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'adjustInto',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function range
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#range()}
 **/
TemporalField.prototype.range = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'range',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getRangeUnit
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#getRangeUnit()}
 **/
TemporalField.prototype.getRangeUnit = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getRangeUnit',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#toString()}
 **/
TemporalField.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isDateBased
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#isDateBased()}
 **/
TemporalField.prototype.isDateBased = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDateBased',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function isSupportedBy
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#isSupportedBy(java.time.temporal.TemporalAccessor)}
 **/
TemporalField.prototype.isSupportedBy = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isSupportedBy',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function getFrom
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/temporal/TemporalField.html#getFrom(java.time.temporal.TemporalAccessor)}
 **/
TemporalField.prototype.getFrom = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFrom',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.temporal.TemporalField') {
			return new TemporalField(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

TemporalField.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

TemporalField.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = TemporalField;
