/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.time.zone.ZoneRules
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.time.zone');

/**
 * @class java.time.zone.ZoneRules
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html}
 **/
var ZoneRules = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.time.zone.ZoneRules')) {
		result = arguments[0];
	}
	else {
		result = ZoneRules.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
ZoneRules.prototype = Object.create(SuperClass.prototype);
ZoneRules.prototype.constructor = ZoneRules;

Object.defineProperty(ZoneRules.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new ZoneRules(this.$native.super);
	},
	enumerable: true
});

ZoneRules.className = 'java.time.zone.ZoneRules';
ZoneRules.prototype.className = 'java.time.zone.ZoneRules';

// class property
Object.defineProperty(ZoneRules, 'class', {
	get: function() {
		return Hyperloop.getClass('java.time.zone.ZoneRules');
	},
	enumerable: true,
	configurable: false
});


// Cast
ZoneRules.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new ZoneRules(Hyperloop.cast('java.time.zone.ZoneRules', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function of
 * @static
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#of(java.time.ZoneOffset, java.time.ZoneOffset, java.util.List, java.util.List, java.util.List)}
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#of(java.time.ZoneOffset)}
 **/
ZoneRules.of = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'of',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getTransitions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getTransitions()}
 **/
ZoneRules.prototype.getTransitions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTransitions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getDaylightSavings
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getDaylightSavings(java.time.Instant)}
 **/
ZoneRules.prototype.getDaylightSavings = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDaylightSavings',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function previousTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#previousTransition(java.time.Instant)}
 **/
ZoneRules.prototype.previousTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'previousTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTransitionRules
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getTransitionRules()}
 **/
ZoneRules.prototype.getTransitionRules = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTransitionRules',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getOffset(java.time.Instant)}
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getOffset(java.time.LocalDateTime)}
 **/
ZoneRules.prototype.getOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isFixedOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#isFixedOffset()}
 **/
ZoneRules.prototype.isFixedOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isFixedOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function hashCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#hashCode()}
 **/
ZoneRules.prototype.hashCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getValidOffsets
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getValidOffsets(java.time.LocalDateTime)}
 **/
ZoneRules.prototype.getValidOffsets = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getValidOffsets',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getTransition(java.time.LocalDateTime)}
 **/
ZoneRules.prototype.getTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function equals
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#equals(java.lang.Object)}
 **/
ZoneRules.prototype.equals = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStandardOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#getStandardOffset(java.time.Instant)}
 **/
ZoneRules.prototype.getStandardOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStandardOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function nextTransition
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#nextTransition(java.time.Instant)}
 **/
ZoneRules.prototype.nextTransition = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'nextTransition',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#toString()}
 **/
ZoneRules.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDaylightSavings
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#isDaylightSavings(java.time.Instant)}
 **/
ZoneRules.prototype.isDaylightSavings = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDaylightSavings',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isValidOffset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/time/zone/ZoneRules.html#isValidOffset(java.time.LocalDateTime, java.time.ZoneOffset)}
 **/
ZoneRules.prototype.isValidOffset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isValidOffset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.time.zone.ZoneRules') {
			return new ZoneRules(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = ZoneRules;
