/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.concurrent.FutureTask
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.concurrent');

/**
 * @class java.util.concurrent.FutureTask
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html}
 **/
var FutureTask = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.concurrent.FutureTask')) {
		result = arguments[0];
	}
	else {
		result = FutureTask.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FutureTask.prototype = Object.create(SuperClass.prototype);
FutureTask.prototype.constructor = FutureTask;

Object.defineProperty(FutureTask.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FutureTask(this.$native.super);
	},
	enumerable: true
});

FutureTask.className = 'java.util.concurrent.FutureTask';
FutureTask.prototype.className = 'java.util.concurrent.FutureTask';

// class property
Object.defineProperty(FutureTask, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.concurrent.FutureTask');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FutureTask.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.util.concurrent.FutureTask');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FutureTask.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FutureTask.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FutureTask(Hyperloop.cast('java.util.concurrent.FutureTask', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function cancel
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#cancel(boolean)}
 **/
FutureTask.prototype.cancel = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'cancel',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isCancelled
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#isCancelled()}
 **/
FutureTask.prototype.isCancelled = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isCancelled',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function runAndReset
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#runAndReset()}
 **/
FutureTask.prototype.runAndReset = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'runAndReset',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function set
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#set(java.lang.Object)}
 **/
FutureTask.prototype.set = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'set',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#get()}
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#get(long, java.util.concurrent.TimeUnit)}
 **/
FutureTask.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function run
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#run()}
 **/
FutureTask.prototype.run = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'run',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#toString()}
 **/
FutureTask.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setException
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#setException(java.lang.Throwable)}
 **/
FutureTask.prototype.setException = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setException',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isDone
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#isDone()}
 **/
FutureTask.prototype.isDone = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isDone',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function done
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/FutureTask.html#done()}
 **/
FutureTask.prototype.done = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'done',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.FutureTask') {
			return new FutureTask(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = FutureTask;
