/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module java.util.concurrent.atomic.AtomicReference
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.concurrent.atomic');

/**
 * @class java.util.concurrent.atomic.AtomicReference
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html}
 **/
var AtomicReference = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('java.util.concurrent.atomic.AtomicReference')) {
		result = arguments[0];
	}
	else {
		result = AtomicReference.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
AtomicReference.prototype = Object.create(SuperClass.prototype);
AtomicReference.prototype.constructor = AtomicReference;

Object.defineProperty(AtomicReference.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new AtomicReference(this.$native.super);
	},
	enumerable: true
});

AtomicReference.className = 'java.util.concurrent.atomic.AtomicReference';
AtomicReference.prototype.className = 'java.util.concurrent.atomic.AtomicReference';

// class property
Object.defineProperty(AtomicReference, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.concurrent.atomic.AtomicReference');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
AtomicReference.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('java.util.concurrent.atomic.AtomicReference');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(AtomicReference.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
AtomicReference.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new AtomicReference(Hyperloop.cast('java.util.concurrent.atomic.AtomicReference', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function setPlain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#setPlain(java.lang.Object)}
 **/
AtomicReference.prototype.setPlain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setPlain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetPlain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#weakCompareAndSetPlain(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.weakCompareAndSetPlain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetPlain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndExchange
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#compareAndExchange(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.compareAndExchange = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndExchange',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAcquire
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#getAcquire()}
 **/
AtomicReference.prototype.getAcquire = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAcquire',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function updateAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#updateAndGet(java.util.function.UnaryOperator)}
 **/
AtomicReference.prototype.updateAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'updateAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getOpaque
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#getOpaque()}
 **/
AtomicReference.prototype.getOpaque = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getOpaque',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#get()}
 **/
AtomicReference.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function lazySet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#lazySet(java.lang.Object)}
 **/
AtomicReference.prototype.lazySet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'lazySet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndSet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#getAndSet(java.lang.Object)}
 **/
AtomicReference.prototype.getAndSet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndSet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetAcquire
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#weakCompareAndSetAcquire(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.weakCompareAndSetAcquire = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetAcquire',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndAccumulate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#getAndAccumulate(java.lang.Object, java.util.function.BinaryOperator)}
 **/
AtomicReference.prototype.getAndAccumulate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndAccumulate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function accumulateAndGet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#accumulateAndGet(java.lang.Object, java.util.function.BinaryOperator)}
 **/
AtomicReference.prototype.accumulateAndGet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'accumulateAndGet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetVolatile
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#weakCompareAndSetVolatile(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.weakCompareAndSetVolatile = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetVolatile',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function set
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#set(java.lang.Object)}
 **/
AtomicReference.prototype.set = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'set',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSetRelease
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#weakCompareAndSetRelease(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.weakCompareAndSetRelease = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSetRelease',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function weakCompareAndSet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#weakCompareAndSet(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.weakCompareAndSet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'weakCompareAndSet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setOpaque
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#setOpaque(java.lang.Object)}
 **/
AtomicReference.prototype.setOpaque = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setOpaque',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getPlain
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#getPlain()}
 **/
AtomicReference.prototype.getPlain = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getPlain',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndExchangeRelease
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#compareAndExchangeRelease(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.compareAndExchangeRelease = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndExchangeRelease',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndSet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#compareAndSet(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.compareAndSet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndSet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function compareAndExchangeAcquire
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#compareAndExchangeAcquire(java.lang.Object, java.lang.Object)}
 **/
AtomicReference.prototype.compareAndExchangeAcquire = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'compareAndExchangeAcquire',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#toString()}
 **/
AtomicReference.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setRelease
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#setRelease(java.lang.Object)}
 **/
AtomicReference.prototype.setRelease = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setRelease',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getAndUpdate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/concurrent/atomic/AtomicReference.html#getAndUpdate(java.util.function.UnaryOperator)}
 **/
AtomicReference.prototype.getAndUpdate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getAndUpdate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.concurrent.atomic.AtomicReference') {
			return new AtomicReference(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = AtomicReference;
