/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module DoublePredicate
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./java.util.function');

/**
 * constructor
 * http://developer.android.com/reference/java/util/function/DoublePredicate.html
 **/
var DoublePredicate = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].apiName && arguments[0].apiName === 'java.util.function.DoublePredicate') {
		result = arguments[0];
	}
	else {
		var instance = this,
			copy = Array.prototype.slice.call(arguments)[0],
			modified = {},
			subclass;

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};
		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		// Create dynamic subclass of the interface
		// Then generate a new instance of the subclass with the modified overrides that auto wrap native objects in JS wrappers
		// and delegate to the original impls.
		subclass = Hyperloop.implement('java.util.function.DoublePredicate');
		result = subclass.newInstance(modified);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};


var SuperClass = require('./java.lang.Object');
DoublePredicate.prototype = Object.create(SuperClass.prototype);
DoublePredicate.prototype.constructor = DoublePredicate;

Object.defineProperty(DoublePredicate.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new DoublePredicate(this.$native.super);
	},
	enumerable: true
});

DoublePredicate.isInstanceOf = function (self, cls) {
	if (typeof cls !== "function" || typeof self !== "function") { return false; }
	while (self) {
		if (cls === self || self instanceof cls || self.className === cls.className) {
			return true;
		}
		self = self.__superclass__;
	}
	return false;
};

DoublePredicate.className = "java.util.function.DoublePredicate";
DoublePredicate.prototype.className = "java.util.function.DoublePredicate";

// class property
Object.defineProperty(DoublePredicate, 'class', {
	get: function() {
		return Hyperloop.getClass('java.util.function.DoublePredicate');
	},
	enumerable: true,
	configurable: false
});

// Cast
DoublePredicate.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new DoublePredicate(Hyperloop.cast('java.util.function.DoublePredicate', object.$native));
};

// Constants

// Static methods

// Instance methods
/**
 * @function or
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/function/DoublePredicate.html#or(java.util.function.DoublePredicate)}
 **/
DoublePredicate.prototype.or = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'or',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.function.DoublePredicate') {
			return new DoublePredicate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function test
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/function/DoublePredicate.html#test(double)}
 **/
DoublePredicate.prototype.test = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'test',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.function.DoublePredicate') {
			return new DoublePredicate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function and
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/function/DoublePredicate.html#and(java.util.function.DoublePredicate)}
 **/
DoublePredicate.prototype.and = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'and',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.function.DoublePredicate') {
			return new DoublePredicate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * @function negate
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/java/util/function/DoublePredicate.html#negate()}
 **/
DoublePredicate.prototype.negate = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'negate',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'java.util.function.DoublePredicate') {
			return new DoublePredicate(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

DoublePredicate.prototype.equals = function (other) {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'equals',
		instanceMethod: true,
		args: [other]
	});
	return result;
};

DoublePredicate.prototype.hashCode = function () {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'hashCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	return result;
};

// export the interface
module.exports = DoublePredicate;
