/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.kroll.KrollFunction$FunctionArgs
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.kroll.KrollFunction');

/**
 * @class org.appcelerator.kroll.KrollFunction$FunctionArgs
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/kroll/KrollFunction.FunctionArgs.html}
 **/
var FunctionArgs = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.kroll.KrollFunction$FunctionArgs')) {
		result = arguments[0];
	}
	else {
		result = FunctionArgs.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
FunctionArgs.prototype = Object.create(SuperClass.prototype);
FunctionArgs.prototype.constructor = FunctionArgs;

Object.defineProperty(FunctionArgs.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new FunctionArgs(this.$native.super);
	},
	enumerable: true
});

FunctionArgs.className = 'org.appcelerator.kroll.KrollFunction$FunctionArgs';
FunctionArgs.prototype.className = 'org.appcelerator.kroll.KrollFunction$FunctionArgs';

// class property
Object.defineProperty(FunctionArgs, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.kroll.KrollFunction$FunctionArgs');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
FunctionArgs.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.kroll.KrollFunction$FunctionArgs');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(FunctionArgs.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
FunctionArgs.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new FunctionArgs(Hyperloop.cast('org.appcelerator.kroll.KrollFunction$FunctionArgs', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/kroll/KrollFunction.FunctionArgs.html#args
Object.defineProperty(FunctionArgs.prototype, 'args', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('args');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollFunction$FunctionArgs') {
				return new FunctionArgs(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('args', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/kroll/KrollFunction.FunctionArgs.html#krollObject
Object.defineProperty(FunctionArgs.prototype, 'krollObject', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('krollObject');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.kroll.KrollFunction$FunctionArgs') {
				return new FunctionArgs(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('krollObject', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods

// export the class
module.exports = FunctionArgs;
