/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.TiLifecycle
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * @class org.appcelerator.titanium.TiLifecycle
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html}
 **/
var TiLifecycle = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.TiLifecycle')) {
		result = arguments[0];
	}
	else {
		result = TiLifecycle.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiLifecycle.prototype = Object.create(SuperClass.prototype);
TiLifecycle.prototype.constructor = TiLifecycle;

Object.defineProperty(TiLifecycle.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiLifecycle(this.$native.super);
	},
	enumerable: true
});

TiLifecycle.className = 'org.appcelerator.titanium.TiLifecycle';
TiLifecycle.prototype.className = 'org.appcelerator.titanium.TiLifecycle';

// class property
Object.defineProperty(TiLifecycle, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.TiLifecycle');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiLifecycle.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.TiLifecycle');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiLifecycle.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiLifecycle.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiLifecycle(Hyperloop.cast('org.appcelerator.titanium.TiLifecycle', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#LIFECYCLE_ON_PAUSE}
 */
TiLifecycle.LIFECYCLE_ON_PAUSE = 2;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#LIFECYCLE_ON_STOP}
 */
TiLifecycle.LIFECYCLE_ON_STOP = 3;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#LIFECYCLE_ON_DESTROY}
 */
TiLifecycle.LIFECYCLE_ON_DESTROY = 4;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#LIFECYCLE_ON_RESUME}
 */
TiLifecycle.LIFECYCLE_ON_RESUME = 1;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#ON_SAVE_INSTANCE_STATE}
 */
TiLifecycle.ON_SAVE_INSTANCE_STATE = 6;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#ON_RESTORE_INSTANCE_STATE}
 */
TiLifecycle.ON_RESTORE_INSTANCE_STATE = 7;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#LIFECYCLE_ON_START}
 */
TiLifecycle.LIFECYCLE_ON_START = 0;
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#LIFECYCLE_ON_CREATE}
 */
TiLifecycle.LIFECYCLE_ON_CREATE = 5;

// Inner classes
Object.defineProperty(TiLifecycle, 'OnActivityResultEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$OnActivityResultEvent');
	},
	enumerable: true
});
Object.defineProperty(TiLifecycle, 'OnCreateOptionsMenuEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$OnCreateOptionsMenuEvent');
	},
	enumerable: true
});
Object.defineProperty(TiLifecycle, 'OnInstanceStateEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$OnInstanceStateEvent');
	},
	enumerable: true
});
Object.defineProperty(TiLifecycle, 'OnLifecycleEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$OnLifecycleEvent');
	},
	enumerable: true
});
Object.defineProperty(TiLifecycle, 'OnPrepareOptionsMenuEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$OnPrepareOptionsMenuEvent');
	},
	enumerable: true
});
Object.defineProperty(TiLifecycle, 'OnWindowFocusChangedEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$OnWindowFocusChangedEvent');
	},
	enumerable: true
});
Object.defineProperty(TiLifecycle, 'interceptOnBackPressedEvent', {
	get: function() {
		return require('./org.appcelerator.titanium.TiLifecycle$interceptOnBackPressedEvent');
	},
	enumerable: true
});

// Static fields

// Instance Fields

// Static methods
/**
 * TODO Fill out docs more...
 * @function fireOnCreateOptionsMenuEvent
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#fireOnCreateOptionsMenuEvent(android.app.Activity, org.appcelerator.titanium.TiLifecycle$OnCreateOptionsMenuEvent, android.view.Menu)}
 **/
TiLifecycle.fireOnCreateOptionsMenuEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fireOnCreateOptionsMenuEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiLifecycle') {
			return new TiLifecycle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireInstanceStateEvent
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#fireInstanceStateEvent(android.os.Bundle, org.appcelerator.titanium.TiLifecycle$OnInstanceStateEvent, int)}
 **/
TiLifecycle.fireInstanceStateEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fireInstanceStateEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiLifecycle') {
			return new TiLifecycle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireOnActivityResultEvent
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#fireOnActivityResultEvent(android.app.Activity, org.appcelerator.titanium.TiLifecycle$OnActivityResultEvent, int, int, android.content.Intent)}
 **/
TiLifecycle.fireOnActivityResultEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fireOnActivityResultEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiLifecycle') {
			return new TiLifecycle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireOnPrepareOptionsMenuEvent
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#fireOnPrepareOptionsMenuEvent(android.app.Activity, org.appcelerator.titanium.TiLifecycle$OnPrepareOptionsMenuEvent, android.view.Menu)}
 **/
TiLifecycle.fireOnPrepareOptionsMenuEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fireOnPrepareOptionsMenuEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiLifecycle') {
			return new TiLifecycle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function fireLifecycleEvent
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#fireLifecycleEvent(android.app.Activity, org.appcelerator.titanium.TiLifecycle$OnLifecycleEvent, int)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiLifecycle.html#fireLifecycleEvent(android.app.Activity, org.appcelerator.titanium.TiLifecycle$OnLifecycleEvent, android.os.Bundle, int)}
 **/
TiLifecycle.fireLifecycleEvent = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'fireLifecycleEvent',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiLifecycle') {
			return new TiLifecycle(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods

// export the class
module.exports = TiLifecycle;
