/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.TiStylesheet
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium');

/**
 * @class org.appcelerator.titanium.TiStylesheet
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html}
 **/
var TiStylesheet = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.TiStylesheet')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: org.appcelerator.titanium.TiStylesheet. Create a subclass using org.appcelerator.titanium.TiStylesheet.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiStylesheet.prototype = Object.create(SuperClass.prototype);
TiStylesheet.prototype.constructor = TiStylesheet;

Object.defineProperty(TiStylesheet.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiStylesheet(this.$native.super);
	},
	enumerable: true
});

TiStylesheet.className = 'org.appcelerator.titanium.TiStylesheet';
TiStylesheet.prototype.className = 'org.appcelerator.titanium.TiStylesheet';

// class property
Object.defineProperty(TiStylesheet, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.TiStylesheet');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiStylesheet.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.TiStylesheet');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiStylesheet.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiStylesheet.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiStylesheet(Hyperloop.cast('org.appcelerator.titanium.TiStylesheet', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html#classesMap
Object.defineProperty(TiStylesheet.prototype, 'classesMap', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('classesMap');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiStylesheet') {
				return new TiStylesheet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html#idsMap
Object.defineProperty(TiStylesheet.prototype, 'idsMap', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('idsMap');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiStylesheet') {
				return new TiStylesheet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html#idsDensityMap
Object.defineProperty(TiStylesheet.prototype, 'idsDensityMap', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('idsDensityMap');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiStylesheet') {
				return new TiStylesheet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html#classesDensityMap
Object.defineProperty(TiStylesheet.prototype, 'classesDensityMap', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('classesDensityMap');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.TiStylesheet') {
				return new TiStylesheet(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function addAll
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html#addAll(org.appcelerator.kroll.KrollDict, java.util.HashMap, java.lang.String)}
 **/
TiStylesheet.prototype.addAll = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'addAll',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiStylesheet') {
			return new TiStylesheet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getStylesheet
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/TiStylesheet.html#getStylesheet(java.lang.String, java.util.Collection, java.lang.String, java.lang.String)}
 **/
TiStylesheet.prototype.getStylesheet = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getStylesheet',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.TiStylesheet') {
			return new TiStylesheet(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiStylesheet;
