/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.proxy.TiToolbarProxy
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.proxy');

/**
 * @class org.appcelerator.titanium.proxy.TiToolbarProxy
 * @extends org.appcelerator.titanium.proxy.TiViewProxy 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/TiToolbarProxy.html}
 **/
var TiToolbarProxy = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.proxy.TiToolbarProxy')) {
		result = arguments[0];
	}
	else {
		Ti.API.error('Cannot instantiate instance of abstract class: org.appcelerator.titanium.proxy.TiToolbarProxy. Create a subclass using org.appcelerator.titanium.proxy.TiToolbarProxy.extend();' );
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./org.appcelerator.titanium.proxy.TiViewProxy');
TiToolbarProxy.prototype = Object.create(SuperClass.prototype);
TiToolbarProxy.prototype.constructor = TiToolbarProxy;

Object.defineProperty(TiToolbarProxy.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiToolbarProxy(this.$native.super);
	},
	enumerable: true
});

TiToolbarProxy.className = 'org.appcelerator.titanium.proxy.TiToolbarProxy';
TiToolbarProxy.prototype.className = 'org.appcelerator.titanium.proxy.TiToolbarProxy';

// class property
Object.defineProperty(TiToolbarProxy, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.proxy.TiToolbarProxy');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiToolbarProxy.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.proxy.TiToolbarProxy');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiToolbarProxy.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiToolbarProxy.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiToolbarProxy(Hyperloop.cast('org.appcelerator.titanium.proxy.TiToolbarProxy', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getToolbarInstance
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/proxy/TiToolbarProxy.html#getToolbarInstance()}
 **/
TiToolbarProxy.prototype.getToolbarInstance = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getToolbarInstance',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.proxy.TiToolbarProxy') {
			return new TiToolbarProxy(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiToolbarProxy;
