/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiActivitySupportHelper
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.util');

/**
 * @class org.appcelerator.titanium.util.TiActivitySupportHelper
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html}
 **/
var TiActivitySupportHelper = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiActivitySupportHelper')) {
		result = arguments[0];
	}
	else {
		result = TiActivitySupportHelper.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiActivitySupportHelper.prototype = Object.create(SuperClass.prototype);
TiActivitySupportHelper.prototype.constructor = TiActivitySupportHelper;

Object.defineProperty(TiActivitySupportHelper.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiActivitySupportHelper(this.$native.super);
	},
	enumerable: true
});

TiActivitySupportHelper.className = 'org.appcelerator.titanium.util.TiActivitySupportHelper';
TiActivitySupportHelper.prototype.className = 'org.appcelerator.titanium.util.TiActivitySupportHelper';

// class property
Object.defineProperty(TiActivitySupportHelper, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiActivitySupportHelper');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiActivitySupportHelper.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiActivitySupportHelper');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiActivitySupportHelper.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiActivitySupportHelper.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiActivitySupportHelper(Hyperloop.cast('org.appcelerator.titanium.util.TiActivitySupportHelper', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#activity
Object.defineProperty(TiActivitySupportHelper.prototype, 'activity', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('activity');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
				return new TiActivitySupportHelper(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('activity', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#resultHandlers
Object.defineProperty(TiActivitySupportHelper.prototype, 'resultHandlers', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('resultHandlers');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
				return new TiActivitySupportHelper(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('resultHandlers', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#uniqueResultCodeAllocator
Object.defineProperty(TiActivitySupportHelper.prototype, 'uniqueResultCodeAllocator', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('uniqueResultCodeAllocator');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
				return new TiActivitySupportHelper(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('uniqueResultCodeAllocator', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function launchIntentSenderForResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#launchIntentSenderForResult(android.content.IntentSender, int, android.content.Intent, int, int, int, android.os.Bundle, org.appcelerator.titanium.util.TiActivityResultHandler)}
 **/
TiActivitySupportHelper.prototype.launchIntentSenderForResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'launchIntentSenderForResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function removeResultHandler
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#removeResultHandler(int)}
 **/
TiActivitySupportHelper.prototype.removeResultHandler = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'removeResultHandler',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getUniqueResultCode
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#getUniqueResultCode()}
 **/
TiActivitySupportHelper.prototype.getUniqueResultCode = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getUniqueResultCode',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function registerResultHandler
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#registerResultHandler(int, org.appcelerator.titanium.util.TiActivityResultHandler)}
 **/
TiActivitySupportHelper.prototype.registerResultHandler = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'registerResultHandler',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function onActivityResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#onActivityResult(int, int, android.content.Intent)}
 **/
TiActivitySupportHelper.prototype.onActivityResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'onActivityResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function launchActivityForResult
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#launchActivityForResult(android.content.Intent, int, org.appcelerator.titanium.util.TiActivityResultHandler)}
 **/
TiActivitySupportHelper.prototype.launchActivityForResult = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'launchActivityForResult',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setActivity
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiActivitySupportHelper.html#setActivity(android.app.Activity)}
 **/
TiActivitySupportHelper.prototype.setActivity = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setActivity',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiActivitySupportHelper') {
			return new TiActivitySupportHelper(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiActivitySupportHelper;
