/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation
 */
var Hyperloop = require('hyperloop');

var EnclosingClass = require('./org.appcelerator.titanium.util.TiAnimationBuilder');

/**
 * @class org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation
 * @extends android.view.animation.Animation 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html}
 **/
var TiMatrixAnimation = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation')) {
		result = arguments[0];
	}
	else {
		result = TiMatrixAnimation.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./android.view.animation.Animation');
TiMatrixAnimation.prototype = Object.create(SuperClass.prototype);
TiMatrixAnimation.prototype.constructor = TiMatrixAnimation;

Object.defineProperty(TiMatrixAnimation.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiMatrixAnimation(this.$native.super);
	},
	enumerable: true
});

TiMatrixAnimation.className = 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation';
TiMatrixAnimation.prototype.className = 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation';

// class property
Object.defineProperty(TiMatrixAnimation, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiMatrixAnimation.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiMatrixAnimation.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiMatrixAnimation.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiMatrixAnimation(Hyperloop.cast('org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#anchorY
Object.defineProperty(TiMatrixAnimation.prototype, 'anchorY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('anchorY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
				return new TiMatrixAnimation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('anchorY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#anchorX
Object.defineProperty(TiMatrixAnimation.prototype, 'anchorX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('anchorX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
				return new TiMatrixAnimation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('anchorX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#childHeight
Object.defineProperty(TiMatrixAnimation.prototype, 'childHeight', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('childHeight');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
				return new TiMatrixAnimation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('childHeight', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#interpolate
Object.defineProperty(TiMatrixAnimation.prototype, 'interpolate', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('interpolate');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
				return new TiMatrixAnimation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('interpolate', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#childWidth
Object.defineProperty(TiMatrixAnimation.prototype, 'childWidth', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('childWidth');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
				return new TiMatrixAnimation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('childWidth', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#matrix
Object.defineProperty(TiMatrixAnimation.prototype, 'matrix', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('matrix');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
				return new TiMatrixAnimation(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('matrix', newValue);
	},
	enumerable: true
});

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getFinalMatrix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#getFinalMatrix(int, int)}
 **/
TiMatrixAnimation.prototype.getFinalMatrix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getFinalMatrix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
			return new TiMatrixAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function invalidateWithMatrix
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#invalidateWithMatrix(android.view.View)}
 **/
TiMatrixAnimation.prototype.invalidateWithMatrix = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'invalidateWithMatrix',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
			return new TiMatrixAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyTransformation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#applyTransformation(float, android.view.animation.Transformation)}
 **/
TiMatrixAnimation.prototype.applyTransformation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyTransformation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
			return new TiMatrixAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function initialize
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.TiMatrixAnimation.html#initialize(int, int, int, int)}
 **/
TiMatrixAnimation.prototype.initialize = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'initialize',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation') {
			return new TiMatrixAnimation(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiMatrixAnimation;
