/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiAnimationBuilder
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.util');

/**
 * @class org.appcelerator.titanium.util.TiAnimationBuilder
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html}
 **/
var TiAnimationBuilder = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiAnimationBuilder')) {
		result = arguments[0];
	}
	else {
		result = TiAnimationBuilder.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiAnimationBuilder.prototype = Object.create(SuperClass.prototype);
TiAnimationBuilder.prototype.constructor = TiAnimationBuilder;

Object.defineProperty(TiAnimationBuilder.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiAnimationBuilder(this.$native.super);
	},
	enumerable: true
});

TiAnimationBuilder.className = 'org.appcelerator.titanium.util.TiAnimationBuilder';
TiAnimationBuilder.prototype.className = 'org.appcelerator.titanium.util.TiAnimationBuilder';

// class property
Object.defineProperty(TiAnimationBuilder, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiAnimationBuilder');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiAnimationBuilder.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiAnimationBuilder');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiAnimationBuilder.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiAnimationBuilder.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiAnimationBuilder(Hyperloop.cast('org.appcelerator.titanium.util.TiAnimationBuilder', object.$native));
};

// Constants

// Inner classes
Object.defineProperty(TiAnimationBuilder, 'AnimationListener', {
	get: function() {
		return require('./org.appcelerator.titanium.util.TiAnimationBuilder$AnimationListener');
	},
	enumerable: true
});
Object.defineProperty(TiAnimationBuilder, 'AnimatorHelper', {
	get: function() {
		return require('./org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorHelper');
	},
	enumerable: true
});
Object.defineProperty(TiAnimationBuilder, 'AnimatorListener', {
	get: function() {
		return require('./org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorListener');
	},
	enumerable: true
});
Object.defineProperty(TiAnimationBuilder, 'AnimatorUpdateListener', {
	get: function() {
		return require('./org.appcelerator.titanium.util.TiAnimationBuilder$AnimatorUpdateListener');
	},
	enumerable: true
});
Object.defineProperty(TiAnimationBuilder, 'TiMatrixAnimation', {
	get: function() {
		return require('./org.appcelerator.titanium.util.TiAnimationBuilder$TiMatrixAnimation');
	},
	enumerable: true
});

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#applyOpacity
Object.defineProperty(TiAnimationBuilder.prototype, 'applyOpacity', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('applyOpacity');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('applyOpacity', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#centerY
Object.defineProperty(TiAnimationBuilder.prototype, 'centerY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('centerY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('centerY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#color
Object.defineProperty(TiAnimationBuilder.prototype, 'color', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('color');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('color', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#animatorHelper
Object.defineProperty(TiAnimationBuilder.prototype, 'animatorHelper', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('animatorHelper');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('animatorHelper', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#toOpacity
Object.defineProperty(TiAnimationBuilder.prototype, 'toOpacity', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('toOpacity');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('toOpacity', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#centerX
Object.defineProperty(TiAnimationBuilder.prototype, 'centerX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('centerX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('centerX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#curve
Object.defineProperty(TiAnimationBuilder.prototype, 'curve', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('curve');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('curve', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#duration
Object.defineProperty(TiAnimationBuilder.prototype, 'duration', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('duration');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('duration', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#anchorY
Object.defineProperty(TiAnimationBuilder.prototype, 'anchorY', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('anchorY');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('anchorY', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#view
Object.defineProperty(TiAnimationBuilder.prototype, 'view', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('view');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('view', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#top
Object.defineProperty(TiAnimationBuilder.prototype, 'top', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('top');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('top', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#anchorX
Object.defineProperty(TiAnimationBuilder.prototype, 'anchorX', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('anchorX');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('anchorX', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#repeat
Object.defineProperty(TiAnimationBuilder.prototype, 'repeat', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('repeat');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('repeat', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#options
Object.defineProperty(TiAnimationBuilder.prototype, 'options', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('options');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('options', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#height
Object.defineProperty(TiAnimationBuilder.prototype, 'height', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('height');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('height', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#elevation
Object.defineProperty(TiAnimationBuilder.prototype, 'elevation', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('elevation');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('elevation', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#animationProxy
Object.defineProperty(TiAnimationBuilder.prototype, 'animationProxy', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('animationProxy');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('animationProxy', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#viewProxy
Object.defineProperty(TiAnimationBuilder.prototype, 'viewProxy', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('viewProxy');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('viewProxy', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#backgroundColor
Object.defineProperty(TiAnimationBuilder.prototype, 'backgroundColor', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('backgroundColor');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('backgroundColor', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#bottom
Object.defineProperty(TiAnimationBuilder.prototype, 'bottom', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('bottom');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('bottom', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#right
Object.defineProperty(TiAnimationBuilder.prototype, 'right', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('right');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('right', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#delay
Object.defineProperty(TiAnimationBuilder.prototype, 'delay', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('delay');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('delay', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#left
Object.defineProperty(TiAnimationBuilder.prototype, 'left', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('left');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('left', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#autoreverse
Object.defineProperty(TiAnimationBuilder.prototype, 'autoreverse', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('autoreverse');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('autoreverse', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#width
Object.defineProperty(TiAnimationBuilder.prototype, 'width', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('width');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('width', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#callback
Object.defineProperty(TiAnimationBuilder.prototype, 'callback', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('callback');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('callback', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#relayoutChild
Object.defineProperty(TiAnimationBuilder.prototype, 'relayoutChild', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('relayoutChild');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('relayoutChild', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#tdm
Object.defineProperty(TiAnimationBuilder.prototype, 'tdm', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('tdm');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
				return new TiAnimationBuilder(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('tdm', newValue);
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function isAnimationRunningFor
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#isAnimationRunningFor(android.view.View)}
 **/
TiAnimationBuilder.isAnimationRunningFor = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'isAnimationRunningFor',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function createMatrixAnimation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#createMatrixAnimation(org.appcelerator.titanium.view.Ti2DMatrix)}
 **/
TiAnimationBuilder.prototype.createMatrixAnimation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'createMatrixAnimation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isUsingPropertyAnimators
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#isUsingPropertyAnimators()}
 **/
TiAnimationBuilder.prototype.isUsingPropertyAnimators = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isUsingPropertyAnimators',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyAnimation
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#applyAnimation(org.appcelerator.titanium.view.TiAnimation)}
 **/
TiAnimationBuilder.prototype.applyAnimation = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyAnimation',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function start
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#start(org.appcelerator.titanium.proxy.TiViewProxy, android.view.View)}
 **/
TiAnimationBuilder.prototype.start = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'start',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function setCallback
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#setCallback(org.appcelerator.kroll.KrollFunction)}
 **/
TiAnimationBuilder.prototype.setCallback = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'setCallback',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function applyOptions
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiAnimationBuilder.html#applyOptions(java.util.HashMap)}
 **/
TiAnimationBuilder.prototype.applyOptions = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'applyOptions',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiAnimationBuilder') {
			return new TiAnimationBuilder(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiAnimationBuilder;
