/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.appcelerator.titanium.util.TiUrl
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.appcelerator.titanium.util');

/**
 * @class org.appcelerator.titanium.util.TiUrl
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html}
 **/
var TiUrl = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.appcelerator.titanium.util.TiUrl')) {
		result = arguments[0];
	}
	else {
		result = TiUrl.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
TiUrl.prototype = Object.create(SuperClass.prototype);
TiUrl.prototype.constructor = TiUrl;

Object.defineProperty(TiUrl.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new TiUrl(this.$native.super);
	},
	enumerable: true
});

TiUrl.className = 'org.appcelerator.titanium.util.TiUrl';
TiUrl.prototype.className = 'org.appcelerator.titanium.util.TiUrl';

// class property
Object.defineProperty(TiUrl, 'class', {
	get: function() {
		return Hyperloop.getClass('org.appcelerator.titanium.util.TiUrl');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
TiUrl.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.appcelerator.titanium.util.TiUrl');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(TiUrl.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
TiUrl.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new TiUrl(Hyperloop.cast('org.appcelerator.titanium.util.TiUrl', object.$native));
};

// Constants
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#SCHEME_SUFFIX}
 */
TiUrl.SCHEME_SUFFIX = "://";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#CURRENT_PATH}
 */
TiUrl.CURRENT_PATH = ".";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#CURRENT_PATH_WITH_SEPARATOR}
 */
TiUrl.CURRENT_PATH_WITH_SEPARATOR = "./";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#PATH_SEPARATOR}
 */
TiUrl.PATH_SEPARATOR = "/";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#TAG}
 */
TiUrl.TAG = "TiUrl";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#PARENT_PATH_WITH_SEPARATOR}
 */
TiUrl.PARENT_PATH_WITH_SEPARATOR = "../";
/**
 * @constant
 * @default
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#PARENT_PATH}
 */
TiUrl.PARENT_PATH = "..";

// Inner classes

// Static fields

// Instance Fields
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#baseUrl
Object.defineProperty(TiUrl.prototype, 'baseUrl', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('baseUrl');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
				return new TiUrl(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('baseUrl', newValue);
	},
	enumerable: true
});
// http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#url
Object.defineProperty(TiUrl.prototype, 'url', {
	get: function() {
		if (!this._hasPointer) return null;

		var result = this.$native.getNativeField('url');
		if (result == null) {
			return null;
		}
		// Wrap result if it's not a primitive type?
		if (result.apiName) {
			if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
				return new TiUrl(result);
			} else {
				var ctor = require('./' + result.apiName);
				return new ctor(result);
			}
		}
		return result;
	},
	set: function(newValue) {
		if (!this._hasPointer) return;

		this.$native.setNativeField('url', newValue);
	},
	enumerable: true
});

// Static methods
/**
 * TODO Fill out docs more...
 * @function resolve
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#resolve(java.lang.String, java.lang.String, java.lang.String)}
 **/
TiUrl.resolve = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'resolve',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function absoluteUrl
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#absoluteUrl(java.lang.String, java.lang.String, java.lang.String)}
 **/
TiUrl.absoluteUrl = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'absoluteUrl',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function createProxyUrl
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#createProxyUrl(java.lang.String)}
 **/
TiUrl.createProxyUrl = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'createProxyUrl',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function parseRelativeBaseUrl
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#parseRelativeBaseUrl(java.lang.String, java.lang.String, boolean)}
 **/
TiUrl.parseRelativeBaseUrl = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'parseRelativeBaseUrl',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getCleanUri
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#getCleanUri(java.lang.String)}
 **/
TiUrl.getCleanUri = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'getCleanUri',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function normalizeWindowUrl
 * @static
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#normalizeWindowUrl(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#normalizeWindowUrl(java.lang.String, java.lang.String)}
 **/
TiUrl.normalizeWindowUrl = function() {
	if (!this.class) return null;

	var result = this.class.callNativeFunction({
		func: 'normalizeWindowUrl',
		instanceMethod: false,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// Instance methods
/**
 * TODO Fill out docs more...
 * @function resolve
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#resolve()}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#resolve(java.lang.String)}
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#resolve(java.lang.String, java.lang.String)}
 **/
TiUrl.prototype.resolve = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'resolve',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getNormalizedUrl
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/appcelerator/titanium/util/TiUrl.html#getNormalizedUrl()}
 **/
TiUrl.prototype.getNormalizedUrl = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getNormalizedUrl',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.appcelerator.titanium.util.TiUrl') {
			return new TiUrl(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = TiUrl;
