/**
 * Hyperloop
 * Generated code is Copyright (c) 2022 Appcelerator, Inc. and subject to the
 * Appcelerator Platform Subscription agreement.
 *
 * WARNING: This is generated code. Modify at your own risk and without support
 *
 * @module org.json.JSONArray
 */
var Hyperloop = require('hyperloop');

var parentPackage = require('./org.json');

/**
 * @class org.json.JSONArray
 * @extends java.lang.Object 
 * @constructor
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html}
 **/
var JSONArray = function() {
	var result;
	// Allow the constructor to either invoke the real java constructor, or function as a "wrapping" method that will take
	// a single argument that is a native hyperloop proxy for this class type and just wraps it in our JS type.
	if (arguments.length == 1 && arguments[0].isNativeProxy && arguments[0].isInstanceProxy && arguments[0].isInstanceOf('org.json.JSONArray')) {
		result = arguments[0];
	}
	else {
		result = JSONArray.class.newInstance(arguments);
	}

	this.$native = result;
	this._hasPointer = result != null;
	this._private = {};
};

var SuperClass = require('./java.lang.Object');
JSONArray.prototype = Object.create(SuperClass.prototype);
JSONArray.prototype.constructor = JSONArray;

Object.defineProperty(JSONArray.prototype, 'super', {
	get: function() {
		if (!this._hasPointer) return null;
		return new JSONArray(this.$native.super);
	},
	enumerable: true
});

JSONArray.className = 'org.json.JSONArray';
JSONArray.prototype.className = 'org.json.JSONArray';

// class property
Object.defineProperty(JSONArray, 'class', {
	get: function() {
		return Hyperloop.getClass('org.json.JSONArray');
	},
	enumerable: true,
	configurable: false
});

// Allow subclassing
JSONArray.extend = function (overrides) {
	var subclassProxy = Hyperloop.extend('org.json.JSONArray');

	// Generate a JS wrapper for our dynamic subclass
	var SubClass = function() {
		var result = subclassProxy.newInstance(arguments),
			instance = this,
			copy = overrides,
			modified = {};

		function _wrapArg(arg) {
			if (arg && arg.apiName && arg.isNativeProxy && arg.isInstanceProxy) { // Assume hyperloop proxy, wrap in JS wrapper
				var other = require('./' + arg.apiName);
				return new other(arg);
			}
			return arg;
		}

		function _wrapArgs() {
			var newArgs = [];
			for (var i = 0; i < arguments.length; i++) {
				newArgs[i] = _wrapArg(arguments[i]);
			}
			return newArgs;
		};

		Object.keys(copy).forEach(function (each) {
			// Hang the original override method on the JS wrapper object
			instance[each] = function() {
				return copy[each].apply(instance, arguments);
			};

			// Hang a delegate on the "overrides" object we pass into Java.
			// This one wraps hyperloop proxies from Java in their JS wrapper before forwarding on
			modified[each] = function() {
				return instance[each].apply(instance, _wrapArgs.apply(this, arguments));
			}
		});
		result.setOverrides(modified);

		this.$native = result;
		this._hasPointer = result != null;
		this._private = {};
	};
	// it extends the JS wrapper for the parent type
	SubClass.prototype = Object.create(JSONArray.prototype);
	SubClass.prototype.constructor = SubClass;
	return SubClass;
};

// Cast
JSONArray.cast = function(object) {
	if (!object.$native || !object.$native.isInstanceProxy) return object;
	return new JSONArray(Hyperloop.cast('org.json.JSONArray', object.$native));
};

// Constants

// Inner classes

// Static fields

// Instance Fields

// Static methods

// Instance methods
/**
 * TODO Fill out docs more...
 * @function getDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getDouble(int)}
 **/
JSONArray.prototype.getDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function put
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(boolean)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(java.util.Collection)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(double)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(long)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(java.util.Map)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(java.lang.Object)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, boolean)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, java.util.Collection)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, double)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, long)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, java.util.Map)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#put(int, java.lang.Object)}
 **/
JSONArray.prototype.put = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'put',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function remove
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#remove(int)}
 **/
JSONArray.prototype.remove = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'remove',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getJSONArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getJSONArray(int)}
 **/
JSONArray.prototype.getJSONArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getJSONArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optBoolean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optBoolean(int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optBoolean(int, boolean)}
 **/
JSONArray.prototype.optBoolean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optBoolean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function get
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#get(int)}
 **/
JSONArray.prototype.get = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'get',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optString(int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optString(int, java.lang.String)}
 **/
JSONArray.prototype.optString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toJSONObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#toJSONObject(org.json.JSONArray)}
 **/
JSONArray.prototype.toJSONObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toJSONObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getBoolean
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getBoolean(int)}
 **/
JSONArray.prototype.getBoolean = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getBoolean',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function join
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#join(java.lang.String)}
 **/
JSONArray.prototype.join = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'join',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function write
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#write(java.io.Writer)}
 **/
JSONArray.prototype.write = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'write',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optJSONObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optJSONObject(int)}
 **/
JSONArray.prototype.optJSONObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optJSONObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function length
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#length()}
 **/
JSONArray.prototype.length = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'length',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getString(int)}
 **/
JSONArray.prototype.getString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optJSONArray
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optJSONArray(int)}
 **/
JSONArray.prototype.optJSONArray = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optJSONArray',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getLong(int)}
 **/
JSONArray.prototype.getLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getInt(int)}
 **/
JSONArray.prototype.getInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function opt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#opt(int)}
 **/
JSONArray.prototype.opt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'opt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optInt
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optInt(int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optInt(int, int)}
 **/
JSONArray.prototype.optInt = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optInt',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optLong
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optLong(int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optLong(int, long)}
 **/
JSONArray.prototype.optLong = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optLong',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function isNull
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#isNull(int)}
 **/
JSONArray.prototype.isNull = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'isNull',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function toString
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#toString()}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#toString(int)}
 **/
JSONArray.prototype.toString = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'toString',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function optDouble
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optDouble(int)}
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#optDouble(int, double)}
 **/
JSONArray.prototype.optDouble = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'optDouble',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};
/**
 * TODO Fill out docs more...
 * @function getJSONObject
 * @memberof
 * @instance
 * @see {@link http://developer.android.com/reference/org/json/JSONArray.html#getJSONObject(int)}
 **/
JSONArray.prototype.getJSONObject = function() {
	if (!this._hasPointer) return null;

	var result = this.$native.callNativeFunction({
		func: 'getJSONObject',
		instanceMethod: true,
		args: Array.prototype.slice.call(arguments)
	});
	if (result == null) {
		return null;
	}
	// Wrap result if it's not a primitive type?
	if (result.apiName) {
		if (result.apiName === 'org.json.JSONArray') {
			return new JSONArray(result);
		} else {
			var ctor = require('./' + result.apiName);
			return new ctor(result);
		}
	}
	return result;
};

// export the class
module.exports = JSONArray;
